(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.QtestContext = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _statusEnum = require('./services/model/statusEnum.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var QtestContext = exports.QtestContext = function () {
  function QtestContext() {
    _classCallCheck(this, QtestContext);
  }

  _createClass(QtestContext, null, [{
    key: 'clear',
    value: function clear() {
      this._user = null;
      this._session = null;
      this._projects = [];
      this._selectedProject = null;
      this._timeTypes = [];
      this._noteTypes = [];
      this._pendingAnnotations = [];
      this._currentProcessingScreen = null;
      this._domainOptions = null;
      this._runFromQtest = false;
      this._projectId = null;
      this._sessionId = null;
      this._status = {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    }
  }, {
    key: 'canRecordMedia',
    value: function canRecordMedia() {
      return this._qTestVersion && this._qTestVersion >= 6;
    }
  }, {
    key: 'getProjectAutoStartSupported',
    value: function getProjectAutoStartSupported() {
      var result = [];
      if (this._projects) {
        var ref = this._projects;
        for (var j = 0, len = ref.length; j < len; j++) {
          var p = ref[j];
          if (p.alwaysOnSetting.domains.length > 0 && p.alwaysOnSetting.enabled) {
            result.push(p);
          }
        }
      }
      return result;
    }
  }, {
    key: 'qTestVersion',
    get: function get() {
      return this._qTestVersion || null;
    },
    set: function set(qTestVersion) {
      this._qTestVersion = qTestVersion;
    }
  }, {
    key: 'qTestMinorVersion',
    get: function get() {
      return this._qTestMinorVersion || null;
    },
    set: function set(qTestMinorVersion) {
      this._qTestMinorVersion = qTestMinorVersion;
    }
  }, {
    key: 'session',
    get: function get() {
      return this._session || null;
    },
    set: function set(session) {
      this._session = session;
    }
  }, {
    key: 'user',
    get: function get() {
      return this._user || null;
    },
    set: function set(user) {
      this._user = user;
    }
  }, {
    key: 'projects',
    get: function get() {
      if (!this._projects) {
        this._projects = [];
      }
      return this._projects;
    },
    set: function set(projects) {
      this._projects = projects;
    }
  }, {
    key: 'selectedProject',
    get: function get() {
      return this._selectedProject || null;
    },
    set: function set(selectedProject) {
      this._selectedProject = selectedProject;
    }
  }, {
    key: 'timeTypes',
    get: function get() {
      if (!this._timeTypes) {
        this._timeTypes = [];
      }
      return this._timeTypes;
    },
    set: function set(timeTypes) {
      this._timeTypes = timeTypes;
    }
  }, {
    key: 'noteTypes',
    get: function get() {
      if (!this._noteTypes) {
        this._noteTypes = [];
      }
      return this._noteTypes;
    },
    set: function set(noteTypes) {
      this._noteTypes = noteTypes;
    }
  }, {
    key: 'pendingAnnotations',
    get: function get() {
      if (!this._pendingAnnotations) {
        this._pendingAnnotations = [];
      }
      return this._pendingAnnotations;
    },
    set: function set(pendingAnnotations) {
      this._pendingAnnotations = pendingAnnotations;
    }
  }, {
    key: 'currentProcessingScreen',
    get: function get() {
      return this._currentProcessingScreen || null;
    },
    set: function set(currentProcessingScreen) {
      this._currentProcessingScreen = currentProcessingScreen;
    }
  }, {
    key: 'domainOptions',
    get: function get() {
      return this._domainOptions || null;
    },
    set: function set(domainOptions) {
      this._domainOptions = domainOptions;
    }
  }, {
    key: 'runFromQtest',
    get: function get() {
      return this._runFromQtest || false;
    },
    set: function set(runFromQtest) {
      this._runFromQtest = runFromQtest;
    }
  }, {
    key: 'projectId',
    get: function get() {
      return this._projectId || null;
    },
    set: function set(projectId) {
      this._projectId = projectId;
    }
  }, {
    key: 'sessionId',
    get: function get() {
      return this._sessionId || null;
    },
    set: function set(sessionId) {
      this._sessionId = sessionId;
    }
  }, {
    key: 'status',
    get: function get() {
      return this._status || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._status = value;
    }
  }, {
    key: 'currentqTestSession',
    get: function get() {
      return this._currentqTestSession || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._currentqTestSession = value;
    }
  }, {
    key: 'sessionManagerVersion',
    get: function get() {
      return this._sessionManagerVersion || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._sessionManagerVersion = value;
    }
  }]);

  return QtestContext;
}();

},{"./services/model/statusEnum.js":4}],2:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GetStatusMessageHandler = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _statusEnum = require('./model/statusEnum.js');

var _qTestContext = require('../qTestContext.js');

var _tabManager = require('../../extension/js/background/tabManager.js');

var _storage = require('../services/storage.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var GetStatusMessageHandler = exports.GetStatusMessageHandler = function () {
  function GetStatusMessageHandler() {
    _classCallCheck(this, GetStatusMessageHandler);
  }

  _createClass(GetStatusMessageHandler, [{
    key: 'handle',
    value: async function handle() {
      console.log('current status: ' + _qTestContext.QtestContext.status.name);
      var statusName = _qTestContext.QtestContext.status.name;
      var domainArray = await _tabManager.TabManager.getOpeningDomains();
      switch (statusName) {
        case _statusEnum.StatusEnum.loadedServerSession:
          return {
            name: statusName,
            info: {
              projects: _qTestContext.QtestContext.projects,
              selectedProject: _qTestContext.QtestContext.selectedProject.id,
              user: _qTestContext.QtestContext.user,
              domainOptions: {
                all: true,
                domains: domainArray,
                include: false,
                exclude: false
              }
            }
          };
        case _statusEnum.StatusEnum.loadingServerSession:
          return {
            name: statusName,
            info: {
              projects: _qTestContext.QtestContext.projects,
              selectedProject: null,
              user: _qTestContext.QtestContext.user,
              domainOptions: {
                all: true,
                domains: domainArray,
                include: false,
                exclude: false
              }
            }
          };
        case _statusEnum.StatusEnum.loggedIn:
          var lastSelectedProjectId = _storage.Storage.get('lastSelectedProjectId');
          return {
            name: statusName,
            info: {
              runFromQtest: _qTestContext.QtestContext.runFromQtest,
              projectId: _qTestContext.QtestContext.projectId,
              sessionId: _qTestContext.QtestContext.sessionId,
              projects: _qTestContext.QtestContext.projects,
              user: _qTestContext.QtestContext.user,
              domainOptions: {
                all: true,
                domains: domainArray,
                include: false,
                exclude: false
              },
              lastSelectedProjectId: lastSelectedProjectId ? parseInt(lastSelectedProjectId, 10) : undefined
            }
          };
        case _statusEnum.StatusEnum.loggingIn:
          return {
            name: statusName,
            info: {
              loginOption: _qTestContext.QtestContext.status.info.loginOption,
              user: _qTestContext.QtestContext.status.info.user
            }
          };
        case _statusEnum.StatusEnum.startingSession:
          return {
            name: statusName,
            info: {
              user: _qTestContext.QtestContext.user,
              session: _qTestContext.QtestContext.session.getViewData(),
              projects: _qTestContext.QtestContext.projects,
              selectedProject: _qTestContext.QtestContext.selectedProject.id,
              runExisting: _qTestContext.QtestContext.status.info ? _qTestContext.QtestContext.status.info.runExisting : undefined,
              domainOptions: _qTestContext.QtestContext.status.info.domainOptions
            }
          };
        case _statusEnum.StatusEnum.recording:
          var canCaptureVisiblePart = _tabManager.TabManager.isActiveTabCapturable;
          var canCaptureFullPage = canCaptureVisiblePart && _tabManager.TabManager.canCaptureFullPageOfActiveTab;
          var canEditCurrentScreen = _qTestContext.QtestContext.currentProcessingScreen ? true : false;
          return {
            name: statusName,
            info: {
              user: _qTestContext.QtestContext.user,
              session: _qTestContext.QtestContext.session.getViewData(),
              projects: _qTestContext.QtestContext.projects,
              timeTypes: _qTestContext.QtestContext.timeTypes,
              noteTypes: _qTestContext.QtestContext.noteTypes,
              canCaptureVisiblePart: canCaptureVisiblePart,
              canCaptureFullPage: canCaptureFullPage,
              canEditCurrentScreen: canEditCurrentScreen
            }
          };
        case _statusEnum.StatusEnum.capturingFullPage:
          return {
            name: statusName,
            info: {
              user: _qTestContext.QtestContext.user
            }
          };
        case _statusEnum.StatusEnum.completingSession:
          return {
            name: statusName,
            info: {
              user: _qTestContext.QtestContext.user,
              session: _qTestContext.QtestContext.session.getViewData(),
              projects: _qTestContext.QtestContext.projects,
              timeTypes: _qTestContext.QtestContext.timeTypes,
              noteTypes: _qTestContext.QtestContext.noteTypes
            }
          };
        case _statusEnum.StatusEnum.notLoggedIn:
          var user = _storage.Storage.get('credentials');
          var loginOption = _storage.Storage.get('loginOption');
          if (!loginOption) {
            loginOption = 'qtest';
          }
          if (user) {
            console.log('notLoggedIn, user: ' + JSON.stringify(user) + ', loginOption: ' + loginOption);
            return {
              name: statusName,
              info: {
                user: user,
                loginOption: loginOption
              }
            };
          }
          return {
            name: _statusEnum.StatusEnum.notLoggedIn,
            info: {
              loginOption: loginOption
            }
          };
        case _statusEnum.StatusEnum.paused:
          return {
            name: statusName,
            info: {
              user: _qTestContext.QtestContext.user,
              session: _qTestContext.QtestContext.session.getViewData(),
              timeTypes: _qTestContext.QtestContext.timeTypes,
              noteTypes: _qTestContext.QtestContext.noteTypes
            }
          };
        case _statusEnum.StatusEnum.recordingMedia:
          return {
            name: statusName,
            info: {
              user: _qTestContext.QtestContext.user,
              session: _qTestContext.QtestContext.session.getViewData(),
              startAt: _qTestContext.QtestContext.status.info.startAt,
              stopAt: _qTestContext.QtestContext.status.info.stopAt,
              mediaType: _qTestContext.QtestContext.status.info.mediaType
            }
          };
        case _statusEnum.StatusEnum.startingSessionIndicator:
          return {
            name: statusName,
            info: _qTestContext.QtestContext.status.info
          };
        default:
          return {
            name: _qTestContext.QtestContext.status.name
          };
      }
    }
  }]);

  return GetStatusMessageHandler;
}();

},{"../../extension/js/background/tabManager.js":7,"../qTestContext.js":1,"../services/storage.js":5,"./model/statusEnum.js":4}],3:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var MessageEnum = exports.MessageEnum = {
  getStatus: 'getStatus',

  login: 'login',

  logout: 'logout',

  getSessions: 'getSessions',

  startSession: 'startSession',

  viewSession: 'viewSession',

  completeSession: 'completeSession',

  addNote: 'addNote',

  switchTimetype: 'switchTimetype',

  keyEvent: 'keyEvent',

  clickEvent: 'clickEvent',

  takeSnapshot: 'takeSnapshot',

  modalDialog: 'modalDialog',

  devicePixelRatio: 'devicePixelRatio',

  toggleRecordingStatus: 'toggleRecordingStatus',

  captureVisiblePart: 'captureVisiblePart',

  captureFullPage: 'captureFullPage',

  captureScrollingPage: 'captureScrollingPage',

  finishedScrolling: 'finishedScrolling',

  finishedCaptureFullPage: 'finishedCaptureFullPage',

  discardScrollingCapture: 'discardScrollingCapture',

  openUrl: 'openUrl',

  editCurrentScreen: 'editCurrentScreen',

  editorReady: 'editorReady',

  saveCurrentScreen: 'saveCurrentScreen',

  cancelEditCurrentScreen: 'cancelEditCurrentScreen',

  confirmMediaPermission: 'confirmMediaPermission',

  deniedMediaPermission: 'deniedMediaPermission',

  cancelledMediaPermission: 'cancelledMediaPermission',

  recordMedia: 'recordMedia',

  stopRecordMedia: 'stopRecordMedia',

  cancelRecordMedia: 'cancelRecordMedia',

  showSettings: 'showSettings',

  getSettings: 'getSettings',

  saveSettings: 'saveSettings',

  cancelSaveSettings: 'cancelSaveSettings',

  closeSettings: 'closeSettings',

  openCommandsConfiguration: 'openCommandsConfiguration',

  startSessionFromqTest: 'startSessionFromqTest',

  currentqTestSession: 'currentqTestSession',

  getCurrentqTestSession: 'getCurrentqTestSession',

  getOpeningDomains: 'getOpeningDomains',

  getAutoStartData: 'getAutoStartData',

  autoStartDisableConfirm: 'autoStartDisableConfirm',

  startAutoStartSession: 'startAutoStartSession',

  removeAutoStartDialog: 'remove-web-explorer-confirm-start-always-on-session-dialog',

  removeStartSessionDialog: 'remove-web-explorer-start-session-dialog'
};

},{}],4:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var StatusEnum = exports.StatusEnum = {
  notLoggedIn: 'notLoggedIn',

  loggingIn: 'loggingIn',

  loggedIn: 'loggedIn',

  loadingServerSession: 'loadingServerSession',

  loadedServerSession: 'loadedServerSession',

  startingSession: 'startingSession',

  startingSessionIndicator: 'startingSessionIndicator',

  recording: 'recording',

  editing: 'editing',

  paused: 'paused',

  capturingFullPage: 'capturingFullPage',

  inProgress: 'inProgress',

  completingSession: 'completingSession',

  recordingMedia: 'recordingMedia'
};

},{}],5:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ___ = ['\x6D\x74\x26\x79\x6B\x4E\x57\x55\x62\x4E\x49\x65\x52\x26\x34\x33'][0];

var Storage = exports.Storage = function () {
  function Storage() {
    _classCallCheck(this, Storage);
  }

  _createClass(Storage, null, [{
    key: 'encrypt',
    value: function encrypt(vString) {
      // eslint-disable-next-line no-undef
      return sjcl.encrypt(___, vString);
    }
  }, {
    key: 'decrypt',
    value: function decrypt(vString) {
      // eslint-disable-next-line no-undef
      return sjcl.decrypt(___, vString);
    }

    // get(k: string): Object

  }, {
    key: 'get',
    value: function get(k) {
      try {
        var vString = localStorage.getItem(k);
        if (!vString) {
          return null;
        }

        var obj = JSON.parse(vString);
        if (obj.cipher && obj.salt && obj.mode) {
          obj = JSON.parse(this.decrypt(vString));
        }

        // backward compatible: old version stringify the obj multiple times
        if (typeof obj === 'string') {
          try {
            var tempObj = JSON.parse(obj);
            obj = tempObj;
            // eslint-disable-next-line no-empty
          } catch (e) {}
        }

        if (obj.expires) {
          // check expiration
          var now = new Date();
          var expires = new Date(obj.expires);
          if (now.getTime() >= expires.getTime()) {
            console.error('Storage "' + k + '" expired on ' + obj.expires);
            this.remove(k);
            return null;
          }
        }

        return obj;
      } catch (error) {
        console.log(error);
        return null;
      }
    }

    // set(k: string, vString: string, opts: { secure: boolean })

  }, {
    key: 'set',
    value: function set(k, vString) {
      var opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      if (!vString) {
        this.remove(k);
        return;
      }

      localStorage.setItem(k, opts.secure ? this.encrypt(vString) : vString);
    }
  }, {
    key: 'remove',
    value: function remove(k) {
      localStorage.removeItem(k);
    }
  }]);

  return Storage;
}();

},{}],6:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EditorHandler = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _qTestContext = require('../../../common/qTestContext.js');

var _messageEnum = require('../../../common/services/model/messageEnum.js');

var _statusEnum = require('../../../common/services/model/statusEnum.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var EditorHandler = exports.EditorHandler = function () {
  function EditorHandler() {
    _classCallCheck(this, EditorHandler);

    this.URL = '../../../common/editor/editor.html';
    this.editorTab = null;
    this.lastActiveTab = null;
  }

  _createClass(EditorHandler, [{
    key: 'activeTab',
    value: function activeTab(tab, reload) {
      this.editorTab = {
        id: tab.id,
        url: tab.url,
        windowId: tab.windowId
      };
      chrome.windows.update(tab.windowId, {
        focused: true
      });
      chrome.tabs.update(tab.id, {
        active: true
      });
      if (reload) {
        chrome.tabs.reload(tab.id);
      }
      return {
        success: true
      };
    }
  }, {
    key: 'handle',
    value: function handle(message) {
      var _this = this;

      return new Promise(async function (resolve) {
        var tab = {};
        if (message.name === _messageEnum.MessageEnum.editCurrentScreen) {
          if (!_qTestContext.QtestContext.currentProcessingScreen) {
            console.log(new Date().toString() + ' handle editCurrentScreen message, but current processing screen is not available');
            resolve({ success: false });
          }
          tab = await _this.findEditorTab();
          if (tab) {
            _this.activeTab(tab, true);
          } else {
            _this.lastActiveTab = null;
            chrome.tabs.query({
              windowId: chrome.windows.WINDOW_ID_CURRENT,
              active: true
            }, function (tabs) {
              if (tabs && tabs.length > 0) {
                tab = tabs[0];
                _this.lastActiveTab = {
                  id: tab.id,
                  url: tab.url,
                  windowId: tab.windowId
                };
                chrome.tabs.create({
                  index: tab.index + 1,
                  url: _this.URL
                }, function (newTab) {
                  resolve(_this.activeTab(newTab, false));
                });
              } else {
                _this.lastActiveTab = null;
                chrome.tabs.create({
                  url: _this.URL
                }, function (newTab) {
                  resolve(_this.activeTab(newTab, false));
                });
              }
            });
          }
        } else if (message.name === _messageEnum.MessageEnum.editorReady) {
          if (_qTestContext.QtestContext.currentProcessingScreen && _this.editorTab) {
            var screen = _qTestContext.QtestContext.currentProcessingScreen.getDrawableData();
            var obj = {
              screen: screen,
              noteTypes: _qTestContext.QtestContext.noteTypes,
              qTestVersion: {
                major: _qTestContext.QtestContext.qTestVersion,
                minor: _qTestContext.QtestContext.qTestMinorVersion
              }
            };
            var dataString = JSON.stringify(obj);
            chrome.tabs.sendMessage(_this.editorTab.id, {
              name: 'currentScreen',
              data: dataString
            }, function (response) {
              _qTestContext.QtestContext.status = {
                name: _statusEnum.StatusEnum.editing
              };
              resolve({ success: true });
            });
          }
        } else if (message.name === _messageEnum.MessageEnum.saveCurrentScreen) {
          _qTestContext.QtestContext.currentProcessingScreen.importData(message.data);
          _qTestContext.QtestContext.status = {
            name: _statusEnum.StatusEnum.recording
          };
          chrome.tabs.sendMessage(_this.editorTab.id, {
            name: 'savedCurrentScreen',
            data: null
          }, function (response) {});
          await _this.closeEditorTab(_this.editorTab.id);
          await _this.activateLastActiveTab(_this.lastActiveTab.id);
          _this.lastActiveTab = null;
          resolve({ success: true });
        } else if (message.name === _messageEnum.MessageEnum.cancelEditCurrentScreen) {
          _qTestContext.QtestContext.status = {
            name: _statusEnum.StatusEnum.recording
          };
          await _this.closeEditorTab(_this.editorTab.id);
          if (_this.lastActiveTab && _this.lastActiveTab.id) {
            await _this.activateLastActiveTab(_this.lastActiveTab.id);
          }
          _this.lastActiveTab = null;
          resolve({ success: true });
        }
      });
    }
  }, {
    key: 'findEditorTab',
    value: async function findEditorTab() {
      return new Promise(function (resolve) {
        chrome.windows.getAll({
          populate: true
        }, function (wnds) {
          var tab = null;
          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = wnds[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var wd = _step.value;

              if (tab) {
                break;
              }
              var _iteratorNormalCompletion2 = true;
              var _didIteratorError2 = false;
              var _iteratorError2 = undefined;

              try {
                for (var _iterator2 = wd.tabs[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                  var tb = _step2.value;

                  if (tb.url.indexOf(EditorHandler.URL_PREFIX) >= 0) {
                    tab = tb;
                    break;
                  }
                }
              } catch (err) {
                _didIteratorError2 = true;
                _iteratorError2 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion2 && _iterator2.return) {
                    _iterator2.return();
                  }
                } finally {
                  if (_didIteratorError2) {
                    throw _iteratorError2;
                  }
                }
              }
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }

          resolve(tab);
        });
      });
    }
  }, {
    key: 'closeEditorTab',
    value: async function closeEditorTab(tabId) {
      return new Promise(function (resolve) {
        chrome.tabs.query({}, function (tabs) {
          if (tabs) {
            var found = false;
            var _iteratorNormalCompletion3 = true;
            var _didIteratorError3 = false;
            var _iteratorError3 = undefined;

            try {
              for (var _iterator3 = tabs[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                var tab = _step3.value;

                if (tab.id === tabId) {
                  found = true;
                  break;
                }
              }
            } catch (err) {
              _didIteratorError3 = true;
              _iteratorError3 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion3 && _iterator3.return) {
                  _iterator3.return();
                }
              } finally {
                if (_didIteratorError3) {
                  throw _iteratorError3;
                }
              }
            }

            if (found) {
              chrome.tabs.remove(tabId, function () {});
            }
          }
          resolve(true);
        });
      });
    }
  }, {
    key: 'activateLastActiveTab',
    value: async function activateLastActiveTab(tabId) {
      return new Promise(function (resolve) {
        chrome.windows.getAll({
          populate: true
        }, function (wnds) {
          var tab = null;
          var _iteratorNormalCompletion4 = true;
          var _didIteratorError4 = false;
          var _iteratorError4 = undefined;

          try {
            for (var _iterator4 = wnds[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
              var wd = _step4.value;

              if (tab) {
                break;
              }
              var _iteratorNormalCompletion5 = true;
              var _didIteratorError5 = false;
              var _iteratorError5 = undefined;

              try {
                for (var _iterator5 = wd.tabs[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
                  var tb = _step5.value;

                  if (tb.id === tabId) {
                    tab = tb;
                    break;
                  }
                }
              } catch (err) {
                _didIteratorError5 = true;
                _iteratorError5 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion5 && _iterator5.return) {
                    _iterator5.return();
                  }
                } finally {
                  if (_didIteratorError5) {
                    throw _iteratorError5;
                  }
                }
              }
            }
          } catch (err) {
            _didIteratorError4 = true;
            _iteratorError4 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion4 && _iterator4.return) {
                _iterator4.return();
              }
            } finally {
              if (_didIteratorError4) {
                throw _iteratorError4;
              }
            }
          }

          if (tab) {
            chrome.windows.update(tab.windowId, {
              focused: true
            });
            chrome.tabs.update(tab.id, {
              active: true
            });
          }
          resolve(true);
        });
      });
    }
  }], [{
    key: 'URL_PREFIX',
    get: function get() {
      return 'moz-extension://' + chrome.i18n.getMessage('@@extension_id');
    }
  }]);

  return EditorHandler;
}();

},{"../../../common/qTestContext.js":1,"../../../common/services/model/messageEnum.js":3,"../../../common/services/model/statusEnum.js":4}],7:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TabManager = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _qTestContext = require('../../../common/qTestContext.js');

var _statusEnum = require('../../../common/services/model/statusEnum.js');

var _messageEnum = require('../../../common/services/model/messageEnum.js');

var _editorHandler = require('../background/editorHandler.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TabManager = exports.TabManager = function () {
  function TabManager() {
    _classCallCheck(this, TabManager);
  }

  _createClass(TabManager, null, [{
    key: 'isCapturableTab',
    value: function isCapturableTab(tabUrl) {
      // eslint-disable-next-line no-undef
      if (!tabUrl || tabUrl.length === 0 || tabUrl.match(/(chrome):\/\//gi) || tabUrl.match(/(opera):\/\//gi) || tabUrl.match(/(chrome-extension):\/\//gi) || tabUrl.match(/(chrome-devtools):\/\//gi) || tabUrl.indexOf('about:') >= 0 || tabUrl.indexOf(_editorHandler.EditorHandler.URL_PREFIX) === 0) {
        return false;
      }
      if (_qTestContext.QtestContext.session) {
        if (tabUrl.indexOf(_qTestContext.QtestContext.session.redirectUrl) === 0 || tabUrl.indexOf(_qTestContext.QtestContext.session.url) === 0) {
          return false;
        }
        if (_qTestContext.QtestContext.domainOptions.all) {
          return true;
        }
        if (_qTestContext.QtestContext.domainOptions.include) {
          if (_qTestContext.QtestContext.domainOptions.domains.length === 0) {
            return false;
          }
          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = _qTestContext.QtestContext.domainOptions.domains[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var domain = _step.value;

              if (tabUrl.length >= domain.length && tabUrl.indexOf(domain) >= 0) {
                return true;
              }
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }

          return false;
        } else if (_qTestContext.QtestContext.domainOptions.exclude) {
          if (_qTestContext.QtestContext.domainOptions.domains.length === 0) {
            return true;
          }
          var _iteratorNormalCompletion2 = true;
          var _didIteratorError2 = false;
          var _iteratorError2 = undefined;

          try {
            for (var _iterator2 = _qTestContext.QtestContext.domainOptions.domains[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
              var _domain = _step2.value;

              if (tabUrl.length >= _domain.length && tabUrl.indexOf(_domain) >= 0) {
                return false;
              }
            }
          } catch (err) {
            _didIteratorError2 = true;
            _iteratorError2 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion2 && _iterator2.return) {
                _iterator2.return();
              }
            } finally {
              if (_didIteratorError2) {
                throw _iteratorError2;
              }
            }
          }

          return true;
        }
      }
      return true;
    }
  }, {
    key: 'isExisting',
    value: function isExisting(domains, domainString) {
      if (domains.length === 0) {
        return false;
      }
      var _iteratorNormalCompletion3 = true;
      var _didIteratorError3 = false;
      var _iteratorError3 = undefined;

      try {
        for (var _iterator3 = domains[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
          var domain = _step3.value;

          if (domain.toLowerCase() === domainString.toLowerCase()) {
            return true;
          }
        }
      } catch (err) {
        _didIteratorError3 = true;
        _iteratorError3 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion3 && _iterator3.return) {
            _iterator3.return();
          }
        } finally {
          if (_didIteratorError3) {
            throw _iteratorError3;
          }
        }
      }

      return false;
    }
  }, {
    key: 'getOpeningDomains',
    value: function getOpeningDomains() {
      var _this = this;

      return new Promise(function (resolve) {
        var domains = [];
        return chrome.windows.getAll({
          populate: true
        }, function (wnds) {
          var _iteratorNormalCompletion4 = true;
          var _didIteratorError4 = false;
          var _iteratorError4 = undefined;

          try {
            for (var _iterator4 = wnds[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
              var wd = _step4.value;
              var _iteratorNormalCompletion5 = true;
              var _didIteratorError5 = false;
              var _iteratorError5 = undefined;

              try {
                for (var _iterator5 = wd.tabs[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
                  var tb = _step5.value;

                  if (tb.url && _this.isCapturableTab(tb.url)) {
                    var domain = new URL(tb.url).hostname.trim();
                    if (domain !== '' && !_this.isExisting(domains, domain)) {
                      domains.push(domain.toLowerCase());
                    }
                  }
                }
              } catch (err) {
                _didIteratorError5 = true;
                _iteratorError5 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion5 && _iterator5.return) {
                    _iterator5.return();
                  }
                } finally {
                  if (_didIteratorError5) {
                    throw _iteratorError5;
                  }
                }
              }
            }
          } catch (err) {
            _didIteratorError4 = true;
            _iteratorError4 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion4 && _iterator4.return) {
                _iterator4.return();
              }
            } finally {
              if (_didIteratorError4) {
                throw _iteratorError4;
              }
            }
          }

          resolve(domains);
        });
      });
    }
  }, {
    key: 'registerTabEvents',
    value: function registerTabEvents(register) {
      var _this2 = this;

      this.onCreated = function (tab) {
        if (_this2.isCapturableTab(tab.url)) {
          if (_qTestContext.QtestContext.status.name === _statusEnum.StatusEnum.recording) {
            _this2.updateTabCaptureState(tab.id, 1);
          } else if (_qTestContext.QtestContext.status.name === _statusEnum.StatusEnum.paused) {
            _this2.updateTabCaptureState(tab.id, 2);
          }
        }
      };
      this.onAttached = function (tabId, attachInfo) {};
      this.onDetached = function (tabId, detachInfo) {};
      this.onActivated = function (activeInfo) {
        console.log(new Date().toString() + ' tab activated - tabId: ' + activeInfo.tabId + ', windowId: ' + activeInfo.windowId);
        return chrome.tabs.get(activeInfo.tabId, function (tab) {
          if (tab) {
            _this2.detectCapturableTab(tab);
            if (_this2.isActiveTabCapturable) {
              _this2.sendMessageToQueryDevicePixelRatio(activeInfo.tabId);
            }
          }
        });
      };
      this.onZoomChange = function (zoomChangeInfo) {
        console.log(new Date().toString() + ' zoom changed - tabId: \n      ' + zoomChangeInfo.tabId + ', oldZoomFactor: ' + zoomChangeInfo.oldZoomFactor + ', \n      newZoomFactor: ' + zoomChangeInfo.newZoomFactor);
        if (zoomChangeInfo.oldZoomFactor !== zoomChangeInfo.newZoomFactor) {
          _this2.activeTabDevicePixelRatio = zoomChangeInfo.newZoomFactor;
        }
      };
      this.onFocusChanged = function (windowId) {
        if (windowId !== chrome.windows.WINDOW_ID_NONE) {
          chrome.tabs.query({
            windowId: windowId,
            active: true
          }, function (tabs) {
            if ((tabs ? tabs.length : undefined) > 0) {
              _this2.detectCapturableTab(tabs[0]);
              if (_this2.isActiveTabCapturable) {
                _this2.sendMessageToQueryDevicePixelRatio(tabs[0].id);
              }
            }
          });
        }
      };
      if (register) {
        console.log(new Date().toString() + ' register tab events...');
        chrome.tabs.onCreated.addListener(this.onCreated);
        chrome.tabs.onAttached.addListener(this.onAttached);
        chrome.tabs.onDetached.addListener(this.onDetached);
        chrome.tabs.onActivated.addListener(this.onActivated);
        chrome.tabs.onZoomChange.addListener(this.onZoomChange);
        chrome.windows.onFocusChanged.addListener(this.onFocusChanged);
        chrome.tabs.query({
          windowId: chrome.windows.WINDOW_ID_CURRENT,
          active: true
        }, function (tabs) {
          if ((tabs ? tabs.length : undefined) > 0) {
            _this2.detectCapturableTab(tabs[0]);
            if (_this2.isActiveTabCapturable) {
              _this2.sendMessageToQueryDevicePixelRatio(tabs[0].id);
            }
          } else {
            console.log(new Date().toString() + ' unregister tab events...');
            chrome.tabs.onCreated.removeListener(_this2.onCreated);
            chrome.tabs.onAttached.removeListener(_this2.onAttached);
            chrome.tabs.onDetached.removeListener(_this2.onDetached);
            chrome.tabs.onActivated.removeListener(_this2.onActivated);
            chrome.tabs.onZoomChange.removeListener(_this2.onZoomChange);
            chrome.windows.onFocusChanged.removeListener(_this2.onFocusChanged);
            _this2.isActiveTabCapturable = false;
            _this2.canCaptureFullPageOfActiveTab = false;
          }
        });
      }
    }
  }, {
    key: 'detectCapturableTab',
    value: function detectCapturableTab(tab) {
      if (tab ? tab.url : undefined) {
        this.isActiveTabCapturable = this.isCapturableTab(tab.url);
        this.canCaptureFullPageOfActiveTab = this.isActiveTabCapturable;
        console.log(new Date().toString() + ' tab \'' + tab.url + '\' is capturable: ' + this.isActiveTabCapturable);
      }
    }
  }, {
    key: 'updateTabCaptureState',
    value: function updateTabCaptureState(tabId, state) {
      var msg = {
        name: 'initCapture',
        state: state,
        defaultDevicePixelRatio: this.defaultDevicePixelRatio
      };
      try {
        return chrome.tabs.sendMessage(tabId, msg, function (response) {});
      } catch (error) {
        return console.log(error);
      }
    }
  }, {
    key: 'sendMessageToQueryDevicePixelRatio',
    value: async function sendMessageToQueryDevicePixelRatio(tabId) {
      var _this3 = this;

      try {
        await chrome.tabs.sendMessage(tabId, {
          name: _messageEnum.MessageEnum.devicePixelRatio
        }, function (response) {
          if (response ? response.devicePixelRatio : undefined) {
            console.log(new Date().toString() + ' current tab\'s devicePixelRatio: ' + response.devicePixelRatio);
            _this3.activeTabDevicePixelRatio = response.devicePixelRatio;
          }
        });
      } catch (error) {
        console.log(error);
      }
    }
  }, {
    key: 'sendUpdateTabCaptureState',
    value: async function sendUpdateTabCaptureState(state) {
      var _this4 = this;

      await chrome.windows.getAll({
        populate: true
      }, async function (wnds) {
        var _iteratorNormalCompletion6 = true;
        var _didIteratorError6 = false;
        var _iteratorError6 = undefined;

        try {
          for (var _iterator6 = wnds[Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
            var wd = _step6.value;
            var _iteratorNormalCompletion7 = true;
            var _didIteratorError7 = false;
            var _iteratorError7 = undefined;

            try {
              for (var _iterator7 = wd.tabs[Symbol.iterator](), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
                var tb = _step7.value;

                if (tb.url.indexOf(_editorHandler.EditorHandler.URL_PREFIX < 0)) {
                  try {
                    _this4.updateTabCaptureState(tb.id, state);
                  } catch (error) {
                    console.log(new Date().toString() + ' updateTabCaptureState for tab ' + tb.id + ' | ' + tb.url + ' failed: ' + error);
                  }
                }
              }
            } catch (err) {
              _didIteratorError7 = true;
              _iteratorError7 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion7 && _iterator7.return) {
                  _iterator7.return();
                }
              } finally {
                if (_didIteratorError7) {
                  throw _iteratorError7;
                }
              }
            }
          }
        } catch (err) {
          _didIteratorError6 = true;
          _iteratorError6 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion6 && _iterator6.return) {
              _iterator6.return();
            }
          } finally {
            if (_didIteratorError6) {
              throw _iteratorError6;
            }
          }
        }
      });
    }
  }, {
    key: 'showAlert',
    value: function showAlert(tabId, errorMessage) {
      var msg = {
        name: 'showError',
        error: errorMessage
      };
      try {
        chrome.tabs.sendMessage(tabId, msg);
      } catch (error) {
        console.log(error);
      }
    }
  }, {
    key: 'openSessionReview',
    value: function openSessionReview(url, redirectUrl, createIfNotExists) {
      chrome.windows.getAll({
        populate: true
      }, function (wnds) {
        var tab = null;
        var _iteratorNormalCompletion8 = true;
        var _didIteratorError8 = false;
        var _iteratorError8 = undefined;

        try {
          for (var _iterator8 = wnds[Symbol.iterator](), _step8; !(_iteratorNormalCompletion8 = (_step8 = _iterator8.next()).done); _iteratorNormalCompletion8 = true) {
            var wd = _step8.value;

            if (tab) {
              break;
            }
            var _iteratorNormalCompletion9 = true;
            var _didIteratorError9 = false;
            var _iteratorError9 = undefined;

            try {
              for (var _iterator9 = wd.tabs[Symbol.iterator](), _step9; !(_iteratorNormalCompletion9 = (_step9 = _iterator9.next()).done); _iteratorNormalCompletion9 = true) {
                var tb = _step9.value;

                if (tb.url.indexOf(redirectUrl) === 0) {
                  tab = tb;
                  break;
                }
              }
            } catch (err) {
              _didIteratorError9 = true;
              _iteratorError9 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion9 && _iterator9.return) {
                  _iterator9.return();
                }
              } finally {
                if (_didIteratorError9) {
                  throw _iteratorError9;
                }
              }
            }
          }
        } catch (err) {
          _didIteratorError8 = true;
          _iteratorError8 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion8 && _iterator8.return) {
              _iterator8.return();
            }
          } finally {
            if (_didIteratorError8) {
              throw _iteratorError8;
            }
          }
        }

        if (tab) {
          chrome.windows.update(tab.windowId, {
            focused: true
          });
          chrome.tabs.update(tab.id, {
            url: url,
            active: true
          });
        } else if (createIfNotExists) {
          chrome.tabs.query({
            windowId: chrome.windows.WINDOW_ID_CURRENT,
            active: true
          }, function (tabs) {
            if (tabs && tabs.length > 0) {
              tab = tabs[0];
              chrome.tabs.create({
                index: tab.index + 1,
                url: url
              }, function () {});
            } else {
              chrome.tabs.create({
                url: url
              }, function () {});
            }
          });
        }
      });
    }
  }, {
    key: 'activeTabDevicePixelRatio',
    get: function get() {
      return this._activeTabDevicePixelRatio || 1;
    },
    set: function set(value) {
      this._activeTabDevicePixelRatio = value;
    }
  }, {
    key: 'defaultDevicePixelRatio',
    get: function get() {
      return this._defaultDevicePixelRatio || null;
    },
    set: function set(value) {
      this._defaultDevicePixelRatio = value;
    }
  }, {
    key: 'isActiveTabCapturable',
    get: function get() {
      if (this._isActiveTabCapturable === undefined) {
        return true;
      }
      return this._isActiveTabCapturable;
    },
    set: function set(value) {
      this._isActiveTabCapturable = value;
    }
  }, {
    key: 'canCaptureFullPageOfActiveTab',
    get: function get() {
      if (this._canCaptureFullPageOfActiveTabs === undefined) {
        return true;
      }
      return this._canCaptureFullPageOfActiveTabs;
    },
    set: function set(value) {
      this._canCaptureFullPageOfActiveTab = value;
    }
  }]);

  return TabManager;
}();

},{"../../../common/qTestContext.js":1,"../../../common/services/model/messageEnum.js":3,"../../../common/services/model/statusEnum.js":4,"../background/editorHandler.js":6}]},{},[2]);
