(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.QtestContext = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _statusEnum = require('./services/model/statusEnum.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var QtestContext = exports.QtestContext = function () {
  function QtestContext() {
    _classCallCheck(this, QtestContext);
  }

  _createClass(QtestContext, null, [{
    key: 'clear',
    value: function clear() {
      this._user = null;
      this._session = null;
      this._projects = [];
      this._selectedProject = null;
      this._timeTypes = [];
      this._noteTypes = [];
      this._pendingAnnotations = [];
      this._currentProcessingScreen = null;
      this._domainOptions = null;
      this._runFromQtest = false;
      this._projectId = null;
      this._sessionId = null;
      this._status = {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    }
  }, {
    key: 'canRecordMedia',
    value: function canRecordMedia() {
      return this._qTestVersion && this._qTestVersion >= 6;
    }
  }, {
    key: 'getProjectAutoStartSupported',
    value: function getProjectAutoStartSupported() {
      var result = [];
      if (this._projects) {
        var ref = this._projects;
        for (var j = 0, len = ref.length; j < len; j++) {
          var p = ref[j];
          if (p.alwaysOnSetting.domains.length > 0 && p.alwaysOnSetting.enabled) {
            result.push(p);
          }
        }
      }
      return result;
    }
  }, {
    key: 'qTestVersion',
    get: function get() {
      return this._qTestVersion || null;
    },
    set: function set(qTestVersion) {
      this._qTestVersion = qTestVersion;
    }
  }, {
    key: 'qTestMinorVersion',
    get: function get() {
      return this._qTestMinorVersion || null;
    },
    set: function set(qTestMinorVersion) {
      this._qTestMinorVersion = qTestMinorVersion;
    }
  }, {
    key: 'session',
    get: function get() {
      return this._session || null;
    },
    set: function set(session) {
      this._session = session;
    }
  }, {
    key: 'user',
    get: function get() {
      return this._user || null;
    },
    set: function set(user) {
      this._user = user;
    }
  }, {
    key: 'projects',
    get: function get() {
      if (!this._projects) {
        this._projects = [];
      }
      return this._projects;
    },
    set: function set(projects) {
      this._projects = projects;
    }
  }, {
    key: 'selectedProject',
    get: function get() {
      return this._selectedProject || null;
    },
    set: function set(selectedProject) {
      this._selectedProject = selectedProject;
    }
  }, {
    key: 'timeTypes',
    get: function get() {
      if (!this._timeTypes) {
        this._timeTypes = [];
      }
      return this._timeTypes;
    },
    set: function set(timeTypes) {
      this._timeTypes = timeTypes;
    }
  }, {
    key: 'noteTypes',
    get: function get() {
      if (!this._noteTypes) {
        this._noteTypes = [];
      }
      return this._noteTypes;
    },
    set: function set(noteTypes) {
      this._noteTypes = noteTypes;
    }
  }, {
    key: 'pendingAnnotations',
    get: function get() {
      if (!this._pendingAnnotations) {
        this._pendingAnnotations = [];
      }
      return this._pendingAnnotations;
    },
    set: function set(pendingAnnotations) {
      this._pendingAnnotations = pendingAnnotations;
    }
  }, {
    key: 'currentProcessingScreen',
    get: function get() {
      return this._currentProcessingScreen || null;
    },
    set: function set(currentProcessingScreen) {
      this._currentProcessingScreen = currentProcessingScreen;
    }
  }, {
    key: 'domainOptions',
    get: function get() {
      return this._domainOptions || null;
    },
    set: function set(domainOptions) {
      this._domainOptions = domainOptions;
    }
  }, {
    key: 'runFromQtest',
    get: function get() {
      return this._runFromQtest || false;
    },
    set: function set(runFromQtest) {
      this._runFromQtest = runFromQtest;
    }
  }, {
    key: 'projectId',
    get: function get() {
      return this._projectId || null;
    },
    set: function set(projectId) {
      this._projectId = projectId;
    }
  }, {
    key: 'sessionId',
    get: function get() {
      return this._sessionId || null;
    },
    set: function set(sessionId) {
      this._sessionId = sessionId;
    }
  }, {
    key: 'status',
    get: function get() {
      return this._status || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._status = value;
    }
  }, {
    key: 'currentqTestSession',
    get: function get() {
      return this._currentqTestSession || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._currentqTestSession = value;
    }
  }, {
    key: 'sessionManagerVersion',
    get: function get() {
      return this._sessionManagerVersion || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._sessionManagerVersion = value;
    }
  }]);

  return QtestContext;
}();

},{"./services/model/statusEnum.js":6}],2:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ApplicationInfo = exports.ApplicationInfo = function ApplicationInfo(name, version, fileVersion) {
  _classCallCheck(this, ApplicationInfo);

  this.name = name;
  this.version = version;
  this.fileVersion = fileVersion;
};

},{}],3:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Hotkey = exports.Hotkey = function () {
  function Hotkey(altKey, shiftKey, keyCode) {
    _classCallCheck(this, Hotkey);

    this.altKey = altKey;
    this.shiftKey = shiftKey;
    this.keyCode = keyCode;
  }

  _createClass(Hotkey, [{
    key: 'build',
    value: function build() {
      var hotkeyString = 'ctrl';
      if (this.altKey) {
        hotkeyString = hotkeyString + '+alt';
      }
      if (this.shiftKey) {
        hotkeyString = hotkeyString + '+shift';
      }
      hotkeyString = hotkeyString + '+' + this.keyCode;
      return hotkeyString.toLowerCase();
    }
  }]);

  return Hotkey;
}();

},{}],4:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var HotkeySetting = exports.HotkeySetting = function HotkeySetting() {
  _classCallCheck(this, HotkeySetting);

  this.stopRecording = null;
  this.pauseResumeRecording = null;
  this.captureVisiblePart = null;
  this.captureFullPage = null;
  this.recordVideo = null;
  this.recordAudio = null;
};

},{}],5:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Setting = exports.Setting = function Setting() {
  _classCallCheck(this, Setting);

  this.version = null;
  this.hotkeySetting = null;
  this.webExplorerSetting = null;
};

},{}],6:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var StatusEnum = exports.StatusEnum = {
  notLoggedIn: 'notLoggedIn',

  loggingIn: 'loggingIn',

  loggedIn: 'loggedIn',

  loadingServerSession: 'loadingServerSession',

  loadedServerSession: 'loadedServerSession',

  startingSession: 'startingSession',

  startingSessionIndicator: 'startingSessionIndicator',

  recording: 'recording',

  editing: 'editing',

  paused: 'paused',

  capturingFullPage: 'capturingFullPage',

  inProgress: 'inProgress',

  completingSession: 'completingSession',

  recordingMedia: 'recordingMedia'
};

},{}],7:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SystemInfo = exports.SystemInfo = function SystemInfo(os, resolutions, appVersion) {
  _classCallCheck(this, SystemInfo);

  this.os = os;
  this.resolutions = resolutions;
  this.appVersion = appVersion;
};

},{}],8:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var WebExplorerSetting = exports.WebExplorerSetting = function WebExplorerSetting() {
  _classCallCheck(this, WebExplorerSetting);

  this.enableAutoLogin = true;
  this.autoLogin = true;
};

},{}],9:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SettingService = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _storage = require('./storage.js');

var _setting = require('./model/setting.js');

var _hotkey = require('./model/hotkey.js');

var _hotkeySetting = require('./model/hotkeySetting.js');

var _config = require('./../../extension/js/background/config.js');

var _webExplorerSetting = require('./model/webExplorerSetting.js');

var _qTestContext = require('../qTestContext.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SettingService = exports.SettingService = function () {
  function SettingService() {
    _classCallCheck(this, SettingService);
  }

  _createClass(SettingService, null, [{
    key: 'load',
    value: function load() {
      var dynamicObject = _storage.Storage.get('settings');
      if (dynamicObject) {
        var dynamicHS = dynamicObject.hotkeySetting;
        var settings = new _setting.Setting();
        if (dynamicObject.version) {
          settings.version = dynamicObject.version;
        } else {
          settings.version = _config.App.version;
        }
        settings.hotkeySetting = new _hotkeySetting.HotkeySetting();
        settings.hotkeySetting.captureVisiblePart = new _hotkey.Hotkey(dynamicHS.captureVisiblePart.altKey, dynamicHS.captureVisiblePart.shiftKey, dynamicHS.captureVisiblePart.keyCode);
        settings.hotkeySetting.captureFullPage = new _hotkey.Hotkey(dynamicHS.captureFullPage.altKey, dynamicHS.captureFullPage.shiftKey, dynamicHS.captureFullPage.keyCode);
        if (dynamicHS.stopRecording) {
          settings.hotkeySetting.stopRecording = new _hotkey.Hotkey(dynamicHS.stopRecording.altKey, dynamicHS.stopRecording.shiftKey, dynamicHS.stopRecording.keyCode);
        }
        if (dynamicHS.pauseResumeRecording) {
          // eslint-disable-next-line max-len
          settings.hotkeySetting.pauseResumeRecording = new _hotkey.Hotkey(dynamicHS.pauseResumeRecording.altKey, dynamicHS.pauseResumeRecording.shiftKey, dynamicHS.pauseResumeRecording.keyCode);
        }
        if (dynamicHS.recordVideo) {
          settings.hotkeySetting.recordVideo = new _hotkey.Hotkey(dynamicHS.recordVideo.altKey, dynamicHS.recordVideo.shiftKey, dynamicHS.recordVideo.keyCode);
        }
        if (dynamicHS.recordAudio) {
          settings.hotkeySetting.recordAudio = new _hotkey.Hotkey(dynamicHS.recordAudio.altKey, dynamicHS.recordAudio.shiftKey, dynamicHS.recordAudio.keyCode);
        }

        settings.webExplorerSetting = new _webExplorerSetting.WebExplorerSetting();
        var dynamicGS = dynamicObject.webExplorerSetting;
        if (dynamicGS) {
          settings.webExplorerSetting.enableAutoLogin = dynamicGS.enableAutoLogin;
          settings.webExplorerSetting.autoLogin = dynamicGS.autoLogin;
        }

        return settings;
      }
      return undefined;
    }
  }, {
    key: 'save',
    value: function save(settings) {
      if (settings) {
        _storage.Storage.set('settings', JSON.stringify(settings), {
          secure: true
        });

        if (settings.webExplorerSetting && _qTestContext.QtestContext.user) {
          if (settings.webExplorerSetting.autoLogin) {
            var credentialsString = _qTestContext.QtestContext.user.getUserCredentials();
            _storage.Storage.set('credentials', credentialsString, {
              secure: true
            });
          } else {
            _storage.Storage.remove('credentials');
          }
        }
      } else {
        _storage.Storage.remove('settings');
      }
    }
  }]);

  return SettingService;
}();

},{"../qTestContext.js":1,"./../../extension/js/background/config.js":11,"./model/hotkey.js":3,"./model/hotkeySetting.js":4,"./model/setting.js":5,"./model/webExplorerSetting.js":8,"./storage.js":10}],10:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ___ = ['\x6D\x74\x26\x79\x6B\x4E\x57\x55\x62\x4E\x49\x65\x52\x26\x34\x33'][0];

var Storage = exports.Storage = function () {
  function Storage() {
    _classCallCheck(this, Storage);
  }

  _createClass(Storage, null, [{
    key: 'encrypt',
    value: function encrypt(vString) {
      // eslint-disable-next-line no-undef
      return sjcl.encrypt(___, vString);
    }
  }, {
    key: 'decrypt',
    value: function decrypt(vString) {
      // eslint-disable-next-line no-undef
      return sjcl.decrypt(___, vString);
    }

    // get(k: string): Object

  }, {
    key: 'get',
    value: function get(k) {
      try {
        var vString = localStorage.getItem(k);
        if (!vString) {
          return null;
        }

        var obj = JSON.parse(vString);
        if (obj.cipher && obj.salt && obj.mode) {
          obj = JSON.parse(this.decrypt(vString));
        }

        // backward compatible: old version stringify the obj multiple times
        if (typeof obj === 'string') {
          try {
            var tempObj = JSON.parse(obj);
            obj = tempObj;
            // eslint-disable-next-line no-empty
          } catch (e) {}
        }

        if (obj.expires) {
          // check expiration
          var now = new Date();
          var expires = new Date(obj.expires);
          if (now.getTime() >= expires.getTime()) {
            console.error('Storage "' + k + '" expired on ' + obj.expires);
            this.remove(k);
            return null;
          }
        }

        return obj;
      } catch (error) {
        console.log(error);
        return null;
      }
    }

    // set(k: string, vString: string, opts: { secure: boolean })

  }, {
    key: 'set',
    value: function set(k, vString) {
      var opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      if (!vString) {
        this.remove(k);
        return;
      }

      localStorage.setItem(k, opts.secure ? this.encrypt(vString) : vString);
    }
  }, {
    key: 'remove',
    value: function remove(k) {
      localStorage.removeItem(k);
    }
  }]);

  return Storage;
}();

},{}],11:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.App = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _systemInfo = require('../../../common/services/model/systemInfo.js');

var _applicationInfo = require('../../../common/services/model/applicationInfo.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var fileVersion = '';
var browserName = '';
var firefoxVersion = '';
var osName = '';
var nAgt = window.navigator.userAgent;
var verOffset = nAgt.indexOf('Firefox');
if (verOffset !== -1) {
  browserName = 'firefox';
  fileVersion = nAgt.substring(verOffset + 8);
  firefoxVersion = parseInt(fileVersion, 10);
}
var mozillaExp = nAgt.match(/Mozilla\/(.*?) /);
if (mozillaExp && mozillaExp.length > 0) {
  var mozillaExp2 = /Mozilla\//;
  var osExp = /\((.*?)\)/;
  osName = navigator.userAgent.match(new RegExp(String(mozillaExp2.source) + mozillaExp[1] + ' ' + osExp.source))[1];
}

var App = exports.App = function () {
  function App() {
    _classCallCheck(this, App);
  }

  _createClass(App, null, [{
    key: 'manifest',
    get: function get() {
      return this._manifest || chrome.runtime.getManifest();
    }
  }, {
    key: 'name',
    get: function get() {
      return this.manifest.name;
    }
  }, {
    key: 'version',
    get: function get() {
      return this.manifest.version;
    }
  }, {
    key: 'apiVersion',
    get: function get() {
      return this.manifest.apiVersion;
    }
  }, {
    key: 'scaleBeforeCompare',
    get: function get() {
      return this._scaleBeforeCompare || true;
    },
    set: function set(value) {
      this._scaleBeforeCompare = value;
    }
  }, {
    key: 'fileVersion',
    get: function get() {
      if (mozillaExp && mozillaExp.length > 0) {
        return mozillaExp[1];
      }
      return -1;
    }
  }, {
    key: 'systemInfo',
    get: function get() {
      var width = window.screen.width * window.devicePixelRatio;
      var height = window.screen.height * window.devicePixelRatio;
      return new _systemInfo.SystemInfo(osName, width + 'x' + height, this.version);
    }
  }, {
    key: 'applicationInfo',
    get: function get() {
      return new _applicationInfo.ApplicationInfo(browserName, firefoxVersion, fileVersion);
    }
  }]);

  return App;
}();

},{"../../../common/services/model/applicationInfo.js":2,"../../../common/services/model/systemInfo.js":7}]},{},[9]);
