(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.QtestContext = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _statusEnum = require('./services/model/statusEnum.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var QtestContext = exports.QtestContext = function () {
  function QtestContext() {
    _classCallCheck(this, QtestContext);
  }

  _createClass(QtestContext, null, [{
    key: 'clear',
    value: function clear() {
      this._user = null;
      this._session = null;
      this._projects = [];
      this._selectedProject = null;
      this._timeTypes = [];
      this._noteTypes = [];
      this._pendingAnnotations = [];
      this._currentProcessingScreen = null;
      this._domainOptions = null;
      this._runFromQtest = false;
      this._projectId = null;
      this._sessionId = null;
      this._status = {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    }
  }, {
    key: 'canRecordMedia',
    value: function canRecordMedia() {
      return this._qTestVersion && this._qTestVersion >= 6;
    }
  }, {
    key: 'getProjectAutoStartSupported',
    value: function getProjectAutoStartSupported() {
      var result = [];
      if (this._projects) {
        var ref = this._projects;
        for (var j = 0, len = ref.length; j < len; j++) {
          var p = ref[j];
          if (p.alwaysOnSetting.domains.length > 0 && p.alwaysOnSetting.enabled) {
            result.push(p);
          }
        }
      }
      return result;
    }
  }, {
    key: 'qTestVersion',
    get: function get() {
      return this._qTestVersion || null;
    },
    set: function set(qTestVersion) {
      this._qTestVersion = qTestVersion;
    }
  }, {
    key: 'qTestMinorVersion',
    get: function get() {
      return this._qTestMinorVersion || null;
    },
    set: function set(qTestMinorVersion) {
      this._qTestMinorVersion = qTestMinorVersion;
    }
  }, {
    key: 'session',
    get: function get() {
      return this._session || null;
    },
    set: function set(session) {
      this._session = session;
    }
  }, {
    key: 'user',
    get: function get() {
      return this._user || null;
    },
    set: function set(user) {
      this._user = user;
    }
  }, {
    key: 'projects',
    get: function get() {
      if (!this._projects) {
        this._projects = [];
      }
      return this._projects;
    },
    set: function set(projects) {
      this._projects = projects;
    }
  }, {
    key: 'selectedProject',
    get: function get() {
      return this._selectedProject || null;
    },
    set: function set(selectedProject) {
      this._selectedProject = selectedProject;
    }
  }, {
    key: 'timeTypes',
    get: function get() {
      if (!this._timeTypes) {
        this._timeTypes = [];
      }
      return this._timeTypes;
    },
    set: function set(timeTypes) {
      this._timeTypes = timeTypes;
    }
  }, {
    key: 'noteTypes',
    get: function get() {
      if (!this._noteTypes) {
        this._noteTypes = [];
      }
      return this._noteTypes;
    },
    set: function set(noteTypes) {
      this._noteTypes = noteTypes;
    }
  }, {
    key: 'pendingAnnotations',
    get: function get() {
      if (!this._pendingAnnotations) {
        this._pendingAnnotations = [];
      }
      return this._pendingAnnotations;
    },
    set: function set(pendingAnnotations) {
      this._pendingAnnotations = pendingAnnotations;
    }
  }, {
    key: 'currentProcessingScreen',
    get: function get() {
      return this._currentProcessingScreen || null;
    },
    set: function set(currentProcessingScreen) {
      this._currentProcessingScreen = currentProcessingScreen;
    }
  }, {
    key: 'domainOptions',
    get: function get() {
      return this._domainOptions || null;
    },
    set: function set(domainOptions) {
      this._domainOptions = domainOptions;
    }
  }, {
    key: 'runFromQtest',
    get: function get() {
      return this._runFromQtest || false;
    },
    set: function set(runFromQtest) {
      this._runFromQtest = runFromQtest;
    }
  }, {
    key: 'projectId',
    get: function get() {
      return this._projectId || null;
    },
    set: function set(projectId) {
      this._projectId = projectId;
    }
  }, {
    key: 'sessionId',
    get: function get() {
      return this._sessionId || null;
    },
    set: function set(sessionId) {
      this._sessionId = sessionId;
    }
  }, {
    key: 'status',
    get: function get() {
      return this._status || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._status = value;
    }
  }, {
    key: 'currentqTestSession',
    get: function get() {
      return this._currentqTestSession || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._currentqTestSession = value;
    }
  }, {
    key: 'sessionManagerVersion',
    get: function get() {
      return this._sessionManagerVersion || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._sessionManagerVersion = value;
    }
  }]);

  return QtestContext;
}();

},{"./services/model/statusEnum.js":10}],2:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HttpRequest = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _qTestContext = require('../qTestContext.js');

var _config = require('../../extension/js/background/config.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var HttpRequest = exports.HttpRequest = function () {
  function HttpRequest() {
    _classCallCheck(this, HttpRequest);
  }

  _createClass(HttpRequest, null, [{
    key: 'getCommonHeaders',
    value: function getCommonHeaders() {
      var headers = {
        'x-client-name': _config.App.name,
        'x-client-version': _config.App.version,
        'x-explorer-api-version': _config.App.apiVersion
      };
      return headers;
    }
  }, {
    key: 'send',
    value: function send(url, token, sendType, data) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        var headers = _this.getCommonHeaders();
        if (token) {
          headers.Authorization = _qTestContext.QtestContext.qTestVersion >= 7 ? 'bearer ' + token : token;
        }
        if (headers && _qTestContext.QtestContext.ownerToken) {
          headers['x-qtest-owner-token'] = _qTestContext.QtestContext.ownerToken;
        }

        // eslint-disable-next-line no-undef
        $.ajax({
          type: sendType,
          url: url,
          data: data,
          contentType: 'application/json;charset=UTF-8',
          dataType: token ? 'json' : null,
          headers: headers
        }).done(function (resultData) {
          resolve({
            data: resultData
          });
        }).fail(function (jqXHR, textStatus, errorThrown) {
          if (jqXHR.status === 200) {
            resolve({});
          } else {
            resolve({
              status: jqXHR.status,
              error: errorThrown
            });
          }
        });
      });
    }
  }, {
    key: 'sendWithResponse',
    value: function sendWithResponse(url, token, sendType, data) {
      var _this2 = this;

      return new Promise(function (resolve, reject) {
        var headers = _this2.getCommonHeaders();
        if (token) {
          headers.Authorization = _qTestContext.QtestContext.qTestVersion >= 7 ? 'bearer ' + token : token;
        }
        if (headers && _qTestContext.QtestContext.ownerToken) {
          headers['x-qtest-owner-token'] = _qTestContext.QtestContext.ownerToken;
        }
        // eslint-disable-next-line no-undef
        $.ajax({
          type: sendType,
          url: url,
          data: data,
          contentType: 'application/json;charset=UTF-8',
          dataType: token ? 'json' : null,
          headers: headers
        }).done(function (resultData, status, xhr) {
          resolve({
            data: resultData,
            response: xhr
          });
        }).fail(function (jqXHR, textStatus, errorThrown) {
          if (jqXHR.status === 200) {
            resolve({});
          } else {
            resolve({
              status: jqXHR.status,
              error: errorThrown
            });
          }
        });
      });
    }
  }, {
    key: 'upload',
    value: function upload(url, token, filename, binaryData, contentType) {
      var _this3 = this;

      return new Promise(function (resolve, reject) {
        if (!binaryData) {
          resolve({
            error: 'HttpRequest: error: No binary data'
          });
          return;
        }
        var oReq = new XMLHttpRequest();
        oReq.open('POST', url, true);
        var headers = _this3.getCommonHeaders();
        if (token) {
          headers.Authorization = _qTestContext.QtestContext.qTestVersion >= 7 ? 'bearer ' + token : token;
        }
        headers['Content-Type'] = contentType;
        headers['x-filename'] = filename;
        // eslint-disable-next-line no-undef
        $.each(headers, function (key, value) {
          if (Object.prototype.hasOwnProperty.call(headers, key) && !(value instanceof Function)) {
            oReq.setRequestHeader(key, value);
          }
        });
        oReq.onload = function (oEvent) {
          var data = oReq.response;
          var responseStatus = oReq.status;
          console.log(new Date().toString() + ' HttpRequest: finished uploading binary data, response status: \'' + responseStatus + '\', response data: \'' + data + '\'...');
          oReq.abort();
          if (responseStatus === 200 || responseStatus === 201) {
            resolve({
              data: JSON.parse(data)
            });
          } else {
            resolve({
              error: responseStatus + 'ERROR'
            });
          }
        };
        oReq.onerror = function (oEvent) {
          resolve({
            error: 'HttpRequest: error :' + oEvent.error
          });
        };
        oReq.send(binaryData);
      });
    }
  }]);

  return HttpRequest;
}();

},{"../../extension/js/background/config.js":18,"../qTestContext.js":1}],3:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MessagingService = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _sendStatusEnum = require('./model/sendStatusEnum.js');

var _DateUtils = require('./utils/DateUtils.js');

var _httpRequest = require('./httpRequest.js');

var _qTestContext = require('../qTestContext.js');

var _config = require('../../extension/js/background/config.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MessagingService = exports.MessagingService = function () {
  function MessagingService(baseURL, token) {
    _classCallCheck(this, MessagingService);

    this.baseURL = baseURL;
    this.token = token;
  }

  _createClass(MessagingService, [{
    key: 'getSessionJson',
    value: function getSessionJson(session, sendCaptureDate) {
      var sysInfoJson = {
        app_version: _config.App.systemInfo.appVersion,
        incl_app_version: true,
        os: _config.App.systemInfo.os,
        incl_os: true,
        resolutions: _config.App.systemInfo.resolutions,
        incl_resolutions: true
      };
      var appInfoJson = {
        name: _config.App.applicationInfo.name,
        file_version: _config.App.applicationInfo.fileVersion,
        incl_file_version: true,
        version: _config.App.applicationInfo.version,
        incl_version: true
      };
      var json = {
        client_name: 'qTestWebeXplorer',
        project_id: session.project,
        title: session.title,
        desc: session.description,
        planned_duration: session.plannedDuration.hour * 3600 + session.plannedDuration.min * 60,
        sys_info: sysInfoJson,
        app_infos: [appInfoJson],
        tester_name: session.tester,
        has_meta_data: true
      };
      if (sendCaptureDate) {
        var capturedDate = _DateUtils.DateUtils.getDateString(new Date());
        json.captured_date = capturedDate;
        json.doc = {
          captured_date: capturedDate
        };
      }
      return json;
    }
  }, {
    key: 'sendCreateSession',
    value: async function sendCreateSession(session) {
      if (session.sendStatus && session.sendStatus !== _sendStatusEnum.SendStatusEnum.notSent) {
        return {
          success: true
        };
      }
      session.sendStatus = _sendStatusEnum.SendStatusEnum.sending;
      var url = this.baseURL + '/sessions';
      var json = this.getSessionJson(session, true);
      json.owner_user = session.tester;
      json.edit_user = session.tester;
      json.tester_name = session.tester;
      json.status = 'running';
      console.log(new Date().toString() + ' about to send create session...');

      var res = await _httpRequest.HttpRequest.send(url, this.token, 'POST', JSON.stringify(json));
      console.log(new Date().toString() + ' finished creating session...');
      if (res.error) {
        session.sendStatus = _sendStatusEnum.SendStatusEnum.error;
      } else {
        _qTestContext.QtestContext.ownerToken = res.data.owner_token;
        session.id = res.data.id;
        session.sendStatus = _sendStatusEnum.SendStatusEnum.sent;
        session.status = 'running';
        this.buildRedirectUrl(session);
      }
      return {
        success: res.error == null, // should be ==
        error: res.error
      };
    }
  }, {
    key: 'buildRedirectUrl',
    value: function buildRedirectUrl(session) {
      var redirectUrl = '';
      var version = _qTestContext.QtestContext.sessionManagerVersion;

      if ((version ? version.major : undefined) >= 3) {
        redirectUrl = _qTestContext.QtestContext.user.url + '/p/' + _qTestContext.QtestContext.session.project + '/portal/session/' + session.id + '/review';
        session.redirectUrl = _qTestContext.QtestContext.user.apiURL + '/' + session.id + '/review';
      } else if (_qTestContext.QtestContext.qTestVersion >= 7) {
        redirectUrl = _qTestContext.QtestContext.user.url + '/p/' + _qTestContext.QtestContext.session.project + '/portal/session/' + session.id + '/review';
        session.redirectUrl = redirectUrl;
      } else {
        redirectUrl = _qTestContext.QtestContext.user.url + '/p/' + _qTestContext.QtestContext.session.project + '/portal/session/playback/' + session.id;
        session.redirectUrl = redirectUrl;
      }
      var encodedRedirectUrl = encodeURIComponent(redirectUrl);
      session.url = _qTestContext.QtestContext.user.url + '/portal/loginform?token=' + _qTestContext.QtestContext.user.token + '&redirect=' + encodedRedirectUrl;
    }
  }, {
    key: 'sendUpdateSession',
    value: async function sendUpdateSession(session, sendCaptureDate) {
      if (!session.sendStatus) {
        return {
          success: false
        };
      }
      var url = this.baseURL + '/sessions/' + session.id;
      var json = this.getSessionJson(session, sendCaptureDate);
      json.time_lines = [];
      var order = 0;
      var actualDuration = 0;
      var ref = _qTestContext.QtestContext.timeTypes;
      for (var i = 0, len = ref.length; i < len; i++) {
        var timeType = ref[i];
        var jsonTimeLine = {
          total_time: 0,
          order: order++,
          time_type: {
            id: timeType.id,
            name: timeType.name,
            color: timeType.color
          }
        };
        json.time_lines.push(jsonTimeLine);
        var timelines = session.timeLines;
        for (var j = 0, len1 = timelines.length; j < len1; j++) {
          var timeLine = timelines[j];
          if (timeLine.timeType.name === timeType.name) {
            jsonTimeLine.total_time += timeLine.totalTime;
          }
        }
        actualDuration += jsonTimeLine.total_time;
      }
      json.actual_duration = actualDuration;

      var res = await _httpRequest.HttpRequest.send(url, this.token, 'PUT', JSON.stringify(json));
      if (res.error) {
        console.error('sendUpdateSession error - status: ' + res.status + ', error: ' + res.error);
      } else {
        this.buildRedirectUrl(session);
      }
      return {
        success: !res.error,
        error: res.error
      };
    }
  }, {
    key: 'sendUpdateSessionStatus',
    value: async function sendUpdateSessionStatus(session, status) {
      var url = this.baseURL + '/sessions/' + session.id + '/status';
      console.log(new Date().toString() + ' about to send update session status \'' + status + '\'...');
      var res = await _httpRequest.HttpRequest.send(url, this.token, 'PUT', '{ "status": "' + status + '" }');
      console.log(new Date().toString() + ' finished updating session status \'' + status + '\'...');
      if (!res.error) {
        session.status = status;
        if (status === 'running') {
          if (!res.data || !res.data.owner_token) {
            console.error(new Date().toString() + ' updating session status error: missing Owner Token...');
            return {
              success: false,
              error: 'missing Owner Token'
            };
          }
          console.log(new Date().toString() + ' obtained Owner Token...');
          _qTestContext.QtestContext.ownerToken = res.data.owner_token;
        }
      }
      return {
        success: !res.error,
        error: res.error
      };
    }
  }, {
    key: 'processUploadScreen',
    value: async function processUploadScreen(sessionId, screen, url) {
      var annotations = [];
      var ref = screen.annotations;
      for (var i = 0, len = ref.length; i < len; i++) {
        var annotation = ref[i];
        var actionJSON = annotation.getJson();
        if (actionJSON.timestamp) {
          actionJSON.timestamp = _DateUtils.DateUtils.getDateString(new Date(actionJSON.timestamp));
        }
        annotations.push(actionJSON);
      }
      var json = {
        order: screen.order,
        title: screen.title,
        browser_url: screen.url,
        capture_mode: 'Form',
        left: 0,
        top: 0,
        width: screen.width,
        height: screen.height,
        app_left: 0,
        app_top: 0,
        app_width: screen.width,
        app_height: screen.height,
        screen_height: screen.height,
        screen_width: screen.width,
        timestamp: _DateUtils.DateUtils.getDateString(new Date(screen.timeStamp)),
        finished_timestamp: _DateUtils.DateUtils.getDateString(new Date(screen.finishedTimestamp)),
        annotations: annotations,
        time_type: screen.timeType ? {
          color: screen.timeType.color,
          name: screen.timeType.name,
          id: screen.timeType.id
        } : null
      };

      var res = await _httpRequest.HttpRequest.send(url, this.token, 'POST', JSON.stringify(json));
      if (res.error) {
        screen.sendStatus = _sendStatusEnum.SendStatusEnum.error;
        console.error(new Date().toString() + ' error sending screen metadata: ' + screen.order + ' to ' + url + ': ' + res.error);
      } else {
        screen.id = res.data.id;
        console.log(new Date().toString() + ' call uploading for screen: ' + res.data.id);
        await this.sendUpload(sessionId, screen);
      }
    }
  }, {
    key: 'processUploadMedia',
    value: async function processUploadMedia(index, sessionId, url, screen, annotationLength) {
      var mediaUploadUrl = this.baseURL + '/upload-objects';
      if (index < annotationLength) {
        var annotation = screen.annotations[index];
        var annotationType = annotation.annotationType;
        if (annotationType === 'Video' || annotationType === 'Audio') {
          var mediaFileName = annotation.description;
          if (annotationType === 'Video') {
            mediaFileName += '.webm';
          } else {
            mediaFileName += '.wav';
          }
          console.log(new Date().toString() + ' about to upload media of type ' + annotationType + ', fileName: ' + mediaFileName);
          var response = await _httpRequest.HttpRequest.upload(mediaUploadUrl, this.token, mediaFileName, annotation.blob, annotation.mimeType);
          if (response.error) {
            console.log(new Date().toString() + ' error uploading media ' + mediaFileName + ': ' + response.error);
          } else {
            annotation.url = response.data.url;
            console.log(new Date().toString() + ' successfully uploading media ' + mediaFileName + ', url: ' + annotation.url);
          }
        }
        var nextIndex = index + 1;
        await this.processUploadMedia(nextIndex, sessionId, url, screen, annotationLength);
      }
    }
  }, {
    key: 'uploadMedia',
    value: async function uploadMedia(sessionId, screen, url) {
      var annotationLength = screen.annotations.length;
      await this.processUploadMedia(0, sessionId, url, screen, annotationLength);
      await this.processUploadScreen(sessionId, screen, url);
    }
  }, {
    key: 'sendCreateScreen',
    value: async function sendCreateScreen(sessionId, screen) {
      if (screen.sendStatus) {
        if (screen.sendStatus === _sendStatusEnum.SendStatusEnum.sent) {
          return;
        } else if (screen.sendStatus === _sendStatusEnum.SendStatusEnum.error) {
          console.error('Error sending screen ' + screen.order());
          return;
        } else if (screen.sendStatus === _sendStatusEnum.SendStatusEnum.sending) {
          return;
        }
      }
      screen.sendStatus = _sendStatusEnum.SendStatusEnum.sending;
      var url = this.baseURL + '/sessions/' + sessionId + '/screens';

      await this.uploadMedia(sessionId, screen, url);
    }
  }, {
    key: 'sendUpload',
    value: async function sendUpload(sessionId, screen) {
      if (screen.sendStatus) {
        if (screen.sendStatus === _sendStatusEnum.SendStatusEnum.sent) {
          return {
            success: true
          };
        } else if (screen.sendStatus !== _sendStatusEnum.SendStatusEnum.sending) {
          return {
            success: false
          };
        }
      }
      var url = this.baseURL + '/sessions/' + sessionId + '/screens/' + screen.id + '/images';
      var fileName = 'Temp';
      var binaryData = screen.screenShotBinary ? new Uint8Array(screen.screenShotBinary) : null;
      console.log(new Date().toString() + ' about to upload screen...');

      var res = await _httpRequest.HttpRequest.upload(url, this.token, fileName, binaryData, 'image/jpeg');
      if (res.error) {
        screen.sendStatus = _sendStatusEnum.SendStatusEnum.error;
        console.error(new Date().toString() + ' error uploading screen ' + screen.id + ': ' + res.error);
      } else {
        screen.sendStatus = _sendStatusEnum.SendStatusEnum.sent;
        console.log(new Date().toString() + ' successfully upload screen ' + screen.id);
      }
      return {
        success: res.error === undefined,
        error: res.error
      };
    }
  }, {
    key: 'sendAllScreens',
    value: async function sendAllScreens(sessionId, screens) {
      if (screens && screens.length > 0) {
        if (screens[0].sendStatus === _sendStatusEnum.SendStatusEnum.notSent) {
          await this.sendCreateScreen(sessionId, screens[0]);
          //
          var shifted = screens.shift();
          if (shifted && typeof shifted.destroyScreenshotBinary === 'function') {
            shifted.destroyScreenshotBinary();
            shifted = null;
          }
          if (screens.length > 0) {
            await this.sendAllScreens(sessionId, screens);
          }
        }
      }
    }
  }, {
    key: 'startSendingAllScreen',
    value: function startSendingAllScreen() {
      try {
        this.sendAllScreens(_qTestContext.QtestContext.session.id, _qTestContext.QtestContext.session.screens);
      } catch (error) {
        console.error('error sending: ' + error);
        var screens = _qTestContext.QtestContext.session.screens;
        if (screens > 0) {
          var shifted = _qTestContext.QtestContext.session.screens.shift();
          if (shifted) {
            shifted.destroyScreenshotBinary();
            shifted = null;
          }
        }
        this.sendAllScreens(_qTestContext.QtestContext.session.id, _qTestContext.QtestContext.session.screens);
      }
    }
  }]);

  return MessagingService;
}();

},{"../../extension/js/background/config.js":18,"../qTestContext.js":1,"./httpRequest.js":2,"./model/sendStatusEnum.js":8,"./utils/DateUtils.js":17}],4:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ApplicationInfo = exports.ApplicationInfo = function ApplicationInfo(name, version, fileVersion) {
  _classCallCheck(this, ApplicationInfo);

  this.name = name;
  this.version = version;
  this.fileVersion = fileVersion;
};

},{}],5:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AutoStartSetting = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _storage = require('../storage.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var AutoStartSetting = exports.AutoStartSetting = function () {
  function AutoStartSetting() {
    _classCallCheck(this, AutoStartSetting);

    this.isEnableAutoStart = false;
    this.projectId = '';
    this.domainsIgnored = {};
    this.domains = '';
    this.projectName = '';
    this.userEmail = '';
  }

  _createClass(AutoStartSetting, [{
    key: 'load',
    value: function load(userEmail, autoStartProjects) {
      this.userEmail = userEmail;
      var obj = _storage.Storage.get('autoStartSetting');
      if (obj) {
        var setting = obj[userEmail];
        if (setting) {
          this.isEnableAutoStart = setting.isEnableAutoStart;
          this.projectId = setting.projectId;
          var valid = false;
          for (var j = 0, len = autoStartProjects.length; j < len; j++) {
            var p = autoStartProjects[j];
            if (this.projectId && this.projectId.toString() === p.id.toString()) {
              valid = true;
              this.projectName = p.name;
              this.domains = p.alwaysOnSetting.domains.split(' ');
              break;
            }
          }
          this.isEnableAutoStart = this.isEnableAutoStart && valid;
          return this.isEnableAutoStart;
        }
      }
      return false;
    }
  }, {
    key: 'canShowAutoStartConfirm',
    value: function canShowAutoStartConfirm(domain) {
      if (this.isEnableAutoStart && this.domainsIgnored[domain] !== false) {
        if (this.domains.length === 0) {
          return false;
        }
        for (var i = 0, j = 0, ref = this.domains.length - 1; ref >= 0 ? j <= ref : j >= ref; i = ref >= 0 ? ++j : --j) {
          var d = this.domains[i];
          if (domain.length >= d.length && domain.indexOf(d) >= 0) {
            return true;
          }
        }
      }
      return false;
    }
  }, {
    key: 'disableShowAutoStartConfirm',
    value: function disableShowAutoStartConfirm(domain) {
      this.domainsIgnored[domain] = false;
    }
  }, {
    key: 'save',
    value: function save() {
      var obj = _storage.Storage.get('autoStartSetting') || {};
      var email = this.userEmail;
      var setting = {};
      setting.projectId = this.projectId;
      if (!setting.projectId || setting.projectId.length === 0) {
        this.isEnableAutoStart = false;
      }
      setting.isEnableAutoStart = this.isEnableAutoStart;
      obj[email] = setting;
      var str = JSON.stringify(obj);

      _storage.Storage.set('autoStartSetting', str);
    }
  }]);

  return AutoStartSetting;
}();

},{"../storage.js":16}],6:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var NoteType = exports.NoteType = function NoteType(id, name, color) {
  _classCallCheck(this, NoteType);

  this.id = id;
  this.name = name;
  this.color = color;
};

},{}],7:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Project = exports.Project = function Project(id, name) {
  _classCallCheck(this, Project);

  this.canCreate = false;
  this.canUpdate = false;

  this.id = id;
  this.name = name;
  this.sessions = [];
  this.alwaysOnSetting = {
    enabled: false,
    domains: ''
  };
};

},{}],8:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var SendStatusEnum = exports.SendStatusEnum = {
  error: 'Error',

  notSent: 'NotSent',

  sent: 'Sent',

  sending: 'Sending'
};

},{}],9:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Session = exports.Session = function () {
  function Session(id, project, title, description1, plannedDuration, tester) {
    _classCallCheck(this, Session);

    this.id = id;
    this.project = project;
    this.title = title;
    this.description = description1;
    this.plannedDuration = plannedDuration;
    this.tester = tester;
    this.currentTimeType = 0;
    this.timeLines = [];
    this.screens = [];
    this.screenCount = 0;
    this.sendStatus = 'NotSent';
    this.status = 'planned';

    this.url = '';
    this.redirectUrl = '';
  }

  _createClass(Session, [{
    key: 'pushScreen',
    value: function pushScreen(newScreen, finishedTimestamp) {
      console.log('-->PUSHING');
      newScreen.finishedTimestamp = finishedTimestamp;
      if (newScreen.order > 0) {
        console.error('DUPPLICATE SCREEN at ' + newScreen.order);
      } else {
        this.screenCount++;
        newScreen.order = this.screenCount;
        this.screens.push(newScreen);
      }
      console.log('-->PUSHED  + ' + newScreen.order);
    }
  }, {
    key: 'getViewData',
    value: function getViewData() {
      var session = {
        id: this.id,
        project: this.project,
        title: this.title,
        url: this.url,
        redirectUrl: this.redirectUrl,
        description: this.description,
        plannedDuration: this.plannedDuration,
        tester: this.tester,
        currentTimeType: this.currentTimeType,
        timeLines: this.timeLines,
        status: this.status
      };
      return session;
    }
  }]);

  return Session;
}();

},{}],10:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var StatusEnum = exports.StatusEnum = {
  notLoggedIn: 'notLoggedIn',

  loggingIn: 'loggingIn',

  loggedIn: 'loggedIn',

  loadingServerSession: 'loadingServerSession',

  loadedServerSession: 'loadedServerSession',

  startingSession: 'startingSession',

  startingSessionIndicator: 'startingSessionIndicator',

  recording: 'recording',

  editing: 'editing',

  paused: 'paused',

  capturingFullPage: 'capturingFullPage',

  inProgress: 'inProgress',

  completingSession: 'completingSession',

  recordingMedia: 'recordingMedia'
};

},{}],11:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SystemInfo = exports.SystemInfo = function SystemInfo(os, resolutions, appVersion) {
  _classCallCheck(this, SystemInfo);

  this.os = os;
  this.resolutions = resolutions;
  this.appVersion = appVersion;
};

},{}],12:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TimeLine = exports.TimeLine = function TimeLine() {
  _classCallCheck(this, TimeLine);

  this.startedTimestamp = null;
  this.finishedTimestamp = null;
  this.timeType = null;
  this.totalTime = null;
};

},{}],13:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TimeType = exports.TimeType = function TimeType(id, name, color) {
  _classCallCheck(this, TimeType);

  this.id = id;
  this.name = name;
  this.color = color;
};

},{}],14:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.User = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _autoStartSetting = require('./autoStartSetting.js');

var _qTestContext = require('../../qTestContext.js');

var _storage = require('../storage.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var User = exports.User = function () {
  function User(url, apiURL, email, token) {
    _classCallCheck(this, User);

    this.url = url;
    this.apiURL = apiURL;
    this.email = email;
    this.token = token;
    if (_qTestContext.QtestContext.qTestVersion >= 7) {
      this.autoStartSetting = new _autoStartSetting.AutoStartSetting();
    }
    this.fromExternal = false;
  }

  _createClass(User, [{
    key: 'saveAutoStartSetting',
    value: function saveAutoStartSetting(setting) {
      if (_qTestContext.QtestContext.qTestVersion >= 7) {
        this.autoStartSetting.isEnableAutoStart = setting.enableAutoStart;
        this.autoStartSetting.projectId = setting.projectId;
        this.autoStartSetting.domains = setting.domains.split(' ');
        this.autoStartSetting.projectName = setting.projectName;
        this.autoStartSetting.save();
      }
    }
  }, {
    key: 'loadAutoStartSetting',
    value: function loadAutoStartSetting(autoStartProjects) {
      if (_qTestContext.QtestContext.qTestVersion >= 7) {
        this.autoStartSetting.load(this.email, autoStartProjects);
      }
    }
  }, {
    key: 'setUserCredentials',
    value: function setUserCredentials(message, expires) {
      var userCredentials = {
        url: message.url,
        loginOption: message.loginOption,
        email: message.email,
        password: message.password,
        ssoToken: message.ssoToken,
        expires: expires
      };
      this.encryptedCredentials = _storage.Storage.encrypt(JSON.stringify(userCredentials));
    }
  }, {
    key: 'getUserCredentials',
    value: function getUserCredentials() {
      return _storage.Storage.decrypt(this.encryptedCredentials);
    }
  }]);

  return User;
}();

},{"../../qTestContext.js":1,"../storage.js":16,"./autoStartSetting.js":5}],15:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StartSessionFromQtestMessageHandler = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _httpRequest = require('./httpRequest.js');

var _statusEnum = require('./model/statusEnum.js');

var _session = require('./model/session.js');

var _messagingService = require('./messagingService.js');

var _timeType = require('./model/timeType.js');

var _timeLine = require('./model/timeLine.js');

var _noteType = require('./model/noteType.js');

var _project2 = require('./model/project.js');

var _user = require('./model/user.js');

var _qTestContext = require('../qTestContext.js');

var _storage = require('./../services/storage.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var StartSessionFromQtestMessageHandler = exports.StartSessionFromQtestMessageHandler = function () {
  function StartSessionFromQtestMessageHandler() {
    _classCallCheck(this, StartSessionFromQtestMessageHandler);
  }

  _createClass(StartSessionFromQtestMessageHandler, [{
    key: 'handle',
    value: async function handle(message) {
      try {
        message.url = message.url.trim().replace(/^\/|\/$/g, '').toLowerCase();
        var loadVersionResult = await this.loadqTestVersion(message);

        if (!loadVersionResult.success) {
          return loadVersionResult;
        }
        _qTestContext.QtestContext.qTestVersion = loadVersionResult.version;
        var validateResult = await this.validateAuthorizationToken(message);

        if (!validateResult.success) {
          return validateResult;
        }
        var userName = validateResult.userName;
        _qTestContext.QtestContext.user = new _user.User(message.url, message.apiURL, userName, message.token);
        _qTestContext.QtestContext.user.fromExternal = true;
        var loadProjectsResult = await this.loadUserProjects(message);

        if (!loadProjectsResult.success) {
          return loadProjectsResult;
        }
        var projects = loadProjectsResult.projects;
        _qTestContext.QtestContext.projects = projects;
        var qProjects = _qTestContext.QtestContext.projects;
        for (var j = 0, len = qProjects.length; j < len; j++) {
          var project = qProjects[j];
          if (project.id === message.project) {
            _qTestContext.QtestContext.selectedProject = project;
          }
        }
        if (!_qTestContext.QtestContext.selectedProject) {
          return {
            success: false,
            error: 'Project not found.'
          };
        }
        var getSessionsResult = await this.getSessionsOfSelectedProject(message);

        if (!getSessionsResult.success) {
          return getSessionsResult;
        }
        _qTestContext.QtestContext.selectedProject.sessions = getSessionsResult.sessions;
        var session = null;
        var sessions = _qTestContext.QtestContext.selectedProject.sessions;
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = sessions[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var existingSession = _step.value;

            if (existingSession.id === message.session) {
              session = existingSession;
              session.title = message.title;
              session.tester = message.tester;
              session.plannedDuration = message.plannedDuration;
              session.description = message.description;
              var redirectUrl = '';
              var sessionVersion = _qTestContext.QtestContext.sessionManagerVersion;
              if ((sessionVersion ? sessionVersion.major : undefined) >= 3) {
                redirectUrl = _qTestContext.QtestContext.user.url + '/p/' + session.project + '/portal/session/' + session.id + '/review';
                session.redirectUrl = _qTestContext.QtestContext.user.apiURL + '/' + session.id + '/review';
              } else if (_qTestContext.QtestContext.qTestVersion >= 7) {
                redirectUrl = _qTestContext.QtestContext.user.url + '/p/' + session.project + '/portal/session/' + session.id + '/review';
                session.redirectUrl = redirectUrl;
              } else {
                redirectUrl = _qTestContext.QtestContext.user.url + '/p/' + session.project + '/portal/session/playback/' + session.id;
                session.redirectUrl = redirectUrl;
              }
              var encodedRedirectUrl = encodeURIComponent(redirectUrl);
              session.url = message.url + '/portal/loginform?token=' + message.token + '&redirect=' + encodedRedirectUrl;
              break;
            }
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }

        if (!session) {
          return {
            success: false,
            error: 'Error creating session: session is out of date.'
          };
        }
        var loadProjectSettingsResult = await this.loadProjectSettings(message);
        if (!(loadProjectSettingsResult ? loadProjectSettingsResult.success : undefined)) {
          return loadProjectSettingsResult;
        }
        _qTestContext.QtestContext.timeTypes = loadProjectSettingsResult.timeTypes;
        _qTestContext.QtestContext.noteTypes = loadProjectSettingsResult.noteTypes;
        _qTestContext.QtestContext.session = session;
        _qTestContext.QtestContext.domainOptions = message.domainOptions;

        var messagingService = new _messagingService.MessagingService(message.apiURL, message.token);
        var updateStatusResult = await messagingService.sendUpdateSessionStatus(session, 'running');

        if (updateStatusResult.success) {
          var updateSessionResult = await messagingService.sendUpdateSession(session, true);
          var result = await this.updateSession(updateSessionResult, session, message);
          return result;
        }
        return {
          success: false,
          error: updateStatusResult.error
        };
      } catch (error) {
        return {
          success: false,
          error: error
        };
      }
    }
  }, {
    key: 'updateSession',
    value: async function updateSession(result, session, message) {
      if (result.success) {
        if (_qTestContext.QtestContext.timeTypes && _qTestContext.QtestContext.timeTypes.length > 0) {
          var firstTimeType = _qTestContext.QtestContext.timeTypes[0];
          var startTimeType = new _timeType.TimeType(firstTimeType.id, firstTimeType.name, firstTimeType.color);
          var startTimeLine = new _timeLine.TimeLine();
          startTimeLine.timeType = startTimeType;
          startTimeLine.startedTimestamp = Math.round(new Date() / 1000);
          _qTestContext.QtestContext.session.timeLines.push(startTimeLine);
          _qTestContext.QtestContext.session.currentTimeType = startTimeType.name;
        }
        _storage.Storage.set('lastSelectedProjectId', JSON.stringify(message.project));
        var lastSession = {
          url: session.url,
          redirectUrl: session.redirectUrl
        };
        _storage.Storage.set('lastSession', JSON.stringify(lastSession), {
          secure: true
        });
        _qTestContext.QtestContext.status = {
          name: _statusEnum.StatusEnum.recording
        };
        return {
          success: true
        };
      }
      return {
        success: false,
        error: result.error
      };
    }
  }, {
    key: 'validateAuthorizationToken',
    value: async function validateAuthorizationToken(message) {
      var projectId = message.project;
      var url = message.url + '/api/v3/re-evaluation/projects/' + projectId;
      var res = await _httpRequest.HttpRequest.sendWithResponse(url, message.token, 'GET', null);
      var response = res.response;
      var error = res.error;

      console.log(new Date().toString() + ' finished validate authorization token request.');
      if (error) {
        return {
          success: false,
          error: error
        };
      }
      var userName = response.getResponseHeader('user-name');
      if (userName) {
        return {
          success: true,
          userName: userName
        };
      }
      return {
        success: false,
        error: 'Error: cannot obtain your account information.'
      };
    }
  }, {
    key: 'loadqTestVersion',
    value: async function loadqTestVersion(message) {
      var getqTestVersionUrl = message.url + '/version';
      console.log(new Date().toString() + ' about to get qTest Version at ' + getqTestVersionUrl + '...');
      var res = await _httpRequest.HttpRequest.send(getqTestVersionUrl, null, 'GET', '');
      var data = res.data;
      var error = res.error;
      if (error) {
        return {
          success: false,
          error: error
        };
      }
      if (!data.version) {
        console.error('cannot obtain qTest version, set version to 5...');
        return {
          success: true,
          version: 5
        };
      }
      var dotIndex = data.version.indexOf('.');
      if (dotIndex === -1) {
        return {
          success: false,
          error: new Error('Could not parse version string from qTest ' + data.version)
        };
      }
      return {
        success: true,
        version: parseInt(data.version.substring(0, dotIndex), 10)
      };
    }
  }, {
    key: 'loadUserProjects',
    value: async function loadUserProjects(message) {
      var getProjectURL = message.url + '/api/v3/projects?expand=always_on';
      console.log(new Date().toString() + ' about to load projects...');
      var res = await _httpRequest.HttpRequest.send(getProjectURL, message.token, 'GET', '');
      var data = res.data;
      var error = res.error;

      console.log(new Date().toString() + ' finished loading projects...');
      if (error) {
        return {
          success: false,
          error: error
        };
      }
      var projects = [];
      var projectIds = '';
      var i = 0;
      for (var j = 0, len = data.length; j < len; j++) {
        var p = data[j];
        var project = new _project2.Project(p.id, p.name);
        if (p.always_on) {
          project.alwaysOnSetting.enabled = p.always_on.enabled;
          project.alwaysOnSetting.domains = p.always_on.domains;
        }
        projects.push(project);
        if (i < data.length - 1) {
          projectIds += p.id + ',';
        } else {
          projectIds += p.id;
        }
        i++;
      }
      if (projects.length === 0) {
        return {
          success: false,
          error: 'Project not found.'
        };
      }
      var getProjectPermissionURL = message.apiURL + '/permissions?system=qtest&projectIds=' + projectIds;
      console.log(new Date().toString() + ' about to get permissions...');
      var getPermission = await _httpRequest.HttpRequest.send(getProjectPermissionURL, message.token, 'GET', '');

      console.log(new Date().toString() + ' finished getting permissions...');
      if (getPermission.error || !getPermission.data || !getPermission.data.permission || getPermission.data.permission.length <= 0) {
        console.log('load project permission getPermission.error: ' + getPermission.error);
        return {
          success: false,
          error: getPermission.error
        };
      }
      var availProjects = [];
      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = projects[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var _project = _step2.value;

          var canView = false;
          var permissionData = getPermission.data.permission;
          for (var l = 0, len2 = permissionData.length; l < len2; l++) {
            var permission = permissionData[l];
            if (permission.project_id.toString() === _project.id.toString()) {
              canView = permission.session.can_view;
              _project.canCreate = permission.session.can_create;
              _project.canUpdate = permission.session.can_edit;
              break;
            }
          }
          if (canView && _project.canUpdate) {
            availProjects.push(_project);
          }
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      if (availProjects.length <= 0) {
        return {
          success: false,
          error: 'You don\'t have priviledge to work with Session Manager module'
        };
      }
      return {
        success: true,
        projects: availProjects
      };
    }
  }, {
    key: 'getSessionsOfSelectedProject',
    value: async function getSessionsOfSelectedProject(message) {
      var maxRecsInPage = -1;
      var url = message.apiURL + '/search?recs=' + maxRecsInPage + '&ot=sessions&status=planned&project_id=' + message.project + '&sortBy=title&sortOrder=acs';
      var allsessions = [];
      var res = await _httpRequest.HttpRequest.send(url, message.token, 'GET', null);
      var data = res.data;
      var error = res.error;

      if (error) {
        return {
          success: false,
          error: error
        };
      }
      if (data.total_record <= 0 || data.total <= 0) {
        return {
          success: true,
          sessions: allsessions
        };
      }
      var items = data.items;
      for (var j = 0, len = items.length; j < len; j++) {
        var session = items[j];
        var hour = 1;
        var min = 30;
        if (session.planned_duration) {
          hour = Math.floor(session.planned_duration / 3600);
          min = (session.planned_duration - hour * 3600) / 60;
        }
        var plannedDuration = {
          hour: hour,
          min: min
        };
        allsessions.push(new _session.Session(session.id, message.project, session.title, session.desc, plannedDuration, ''));
      }

      return {
        success: true,
        sessions: allsessions
      };
    }
  }, {
    key: 'loadProjectSettings',
    value: async function loadProjectSettings(message) {
      var getSettingsURL = message.apiURL + '/project-settings/' + message.project;
      console.log(new Date().toString() + ' about to get time types, note types');
      var res = await _httpRequest.HttpRequest.send(getSettingsURL, message.token, 'GET', '');
      var data = res.data;
      var error = res.error;

      console.log(new Date().toString() + ' finished getting time types, note types');
      if (error || data.total <= 0) {
        return {
          success: false,
          error: error
        };
      }
      var timeTypes = [];
      var timeTypesData = data.items[0].time_types;
      var _iteratorNormalCompletion3 = true;
      var _didIteratorError3 = false;
      var _iteratorError3 = undefined;

      try {
        for (var _iterator3 = timeTypesData[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
          var timeType = _step3.value;

          if (timeType.active) {
            timeTypes.push(new _timeType.TimeType(timeType.id, timeType.name, timeType.color));
          }
        }
      } catch (err) {
        _didIteratorError3 = true;
        _iteratorError3 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion3 && _iterator3.return) {
            _iterator3.return();
          }
        } finally {
          if (_didIteratorError3) {
            throw _iteratorError3;
          }
        }
      }

      var noteTypes = [];
      var notetypesData = data.items[0].note_types;
      var _iteratorNormalCompletion4 = true;
      var _didIteratorError4 = false;
      var _iteratorError4 = undefined;

      try {
        for (var _iterator4 = notetypesData[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
          var type = _step4.value;

          if (type.active) {
            noteTypes.push(new _noteType.NoteType(type.id, type.name, type.color));
          }
        }
      } catch (err) {
        _didIteratorError4 = true;
        _iteratorError4 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion4 && _iterator4.return) {
            _iterator4.return();
          }
        } finally {
          if (_didIteratorError4) {
            throw _iteratorError4;
          }
        }
      }

      return {
        success: true,
        timeTypes: timeTypes,
        noteTypes: noteTypes
      };
    }
  }]);

  return StartSessionFromQtestMessageHandler;
}();

},{"../qTestContext.js":1,"./../services/storage.js":16,"./httpRequest.js":2,"./messagingService.js":3,"./model/noteType.js":6,"./model/project.js":7,"./model/session.js":9,"./model/statusEnum.js":10,"./model/timeLine.js":12,"./model/timeType.js":13,"./model/user.js":14}],16:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ___ = ['\x6D\x74\x26\x79\x6B\x4E\x57\x55\x62\x4E\x49\x65\x52\x26\x34\x33'][0];

var Storage = exports.Storage = function () {
  function Storage() {
    _classCallCheck(this, Storage);
  }

  _createClass(Storage, null, [{
    key: 'encrypt',
    value: function encrypt(vString) {
      // eslint-disable-next-line no-undef
      return sjcl.encrypt(___, vString);
    }
  }, {
    key: 'decrypt',
    value: function decrypt(vString) {
      // eslint-disable-next-line no-undef
      return sjcl.decrypt(___, vString);
    }

    // get(k: string): Object

  }, {
    key: 'get',
    value: function get(k) {
      try {
        var vString = localStorage.getItem(k);
        if (!vString) {
          return null;
        }

        var obj = JSON.parse(vString);
        if (obj.cipher && obj.salt && obj.mode) {
          obj = JSON.parse(this.decrypt(vString));
        }

        // backward compatible: old version stringify the obj multiple times
        if (typeof obj === 'string') {
          try {
            var tempObj = JSON.parse(obj);
            obj = tempObj;
            // eslint-disable-next-line no-empty
          } catch (e) {}
        }

        if (obj.expires) {
          // check expiration
          var now = new Date();
          var expires = new Date(obj.expires);
          if (now.getTime() >= expires.getTime()) {
            console.error('Storage "' + k + '" expired on ' + obj.expires);
            this.remove(k);
            return null;
          }
        }

        return obj;
      } catch (error) {
        console.log(error);
        return null;
      }
    }

    // set(k: string, vString: string, opts: { secure: boolean })

  }, {
    key: 'set',
    value: function set(k, vString) {
      var opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      if (!vString) {
        this.remove(k);
        return;
      }

      localStorage.setItem(k, opts.secure ? this.encrypt(vString) : vString);
    }
  }, {
    key: 'remove',
    value: function remove(k) {
      localStorage.removeItem(k);
    }
  }]);

  return Storage;
}();

},{}],17:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DateUtils = exports.DateUtils = function () {
  function DateUtils() {
    _classCallCheck(this, DateUtils);
  }

  _createClass(DateUtils, null, [{
    key: 'getDateString',
    value: function getDateString(date) {
      var strDate = JSON.stringify(date).toString().replace('"', '').replace('"', '');
      strDate = strDate.substring(0, strDate.indexOf('Z')) + '+00:00';
      return strDate;
    }
  }]);

  return DateUtils;
}();

},{}],18:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.App = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _systemInfo = require('../../../common/services/model/systemInfo.js');

var _applicationInfo = require('../../../common/services/model/applicationInfo.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var fileVersion = '';
var browserName = '';
var firefoxVersion = '';
var osName = '';
var nAgt = window.navigator.userAgent;
var verOffset = nAgt.indexOf('Firefox');
if (verOffset !== -1) {
  browserName = 'firefox';
  fileVersion = nAgt.substring(verOffset + 8);
  firefoxVersion = parseInt(fileVersion, 10);
}
var mozillaExp = nAgt.match(/Mozilla\/(.*?) /);
if (mozillaExp && mozillaExp.length > 0) {
  var mozillaExp2 = /Mozilla\//;
  var osExp = /\((.*?)\)/;
  osName = navigator.userAgent.match(new RegExp(String(mozillaExp2.source) + mozillaExp[1] + ' ' + osExp.source))[1];
}

var App = exports.App = function () {
  function App() {
    _classCallCheck(this, App);
  }

  _createClass(App, null, [{
    key: 'manifest',
    get: function get() {
      return this._manifest || chrome.runtime.getManifest();
    }
  }, {
    key: 'name',
    get: function get() {
      return this.manifest.name;
    }
  }, {
    key: 'version',
    get: function get() {
      return this.manifest.version;
    }
  }, {
    key: 'apiVersion',
    get: function get() {
      return this.manifest.apiVersion;
    }
  }, {
    key: 'scaleBeforeCompare',
    get: function get() {
      return this._scaleBeforeCompare || true;
    },
    set: function set(value) {
      this._scaleBeforeCompare = value;
    }
  }, {
    key: 'fileVersion',
    get: function get() {
      if (mozillaExp && mozillaExp.length > 0) {
        return mozillaExp[1];
      }
      return -1;
    }
  }, {
    key: 'systemInfo',
    get: function get() {
      var width = window.screen.width * window.devicePixelRatio;
      var height = window.screen.height * window.devicePixelRatio;
      return new _systemInfo.SystemInfo(osName, width + 'x' + height, this.version);
    }
  }, {
    key: 'applicationInfo',
    get: function get() {
      return new _applicationInfo.ApplicationInfo(browserName, firefoxVersion, fileVersion);
    }
  }]);

  return App;
}();

},{"../../../common/services/model/applicationInfo.js":4,"../../../common/services/model/systemInfo.js":11}]},{},[15]);
