(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.QtestContext = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _statusEnum = require('./services/model/statusEnum.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var QtestContext = exports.QtestContext = function () {
  function QtestContext() {
    _classCallCheck(this, QtestContext);
  }

  _createClass(QtestContext, null, [{
    key: 'clear',
    value: function clear() {
      this._user = null;
      this._session = null;
      this._projects = [];
      this._selectedProject = null;
      this._timeTypes = [];
      this._noteTypes = [];
      this._pendingAnnotations = [];
      this._currentProcessingScreen = null;
      this._domainOptions = null;
      this._runFromQtest = false;
      this._projectId = null;
      this._sessionId = null;
      this._status = {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    }
  }, {
    key: 'canRecordMedia',
    value: function canRecordMedia() {
      return this._qTestVersion && this._qTestVersion >= 6;
    }
  }, {
    key: 'getProjectAutoStartSupported',
    value: function getProjectAutoStartSupported() {
      var result = [];
      if (this._projects) {
        var ref = this._projects;
        for (var j = 0, len = ref.length; j < len; j++) {
          var p = ref[j];
          if (p.alwaysOnSetting.domains.length > 0 && p.alwaysOnSetting.enabled) {
            result.push(p);
          }
        }
      }
      return result;
    }
  }, {
    key: 'qTestVersion',
    get: function get() {
      return this._qTestVersion || null;
    },
    set: function set(qTestVersion) {
      this._qTestVersion = qTestVersion;
    }
  }, {
    key: 'qTestMinorVersion',
    get: function get() {
      return this._qTestMinorVersion || null;
    },
    set: function set(qTestMinorVersion) {
      this._qTestMinorVersion = qTestMinorVersion;
    }
  }, {
    key: 'session',
    get: function get() {
      return this._session || null;
    },
    set: function set(session) {
      this._session = session;
    }
  }, {
    key: 'user',
    get: function get() {
      return this._user || null;
    },
    set: function set(user) {
      this._user = user;
    }
  }, {
    key: 'projects',
    get: function get() {
      if (!this._projects) {
        this._projects = [];
      }
      return this._projects;
    },
    set: function set(projects) {
      this._projects = projects;
    }
  }, {
    key: 'selectedProject',
    get: function get() {
      return this._selectedProject || null;
    },
    set: function set(selectedProject) {
      this._selectedProject = selectedProject;
    }
  }, {
    key: 'timeTypes',
    get: function get() {
      if (!this._timeTypes) {
        this._timeTypes = [];
      }
      return this._timeTypes;
    },
    set: function set(timeTypes) {
      this._timeTypes = timeTypes;
    }
  }, {
    key: 'noteTypes',
    get: function get() {
      if (!this._noteTypes) {
        this._noteTypes = [];
      }
      return this._noteTypes;
    },
    set: function set(noteTypes) {
      this._noteTypes = noteTypes;
    }
  }, {
    key: 'pendingAnnotations',
    get: function get() {
      if (!this._pendingAnnotations) {
        this._pendingAnnotations = [];
      }
      return this._pendingAnnotations;
    },
    set: function set(pendingAnnotations) {
      this._pendingAnnotations = pendingAnnotations;
    }
  }, {
    key: 'currentProcessingScreen',
    get: function get() {
      return this._currentProcessingScreen || null;
    },
    set: function set(currentProcessingScreen) {
      this._currentProcessingScreen = currentProcessingScreen;
    }
  }, {
    key: 'domainOptions',
    get: function get() {
      return this._domainOptions || null;
    },
    set: function set(domainOptions) {
      this._domainOptions = domainOptions;
    }
  }, {
    key: 'runFromQtest',
    get: function get() {
      return this._runFromQtest || false;
    },
    set: function set(runFromQtest) {
      this._runFromQtest = runFromQtest;
    }
  }, {
    key: 'projectId',
    get: function get() {
      return this._projectId || null;
    },
    set: function set(projectId) {
      this._projectId = projectId;
    }
  }, {
    key: 'sessionId',
    get: function get() {
      return this._sessionId || null;
    },
    set: function set(sessionId) {
      this._sessionId = sessionId;
    }
  }, {
    key: 'status',
    get: function get() {
      return this._status || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._status = value;
    }
  }, {
    key: 'currentqTestSession',
    get: function get() {
      return this._currentqTestSession || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._currentqTestSession = value;
    }
  }, {
    key: 'sessionManagerVersion',
    get: function get() {
      return this._sessionManagerVersion || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._sessionManagerVersion = value;
    }
  }]);

  return QtestContext;
}();

},{"./services/model/statusEnum.js":3}],2:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var MessageEnum = exports.MessageEnum = {
  getStatus: 'getStatus',

  login: 'login',

  logout: 'logout',

  getSessions: 'getSessions',

  startSession: 'startSession',

  viewSession: 'viewSession',

  completeSession: 'completeSession',

  addNote: 'addNote',

  switchTimetype: 'switchTimetype',

  keyEvent: 'keyEvent',

  clickEvent: 'clickEvent',

  takeSnapshot: 'takeSnapshot',

  modalDialog: 'modalDialog',

  devicePixelRatio: 'devicePixelRatio',

  toggleRecordingStatus: 'toggleRecordingStatus',

  captureVisiblePart: 'captureVisiblePart',

  captureFullPage: 'captureFullPage',

  captureScrollingPage: 'captureScrollingPage',

  finishedScrolling: 'finishedScrolling',

  finishedCaptureFullPage: 'finishedCaptureFullPage',

  discardScrollingCapture: 'discardScrollingCapture',

  openUrl: 'openUrl',

  editCurrentScreen: 'editCurrentScreen',

  editorReady: 'editorReady',

  saveCurrentScreen: 'saveCurrentScreen',

  cancelEditCurrentScreen: 'cancelEditCurrentScreen',

  confirmMediaPermission: 'confirmMediaPermission',

  deniedMediaPermission: 'deniedMediaPermission',

  cancelledMediaPermission: 'cancelledMediaPermission',

  recordMedia: 'recordMedia',

  stopRecordMedia: 'stopRecordMedia',

  cancelRecordMedia: 'cancelRecordMedia',

  showSettings: 'showSettings',

  getSettings: 'getSettings',

  saveSettings: 'saveSettings',

  cancelSaveSettings: 'cancelSaveSettings',

  closeSettings: 'closeSettings',

  openCommandsConfiguration: 'openCommandsConfiguration',

  startSessionFromqTest: 'startSessionFromqTest',

  currentqTestSession: 'currentqTestSession',

  getCurrentqTestSession: 'getCurrentqTestSession',

  getOpeningDomains: 'getOpeningDomains',

  getAutoStartData: 'getAutoStartData',

  autoStartDisableConfirm: 'autoStartDisableConfirm',

  startAutoStartSession: 'startAutoStartSession',

  removeAutoStartDialog: 'remove-web-explorer-confirm-start-always-on-session-dialog',

  removeStartSessionDialog: 'remove-web-explorer-start-session-dialog'
};

},{}],3:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var StatusEnum = exports.StatusEnum = {
  notLoggedIn: 'notLoggedIn',

  loggingIn: 'loggingIn',

  loggedIn: 'loggedIn',

  loadingServerSession: 'loadingServerSession',

  loadedServerSession: 'loadedServerSession',

  startingSession: 'startingSession',

  startingSessionIndicator: 'startingSessionIndicator',

  recording: 'recording',

  editing: 'editing',

  paused: 'paused',

  capturingFullPage: 'capturingFullPage',

  inProgress: 'inProgress',

  completingSession: 'completingSession',

  recordingMedia: 'recordingMedia'
};

},{}],4:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EditorHandler = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _qTestContext = require('../../../common/qTestContext.js');

var _messageEnum = require('../../../common/services/model/messageEnum.js');

var _statusEnum = require('../../../common/services/model/statusEnum.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var EditorHandler = exports.EditorHandler = function () {
  function EditorHandler() {
    _classCallCheck(this, EditorHandler);

    this.URL = '../../../common/editor/editor.html';
    this.editorTab = null;
    this.lastActiveTab = null;
  }

  _createClass(EditorHandler, [{
    key: 'activeTab',
    value: function activeTab(tab, reload) {
      this.editorTab = {
        id: tab.id,
        url: tab.url,
        windowId: tab.windowId
      };
      chrome.windows.update(tab.windowId, {
        focused: true
      });
      chrome.tabs.update(tab.id, {
        active: true
      });
      if (reload) {
        chrome.tabs.reload(tab.id);
      }
      return {
        success: true
      };
    }
  }, {
    key: 'handle',
    value: function handle(message) {
      var _this = this;

      return new Promise(async function (resolve) {
        var tab = {};
        if (message.name === _messageEnum.MessageEnum.editCurrentScreen) {
          if (!_qTestContext.QtestContext.currentProcessingScreen) {
            console.log(new Date().toString() + ' handle editCurrentScreen message, but current processing screen is not available');
            resolve({ success: false });
          }
          tab = await _this.findEditorTab();
          if (tab) {
            _this.activeTab(tab, true);
          } else {
            _this.lastActiveTab = null;
            chrome.tabs.query({
              windowId: chrome.windows.WINDOW_ID_CURRENT,
              active: true
            }, function (tabs) {
              if (tabs && tabs.length > 0) {
                tab = tabs[0];
                _this.lastActiveTab = {
                  id: tab.id,
                  url: tab.url,
                  windowId: tab.windowId
                };
                chrome.tabs.create({
                  index: tab.index + 1,
                  url: _this.URL
                }, function (newTab) {
                  resolve(_this.activeTab(newTab, false));
                });
              } else {
                _this.lastActiveTab = null;
                chrome.tabs.create({
                  url: _this.URL
                }, function (newTab) {
                  resolve(_this.activeTab(newTab, false));
                });
              }
            });
          }
        } else if (message.name === _messageEnum.MessageEnum.editorReady) {
          if (_qTestContext.QtestContext.currentProcessingScreen && _this.editorTab) {
            var screen = _qTestContext.QtestContext.currentProcessingScreen.getDrawableData();
            var obj = {
              screen: screen,
              noteTypes: _qTestContext.QtestContext.noteTypes,
              qTestVersion: {
                major: _qTestContext.QtestContext.qTestVersion,
                minor: _qTestContext.QtestContext.qTestMinorVersion
              }
            };
            var dataString = JSON.stringify(obj);
            chrome.tabs.sendMessage(_this.editorTab.id, {
              name: 'currentScreen',
              data: dataString
            }, function (response) {
              _qTestContext.QtestContext.status = {
                name: _statusEnum.StatusEnum.editing
              };
              resolve({ success: true });
            });
          }
        } else if (message.name === _messageEnum.MessageEnum.saveCurrentScreen) {
          _qTestContext.QtestContext.currentProcessingScreen.importData(message.data);
          _qTestContext.QtestContext.status = {
            name: _statusEnum.StatusEnum.recording
          };
          chrome.tabs.sendMessage(_this.editorTab.id, {
            name: 'savedCurrentScreen',
            data: null
          }, function (response) {});
          await _this.closeEditorTab(_this.editorTab.id);
          await _this.activateLastActiveTab(_this.lastActiveTab.id);
          _this.lastActiveTab = null;
          resolve({ success: true });
        } else if (message.name === _messageEnum.MessageEnum.cancelEditCurrentScreen) {
          _qTestContext.QtestContext.status = {
            name: _statusEnum.StatusEnum.recording
          };
          await _this.closeEditorTab(_this.editorTab.id);
          if (_this.lastActiveTab && _this.lastActiveTab.id) {
            await _this.activateLastActiveTab(_this.lastActiveTab.id);
          }
          _this.lastActiveTab = null;
          resolve({ success: true });
        }
      });
    }
  }, {
    key: 'findEditorTab',
    value: async function findEditorTab() {
      return new Promise(function (resolve) {
        chrome.windows.getAll({
          populate: true
        }, function (wnds) {
          var tab = null;
          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = wnds[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var wd = _step.value;

              if (tab) {
                break;
              }
              var _iteratorNormalCompletion2 = true;
              var _didIteratorError2 = false;
              var _iteratorError2 = undefined;

              try {
                for (var _iterator2 = wd.tabs[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                  var tb = _step2.value;

                  if (tb.url.indexOf(EditorHandler.URL_PREFIX) >= 0) {
                    tab = tb;
                    break;
                  }
                }
              } catch (err) {
                _didIteratorError2 = true;
                _iteratorError2 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion2 && _iterator2.return) {
                    _iterator2.return();
                  }
                } finally {
                  if (_didIteratorError2) {
                    throw _iteratorError2;
                  }
                }
              }
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }

          resolve(tab);
        });
      });
    }
  }, {
    key: 'closeEditorTab',
    value: async function closeEditorTab(tabId) {
      return new Promise(function (resolve) {
        chrome.tabs.query({}, function (tabs) {
          if (tabs) {
            var found = false;
            var _iteratorNormalCompletion3 = true;
            var _didIteratorError3 = false;
            var _iteratorError3 = undefined;

            try {
              for (var _iterator3 = tabs[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                var tab = _step3.value;

                if (tab.id === tabId) {
                  found = true;
                  break;
                }
              }
            } catch (err) {
              _didIteratorError3 = true;
              _iteratorError3 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion3 && _iterator3.return) {
                  _iterator3.return();
                }
              } finally {
                if (_didIteratorError3) {
                  throw _iteratorError3;
                }
              }
            }

            if (found) {
              chrome.tabs.remove(tabId, function () {});
            }
          }
          resolve(true);
        });
      });
    }
  }, {
    key: 'activateLastActiveTab',
    value: async function activateLastActiveTab(tabId) {
      return new Promise(function (resolve) {
        chrome.windows.getAll({
          populate: true
        }, function (wnds) {
          var tab = null;
          var _iteratorNormalCompletion4 = true;
          var _didIteratorError4 = false;
          var _iteratorError4 = undefined;

          try {
            for (var _iterator4 = wnds[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
              var wd = _step4.value;

              if (tab) {
                break;
              }
              var _iteratorNormalCompletion5 = true;
              var _didIteratorError5 = false;
              var _iteratorError5 = undefined;

              try {
                for (var _iterator5 = wd.tabs[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
                  var tb = _step5.value;

                  if (tb.id === tabId) {
                    tab = tb;
                    break;
                  }
                }
              } catch (err) {
                _didIteratorError5 = true;
                _iteratorError5 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion5 && _iterator5.return) {
                    _iterator5.return();
                  }
                } finally {
                  if (_didIteratorError5) {
                    throw _iteratorError5;
                  }
                }
              }
            }
          } catch (err) {
            _didIteratorError4 = true;
            _iteratorError4 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion4 && _iterator4.return) {
                _iterator4.return();
              }
            } finally {
              if (_didIteratorError4) {
                throw _iteratorError4;
              }
            }
          }

          if (tab) {
            chrome.windows.update(tab.windowId, {
              focused: true
            });
            chrome.tabs.update(tab.id, {
              active: true
            });
          }
          resolve(true);
        });
      });
    }
  }], [{
    key: 'URL_PREFIX',
    get: function get() {
      return 'moz-extension://' + chrome.i18n.getMessage('@@extension_id');
    }
  }]);

  return EditorHandler;
}();

},{"../../../common/qTestContext.js":1,"../../../common/services/model/messageEnum.js":2,"../../../common/services/model/statusEnum.js":3}]},{},[4]);
