(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var LoginViewModel = exports.LoginViewModel = function () {
  function LoginViewModel(inProgress) {
    _classCallCheck(this, LoginViewModel);

    this.inProgress = inProgress;
    // eslint-disable-next-line no-undef
    this.$form = $('#loginForm');
    this.$url = this.$form.find('#url');
    this.$email = this.$form.find('#email');
    this.$pwd = this.$form.find('#password');
    this.$progress = this.$form.find('.loader');
    this.$fieldSet = this.$form.find('#loginFormFields');
    this.$loginBtn = this.$form.find('#loginBtn');
    this.$errorMessage = this.$form.find('.errorMessage');
    this.$loginWithqTestContainer = this.$form.find('#loginWithqTestContainer');
    this.$loginWithSSOContainer = this.$form.find('#loginWithSSOContainer');
    this.$loginWithqTestOption = this.$form.find('#loginWithqTest');
    this.$loginWithSSOOption = this.$form.find('#loginWithSSO');
    this.$ssoToken = this.$form.find('#ssoToken');
  }

  _createClass(LoginViewModel, [{
    key: 'show',
    value: function show(state) {
      var _this = this;

      var showLogin = function showLogin(user, loginOption) {
        _this.$fieldSet.removeAttr('disabled');
        _this.$progress.hide();
        _this.bindEvents();
        if (user) {
          _this.$url.val(user.url);
          if (loginOption === 'qtest') {
            _this.$email.val(user.email);
            _this.$pwd.val(user.password);
          } else {
            _this.$ssoToken.val(user.ssoToken);
          }
        } else {
          _this.$url.focus();
        }
        _this.resetLoginFormState(loginOption);
      };
      if (this.inProgress) {
        this.$url.val(state.user.url);
        if (state.loginOption === 'qtest') {
          this.$email.val(state.user.email);
          this.$pwd.val(state.user.password);
        } else {
          this.$ssoToken.val(state.user.ssoToken);
        }
        this.resetLoginFormState(state.loginOption);
        this.$fieldSet.attr('disabled', 'disabled');
        this.$progress.show();
        var waitForLoggedInStatus = function waitForLoggedInStatus() {
          window.setTimeout(function () {
            chrome.runtime.sendMessage({
              name: 'getStatus'
            }, function (response) {
              if (response.name === 'loggedIn') {
                window.location.href = 'startSession.html';
              } else if (response.name === 'notLoggedIn') {
                console.log(new Date().toString() + ' login failed');
                showLogin(state.user, state.loginOption);
              } else {
                waitForLoggedInStatus();
              }
            });
          }, 2000);
        };
        waitForLoggedInStatus();
      } else {
        showLogin(state.user, state.loginOption);
      }
    }
  }, {
    key: 'resetLoginFormState',
    value: function resetLoginFormState(loginOption) {
      var _this2 = this;

      var parsleyForm = this.$form.parsley();
      parsleyForm.reset();
      // eslint-disable-next-line no-undef
      $('.has-error').each(function () {
        // eslint-disable-next-line no-undef
        $(_this2).removeClass('has-error');
      });
      if (loginOption === 'qtest') {
        this.$email.attr('required', 'required');
        this.$pwd.attr('required', 'required');
        this.$ssoToken.removeAttr('required');
        this.$loginWithqTestOption.prop('checked', true);
        this.$loginWithqTestContainer.show();
        this.$loginWithSSOContainer.hide();
      } else {
        this.$ssoToken.attr('required', 'required');
        this.$email.removeAttr('required');
        this.$pwd.removeAttr('required');
        this.$loginWithSSOOption.prop('checked', true);
        this.$loginWithqTestContainer.hide();
        this.$loginWithSSOContainer.show();
      }
      this.$errorMessage.hide();
    }
  }, {
    key: 'bindEvents',
    value: function bindEvents() {
      var _this3 = this;

      // eslint-disable-next-line no-undef
      $('input[type=radio][name=loginOption]').on('change', function () {
        // eslint-disable-next-line no-undef
        _this3.resetLoginFormState($('input[type=radio][name=loginOption]:checked').val());
      });

      var parsleyForm = this.$form.parsley();
      parsleyForm.subscribe('parsley:field:error', function (fieldInstance) {
        fieldInstance.$element.parent().addClass('has-error');
      });
      parsleyForm.subscribe('parsley:field:success', function (fieldInstance) {
        fieldInstance.$element.parent().removeClass('has-error');
      });
      parsleyForm.subscribe('parsley:form:validate', function (formInstance) {
        formInstance.submitEvent.preventDefault();
        if (formInstance.isValid('', false)) {
          _this3.$errorMessage.hide();
          _this3.$fieldSet.attr('disabled', 'disabled');
          _this3.$progress.show();
          var message = null;
          if (_this3.$loginWithqTestOption.is(':checked')) {
            message = {
              name: 'login',
              loginOption: 'qtest',
              url: _this3.$url.val(),
              email: _this3.$email.val(),
              password: _this3.$pwd.val()
            };
          } else {
            message = {
              name: 'login',
              loginOption: 'sso',
              url: _this3.$url.val(),
              ssoToken: _this3.$ssoToken.val()
            };
          }
          chrome.runtime.sendMessage(message, function (response) {
            _this3.$progress.hide();
            if (response.success) {
              window.location.href = 'startSession.html';
            } else {
              if (response.error) {
                console.log(new Date().toString() + ' login error: ' + response.error);
                if (response.error.status === 404) {
                  _this3.$errorMessage.text('The URL you entered was not found.');
                } else if (response.error.status === 401 || response.error.status === 400) {
                  if (_this3.$loginWithqTestOption.is(':checked')) {
                    _this3.$errorMessage.text('Cannot log in to qTest. Please verify your URL, Email/User name and Password.');
                  } else {
                    _this3.$errorMessage.text('Cannot log in to qTest. Please verify your URL and SSO token.');
                  }
                } else if (response.error.status === 402) {
                  _this3.$errorMessage.text('Your qTest site has been expired.');
                } else if (response.error.status === 500) {
                  _this3.$errorMessage.text('Server error. Please contact Tricentis.');
                } else if (response.error.message) {
                  _this3.$errorMessage.text(response.error.message);
                } else if (_this3.$loginWithqTestOption.is(':checked')) {
                  _this3.$errorMessage.text('Cannot log in to qTest. Please verify your URL, Email/User name and Password.');
                } else {
                  _this3.$errorMessage.text('Cannot log in to qTest. Please verify your URL and SSO token.');
                }
                _this3.$errorMessage.show();
              }
              _this3.$fieldSet.removeAttr('disabled');
            }
          });
        }
      });
    }
  }]);

  return LoginViewModel;
}();

// eslint-disable-next-line no-undef


$(function () {
  chrome.runtime.sendMessage({
    name: 'getStatus'
  }, function (response) {
    console.log(new Date().toString() + ' received status: ' + response.name);
    if (response && response.name === 'loggedIn') {
      window.location.href = 'startSession.html';
      return;
    }

    var viewModel = null;
    if (response && response.name === 'notLoggedIn') {
      viewModel = new LoginViewModel(false);
    } else if (response && response.name === 'loggingIn') {
      viewModel = new LoginViewModel(true);
    }
    if (viewModel) {
      viewModel.show(response.info);
    }
  });
});

},{}]},{},[1]);
