(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var QTestExplorerTimeLinesControl = exports.QTestExplorerTimeLinesControl = function () {
  function QTestExplorerTimeLinesControl(canvas) {
    _classCallCheck(this, QTestExplorerTimeLinesControl);

    this.canvas = canvas;
    this.pLeft = 0;
    this.width = this.canvas.width - this.pLeft;
    this.plannedDuration = 90 * 60;
    // eslint-disable-next-line no-undef
    this.stage = new createjs.Stage(this.canvas);
    this.strokeSize = 16;
    this.currentColor = '#ff0000';
    this.bgLine = this.drawLine('#d6d6d6', this.pLeft, 15, this.width, 15);
    this.drawCorners();
    this.interval = null;
    this.setProgressPercent(0);
  }

  _createClass(QTestExplorerTimeLinesControl, [{
    key: 'drawCorners',
    value: function drawCorners() {
      // eslint-disable-next-line no-undef
      this.corner1 = new createjs.Shape();
      // eslint-disable-next-line no-undef
      this.corner2 = new createjs.Shape();
      this.corner1.graphics.clear().beginFill('#ffffff').moveTo(this.pLeft, 7).lineTo(this.pLeft + 8, 7).arc(this.pLeft + 8, 15, 8, -0.5 * Math.PI, 0.5 * Math.PI, true).lineTo(this.pLeft, 23).lineTo(this.pLeft, 7);
      this.corner2.graphics.clear().beginFill('#ffffff').moveTo(this.width, 7).lineTo(this.width - 8, 7).arc(this.width - 16, 15, 8, -0.5 * Math.PI, 0.5 * Math.PI, false).lineTo(this.width, 23).lineTo(this.width, 7);
      this.stage.addChild(this.corner1);
      this.stage.addChild(this.corner2);
    }
  }, {
    key: 'drawLine',
    value: function drawLine(strokeColor, x1, y1, x2, y2) {
      // eslint-disable-next-line no-undef
      var line = new createjs.Shape();
      this.stage.addChild(line);
      var graphics = line.graphics;
      graphics.clear().setStrokeStyle(this.strokeSize).beginStroke(strokeColor).moveTo(x1, y1).lineTo(x2, y2);
      this.stage.update();
      this.lines = [];
      return line;
    }
  }, {
    key: 'drawTimeLines',
    value: function drawTimeLines() {
      var currentPos = this.pLeft;
      for (var i = 0; i < this.lines.length; i++) {
        var l = this.lines[i];
        this.stage.removeChild(l);
      }
      this.stage.removeChild(this.bgLine);
      this.stage.removeChild(this.corner1);
      this.stage.removeChild(this.corner2);
      this.lines = [];
      this.bgLine = this.drawLine('#d6d6d6', this.pLeft, 15, this.width, 15);
      for (var j = 0; j < this.timeLines.length; j++) {
        var line = this.timeLines[j];
        var color = String(line.timeType.color);
        var lineTotalTime = 0;
        if (!line.finishedTimestamp) {
          lineTotalTime = Math.round(new Date() / 1000) - line.startedTimestamp;
        } else {
          lineTotalTime = line.totalTime;
        }
        var percent = lineTotalTime / this.plannedDuration;
        var start = currentPos;
        var end = currentPos + Math.floor(this.width * percent);
        if (end > this.width) {
          end = this.width;
        }
        this.lines.push(this.drawLine(color, start, 15, end, 15));
        currentPos = end;
        this.currentColor = color;
      }
      this.drawCorners();
      this.setProgressPercent(Math.round(this.lineTotal * 100 / this.plannedDuration));
    }
  }, {
    key: 'getTotal',
    value: function getTotal() {
      var totalTime = 0;
      for (var i = 0; i < this.timeLines.length; i++) {
        var line = this.timeLines[i];
        var lineTotalTime = 0;
        if (!line.finishedTimestamp) {
          lineTotalTime = Math.round(new Date() / 1000) - line.startedTimestamp;
        } else {
          lineTotalTime = line.totalTime;
        }
        totalTime += lineTotalTime;
      }
      return totalTime;
    }
  }, {
    key: 'setLineItems',
    value: function setLineItems(timeLines) {
      var _this = this;

      if (this.interval) {
        clearInterval(this.interval);
      }
      this.timeLines = timeLines;
      this.lineTotal = this.getTotal();
      var delta = this.lineTotal - this.plannedDuration;
      if (delta > 0) {
        var adjustDuration = 30 * 60;
        this.plannedDuration += Math.ceil(delta / adjustDuration) * adjustDuration;
      }
      this.drawTimeLines();
      this.interval = setInterval(function () {
        _this.lineTotal += 1;
        if (_this.lineTotal >= _this.plannedDuration) {
          _this.plannedDuration += 30 * 60;
        }
        return _this.drawTimeLines();
      }, 1000);
    }
  }, {
    key: 'setProgressPercent',
    value: function setProgressPercent(value) {
      this.stage.removeChild(this.label);
      var text = value + '%';
      // eslint-disable-next-line no-undef
      this.label = new createjs.Text(text, 'normal 12px Arial', '#fff');
      this.stage.addChild(this.label);
      this.label.x = this.width / 2 - 10;
      this.label.y = 15 - 7;
      return this.stage.update();
    }
  }, {
    key: 'stop',
    value: function stop() {
      if (this.interval) {
        clearInterval(this.interval);
      }
    }
  }]);

  return QTestExplorerTimeLinesControl;
}();

},{}],2:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RecordingViewModel = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _timeLinesControl = require('../../../common/controls/timeLinesControl.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var RecordingViewModel = exports.RecordingViewModel = function () {
  function RecordingViewModel(inProgress) {
    var _this = this;

    _classCallCheck(this, RecordingViewModel);

    this.inProgress = inProgress;
    // eslint-disable-next-line no-undef
    this.$tester = $('#tester');
    // eslint-disable-next-line no-undef
    this.$form = $('#recordingForm');
    this.$timeTypes = this.$form.find('#timeTypes');
    this.$noteTypes = this.$form.find('#noteTypes');
    this.$note = this.$form.find('#note');
    this.$addNoteBtn = this.$form.find('#addNoteBtn');
    this.$noteText = this.$form.find('#noteText');
    this.$fieldSet = this.$form.find('#recordingFormFields');
    this.$progress = this.$form.find('.loader');
    var canvas = this.$form.find('#timeLinesCanvas')[0];
    this.$linesControl = new _timeLinesControl.QTestExplorerTimeLinesControl(canvas);
    this.$addNoteBtn.attr('disabled', 'disabled');
    this.$noteText.on('keyup', function () {
      if (_this.$noteText.val().length === 0) {
        _this.$addNoteBtn.attr('disabled', 'disabled');
      }
      _this.$addNoteBtn.removeAttr('disabled');
    });
    this.$sessionLink = this.$form.find('#sessionLink');
    // eslint-disable-next-line no-undef
    this.$logoutIcon = $('#logout-icon');
    this.$pauseBtn = this.$form.find('#pauseBtn');
    this.$completeSessionBtn = this.$form.find('#completeSessionBtn');
    this.$captureVisiblePartBtn = this.$form.find('#captureVisiblePartBtn');
    this.$captureFullPageBtn = this.$form.find('#captureFullPageBtn');
    this.$editCurrentBtn = this.$form.find('#editCurrentBtn');
    this.$staticStatusText = this.$form.find('.staticStatusText');
    // eslint-disable-next-line no-undef
    this.$settingIcon = $('#setting-icon');
  }

  _createClass(RecordingViewModel, [{
    key: 'show',
    value: function show(state) {
      var _this2 = this;

      var populate = function populate(data) {
        if (data.user.email.length <= 36) {
          _this2.$tester.text(data.user.email);
        } else {
          _this2.$tester.text(data.user.email.substring(0, 32) + '...');
        }
        var title = data.session.title;
        if (title.length <= 40) {
          _this2.$sessionLink.text(title);
        } else {
          _this2.$sessionLink.text(title.substring(0, 39) + '...');
        }
        _this2.$sessionLink.attr('title', 'View session \'' + title + '\'');
        if (!data.canCaptureVisiblePart) {
          _this2.$captureVisiblePartBtn.attr('disabled', 'disabled');
        } else {
          _this2.$captureVisiblePartBtn.removeAttr('disabled');
        }
        if (!data.canCaptureFullPage) {
          _this2.$captureFullPageBtn.attr('disabled', 'disabled');
        } else {
          _this2.$captureFullPageBtn.removeAttr('disabled');
        }
        if (!data.canEditCurrentScreen) {
          _this2.$editCurrentBtn.attr('disabled', 'disabled');
        } else {
          _this2.$editCurrentBtn.removeAttr('disabled');
        }
        _this2.$timeTypes.empty();
        // eslint-disable-next-line no-undef
        $.each(data.timeTypes, function (index, timeType) {
          // eslint-disable-next-line no-undef
          var $option = $('<li></li>');
          // eslint-disable-next-line no-undef
          var $optionA = $('<a href="#">' + timeType.name + '</a>');
          $optionA.attr('style', 'color:' + timeType.color + ';');
          $option.append($optionA);
          _this2.$timeTypes.append($option);
          $optionA.on('click', function (e) {
            e.preventDefault();
            _this2.timeTypeChanged(timeType);
          });
        });
        _this2.$timeTypes.val(data.session.currentTimeType);
        if (data.session.plannedDuration) {
          var hour = parseInt(data.session.plannedDuration.hour);
          var min = parseInt(data.session.plannedDuration.min);
          _this2.$linesControl.plannedDuration = (hour * 60 + min) * 60;
          _this2.$linesControl.setLineItems(data.session.timeLines);
          if (data.session.timeLines.length > 0) {
            var l = data.session.timeLines.length;
            _this2.setCurrentTimeType(data.session.timeLines[l - 1].timeType);
          }
        }
        _this2.$noteTypes.empty();
        // eslint-disable-next-line no-undef
        $.each(data.noteTypes, function (index, noteType) {
          // eslint-disable-next-line no-undef
          var $option = $('<li></li>');
          // eslint-disable-next-line no-undef
          var $optionA = $('<a href="#">' + noteType.name + '</a>');
          $optionA.attr('style', 'color:' + noteType.color + ';');
          $option.append($optionA);
          _this2.$noteTypes.append($option);
          $optionA.on('click', function (e) {
            e.preventDefault();
            _this2.noteTypeChanged(noteType);
          });
        });
        if (data.noteTypes.length > 0) {
          _this2.noteTypeChanged(data.noteTypes[0]);
        }
        _this2.bindEvents();
        if (_this2.inProgress) {
          _this2.$fieldSet.attr('disabled', 'disabled');
          _this2.$progress.show();
          _this2.$settingIcon.hide();
          var timeOut = null;
          var waitForLoggedInStatus = function waitForLoggedInStatus() {
            if (timeOut) {
              clearTimeout(timeOut);
              timeOut = null;
            }
            timeOut = window.setTimeout(function () {
              chrome.runtime.sendMessage({
                name: 'getStatus'
              }, function (response) {
                if (response.name === 'loggedIn') {
                  window.close();
                } else {
                  waitForLoggedInStatus();
                }
              });
            }, 2000);
          };
          waitForLoggedInStatus();
        } else {
          _this2.$settingIcon.show();
          _this2.$fieldSet.removeAttr('disabled');
          _this2.$progress.hide();
        }
      };
      if (state) {
        populate(state);
      } else {
        chrome.runtime.sendMessage({
          name: 'getStatus'
        }, function (response) {
          populate(response.info);
        });
      }
    }
  }, {
    key: 'showStatusText',
    value: function showStatusText(text, hideAfterMilliseconds) {
      var _this3 = this;

      this.$staticStatusText.text(text);
      this.$staticStatusText.show();
      if (hideAfterMilliseconds && hideAfterMilliseconds > 0) {
        window.setTimeout(function () {
          _this3.$staticStatusText.hide();
        }, hideAfterMilliseconds);
      }
    }
  }, {
    key: 'bindEvents',
    value: function bindEvents() {
      var _this4 = this;

      this.$sessionLink.on('click', function (e) {
        e.preventDefault();
        chrome.runtime.sendMessage({
          name: 'viewSession'
        }, function (response) {});
      });
      this.$addNoteBtn.on('click', function (e) {
        e.preventDefault();
        _this4.$addNoteBtn.attr('disabled', 'disabled');
        chrome.runtime.sendMessage({
          name: 'addNote',
          noteType: _this4.currentNoteType.name,
          text: _this4.$noteText.val()
        }, function (response) {
          console.log(new Date().toString() + ' add note response: ' + response.success);
          if (response.success === false) {
            _this4.$addNoteBtn.removeAttr('disabled');
          } else {
            _this4.$noteText.val('');
            _this4.showStatusText('Note added successfully.', 1500);
            if (response.canEditCurrentScreen) {
              _this4.$editCurrentBtn.removeAttr('disabled');
            } else {
              _this4.$editCurrentBtn.attr('disabled', 'disabled');
            }
          }
        });
      });
      this.$completeSessionBtn.on('click', function (e) {
        e.preventDefault();
        chrome.runtime.sendMessage({
          name: 'completeSession'
        }, function (response) {});
        _this4.$linesControl.stop();
        window.close();
      });
      this.$pauseBtn.on('click', function (e) {
        e.preventDefault();
        chrome.runtime.sendMessage({
          name: 'toggleRecordingStatus'
        }, function (response) {});
        window.close();
      });
      this.$captureVisiblePartBtn.on('click', function (e) {
        e.preventDefault();
        chrome.runtime.sendMessage({
          name: 'captureVisiblePart'
        }, function (response) {});
        window.close();
      });
      this.$captureFullPageBtn.on('click', function (e) {
        e.preventDefault();
        chrome.runtime.sendMessage({
          name: 'captureFullPage'
        }, function (response) {
          console.log(new Date().toString() + ' captureFullPage response: ' + response.success);
          if (response.success) {
            window.location.href = 'capturingFullPage.html';
          } else {
            window.close();
          }
        });
      });
      this.$editCurrentBtn.on('click', function (e) {
        e.preventDefault();
        chrome.runtime.sendMessage({
          name: 'editCurrentScreen'
        }, function (response) {});
        window.close();
      });
      this.$settingIcon.on('click', function (e) {
        window.location.href = 'settings.html';
      });
    }
  }, {
    key: 'noteTypeChanged',
    value: function noteTypeChanged(noteType) {
      if (this.currentNoteType !== noteType) {
        // eslint-disable-next-line no-undef
        var span = $('#selectedNoteTypeBtn').find('span');
        span.attr('style', 'color:' + noteType.color + ';');
        span.text(noteType.name);
        this.currentNoteType = noteType;
      }
    }
  }, {
    key: 'setCurrentTimeType',
    value: function setCurrentTimeType(timeType) {
      this.$form.find('#selectedTimeTypeBtn').attr('style', 'color:' + timeType.color + ';');
      this.currentTimeType = timeType;
    }
  }, {
    key: 'timeTypeChanged',
    value: function timeTypeChanged(timeType) {
      var _this5 = this;

      if (this.currentTimeType !== timeType) {
        this.setCurrentTimeType(timeType);
        chrome.runtime.sendMessage({
          name: 'switchTimetype',
          timeType: timeType.name
        }, function (response) {
          _this5.$linesControl.setLineItems(response.timeLines);
        });
      }
    }
  }]);

  return RecordingViewModel;
}();

// eslint-disable-next-line no-undef


$(function () {
  chrome.runtime.sendMessage({
    name: 'getStatus'
  }, function (response) {
    var inProgress = response && response.name === 'completingSession';
    var viewModel = new RecordingViewModel(inProgress);
    viewModel.show(response.info);
  });
});

},{"../../../common/controls/timeLinesControl.js":1}]},{},[2]);
