(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SettingsViewModel = exports.SettingsViewModel = function () {
  function SettingsViewModel() {
    _classCallCheck(this, SettingsViewModel);

    // eslint-disable-next-line no-undef
    this.$tester = $('#tester');
    // eslint-disable-next-line no-undef
    this.$form = $('#settings-form');
    this.$stopRecordingSettings = this.$form.find('#stop-recording-settings');
    this.$pauseResumeRecordingSettings = this.$form.find('#pause-resume-settings');
    this.$captureVisiblePartSettings = this.$form.find('#capture-visible-part-settings');
    this.$captureFullPageSettings = this.$form.find('#capture-full-page-settings');
    this.$saveBtn = this.$form.find('#saveBtn');
    this.$cancelBtn = this.$form.find('#cancelBtn');
    this.$errorMessage = this.$form.find('.errorMessage');
    this.$openCommandsConfiguration = this.$form.find('#openCommandsConfiguration');
    this.$enableAutoStart = this.$form.find('#enableAutoStart');
    this.$projects = this.$form.find('#projects');
    this.$domains = this.$form.find('#domains');
    this.$autoStartFields = this.$form.find('#autoStartFields');
    this.selectedProject = null;
    this.$autoStartGroup = this.$form.find('#autoStartGroup');
    this.$autoLogin = this.$form.find('#autoLogin');
    this.$autoLoginLock = this.$form.find('#autoLoginLock');
    this._user = undefined;
  }

  _createClass(SettingsViewModel, [{
    key: 'changeAutoLoginControlState',
    value: function changeAutoLoginControlState(data) {
      var webExplorerSetting = data.settings.webExplorerSetting;
      var enableAutoLogin = webExplorerSetting.enableAutoLogin;
      var autoLogin = webExplorerSetting.autoLogin;
      this.$autoLoginLock.text('This option is managed by your Administrator');

      if (data.user.fromExternal) {
        enableAutoLogin = false;
        autoLogin = false;
        this.$autoLoginLock.text('This option cannot be changed when you\'re redirected from Manager or Sessions');
      }

      if (!enableAutoLogin) {
        this.$autoLogin.attr('disabled', 'disabled');
        this.$autoLoginLock.css('display', 'block');
      } else {
        this.$autoLogin.removeAttr('disabled');
        this.$autoLoginLock.hide();
      }
      this.$autoLogin.prop('checked', autoLogin);
    }
  }, {
    key: 'changeAutoStartControlsState',
    value: function changeAutoStartControlsState(isChecked) {
      if (isChecked) {
        this.$autoStartFields.removeAttr('disabled');
      } else {
        this.$autoStartFields.attr('disabled', 'disabled');
      }
      this.$enableAutoStart.prop('checked', isChecked);
    }
  }, {
    key: 'onProjectChanged',
    value: function onProjectChanged() {
      var selectedProjectId = this.$projects.val();
      for (var i = 0; i < this.autoStartProjects.length; i++) {
        var p = this.autoStartProjects[i];
        if (p.id.toString() === selectedProjectId) {
          this.selectedProject = p;
          this.$domains.val(p.alwaysOnSetting.domains);
          break;
        }
      }
    }
  }, {
    key: 'show',
    value: function show(state) {
      var _this = this;

      this.qTestVersion = state.qTestVersion;
      var populate = function populate(data) {
        if (data.user.email.length <= 36) {
          _this.$tester.text(data.user.email);
        } else {
          _this.$tester.text(data.user.email.substring(0, 32) + '...');
        }

        _this._user = data.user;
        _this.changeAutoLoginControlState(data);

        var hotkeySetting = data.settings.hotkeySetting;
        if (data.qTestVersion >= 7) {
          _this.autoStartProjects = data.autoStartProjects;
          var enableAutoStart = false;
          var domainList = _this.autoStartProjects[0] ? _this.autoStartProjects[0].alwaysOnSetting.domains : undefined;
          // eslint-disable-next-line no-undef
          $.each(_this.autoStartProjects, function (index, project) {
            if (data.user.autoStartSetting.projectId === project.id.toString()) {
              domainList = project.alwaysOnSetting.domains;
              enableAutoStart = data.user.autoStartSetting.isEnableAutoStart && domainList.length > 0;
              // eslint-disable-next-line no-undef
              _this.$projects.append($('<option/>', {
                value: project.id,
                text: project.name,
                selected: 'selected'
              }));
              _this.selectedProject = project;
            } else {
              // eslint-disable-next-line no-undef
              _this.$projects.append($('<option/>', {
                value: project.id,
                text: project.name
              }));
            }
          });
          _this.changeAutoStartControlsState(enableAutoStart);
          _this.$domains.val(domainList);
        } else {
          _this.$autoStartGroup.hide();
        }
        _this.populateHotkeySettings(_this.$stopRecordingSettings, hotkeySetting.stopRecording);
        _this.populateHotkeySettings(_this.$pauseResumeRecordingSettings, hotkeySetting.pauseResumeRecording);
        _this.populateHotkeySettings(_this.$captureVisiblePartSettings, hotkeySetting.captureVisiblePart);
        _this.populateHotkeySettings(_this.$captureFullPageSettings, hotkeySetting.captureFullPage);
        _this.bindEvents();
      };
      if (state) {
        populate(state);
      } else {
        chrome.runtime.sendMessage({
          name: 'getSettings'
        }, function (response) {
          populate(response.info);
        });
      }
    }
  }, {
    key: 'populateHotkeySettings',
    value: function populateHotkeySettings($group, settings) {
      $group.find('#chkAlt').prop('checked', settings.altKey);
      $group.find('#chkShift').prop('checked', settings.shiftKey);
      var $txtKey = $group.find('#txtKey');
      $txtKey.attr('value', settings.keyCode);
      $txtKey.bind('keydown', function (event) {
        if (!event.shiftKey && !event.ctrlKey && !event.altKey && (event.keyCode === 9 || event.keyCode >= 65 && event.keyCode <= 90 || event.keyCode >= 48 && event.keyCode <= 57 || event.keyCode >= 96 && event.keyCode <= 105)) {
          if (event.keyCode !== 9) {
            $txtKey.attr('value', String.fromCharCode(event.keyCode).toUpperCase());
            event.preventDefault();
          }
        } else if (event.keyCode !== 8 && event.keyCode !== 46 && event.keyCode !== 37 && event.keyCode !== 39) {
          event.preventDefault();
        }
      });

      $txtKey.bind('blur focusout', function () {
        if ($txtKey.val() === '') {
          $txtKey.val(settings.keyCode);
        }
      });
    }
  }, {
    key: 'bindEvents',
    value: function bindEvents() {
      var _this2 = this;

      if (this.qTestVersion >= 7) {
        this.$enableAutoStart.on('click', function (e) {
          _this2.changeAutoStartControlsState(e.target.checked);
        });
        this.$projects.on('change', function () {
          _this2.onProjectChanged();
        });
      }
      this.$openCommandsConfiguration.on('click', function (e) {
        e.preventDefault();
        chrome.runtime.sendMessage({
          name: 'openCommandsConfiguration'
        }, function (response) {});
        window.close();
      });
      this.$cancelBtn.on('click', function (e) {
        e.preventDefault();
        window.close();
      });
      this.$saveBtn.on('click', function (e) {
        e.preventDefault();
        _this2.$errorMessage.hide();
        var buildHotkeys = function buildHotkeys($group, groupName) {
          var keyCombination = 'ctrl';
          if ($group.find('#chkAlt').is(':checked')) {
            keyCombination += '+alt';
          }
          if ($group.find('#chkShift').is(':checked')) {
            keyCombination += '+shift';
          }
          keyCombination += '+' + $group.find('#txtKey').val();
          return {
            name: groupName,
            keyCombination: keyCombination
          };
        };
        var hotkeys = [];
        hotkeys.push(buildHotkeys(_this2.$stopRecordingSettings, 'Stop Recording'));
        hotkeys.push(buildHotkeys(_this2.$pauseResumeRecordingSettings, 'Pause/Resume'));
        hotkeys.push(buildHotkeys(_this2.$captureVisiblePartSettings, 'Capture Visible Part'));
        hotkeys.push(buildHotkeys(_this2.$captureFullPageSettings, 'Capture Full Page'));
        var duplicated = false;

        for (var i = 0; i < hotkeys.length - 1; i++) {
          if (duplicated === true) {
            break;
          }

          for (var j = i + 1; j < hotkeys.length; j++) {
            if (hotkeys[i].keyCombination === hotkeys[j].keyCombination) {
              duplicated = true;
              _this2.$errorMessage.text(hotkeys[i].name + ' and ' + hotkeys[j].name + ' keys are duplicated');
              _this2.$errorMessage.show();
              break;
            }
          }
        }
        var collectSetting = function collectSetting($group) {
          return {
            altKey: $group.find('#chkAlt').is(':checked'),
            shiftKey: $group.find('#chkShift').is(':checked'),
            keyCode: $group.find('#txtKey').val()
          };
        };
        if (duplicated === false) {
          var settings = {
            hotkeySetting: {
              stopRecording: collectSetting(_this2.$stopRecordingSettings),
              pauseResumeRecording: collectSetting(_this2.$pauseResumeRecordingSettings),
              captureVisiblePart: collectSetting(_this2.$captureVisiblePartSettings),
              captureFullPage: collectSetting(_this2.$captureFullPageSettings)
            },
            webExplorerSetting: {
              enableAutoLogin: !_this2.$autoLoginLock.is(':disabled'),
              autoLogin: _this2.$autoLogin.is(':checked')
            }
          };
          if (_this2.qTestVersion >= 7) {
            settings.autoStartSetting = {
              enableAutoStart: _this2.$enableAutoStart.prop('checked'),
              projectId: _this2.$projects.val(),
              domains: _this2.$domains.val(),
              projectName: _this2.selectedProject ? _this2.selectedProject.name : undefined
            };
          }

          if (_this2._user && _this2._user.fromExternal) {
            settings.webExplorerSetting = undefined;
          }

          chrome.runtime.sendMessage({
            name: 'saveSettings',
            settings: settings
          }, function (response) {
            window.close();
          });
        }
      });
    }
  }]);

  return SettingsViewModel;
}();

// eslint-disable-next-line no-undef


$(function () {
  chrome.runtime.sendMessage({
    name: 'getSettings'
  }, function (response) {
    var viewModel = new SettingsViewModel();
    viewModel.show(response.info);
  });
});

},{}]},{},[1]);
