(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var StartSessionViewModel = exports.StartSessionViewModel = function () {
  function StartSessionViewModel(inProgress) {
    _classCallCheck(this, StartSessionViewModel);

    this.inProgress = inProgress;
    // eslint-disable-next-line no-undef
    this.$form = $('#createSessionForm');
    // eslint-disable-next-line no-undef
    this.$tester = $('#tester');
    this.$projects = this.$form.find('#projects');
    this.$newSession = this.$form.find('#newSession');
    this.$runSession = this.$form.find('#runSession');
    this.$title = this.$form.find('#title');
    this.$sessions = this.$form.find('#sessions');
    this.$description = this.$form.find('#description');
    this.$plannedDurationHour = this.$form.find('#plannedDuration-hour');
    this.$plannedDurationMin = this.$form.find('#plannedDuration-min');
    this.$progressStartSession = this.$form.find('#progressStartSession');
    this.$progressLoadSessions = this.$form.find('#progressLoadSessions');
    this.$fieldSet = this.$form.find('#createSessionFormFields');
    this.$createSessionBtn = this.$form.find('#createSessionBtn');
    this.$errorMessage = this.$form.find('.errorMessage');
    // eslint-disable-next-line no-undef
    this.$logoutIcon = $('#logout-icon');
    // eslint-disable-next-line no-undef
    this.$settingIcon = $('#setting-icon');
    this.$domainFilterGroup = this.$form.find('input[name=domainFilter]');
    this.$domainEditContainer = this.$form.find('#domainEditContainer');
    this.$domainFilterEdit = this.$form.find('#domainFilterEdit');
  }

  _createClass(StartSessionViewModel, [{
    key: 'sessionChanged',
    value: function sessionChanged(sessions) {
      var _this = this;

      this.$errorMessage.hide();
      if (sessions && sessions.length > 0) {
        this.$sessions.empty();
        // eslint-disable-next-line no-undef
        $.each(sessions, function (index, session) {
          // eslint-disable-next-line no-undef
          _this.$sessions.append($('<option/>', {
            value: session.id,
            text: session.title
          }));
        });
      } else if (!this.allProjectSessions || this.allProjectSessions.length <= 0) {
        this.$sessions.empty();
      }
      var selectedSessionId = this.$sessions.val();
      if (this.allProjectSessions && this.allProjectSessions.length > 0) {
        // eslint-disable-next-line no-undef
        $.each(this.allProjectSessions, function (index, session) {
          if (session.id === selectedSessionId) {
            _this.$description.val(session.description);
            var hour = session.plannedDuration.hour;
            var min = session.plannedDuration.min;
            if (hour === 0 && min === 0) {
              _this.$plannedDurationHour.val('01');
              _this.$plannedDurationMin.val('30');
            } else {
              if (hour < 10) {
                hour = '0' + hour;
              }
              if (min < 10) {
                min = '0' + min;
              }
              _this.$plannedDurationHour.val(hour);
              _this.$plannedDurationMin.val(min);
            }
          }
        });
      }
    }
  }, {
    key: 'runSessionOnChecked',
    value: function runSessionOnChecked() {
      this.$errorMessage.hide();
      this.$title.parent().removeClass('has-error');
      this.$sessions.focus();
      this.hideRequiredTitleMsg();
    }
  }, {
    key: 'hideRequiredTitleMsg',
    value: function hideRequiredTitleMsg() {
      var $parsleyTitle = this.$form.find('#parsley-plannedTitle');
      $parsleyTitle.parent().removeClass('has-error');
      $parsleyTitle.find('.parsley-required').text('');
      $parsleyTitle.hide();
    }
  }, {
    key: 'checkProjectPermission',
    value: function checkProjectPermission() {
      var selectedProjectId = this.$projects.val();
      for (var j = 0; j < this.allProjects.length; j++) {
        var project = this.allProjects[j];
        if (selectedProjectId && project.id.toString() === selectedProjectId.toString()) {
          if (project.canCreate === false) {
            this.$newSession.attr('disabled', 'disabled');
            this.$runSession.prop('checked', true);
            this.runSessionOnChecked();
          } else {
            this.$newSession.removeAttr('disabled');
          }
          break;
        }
      }
    }
  }, {
    key: 'populate',
    value: function populate(data) {
      var _this2 = this;

      if (data.user.email.length <= 36) {
        this.$tester.text(data.user.email);
      } else {
        this.$tester.text(data.user.email.substring(0, 32) + '...');
      }
      this.allProjects = data.projects;
      this.$projects.empty();
      var selectedProject = null;
      var lastSelectedProjectId = data.lastSelectedProjectId;
      var hasLastSelectedProjectId = false;
      // eslint-disable-next-line no-undef
      $.each(data.projects, function (index, project) {
        // eslint-disable-next-line no-undef
        _this2.$projects.append($('<option/>', {
          value: project.id,
          text: project.name
        }));
        if (lastSelectedProjectId === project.id) {
          hasLastSelectedProjectId = true;
        }
        if (data.selectedProject && data.selectedProject === project.id) {
          selectedProject = project;
        }
      });
      if (this.inProgress && selectedProject && data.runExisting) {
        this.$projects.val(selectedProject.id);
        this.$runSession.prop('checked', true);
        this.$title.removeAttr('required');
        this.$sessions.attr('required', 'required');
        this.$sessions.focus();
        this.allProjectSessions = selectedProject.sessions;
        this.sessionChanged(this.allProjectSessions);
        this.$title.hide();
        this.$sessions.show();
      } else if (hasLastSelectedProjectId) {
        this.$projects.val(data.lastSelectedProjectId);
      } else if (data.projects && data.projects.length > 0) {
        this.$projects.val(data.projects[0].id);
      }
      if (hasLastSelectedProjectId) {
        this.$projects.val(data.lastSelectedProjectId);
      } else if (data.projects && data.projects.length > 0) {
        this.$projects.val(data.projects[0].id);
      }
      if (data.session) {
        this.$projects.val(String(data.session.project));
        this.$sessions.val(data.session.id);
        this.$title.val(data.session.title);
        this.$description.val(data.session.description);
        this.$plannedDurationHour.val(data.session.plannedDuration.hour);
        this.$plannedDurationMin.val(data.session.plannedDuration.min);
      }
      this.$tester.val(data.user.email);
      this.domainOptions = data.domainOptions;
      this.$domainFilterEdit.val(this.domainOptions.domains.join(' '));
      var value = 'noFilter';
      if (data.domainOptions.all === true) {
        this.$domainEditContainer.hide();
      } else if (data.domainOptions.include === true) {
        value = 'include';
        this.$domainEditContainer.show();
      } else if (data.domainOptions.exclude === true) {
        value = 'exclude';
        this.$domainEditContainer.show();
      }
      var radio = this.$form.find('input:radio[name=domainFilter][value=' + value + ']');
      radio.attr('checked', true);
      if (this.inProgress === true) {
        this.$logoutIcon.hide();
        this.$settingIcon.hide();
        this.$fieldSet.attr('disabled', 'disabled');
        this.$progressStartSession.show();
        var waitForRecordinginStatus = function waitForRecordinginStatus() {
          window.setTimeout(function () {
            chrome.runtime.sendMessage({
              name: 'getStatus'
            }, function (response) {
              if (response.name === 'recording') {
                window.close();
              } else {
                waitForRecordinginStatus();
              }
            });
          }, 1000);
        };
        waitForRecordinginStatus();
      } else {
        this.$fieldSet.removeAttr('disabled');
        this.$logoutIcon.show();
        this.$settingIcon.show();
        this.$progressStartSession.hide();
        this.bindEvents();
      }
    }
  }, {
    key: 'show',
    value: function show(state) {
      var _this3 = this;

      if (state) {
        this.populate(state);
      } else {
        chrome.runtime.sendMessage({
          name: 'getStatus'
        }, function (response) {
          _this3.populate(response.info);
        });
      }
    }
  }, {
    key: 'bindEvents',
    value: function bindEvents() {
      var _this4 = this;

      var parsleyForm = this.$form.parsley();
      parsleyForm.subscribe('parsley:form:validate', function (formInstance) {
        formInstance.submitEvent.preventDefault();

        if (formInstance.isValid('', false) && _this4.validateTitle() && _this4.validatePlannedDuration()) {
          _this4.$logoutIcon.hide();
          _this4.$settingIcon.hide();
          _this4.$errorMessage.hide();
          _this4.$fieldSet.attr('disabled', 'disabled');
          _this4.$progressStartSession.show();
          var title = _this4.$title.val();
          if (_this4.$runSession.is(':checked')) {
            title = '';
          }
          var domainOptions = {
            all: true,
            include: false,
            exclude: false,
            domains: []
          };
          var domainFilter = _this4.$form.find('input[name=domainFilter]:checked');
          var domainFilterVal = domainFilter.val();
          if (domainFilterVal !== 'noFilter') {
            var domains = [];
            var existing = function existing(domainString) {
              if (domains.length === 0) {
                return false;
              }
              for (var i = 0; i < domains.length; i++) {
                if (domains[i].toLowerCase() === domainString.toLowerCase()) {
                  return true;
                }
              }
              return false;
            };
            var selectedDomains = _this4.$domainFilterEdit.val().split(' ');
            if (selectedDomains.length > 0) {
              for (var i = 0; i < selectedDomains.length; i++) {
                var domainString = selectedDomains[i].trim();
                if (domainString !== '' && existing(domainString) === false) {
                  domains.push(domainString);
                }
              }
            }
            domainOptions = {
              all: false,
              include: domainFilterVal === 'include',
              exclude: domainFilterVal === 'exclude',
              domains: domains
            };
          }
          var canvas = document.createElementNS('http://www.w3.org/1999/xhtml', 'html:canvas');
          var ctx = canvas.getContext('2d');
          var backingStoreRatio = ctx.webkitBackingStorePixelRatio || ctx.mozBackingStorePixelRatio || ctx.msBackingStorePixelRatio || ctx.oBackingStorePixelRatio || ctx.backingStorePixelRatio || 1;
          var devicePixelRatio = window.devicePixelRatio || 1;
          var ratio = devicePixelRatio / backingStoreRatio;
          chrome.runtime.sendMessage({
            name: 'startSession',
            project: _this4.$projects.val(),
            title: title,
            id: _this4.$sessions.val(),
            description: _this4.$description.val(),
            isRunExisting: _this4.$runSession.is(':checked'),
            plannedDuration: {
              hour: _this4.$plannedDurationHour.val(),
              min: _this4.$plannedDurationMin.val()
            },
            tester: _this4.$tester.val(),
            domainOptions: domainOptions,
            defaultDevicePixelRatio: ratio
          }, function (response) {
            _this4.$progressStartSession.hide();
            if (response.success === false) {
              var errorMsg = 'Unknown error while starting session.';
              if (response.error) {
                if (response.error.status === 404) {
                  errorMsg = 'Error starting session: Server not found or session was deleted.';
                } else if (response.error.status === 409 || response.error.status === 412) {
                  errorMsg = 'Error starting session: session is out of date.';
                } else if (response.error.status === 500) {
                  errorMsg = 'Error starting session. Please contact Tricentis.';
                } else {
                  errorMsg = 'Error starting session: ' + response.error.status + '. Please contact Tricentis.';
                }
              }
              _this4.showError(errorMsg, 1500);
              _this4.$fieldSet.removeAttr('disabled');
              _this4.$logoutIcon.show();
              _this4.$settingIcon.show();
            }
          });
        }
      });
      this.bind();
    }
  }, {
    key: 'bind',
    value: function bind() {
      var _this5 = this;

      this.$projects.on('change', function () {
        _this5.projectChanged();
      });
      this.projectChanged();
      this.$runSession.on('change', function () {
        _this5.runSessionOnChecked();
        _this5.projectChanged();
      });
      this.$newSession.on('change', function () {
        _this5.$title.focus();
        _this5.$title.show();
        _this5.$sessions.hide();
        _this5.clearAllFields();
        var $parsleyTitle = _this5.$form.find('#parsley-plannedTitle');
        $parsleyTitle.parent().removeClass('has-error');
        $parsleyTitle.find('.parsley-required').text('');
        $parsleyTitle.hide();
      });
      this.$sessions.on('change', function () {
        _this5.sessionChanged();
      });
      this.$logoutIcon.on('click', function (e) {
        e.preventDefault();
        chrome.runtime.sendMessage({
          name: 'logout'
        }, function (response) {});
        window.close();
      });
      this.$settingIcon.on('click', function (e) {
        e.preventDefault();
        window.location.href = 'settings.html';
      });
      this.$plannedDurationHour.on('keydown', this.onNumericTextboxKeydown);
      this.$plannedDurationMin.on('keydown', this.onNumericTextboxKeydown);
      this.$domainFilterGroup.on('change', function () {
        var checked = _this5.$form.find('input[name=domainFilter]:checked');
        var checkVal = checked.val();
        if (checkVal === 'noFilter') {
          _this5.$domainEditContainer.hide();
        } else {
          _this5.$domainEditContainer.show();
        }
      });
    }
  }, {
    key: 'validateTitle',
    value: function validateTitle() {
      var valid = true;
      var $parsleyTitle = this.$form.find('#parsley-plannedTitle');
      if (this.$newSession.is(':checked') === true) {
        valid = this.$title.val() !== null && this.$title.val().trim() !== '';
        if (valid === false) {
          this.$title.parent().addClass('has-error');
          $parsleyTitle.find('.parsley-required').text('This value is required.');
          $parsleyTitle.show();
        } else {
          $parsleyTitle.find('.parsley-required').text('');
          $parsleyTitle.hide();
          this.$title.parent().removeClass('has-error');
        }
      } else {
        valid = this.$sessions.val() !== null && this.$sessions.val() !== '';
        if (valid === false) {
          this.$sessions.parent().addClass('has-error');
          $parsleyTitle.find('.parsley-required').text('This value is required.');
          $parsleyTitle.show();
        } else {
          this.$sessions.parent().removeClass('has-error');
        }
      }
      return valid;
    }
  }, {
    key: 'validatePlannedDuration',
    value: function validatePlannedDuration() {
      var $parsleyPlannedDuration = this.$form.find('#parsley-plannedDuration');
      var valid = /^[0-9]+$/.test(this.$plannedDurationHour.val());
      if (valid === false) {
        this.$plannedDurationHour.parent().addClass('has-error');
        $parsleyPlannedDuration.find('.parsley-required').text('Hour(s) must be a valid number');
        $parsleyPlannedDuration.show();
      } else {
        this.$plannedDurationHour.parent().removeClass('has-error');
        $parsleyPlannedDuration.hide();
        valid = /^[0-9]+$/.test(this.$plannedDurationMin.val());
        if (valid === false) {
          this.$plannedDurationMin.parent().addClass('has-error');
          $parsleyPlannedDuration.find('.parsley-required').text('Minute(s) must be a valid number');
          $parsleyPlannedDuration.show();
        } else {
          this.$plannedDurationMin.parent().removeClass('has-error');
          $parsleyPlannedDuration.hide();
        }
      }
      if (valid) {
        var hour = parseInt(this.$plannedDurationHour.val());
        var min = parseInt(this.$plannedDurationMin.val());
        if (hour === 0 && min === 0) {
          this.$plannedDurationHour.val('01');
          this.$plannedDurationMin.val('30');
        }
      }
      return valid;
    }
  }, {
    key: 'clearAllFields',
    value: function clearAllFields() {
      this.$title.val('');
      this.$description.val('');
      this.$plannedDurationHour.val('01');
      this.$plannedDurationMin.val('30');
    }
  }, {
    key: 'projectChanged',
    value: function projectChanged() {
      var _this6 = this;

      this.checkProjectPermission();
      if (this.$runSession.is(':checked')) {
        this.$fieldSet.attr('disabled', 'disabled');
        this.$progressLoadSessions.show();
        chrome.runtime.sendMessage({
          name: 'getSessions',
          project: this.$projects.val()
        }, function (response) {
          _this6.$fieldSet.removeAttr('disabled');
          _this6.$progressLoadSessions.hide();
          if (response.success === false) {
            if (response.error) {
              var errorMsg = 'Error loading session: ' + response.error.status + '. Please contact Tricentis.';
              if (response.error.status === 404) {
                errorMsg = 'Error loading session: Server not found.';
              } else if (response.error.status === 500) {
                errorMsg = 'Server error while loading session. Please contact Tricentis.';
              }
              _this6.showError(errorMsg, 1500);
            }
          } else {
            _this6.$title.hide();
            _this6.$sessions.show();
            _this6.allProjectSessions = response.sessions;
            _this6.sessionChanged(_this6.allProjectSessions);
            if (!_this6.allProjectSessions || _this6.allProjectSessions.length <= 0) {
              _this6.clearAllFields();
            }
          }
        });
      }
      this.hideRequiredTitleMsg();
    }
  }, {
    key: 'showError',
    value: function showError(errorMessage, hideAfterMilliseconds) {
      var _this7 = this;

      this.$errorMessage.text(errorMessage);
      this.$errorMessage.show();
      if (hideAfterMilliseconds && hideAfterMilliseconds > 0) {
        window.setTimeout(function () {
          _this7.$errorMessage.hide();
        }, hideAfterMilliseconds);
      }
    }
  }, {
    key: 'onNumericTextboxKeydown',
    value: function onNumericTextboxKeydown(evt) {
      if (evt.shiftKey) {
        if (evt.keyCode !== 9) {
          evt.preventDefault();
          return;
        }
      }
      if (evt.which === 13 || evt.keyCode === 46 || evt.keyCode === 8 || evt.keyCode === 9) {
        return;
      }
      if ((evt.keyCode === 48 || evt.keyCode === 96) && this.val().length === 0) {
        evt.preventDefault();
      } else if (evt.keyCode < 95) {
        if (evt.keyCode < 48 || evt.keyCode > 57) {
          evt.preventDefault();
        }
      } else if (evt.keyCode < 96 || evt.keyCode > 105) {
        evt.preventDefault();
      }
    }
  }]);

  return StartSessionViewModel;
}();

// eslint-disable-next-line no-undef


$(function () {
  chrome.runtime.sendMessage({
    name: 'getStatus'
  }, function (response) {
    var inProgress = response.name === 'startingSession';
    var viewModel = new StartSessionViewModel(inProgress);
    viewModel.show(response.info);
  });
});

},{}]},{},[1]);
