(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.QtestContext = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _statusEnum = require('./services/model/statusEnum.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var QtestContext = exports.QtestContext = function () {
  function QtestContext() {
    _classCallCheck(this, QtestContext);
  }

  _createClass(QtestContext, null, [{
    key: 'clear',
    value: function clear() {
      this._user = null;
      this._session = null;
      this._projects = [];
      this._selectedProject = null;
      this._timeTypes = [];
      this._noteTypes = [];
      this._pendingAnnotations = [];
      this._currentProcessingScreen = null;
      this._domainOptions = null;
      this._runFromQtest = false;
      this._projectId = null;
      this._sessionId = null;
      this._status = {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    }
  }, {
    key: 'canRecordMedia',
    value: function canRecordMedia() {
      return this._qTestVersion && this._qTestVersion >= 6;
    }
  }, {
    key: 'getProjectAutoStartSupported',
    value: function getProjectAutoStartSupported() {
      var result = [];
      if (this._projects) {
        var ref = this._projects;
        for (var j = 0, len = ref.length; j < len; j++) {
          var p = ref[j];
          if (p.alwaysOnSetting.domains.length > 0 && p.alwaysOnSetting.enabled) {
            result.push(p);
          }
        }
      }
      return result;
    }
  }, {
    key: 'qTestVersion',
    get: function get() {
      return this._qTestVersion || null;
    },
    set: function set(qTestVersion) {
      this._qTestVersion = qTestVersion;
    }
  }, {
    key: 'qTestMinorVersion',
    get: function get() {
      return this._qTestMinorVersion || null;
    },
    set: function set(qTestMinorVersion) {
      this._qTestMinorVersion = qTestMinorVersion;
    }
  }, {
    key: 'session',
    get: function get() {
      return this._session || null;
    },
    set: function set(session) {
      this._session = session;
    }
  }, {
    key: 'user',
    get: function get() {
      return this._user || null;
    },
    set: function set(user) {
      this._user = user;
    }
  }, {
    key: 'projects',
    get: function get() {
      if (!this._projects) {
        this._projects = [];
      }
      return this._projects;
    },
    set: function set(projects) {
      this._projects = projects;
    }
  }, {
    key: 'selectedProject',
    get: function get() {
      return this._selectedProject || null;
    },
    set: function set(selectedProject) {
      this._selectedProject = selectedProject;
    }
  }, {
    key: 'timeTypes',
    get: function get() {
      if (!this._timeTypes) {
        this._timeTypes = [];
      }
      return this._timeTypes;
    },
    set: function set(timeTypes) {
      this._timeTypes = timeTypes;
    }
  }, {
    key: 'noteTypes',
    get: function get() {
      if (!this._noteTypes) {
        this._noteTypes = [];
      }
      return this._noteTypes;
    },
    set: function set(noteTypes) {
      this._noteTypes = noteTypes;
    }
  }, {
    key: 'pendingAnnotations',
    get: function get() {
      if (!this._pendingAnnotations) {
        this._pendingAnnotations = [];
      }
      return this._pendingAnnotations;
    },
    set: function set(pendingAnnotations) {
      this._pendingAnnotations = pendingAnnotations;
    }
  }, {
    key: 'currentProcessingScreen',
    get: function get() {
      return this._currentProcessingScreen || null;
    },
    set: function set(currentProcessingScreen) {
      this._currentProcessingScreen = currentProcessingScreen;
    }
  }, {
    key: 'domainOptions',
    get: function get() {
      return this._domainOptions || null;
    },
    set: function set(domainOptions) {
      this._domainOptions = domainOptions;
    }
  }, {
    key: 'runFromQtest',
    get: function get() {
      return this._runFromQtest || false;
    },
    set: function set(runFromQtest) {
      this._runFromQtest = runFromQtest;
    }
  }, {
    key: 'projectId',
    get: function get() {
      return this._projectId || null;
    },
    set: function set(projectId) {
      this._projectId = projectId;
    }
  }, {
    key: 'sessionId',
    get: function get() {
      return this._sessionId || null;
    },
    set: function set(sessionId) {
      this._sessionId = sessionId;
    }
  }, {
    key: 'status',
    get: function get() {
      return this._status || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._status = value;
    }
  }, {
    key: 'currentqTestSession',
    get: function get() {
      return this._currentqTestSession || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._currentqTestSession = value;
    }
  }, {
    key: 'sessionManagerVersion',
    get: function get() {
      return this._sessionManagerVersion || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._sessionManagerVersion = value;
    }
  }]);

  return QtestContext;
}();

},{"./services/model/statusEnum.js":4}],2:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HttpRequest = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _qTestContext = require('../qTestContext.js');

var _config = require('../../extension/js/background/config.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var HttpRequest = exports.HttpRequest = function () {
  function HttpRequest() {
    _classCallCheck(this, HttpRequest);
  }

  _createClass(HttpRequest, null, [{
    key: 'getCommonHeaders',
    value: function getCommonHeaders() {
      var headers = {
        'x-client-name': _config.App.name,
        'x-client-version': _config.App.version,
        'x-explorer-api-version': _config.App.apiVersion
      };
      return headers;
    }
  }, {
    key: 'send',
    value: function send(url, token, sendType, data) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        var headers = _this.getCommonHeaders();
        if (token) {
          headers.Authorization = _qTestContext.QtestContext.qTestVersion >= 7 ? 'bearer ' + token : token;
        }
        if (headers && _qTestContext.QtestContext.ownerToken) {
          headers['x-qtest-owner-token'] = _qTestContext.QtestContext.ownerToken;
        }

        // eslint-disable-next-line no-undef
        $.ajax({
          type: sendType,
          url: url,
          data: data,
          contentType: 'application/json;charset=UTF-8',
          dataType: token ? 'json' : null,
          headers: headers
        }).done(function (resultData) {
          resolve({
            data: resultData
          });
        }).fail(function (jqXHR, textStatus, errorThrown) {
          if (jqXHR.status === 200) {
            resolve({});
          } else {
            resolve({
              status: jqXHR.status,
              error: errorThrown
            });
          }
        });
      });
    }
  }, {
    key: 'sendWithResponse',
    value: function sendWithResponse(url, token, sendType, data) {
      var _this2 = this;

      return new Promise(function (resolve, reject) {
        var headers = _this2.getCommonHeaders();
        if (token) {
          headers.Authorization = _qTestContext.QtestContext.qTestVersion >= 7 ? 'bearer ' + token : token;
        }
        if (headers && _qTestContext.QtestContext.ownerToken) {
          headers['x-qtest-owner-token'] = _qTestContext.QtestContext.ownerToken;
        }
        // eslint-disable-next-line no-undef
        $.ajax({
          type: sendType,
          url: url,
          data: data,
          contentType: 'application/json;charset=UTF-8',
          dataType: token ? 'json' : null,
          headers: headers
        }).done(function (resultData, status, xhr) {
          resolve({
            data: resultData,
            response: xhr
          });
        }).fail(function (jqXHR, textStatus, errorThrown) {
          if (jqXHR.status === 200) {
            resolve({});
          } else {
            resolve({
              status: jqXHR.status,
              error: errorThrown
            });
          }
        });
      });
    }
  }, {
    key: 'upload',
    value: function upload(url, token, filename, binaryData, contentType) {
      var _this3 = this;

      return new Promise(function (resolve, reject) {
        if (!binaryData) {
          resolve({
            error: 'HttpRequest: error: No binary data'
          });
          return;
        }
        var oReq = new XMLHttpRequest();
        oReq.open('POST', url, true);
        var headers = _this3.getCommonHeaders();
        if (token) {
          headers.Authorization = _qTestContext.QtestContext.qTestVersion >= 7 ? 'bearer ' + token : token;
        }
        headers['Content-Type'] = contentType;
        headers['x-filename'] = filename;
        // eslint-disable-next-line no-undef
        $.each(headers, function (key, value) {
          if (Object.prototype.hasOwnProperty.call(headers, key) && !(value instanceof Function)) {
            oReq.setRequestHeader(key, value);
          }
        });
        oReq.onload = function (oEvent) {
          var data = oReq.response;
          var responseStatus = oReq.status;
          console.log(new Date().toString() + ' HttpRequest: finished uploading binary data, response status: \'' + responseStatus + '\', response data: \'' + data + '\'...');
          oReq.abort();
          if (responseStatus === 200 || responseStatus === 201) {
            resolve({
              data: JSON.parse(data)
            });
          } else {
            resolve({
              error: responseStatus + 'ERROR'
            });
          }
        };
        oReq.onerror = function (oEvent) {
          resolve({
            error: 'HttpRequest: error :' + oEvent.error
          });
        };
        oReq.send(binaryData);
      });
    }
  }]);

  return HttpRequest;
}();

},{"../../extension/js/background/config.js":6,"../qTestContext.js":1}],3:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ApplicationInfo = exports.ApplicationInfo = function ApplicationInfo(name, version, fileVersion) {
  _classCallCheck(this, ApplicationInfo);

  this.name = name;
  this.version = version;
  this.fileVersion = fileVersion;
};

},{}],4:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var StatusEnum = exports.StatusEnum = {
  notLoggedIn: 'notLoggedIn',

  loggingIn: 'loggingIn',

  loggedIn: 'loggedIn',

  loadingServerSession: 'loadingServerSession',

  loadedServerSession: 'loadedServerSession',

  startingSession: 'startingSession',

  startingSessionIndicator: 'startingSessionIndicator',

  recording: 'recording',

  editing: 'editing',

  paused: 'paused',

  capturingFullPage: 'capturingFullPage',

  inProgress: 'inProgress',

  completingSession: 'completingSession',

  recordingMedia: 'recordingMedia'
};

},{}],5:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SystemInfo = exports.SystemInfo = function SystemInfo(os, resolutions, appVersion) {
  _classCallCheck(this, SystemInfo);

  this.os = os;
  this.resolutions = resolutions;
  this.appVersion = appVersion;
};

},{}],6:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.App = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _systemInfo = require('../../../common/services/model/systemInfo.js');

var _applicationInfo = require('../../../common/services/model/applicationInfo.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var fileVersion = '';
var browserName = '';
var firefoxVersion = '';
var osName = '';
var nAgt = window.navigator.userAgent;
var verOffset = nAgt.indexOf('Firefox');
if (verOffset !== -1) {
  browserName = 'firefox';
  fileVersion = nAgt.substring(verOffset + 8);
  firefoxVersion = parseInt(fileVersion, 10);
}
var mozillaExp = nAgt.match(/Mozilla\/(.*?) /);
if (mozillaExp && mozillaExp.length > 0) {
  var mozillaExp2 = /Mozilla\//;
  var osExp = /\((.*?)\)/;
  osName = navigator.userAgent.match(new RegExp(String(mozillaExp2.source) + mozillaExp[1] + ' ' + osExp.source))[1];
}

var App = exports.App = function () {
  function App() {
    _classCallCheck(this, App);
  }

  _createClass(App, null, [{
    key: 'manifest',
    get: function get() {
      return this._manifest || chrome.runtime.getManifest();
    }
  }, {
    key: 'name',
    get: function get() {
      return this.manifest.name;
    }
  }, {
    key: 'version',
    get: function get() {
      return this.manifest.version;
    }
  }, {
    key: 'apiVersion',
    get: function get() {
      return this.manifest.apiVersion;
    }
  }, {
    key: 'scaleBeforeCompare',
    get: function get() {
      return this._scaleBeforeCompare || true;
    },
    set: function set(value) {
      this._scaleBeforeCompare = value;
    }
  }, {
    key: 'fileVersion',
    get: function get() {
      if (mozillaExp && mozillaExp.length > 0) {
        return mozillaExp[1];
      }
      return -1;
    }
  }, {
    key: 'systemInfo',
    get: function get() {
      var width = window.screen.width * window.devicePixelRatio;
      var height = window.screen.height * window.devicePixelRatio;
      return new _systemInfo.SystemInfo(osName, width + 'x' + height, this.version);
    }
  }, {
    key: 'applicationInfo',
    get: function get() {
      return new _applicationInfo.ApplicationInfo(browserName, firefoxVersion, fileVersion);
    }
  }]);

  return App;
}();

},{"../../../common/services/model/applicationInfo.js":3,"../../../common/services/model/systemInfo.js":5}]},{},[2]);
