(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ImageComparer = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _config = require('./../../extension/js/background/config.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ImageComparer = exports.ImageComparer = function () {
  function ImageComparer() {
    _classCallCheck(this, ImageComparer);
  }

  _createClass(ImageComparer, null, [{
    key: 'imCompare',
    value: function imCompare(c1, c2) {
      /* eslint-disable no-undef */
      return new Promise(function (resolve, reject) {
        IM.setAsynchronous(true);
        IM.setTolerance(99.99);
        IM.compare([c1, c2], function (aCanvas, nElapsedTime, nPercentageMatch) {
          resolve(true);
        }, function (oCanvas, nElapsedTime, nPercentageMatch) {
          resolve(false);
        });
      });
    }
  }, {
    key: 'binaryToBlob',
    value: function binaryToBlob(binary) {
      var byteArray = new Uint8Array(binary);
      var blob = new Blob([byteArray], {
        type: 'image/jpeg'
      });
      return blob;
    }
  }, {
    key: 'compare',
    value: async function compare(s1, s2) {
      if (s1.width !== s2.width || s1.height !== s2.height) {
        return false;
      }
      if (!s1.screenShotBinary && s2.screenShotBinary) {
        return false;
      }
      if (s1.screenShotBinary && !s2.screenShotBinary) {
        return false;
      }
      var image_1 = new Image();
      var image_2 = new Image();
      var canvas_1 = document.createElementNS('http://www.w3.org/1999/xhtml', 'html:canvas');
      var ctx_1 = canvas_1.getContext('2d');
      var canvas_2 = document.createElementNS('http://www.w3.org/1999/xhtml', 'html:canvas');
      var ctx_2 = canvas_2.getContext('2d');

      // let loadCount = 0;
      var scale = 1;
      if (_config.App.scaleBeforeCompare) {
        var width = s1.width;
        var height = s1.height;
        if (width > height && width > 500) {
          scale = 500 / width;
        } else if (height > width && height > 500) {
          scale = 500 / height;
        }
        if (scale < 1) {
          IM.setTolerance(99.99);
        }
      }
      image_1.onload = function () {
        var w = image_1.width;
        var h = image_1.height;

        canvas_1.width = w * scale;
        canvas_1.height = h * scale;
        ctx_1.drawImage(image_1, 0, 0, w, h, 0, 0, w * scale, h * scale);
        window.URL.revokeObjectURL(image_1.src);
      };
      image_2.onload = function () {
        var w = image_2.width;
        var h = image_2.height;
        canvas_2.width = w * scale;
        canvas_2.height = h * scale;
        ctx_2.drawImage(image_2, 0, 0, w, h, 0, 0, w * scale, h * scale);
        window.URL.revokeObjectURL(image_2.src);
      };

      image_1.onerror = function () {
        console.error('Error loading image 1...');
        return false;
      };
      image_2.onerror = function () {
        console.error('Error loading image 2...');
        return false;
      };

      try {
        image_1.src = window.URL.createObjectURL(this.binaryToBlob(s1.screenShotBinary));
      } catch (error) {
        console.error('error converting image binary of screen 1 to blob: ' + error.message);
        return false;
      }
      try {
        image_2.src = window.URL.createObjectURL(this.binaryToBlob(s2.screenShotBinary));
      } catch (error) {
        console.error('error converting image binary of screen 2 to blob: ' + error.message);
        return false;
      }
      try {
        var result = await this.imCompare(canvas_1, canvas_2);
        console.log('compare image successfully, same: ' + result);
        return result;
      } catch (error) {
        console.error('error comparing image: ' + error.message);
        return false;
      }
    }
  }]);

  return ImageComparer;
}();

},{"./../../extension/js/background/config.js":4}],2:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ApplicationInfo = exports.ApplicationInfo = function ApplicationInfo(name, version, fileVersion) {
  _classCallCheck(this, ApplicationInfo);

  this.name = name;
  this.version = version;
  this.fileVersion = fileVersion;
};

},{}],3:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SystemInfo = exports.SystemInfo = function SystemInfo(os, resolutions, appVersion) {
  _classCallCheck(this, SystemInfo);

  this.os = os;
  this.resolutions = resolutions;
  this.appVersion = appVersion;
};

},{}],4:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.App = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _systemInfo = require('../../../common/services/model/systemInfo.js');

var _applicationInfo = require('../../../common/services/model/applicationInfo.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var fileVersion = '';
var browserName = '';
var firefoxVersion = '';
var osName = '';
var nAgt = window.navigator.userAgent;
var verOffset = nAgt.indexOf('Firefox');
if (verOffset !== -1) {
  browserName = 'firefox';
  fileVersion = nAgt.substring(verOffset + 8);
  firefoxVersion = parseInt(fileVersion, 10);
}
var mozillaExp = nAgt.match(/Mozilla\/(.*?) /);
if (mozillaExp && mozillaExp.length > 0) {
  var mozillaExp2 = /Mozilla\//;
  var osExp = /\((.*?)\)/;
  osName = navigator.userAgent.match(new RegExp(String(mozillaExp2.source) + mozillaExp[1] + ' ' + osExp.source))[1];
}

var App = exports.App = function () {
  function App() {
    _classCallCheck(this, App);
  }

  _createClass(App, null, [{
    key: 'manifest',
    get: function get() {
      return this._manifest || chrome.runtime.getManifest();
    }
  }, {
    key: 'name',
    get: function get() {
      return this.manifest.name;
    }
  }, {
    key: 'version',
    get: function get() {
      return this.manifest.version;
    }
  }, {
    key: 'apiVersion',
    get: function get() {
      return this.manifest.apiVersion;
    }
  }, {
    key: 'scaleBeforeCompare',
    get: function get() {
      return this._scaleBeforeCompare || true;
    },
    set: function set(value) {
      this._scaleBeforeCompare = value;
    }
  }, {
    key: 'fileVersion',
    get: function get() {
      if (mozillaExp && mozillaExp.length > 0) {
        return mozillaExp[1];
      }
      return -1;
    }
  }, {
    key: 'systemInfo',
    get: function get() {
      var width = window.screen.width * window.devicePixelRatio;
      var height = window.screen.height * window.devicePixelRatio;
      return new _systemInfo.SystemInfo(osName, width + 'x' + height, this.version);
    }
  }, {
    key: 'applicationInfo',
    get: function get() {
      return new _applicationInfo.ApplicationInfo(browserName, firefoxVersion, fileVersion);
    }
  }]);

  return App;
}();

},{"../../../common/services/model/applicationInfo.js":2,"../../../common/services/model/systemInfo.js":3}]},{},[1]);
