(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.QtestContext = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _statusEnum = require('./services/model/statusEnum.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var QtestContext = exports.QtestContext = function () {
  function QtestContext() {
    _classCallCheck(this, QtestContext);
  }

  _createClass(QtestContext, null, [{
    key: 'clear',
    value: function clear() {
      this._user = null;
      this._session = null;
      this._projects = [];
      this._selectedProject = null;
      this._timeTypes = [];
      this._noteTypes = [];
      this._pendingAnnotations = [];
      this._currentProcessingScreen = null;
      this._domainOptions = null;
      this._runFromQtest = false;
      this._projectId = null;
      this._sessionId = null;
      this._status = {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    }
  }, {
    key: 'canRecordMedia',
    value: function canRecordMedia() {
      return this._qTestVersion && this._qTestVersion >= 6;
    }
  }, {
    key: 'getProjectAutoStartSupported',
    value: function getProjectAutoStartSupported() {
      var result = [];
      if (this._projects) {
        var ref = this._projects;
        for (var j = 0, len = ref.length; j < len; j++) {
          var p = ref[j];
          if (p.alwaysOnSetting.domains.length > 0 && p.alwaysOnSetting.enabled) {
            result.push(p);
          }
        }
      }
      return result;
    }
  }, {
    key: 'qTestVersion',
    get: function get() {
      return this._qTestVersion || null;
    },
    set: function set(qTestVersion) {
      this._qTestVersion = qTestVersion;
    }
  }, {
    key: 'qTestMinorVersion',
    get: function get() {
      return this._qTestMinorVersion || null;
    },
    set: function set(qTestMinorVersion) {
      this._qTestMinorVersion = qTestMinorVersion;
    }
  }, {
    key: 'session',
    get: function get() {
      return this._session || null;
    },
    set: function set(session) {
      this._session = session;
    }
  }, {
    key: 'user',
    get: function get() {
      return this._user || null;
    },
    set: function set(user) {
      this._user = user;
    }
  }, {
    key: 'projects',
    get: function get() {
      if (!this._projects) {
        this._projects = [];
      }
      return this._projects;
    },
    set: function set(projects) {
      this._projects = projects;
    }
  }, {
    key: 'selectedProject',
    get: function get() {
      return this._selectedProject || null;
    },
    set: function set(selectedProject) {
      this._selectedProject = selectedProject;
    }
  }, {
    key: 'timeTypes',
    get: function get() {
      if (!this._timeTypes) {
        this._timeTypes = [];
      }
      return this._timeTypes;
    },
    set: function set(timeTypes) {
      this._timeTypes = timeTypes;
    }
  }, {
    key: 'noteTypes',
    get: function get() {
      if (!this._noteTypes) {
        this._noteTypes = [];
      }
      return this._noteTypes;
    },
    set: function set(noteTypes) {
      this._noteTypes = noteTypes;
    }
  }, {
    key: 'pendingAnnotations',
    get: function get() {
      if (!this._pendingAnnotations) {
        this._pendingAnnotations = [];
      }
      return this._pendingAnnotations;
    },
    set: function set(pendingAnnotations) {
      this._pendingAnnotations = pendingAnnotations;
    }
  }, {
    key: 'currentProcessingScreen',
    get: function get() {
      return this._currentProcessingScreen || null;
    },
    set: function set(currentProcessingScreen) {
      this._currentProcessingScreen = currentProcessingScreen;
    }
  }, {
    key: 'domainOptions',
    get: function get() {
      return this._domainOptions || null;
    },
    set: function set(domainOptions) {
      this._domainOptions = domainOptions;
    }
  }, {
    key: 'runFromQtest',
    get: function get() {
      return this._runFromQtest || false;
    },
    set: function set(runFromQtest) {
      this._runFromQtest = runFromQtest;
    }
  }, {
    key: 'projectId',
    get: function get() {
      return this._projectId || null;
    },
    set: function set(projectId) {
      this._projectId = projectId;
    }
  }, {
    key: 'sessionId',
    get: function get() {
      return this._sessionId || null;
    },
    set: function set(sessionId) {
      this._sessionId = sessionId;
    }
  }, {
    key: 'status',
    get: function get() {
      return this._status || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._status = value;
    }
  }, {
    key: 'currentqTestSession',
    get: function get() {
      return this._currentqTestSession || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._currentqTestSession = value;
    }
  }, {
    key: 'sessionManagerVersion',
    get: function get() {
      return this._sessionManagerVersion || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._sessionManagerVersion = value;
    }
  }]);

  return QtestContext;
}();

},{"./services/model/statusEnum.js":10}],2:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HttpRequest = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _qTestContext = require('../qTestContext.js');

var _config = require('../../extension/js/background/config.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var HttpRequest = exports.HttpRequest = function () {
  function HttpRequest() {
    _classCallCheck(this, HttpRequest);
  }

  _createClass(HttpRequest, null, [{
    key: 'getCommonHeaders',
    value: function getCommonHeaders() {
      var headers = {
        'x-client-name': _config.App.name,
        'x-client-version': _config.App.version,
        'x-explorer-api-version': _config.App.apiVersion
      };
      return headers;
    }
  }, {
    key: 'send',
    value: function send(url, token, sendType, data) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        var headers = _this.getCommonHeaders();
        if (token) {
          headers.Authorization = _qTestContext.QtestContext.qTestVersion >= 7 ? 'bearer ' + token : token;
        }
        if (headers && _qTestContext.QtestContext.ownerToken) {
          headers['x-qtest-owner-token'] = _qTestContext.QtestContext.ownerToken;
        }

        // eslint-disable-next-line no-undef
        $.ajax({
          type: sendType,
          url: url,
          data: data,
          contentType: 'application/json;charset=UTF-8',
          dataType: token ? 'json' : null,
          headers: headers
        }).done(function (resultData) {
          resolve({
            data: resultData
          });
        }).fail(function (jqXHR, textStatus, errorThrown) {
          if (jqXHR.status === 200) {
            resolve({});
          } else {
            resolve({
              status: jqXHR.status,
              error: errorThrown
            });
          }
        });
      });
    }
  }, {
    key: 'sendWithResponse',
    value: function sendWithResponse(url, token, sendType, data) {
      var _this2 = this;

      return new Promise(function (resolve, reject) {
        var headers = _this2.getCommonHeaders();
        if (token) {
          headers.Authorization = _qTestContext.QtestContext.qTestVersion >= 7 ? 'bearer ' + token : token;
        }
        if (headers && _qTestContext.QtestContext.ownerToken) {
          headers['x-qtest-owner-token'] = _qTestContext.QtestContext.ownerToken;
        }
        // eslint-disable-next-line no-undef
        $.ajax({
          type: sendType,
          url: url,
          data: data,
          contentType: 'application/json;charset=UTF-8',
          dataType: token ? 'json' : null,
          headers: headers
        }).done(function (resultData, status, xhr) {
          resolve({
            data: resultData,
            response: xhr
          });
        }).fail(function (jqXHR, textStatus, errorThrown) {
          if (jqXHR.status === 200) {
            resolve({});
          } else {
            resolve({
              status: jqXHR.status,
              error: errorThrown
            });
          }
        });
      });
    }
  }, {
    key: 'upload',
    value: function upload(url, token, filename, binaryData, contentType) {
      var _this3 = this;

      return new Promise(function (resolve, reject) {
        if (!binaryData) {
          resolve({
            error: 'HttpRequest: error: No binary data'
          });
          return;
        }
        var oReq = new XMLHttpRequest();
        oReq.open('POST', url, true);
        var headers = _this3.getCommonHeaders();
        if (token) {
          headers.Authorization = _qTestContext.QtestContext.qTestVersion >= 7 ? 'bearer ' + token : token;
        }
        headers['Content-Type'] = contentType;
        headers['x-filename'] = filename;
        // eslint-disable-next-line no-undef
        $.each(headers, function (key, value) {
          if (Object.prototype.hasOwnProperty.call(headers, key) && !(value instanceof Function)) {
            oReq.setRequestHeader(key, value);
          }
        });
        oReq.onload = function (oEvent) {
          var data = oReq.response;
          var responseStatus = oReq.status;
          console.log(new Date().toString() + ' HttpRequest: finished uploading binary data, response status: \'' + responseStatus + '\', response data: \'' + data + '\'...');
          oReq.abort();
          if (responseStatus === 200 || responseStatus === 201) {
            resolve({
              data: JSON.parse(data)
            });
          } else {
            resolve({
              error: responseStatus + 'ERROR'
            });
          }
        };
        oReq.onerror = function (oEvent) {
          resolve({
            error: 'HttpRequest: error :' + oEvent.error
          });
        };
        oReq.send(binaryData);
      });
    }
  }]);

  return HttpRequest;
}();

},{"../../extension/js/background/config.js":16,"../qTestContext.js":1}],3:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LoginMessageHandler = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _httpRequest = require('./httpRequest.js');

var _qTestContext = require('../qTestContext.js');

var _statusEnum = require('./model/statusEnum.js');

var _user = require('./model/user.js');

var _project2 = require('./model/project.js');

var _storage = require('./storage.js');

var _settingService = require('../services/settingService.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var LoginMessageHandler = exports.LoginMessageHandler = function () {
  function LoginMessageHandler() {
    _classCallCheck(this, LoginMessageHandler);
  }

  _createClass(LoginMessageHandler, [{
    key: 'handle',
    value: async function handle(message) {
      message.url = message.url.trim().replace(/^\/|\/$/g, '').toLowerCase();
      var getqTestVersionUrl = message.url + '/version';
      console.log(new Date().toString() + ' about to get qTest Version at ' + getqTestVersionUrl + '...');
      var response = await _httpRequest.HttpRequest.send(getqTestVersionUrl, null, 'GET', '');

      if (!response.error) {
        if (!response.data.version) {
          console.error('cannot obtain qTest version...');
          _qTestContext.QtestContext.setqTestVersion = 5;
          _qTestContext.QtestContext.qTestMinorVersion = 0;
        } else {
          var versions = response.data.version.split('.');
          _qTestContext.QtestContext.qTestVersion = parseInt(versions[0], 10);
          _qTestContext.QtestContext.qTestMinorVersion = parseInt(versions[1], 10);
          console.log(new Date().toString() + ' extracted qTest Version: ' + _qTestContext.QtestContext.qTestVersion);
          console.log(new Date().toString() + ' extracted qTest minor Version: ' + _qTestContext.QtestContext.qTestMinorVersion);
        }
        _qTestContext.QtestContext.status = {
          name: _statusEnum.StatusEnum.loggingIn,
          info: {
            loginOption: message.loginOption,
            user: {
              url: message.url,
              loginOption: message.loginOption,
              email: message.email,
              password: message.password,
              ssoToken: message.ssoToken
            }
          }
        };
        if (_qTestContext.QtestContext.qTestVersion >= 7) {
          var _res = await this.loginOptionOauth(message);
          if (_res.success) {
            await this.handleWebExplorerSetting(message);
          }
          return _res;
        }
        var res = await this.login(message);
        if (res.success) {
          await this.handleWebExplorerSetting(message);
        }
        return res;
      }
      return {
        success: false,
        error: response.error
      };
    }
  }, {
    key: 'handleWebExplorerSetting',
    value: async function handleWebExplorerSetting(message) {
      var getWebExplorerSettingURL = _qTestContext.QtestContext.user.apiURL + '/site-settings?type=site_web_explorer';

      var _ref = await _httpRequest.HttpRequest.send(getWebExplorerSettingURL, _qTestContext.QtestContext.user.token, 'GET', ''),
          data = _ref.data,
          error = _ref.error;

      var enableAutoLogin = false;
      if (error || data.enableAutoLogin) {
        enableAutoLogin = true;
      }

      var autoLogin = false;
      var settings = _settingService.SettingService.load();
      if (enableAutoLogin) {
        autoLogin = true;
        var credentials = _storage.Storage.get('credentials');
        if (credentials && credentials.rememberMe !== undefined) {
          autoLogin = credentials.rememberMe;
        } else if (settings.webExplorerSetting && settings.webExplorerSetting.autoLogin !== undefined) {
          autoLogin = settings.webExplorerSetting.autoLogin;
        }
      }

      var expires = undefined;
      if (enableAutoLogin && data && data.autoLoginExpiredValue !== undefined && data.selectedExpireUnitId !== undefined) {
        var expireDate = new Date();
        var expireValue = parseInt(data.autoLoginExpiredValue);
        var expireUnit = parseInt(data.selectedExpireUnitId);

        switch (expireUnit) {
          case 1:
            // hour
            expireDate.setHours(expireDate.getHours() + expireValue);
            break;
          case 2:
            // day
            expireDate.setDate(expireDate.getDate() + expireValue);
            break;
          case 3:
            // week
            expireDate.setDate(expireDate.getDate() + expireValue * 7);
            break;
          case 4:
            // month
            expireDate.setMonth(expireDate.getMonth() + expireValue);
            break;
          case 5:
            // year
            expireDate.setFullYear(expireDate.getFullYear() + expireValue);
            break;
          case 0: // min
          default:
            expireDate.setMinutes(expireDate.getMinutes() + expireValue);
            break;
        }

        expires = expireDate.toString();
      }

      _qTestContext.QtestContext.user.setUserCredentials(message, expires);

      settings.webExplorerSetting.enableAutoLogin = enableAutoLogin;
      settings.webExplorerSetting.autoLogin = autoLogin;
      _settingService.SettingService.save(settings);
    }
  }, {
    key: 'login',
    value: async function login(message) {
      var loginURL = message.url + '/api/login?j_username=' + encodeURIComponent(message.email) + '&j_password=' + encodeURIComponent(message.password);
      var res = await _httpRequest.HttpRequest.send(loginURL, null, 'POST', null);

      console.log(new Date().toString() + ' finished login request.');
      if (res.error) {
        _qTestContext.QtestContext.status = {
          name: _statusEnum.StatusEnum.notLoggedIn
        };
        return {
          sucess: false,
          error: res.error
        };
      }
      _qTestContext.QtestContext.user = new _user.User(message.url, '', message.email, '');
      var response = await this.loadSessionManagerInfo(message, res.data);
      return response;
    }
  }, {
    key: 'loginOptionOauth',
    value: async function loginOptionOauth(message) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        var data = {};
        console.log(new Date().toString() + ' about to send login request.');
        if (message.loginOption && message.loginOption === 'sso') {
          data = {
            grant_type: 'refresh_token',
            refresh_token: message.ssoToken
          };
        } else {
          data = {
            grant_type: 'password',
            username: message.email,
            password: message.password
          };
        }
        var headers = {
          Authorization: 'Basic d2ViLWV4cGxvcmVyOkRnZ0NZZ0RSU2F5djEwY2EyV2NrRWFKUnpLRFRhU1gy'
        };

        // eslint-disable-next-line no-undef
        $.ajax({
          type: 'POST',
          url: message.url + '/oauth/token',
          data: data,
          contentType: 'application/x-www-form-urlencoded;charset=UTF-8',
          headers: headers
          // eslint-disable-next-line consistent-return
        }).done(function (dataResult, status, xhr) {
          var email = '';
          if (message.loginOption && message.loginOption === 'sso') {
            var userName = xhr.getResponseHeader('user-name');
            if (userName && userName !== '') {
              email = userName;
            } else {
              resolve({
                success: false,
                error: {
                  message: 'Error: cannot obtain your account information.'
                }
              });
            }
          } else {
            var _userName = xhr.getResponseHeader('user-name');
            if (_userName && _userName !== '') {
              email = _userName;
            } else {
              email = message.email;
            }
          }
          console.log(new Date().toString() + ' login successfully with ' + email);
          _qTestContext.QtestContext.user = new _user.User(message.url, '', email, '');
          _this.loadSessionManagerInfo(message, dataResult.access_token).then(function (response) {
            resolve(response);
          });
        }).fail(function (jqXHR, status, error) {
          console.log(new Date().toString() + ' login failed: ' + error);
          _qTestContext.QtestContext.status = {
            name: _statusEnum.StatusEnum.notLoggedIn
          };
          resolve({
            success: false,
            error: {
              status: jqXHR.status,
              message: jqXHR.statusText
            }
          });
        });
      });
    }
  }, {
    key: 'loadSessionManagerInfo',
    value: async function loadSessionManagerInfo(message, token) {
      var getSessionManagerURL = message.url + '/api/v3/explorer-api';
      console.log(new Date().toString() + ' about to get session manager info...');
      var res = await _httpRequest.HttpRequest.send(getSessionManagerURL, token, 'GET', '');

      console.log(new Date().toString() + ' finished getting session manager info...');
      if (res.error && res.error.status !== 402) {
        return {
          success: false,
          error: res.error
        };
      }
      if (res.error || res.data.allowed_action !== 1) {
        _qTestContext.QtestContext.status = {
          name: _statusEnum.StatusEnum.notLoggedIn
        };
        return {
          success: false,
          error: {
            message: 'This feature requires qTest Premium Edition.'
          }
        };
      }

      var apiURL = res.data.explorer_api_url;
      if (apiURL.length > 0) {
        apiURL = apiURL.replace(/^\/+/g, '').replace(/\/+$/g, '');
      }
      var response = await this.loadSessionManagerVersion(message, apiURL, token);
      return response;
    }
  }, {
    key: 'loadSessionManagerVersion',
    value: async function loadSessionManagerVersion(message, apiURL, token) {
      var getSessionManagerVersionURL = apiURL + '/version';
      console.log(new Date().toString() + ' about to load session manager version...');
      var res = await _httpRequest.HttpRequest.send(getSessionManagerVersionURL, null, 'GET', '');

      var json = res.data;
      var error = res.error;
      if (!error) {
        if (!json.Version) {
          console.error('cannot obtain Session Manager version...');
          _qTestContext.QtestContext.sessionManagerVersion = null;
        } else {
          var versions = json.Version.split('.');
          _qTestContext.QtestContext.sessionManagerVersion = {
            major: parseInt(versions[0], 10),
            minor: parseInt(versions[1], 10),
            buildNumber: parseInt(versions[2], 10)
          };
          console.log(new Date().toString() + ' extracted Session Manager major version: ' + _qTestContext.QtestContext.sessionManagerVersion.major);
          console.log(new Date().toString() + ' extracted Session Manager minor version: ' + _qTestContext.QtestContext.sessionManagerVersion.minor);
          console.log(new Date().toString() + ' extracted Session Manager build number: ' + _qTestContext.QtestContext.sessionManagerVersion.buildNumber);
        }
      }
      var response = await this.loadUserProjects(message, apiURL, token);
      return response;
    }
  }, {
    key: 'loadUserProjects',
    value: async function loadUserProjects(message, apiURL, token) {
      return new Promise(function (resolve, reject) {
        var getProjectURL = message.url + '/api/v3/projects?expand=always_on';
        console.log(new Date().toString() + ' about to load projects...');
        _httpRequest.HttpRequest.send(getProjectURL, token, 'GET', '').then(function (response) {
          var data = response.data;
          var error = response.errror;
          console.log(new Date().toString() + ' finished loading projects...');
          if (error) {
            _qTestContext.QtestContext.clear();
            _qTestContext.QtestContext.status = {
              name: _statusEnum.StatusEnum.notLoggedIn
            };
            resolve({
              success: false,
              error: error
            });
          } else {
            var projects = [];
            var projectIds = '';
            var i = 0;
            for (var j = 0, len = data.length; j < len; j++) {
              var p = data[j];
              var project = new _project2.Project(p.id, p.name);
              if (p.always_on) {
                project.alwaysOnSetting.enabled = p.always_on.enabled;
                project.alwaysOnSetting.domains = p.always_on.domains;
              }
              projects.push(project);
              if (i < data.length - 1) {
                projectIds += p.id + ',';
              } else {
                projectIds += p.id;
              }
              i++;
            }
            _qTestContext.QtestContext.user.apiURL = apiURL;
            _qTestContext.QtestContext.user.token = token;
            _qTestContext.QtestContext.projects = projects;
            var getProjectPermissionURL = apiURL + '/permissions?system=qtest&projectIds=' + projectIds;
            console.log(new Date().toString() + ' about to get permissions...');
            _httpRequest.HttpRequest.send(getProjectPermissionURL, token, 'GET', '').then(function (res) {
              var projectPermissionData = res.data;
              var getPermissionError = res.error;
              console.log(new Date().toString() + ' finished getting permissions...');
              if (getPermissionError || !projectPermissionData || !projectPermissionData.permission || projectPermissionData.permission.length <= 0) {
                _qTestContext.QtestContext.clear();
                _qTestContext.QtestContext.status = {
                  name: _statusEnum.StatusEnum.notLoggedIn
                };
                resolve({
                  success: false,
                  error: error
                });
              } else {
                var availProject = [];
                var projects1 = _qTestContext.QtestContext.projects;
                var _iteratorNormalCompletion = true;
                var _didIteratorError = false;
                var _iteratorError = undefined;

                try {
                  for (var _iterator = projects1[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var _project = _step.value;

                    var canView = false;
                    var permissions = projectPermissionData.permission;
                    for (var l = 0, len2 = permissions.length; l < len2; l++) {
                      var permission = permissions[l];
                      if (permission.project_id.toString() === _project.id.toString()) {
                        canView = permission.session.can_view;
                        _project.canCreate = permission.session.can_create;
                        _project.canUpdate = permission.session.can_edit;
                        break;
                      }
                    }
                    if (canView && _project.canUpdate) {
                      availProject.push(_project);
                    }
                  }
                } catch (err) {
                  _didIteratorError = true;
                  _iteratorError = err;
                } finally {
                  try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                      _iterator.return();
                    }
                  } finally {
                    if (_didIteratorError) {
                      throw _iteratorError;
                    }
                  }
                }

                _qTestContext.QtestContext.projects = availProject;
                if (_qTestContext.QtestContext.projects.length <= 0) {
                  _qTestContext.QtestContext.clear();
                  _qTestContext.QtestContext.status = {
                    name: _statusEnum.StatusEnum.notLoggedIn
                  };
                  resolve({
                    success: false,
                    error: {
                      message: 'You don\'t have priviledge to work with Session Manager module'
                    }
                  });
                } else {
                  _qTestContext.QtestContext.status = {
                    name: _statusEnum.StatusEnum.loggedIn,
                    text: 'logged in successfully'
                  };
                  _storage.Storage.set('loginOption', JSON.stringify(message.loginOption), {
                    secure: true
                  });
                  resolve({
                    success: true
                  });
                }
              }
            });
          }
        });
      });
    }
  }]);

  return LoginMessageHandler;
}();

},{"../qTestContext.js":1,"../services/settingService.js":14,"./httpRequest.js":2,"./model/project.js":8,"./model/statusEnum.js":10,"./model/user.js":12,"./storage.js":15}],4:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ApplicationInfo = exports.ApplicationInfo = function ApplicationInfo(name, version, fileVersion) {
  _classCallCheck(this, ApplicationInfo);

  this.name = name;
  this.version = version;
  this.fileVersion = fileVersion;
};

},{}],5:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AutoStartSetting = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _storage = require('../storage.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var AutoStartSetting = exports.AutoStartSetting = function () {
  function AutoStartSetting() {
    _classCallCheck(this, AutoStartSetting);

    this.isEnableAutoStart = false;
    this.projectId = '';
    this.domainsIgnored = {};
    this.domains = '';
    this.projectName = '';
    this.userEmail = '';
  }

  _createClass(AutoStartSetting, [{
    key: 'load',
    value: function load(userEmail, autoStartProjects) {
      this.userEmail = userEmail;
      var obj = _storage.Storage.get('autoStartSetting');
      if (obj) {
        var setting = obj[userEmail];
        if (setting) {
          this.isEnableAutoStart = setting.isEnableAutoStart;
          this.projectId = setting.projectId;
          var valid = false;
          for (var j = 0, len = autoStartProjects.length; j < len; j++) {
            var p = autoStartProjects[j];
            if (this.projectId && this.projectId.toString() === p.id.toString()) {
              valid = true;
              this.projectName = p.name;
              this.domains = p.alwaysOnSetting.domains.split(' ');
              break;
            }
          }
          this.isEnableAutoStart = this.isEnableAutoStart && valid;
          return this.isEnableAutoStart;
        }
      }
      return false;
    }
  }, {
    key: 'canShowAutoStartConfirm',
    value: function canShowAutoStartConfirm(domain) {
      if (this.isEnableAutoStart && this.domainsIgnored[domain] !== false) {
        if (this.domains.length === 0) {
          return false;
        }
        for (var i = 0, j = 0, ref = this.domains.length - 1; ref >= 0 ? j <= ref : j >= ref; i = ref >= 0 ? ++j : --j) {
          var d = this.domains[i];
          if (domain.length >= d.length && domain.indexOf(d) >= 0) {
            return true;
          }
        }
      }
      return false;
    }
  }, {
    key: 'disableShowAutoStartConfirm',
    value: function disableShowAutoStartConfirm(domain) {
      this.domainsIgnored[domain] = false;
    }
  }, {
    key: 'save',
    value: function save() {
      var obj = _storage.Storage.get('autoStartSetting') || {};
      var email = this.userEmail;
      var setting = {};
      setting.projectId = this.projectId;
      if (!setting.projectId || setting.projectId.length === 0) {
        this.isEnableAutoStart = false;
      }
      setting.isEnableAutoStart = this.isEnableAutoStart;
      obj[email] = setting;
      var str = JSON.stringify(obj);

      _storage.Storage.set('autoStartSetting', str);
    }
  }]);

  return AutoStartSetting;
}();

},{"../storage.js":15}],6:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Hotkey = exports.Hotkey = function () {
  function Hotkey(altKey, shiftKey, keyCode) {
    _classCallCheck(this, Hotkey);

    this.altKey = altKey;
    this.shiftKey = shiftKey;
    this.keyCode = keyCode;
  }

  _createClass(Hotkey, [{
    key: 'build',
    value: function build() {
      var hotkeyString = 'ctrl';
      if (this.altKey) {
        hotkeyString = hotkeyString + '+alt';
      }
      if (this.shiftKey) {
        hotkeyString = hotkeyString + '+shift';
      }
      hotkeyString = hotkeyString + '+' + this.keyCode;
      return hotkeyString.toLowerCase();
    }
  }]);

  return Hotkey;
}();

},{}],7:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var HotkeySetting = exports.HotkeySetting = function HotkeySetting() {
  _classCallCheck(this, HotkeySetting);

  this.stopRecording = null;
  this.pauseResumeRecording = null;
  this.captureVisiblePart = null;
  this.captureFullPage = null;
  this.recordVideo = null;
  this.recordAudio = null;
};

},{}],8:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Project = exports.Project = function Project(id, name) {
  _classCallCheck(this, Project);

  this.canCreate = false;
  this.canUpdate = false;

  this.id = id;
  this.name = name;
  this.sessions = [];
  this.alwaysOnSetting = {
    enabled: false,
    domains: ''
  };
};

},{}],9:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Setting = exports.Setting = function Setting() {
  _classCallCheck(this, Setting);

  this.version = null;
  this.hotkeySetting = null;
  this.webExplorerSetting = null;
};

},{}],10:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var StatusEnum = exports.StatusEnum = {
  notLoggedIn: 'notLoggedIn',

  loggingIn: 'loggingIn',

  loggedIn: 'loggedIn',

  loadingServerSession: 'loadingServerSession',

  loadedServerSession: 'loadedServerSession',

  startingSession: 'startingSession',

  startingSessionIndicator: 'startingSessionIndicator',

  recording: 'recording',

  editing: 'editing',

  paused: 'paused',

  capturingFullPage: 'capturingFullPage',

  inProgress: 'inProgress',

  completingSession: 'completingSession',

  recordingMedia: 'recordingMedia'
};

},{}],11:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SystemInfo = exports.SystemInfo = function SystemInfo(os, resolutions, appVersion) {
  _classCallCheck(this, SystemInfo);

  this.os = os;
  this.resolutions = resolutions;
  this.appVersion = appVersion;
};

},{}],12:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.User = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _autoStartSetting = require('./autoStartSetting.js');

var _qTestContext = require('../../qTestContext.js');

var _storage = require('../storage.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var User = exports.User = function () {
  function User(url, apiURL, email, token) {
    _classCallCheck(this, User);

    this.url = url;
    this.apiURL = apiURL;
    this.email = email;
    this.token = token;
    if (_qTestContext.QtestContext.qTestVersion >= 7) {
      this.autoStartSetting = new _autoStartSetting.AutoStartSetting();
    }
    this.fromExternal = false;
  }

  _createClass(User, [{
    key: 'saveAutoStartSetting',
    value: function saveAutoStartSetting(setting) {
      if (_qTestContext.QtestContext.qTestVersion >= 7) {
        this.autoStartSetting.isEnableAutoStart = setting.enableAutoStart;
        this.autoStartSetting.projectId = setting.projectId;
        this.autoStartSetting.domains = setting.domains.split(' ');
        this.autoStartSetting.projectName = setting.projectName;
        this.autoStartSetting.save();
      }
    }
  }, {
    key: 'loadAutoStartSetting',
    value: function loadAutoStartSetting(autoStartProjects) {
      if (_qTestContext.QtestContext.qTestVersion >= 7) {
        this.autoStartSetting.load(this.email, autoStartProjects);
      }
    }
  }, {
    key: 'setUserCredentials',
    value: function setUserCredentials(message, expires) {
      var userCredentials = {
        url: message.url,
        loginOption: message.loginOption,
        email: message.email,
        password: message.password,
        ssoToken: message.ssoToken,
        expires: expires
      };
      this.encryptedCredentials = _storage.Storage.encrypt(JSON.stringify(userCredentials));
    }
  }, {
    key: 'getUserCredentials',
    value: function getUserCredentials() {
      return _storage.Storage.decrypt(this.encryptedCredentials);
    }
  }]);

  return User;
}();

},{"../../qTestContext.js":1,"../storage.js":15,"./autoStartSetting.js":5}],13:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var WebExplorerSetting = exports.WebExplorerSetting = function WebExplorerSetting() {
  _classCallCheck(this, WebExplorerSetting);

  this.enableAutoLogin = true;
  this.autoLogin = true;
};

},{}],14:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SettingService = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _storage = require('./storage.js');

var _setting = require('./model/setting.js');

var _hotkey = require('./model/hotkey.js');

var _hotkeySetting = require('./model/hotkeySetting.js');

var _config = require('./../../extension/js/background/config.js');

var _webExplorerSetting = require('./model/webExplorerSetting.js');

var _qTestContext = require('../qTestContext.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SettingService = exports.SettingService = function () {
  function SettingService() {
    _classCallCheck(this, SettingService);
  }

  _createClass(SettingService, null, [{
    key: 'load',
    value: function load() {
      var dynamicObject = _storage.Storage.get('settings');
      if (dynamicObject) {
        var dynamicHS = dynamicObject.hotkeySetting;
        var settings = new _setting.Setting();
        if (dynamicObject.version) {
          settings.version = dynamicObject.version;
        } else {
          settings.version = _config.App.version;
        }
        settings.hotkeySetting = new _hotkeySetting.HotkeySetting();
        settings.hotkeySetting.captureVisiblePart = new _hotkey.Hotkey(dynamicHS.captureVisiblePart.altKey, dynamicHS.captureVisiblePart.shiftKey, dynamicHS.captureVisiblePart.keyCode);
        settings.hotkeySetting.captureFullPage = new _hotkey.Hotkey(dynamicHS.captureFullPage.altKey, dynamicHS.captureFullPage.shiftKey, dynamicHS.captureFullPage.keyCode);
        if (dynamicHS.stopRecording) {
          settings.hotkeySetting.stopRecording = new _hotkey.Hotkey(dynamicHS.stopRecording.altKey, dynamicHS.stopRecording.shiftKey, dynamicHS.stopRecording.keyCode);
        }
        if (dynamicHS.pauseResumeRecording) {
          // eslint-disable-next-line max-len
          settings.hotkeySetting.pauseResumeRecording = new _hotkey.Hotkey(dynamicHS.pauseResumeRecording.altKey, dynamicHS.pauseResumeRecording.shiftKey, dynamicHS.pauseResumeRecording.keyCode);
        }
        if (dynamicHS.recordVideo) {
          settings.hotkeySetting.recordVideo = new _hotkey.Hotkey(dynamicHS.recordVideo.altKey, dynamicHS.recordVideo.shiftKey, dynamicHS.recordVideo.keyCode);
        }
        if (dynamicHS.recordAudio) {
          settings.hotkeySetting.recordAudio = new _hotkey.Hotkey(dynamicHS.recordAudio.altKey, dynamicHS.recordAudio.shiftKey, dynamicHS.recordAudio.keyCode);
        }

        settings.webExplorerSetting = new _webExplorerSetting.WebExplorerSetting();
        var dynamicGS = dynamicObject.webExplorerSetting;
        if (dynamicGS) {
          settings.webExplorerSetting.enableAutoLogin = dynamicGS.enableAutoLogin;
          settings.webExplorerSetting.autoLogin = dynamicGS.autoLogin;
        }

        return settings;
      }
      return undefined;
    }
  }, {
    key: 'save',
    value: function save(settings) {
      if (settings) {
        _storage.Storage.set('settings', JSON.stringify(settings), {
          secure: true
        });

        if (settings.webExplorerSetting && _qTestContext.QtestContext.user) {
          if (settings.webExplorerSetting.autoLogin) {
            var credentialsString = _qTestContext.QtestContext.user.getUserCredentials();
            _storage.Storage.set('credentials', credentialsString, {
              secure: true
            });
          } else {
            _storage.Storage.remove('credentials');
          }
        }
      } else {
        _storage.Storage.remove('settings');
      }
    }
  }]);

  return SettingService;
}();

},{"../qTestContext.js":1,"./../../extension/js/background/config.js":16,"./model/hotkey.js":6,"./model/hotkeySetting.js":7,"./model/setting.js":9,"./model/webExplorerSetting.js":13,"./storage.js":15}],15:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ___ = ['\x6D\x74\x26\x79\x6B\x4E\x57\x55\x62\x4E\x49\x65\x52\x26\x34\x33'][0];

var Storage = exports.Storage = function () {
  function Storage() {
    _classCallCheck(this, Storage);
  }

  _createClass(Storage, null, [{
    key: 'encrypt',
    value: function encrypt(vString) {
      // eslint-disable-next-line no-undef
      return sjcl.encrypt(___, vString);
    }
  }, {
    key: 'decrypt',
    value: function decrypt(vString) {
      // eslint-disable-next-line no-undef
      return sjcl.decrypt(___, vString);
    }

    // get(k: string): Object

  }, {
    key: 'get',
    value: function get(k) {
      try {
        var vString = localStorage.getItem(k);
        if (!vString) {
          return null;
        }

        var obj = JSON.parse(vString);
        if (obj.cipher && obj.salt && obj.mode) {
          obj = JSON.parse(this.decrypt(vString));
        }

        // backward compatible: old version stringify the obj multiple times
        if (typeof obj === 'string') {
          try {
            var tempObj = JSON.parse(obj);
            obj = tempObj;
            // eslint-disable-next-line no-empty
          } catch (e) {}
        }

        if (obj.expires) {
          // check expiration
          var now = new Date();
          var expires = new Date(obj.expires);
          if (now.getTime() >= expires.getTime()) {
            console.error('Storage "' + k + '" expired on ' + obj.expires);
            this.remove(k);
            return null;
          }
        }

        return obj;
      } catch (error) {
        console.log(error);
        return null;
      }
    }

    // set(k: string, vString: string, opts: { secure: boolean })

  }, {
    key: 'set',
    value: function set(k, vString) {
      var opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      if (!vString) {
        this.remove(k);
        return;
      }

      localStorage.setItem(k, opts.secure ? this.encrypt(vString) : vString);
    }
  }, {
    key: 'remove',
    value: function remove(k) {
      localStorage.removeItem(k);
    }
  }]);

  return Storage;
}();

},{}],16:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.App = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _systemInfo = require('../../../common/services/model/systemInfo.js');

var _applicationInfo = require('../../../common/services/model/applicationInfo.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var fileVersion = '';
var browserName = '';
var firefoxVersion = '';
var osName = '';
var nAgt = window.navigator.userAgent;
var verOffset = nAgt.indexOf('Firefox');
if (verOffset !== -1) {
  browserName = 'firefox';
  fileVersion = nAgt.substring(verOffset + 8);
  firefoxVersion = parseInt(fileVersion, 10);
}
var mozillaExp = nAgt.match(/Mozilla\/(.*?) /);
if (mozillaExp && mozillaExp.length > 0) {
  var mozillaExp2 = /Mozilla\//;
  var osExp = /\((.*?)\)/;
  osName = navigator.userAgent.match(new RegExp(String(mozillaExp2.source) + mozillaExp[1] + ' ' + osExp.source))[1];
}

var App = exports.App = function () {
  function App() {
    _classCallCheck(this, App);
  }

  _createClass(App, null, [{
    key: 'manifest',
    get: function get() {
      return this._manifest || chrome.runtime.getManifest();
    }
  }, {
    key: 'name',
    get: function get() {
      return this.manifest.name;
    }
  }, {
    key: 'version',
    get: function get() {
      return this.manifest.version;
    }
  }, {
    key: 'apiVersion',
    get: function get() {
      return this.manifest.apiVersion;
    }
  }, {
    key: 'scaleBeforeCompare',
    get: function get() {
      return this._scaleBeforeCompare || true;
    },
    set: function set(value) {
      this._scaleBeforeCompare = value;
    }
  }, {
    key: 'fileVersion',
    get: function get() {
      if (mozillaExp && mozillaExp.length > 0) {
        return mozillaExp[1];
      }
      return -1;
    }
  }, {
    key: 'systemInfo',
    get: function get() {
      var width = window.screen.width * window.devicePixelRatio;
      var height = window.screen.height * window.devicePixelRatio;
      return new _systemInfo.SystemInfo(osName, width + 'x' + height, this.version);
    }
  }, {
    key: 'applicationInfo',
    get: function get() {
      return new _applicationInfo.ApplicationInfo(browserName, firefoxVersion, fileVersion);
    }
  }]);

  return App;
}();

},{"../../../common/services/model/applicationInfo.js":4,"../../../common/services/model/systemInfo.js":11}]},{},[3]);
