(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.QtestContext = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _statusEnum = require('./services/model/statusEnum.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var QtestContext = exports.QtestContext = function () {
  function QtestContext() {
    _classCallCheck(this, QtestContext);
  }

  _createClass(QtestContext, null, [{
    key: 'clear',
    value: function clear() {
      this._user = null;
      this._session = null;
      this._projects = [];
      this._selectedProject = null;
      this._timeTypes = [];
      this._noteTypes = [];
      this._pendingAnnotations = [];
      this._currentProcessingScreen = null;
      this._domainOptions = null;
      this._runFromQtest = false;
      this._projectId = null;
      this._sessionId = null;
      this._status = {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    }
  }, {
    key: 'canRecordMedia',
    value: function canRecordMedia() {
      return this._qTestVersion && this._qTestVersion >= 6;
    }
  }, {
    key: 'getProjectAutoStartSupported',
    value: function getProjectAutoStartSupported() {
      var result = [];
      if (this._projects) {
        var ref = this._projects;
        for (var j = 0, len = ref.length; j < len; j++) {
          var p = ref[j];
          if (p.alwaysOnSetting.domains.length > 0 && p.alwaysOnSetting.enabled) {
            result.push(p);
          }
        }
      }
      return result;
    }
  }, {
    key: 'qTestVersion',
    get: function get() {
      return this._qTestVersion || null;
    },
    set: function set(qTestVersion) {
      this._qTestVersion = qTestVersion;
    }
  }, {
    key: 'qTestMinorVersion',
    get: function get() {
      return this._qTestMinorVersion || null;
    },
    set: function set(qTestMinorVersion) {
      this._qTestMinorVersion = qTestMinorVersion;
    }
  }, {
    key: 'session',
    get: function get() {
      return this._session || null;
    },
    set: function set(session) {
      this._session = session;
    }
  }, {
    key: 'user',
    get: function get() {
      return this._user || null;
    },
    set: function set(user) {
      this._user = user;
    }
  }, {
    key: 'projects',
    get: function get() {
      if (!this._projects) {
        this._projects = [];
      }
      return this._projects;
    },
    set: function set(projects) {
      this._projects = projects;
    }
  }, {
    key: 'selectedProject',
    get: function get() {
      return this._selectedProject || null;
    },
    set: function set(selectedProject) {
      this._selectedProject = selectedProject;
    }
  }, {
    key: 'timeTypes',
    get: function get() {
      if (!this._timeTypes) {
        this._timeTypes = [];
      }
      return this._timeTypes;
    },
    set: function set(timeTypes) {
      this._timeTypes = timeTypes;
    }
  }, {
    key: 'noteTypes',
    get: function get() {
      if (!this._noteTypes) {
        this._noteTypes = [];
      }
      return this._noteTypes;
    },
    set: function set(noteTypes) {
      this._noteTypes = noteTypes;
    }
  }, {
    key: 'pendingAnnotations',
    get: function get() {
      if (!this._pendingAnnotations) {
        this._pendingAnnotations = [];
      }
      return this._pendingAnnotations;
    },
    set: function set(pendingAnnotations) {
      this._pendingAnnotations = pendingAnnotations;
    }
  }, {
    key: 'currentProcessingScreen',
    get: function get() {
      return this._currentProcessingScreen || null;
    },
    set: function set(currentProcessingScreen) {
      this._currentProcessingScreen = currentProcessingScreen;
    }
  }, {
    key: 'domainOptions',
    get: function get() {
      return this._domainOptions || null;
    },
    set: function set(domainOptions) {
      this._domainOptions = domainOptions;
    }
  }, {
    key: 'runFromQtest',
    get: function get() {
      return this._runFromQtest || false;
    },
    set: function set(runFromQtest) {
      this._runFromQtest = runFromQtest;
    }
  }, {
    key: 'projectId',
    get: function get() {
      return this._projectId || null;
    },
    set: function set(projectId) {
      this._projectId = projectId;
    }
  }, {
    key: 'sessionId',
    get: function get() {
      return this._sessionId || null;
    },
    set: function set(sessionId) {
      this._sessionId = sessionId;
    }
  }, {
    key: 'status',
    get: function get() {
      return this._status || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._status = value;
    }
  }, {
    key: 'currentqTestSession',
    get: function get() {
      return this._currentqTestSession || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._currentqTestSession = value;
    }
  }, {
    key: 'sessionManagerVersion',
    get: function get() {
      return this._sessionManagerVersion || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._sessionManagerVersion = value;
    }
  }]);

  return QtestContext;
}();

},{"./services/model/statusEnum.js":6}],2:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HttpRequest = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _qTestContext = require('../qTestContext.js');

var _config = require('../../extension/js/background/config.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var HttpRequest = exports.HttpRequest = function () {
  function HttpRequest() {
    _classCallCheck(this, HttpRequest);
  }

  _createClass(HttpRequest, null, [{
    key: 'getCommonHeaders',
    value: function getCommonHeaders() {
      var headers = {
        'x-client-name': _config.App.name,
        'x-client-version': _config.App.version,
        'x-explorer-api-version': _config.App.apiVersion
      };
      return headers;
    }
  }, {
    key: 'send',
    value: function send(url, token, sendType, data) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        var headers = _this.getCommonHeaders();
        if (token) {
          headers.Authorization = _qTestContext.QtestContext.qTestVersion >= 7 ? 'bearer ' + token : token;
        }
        if (headers && _qTestContext.QtestContext.ownerToken) {
          headers['x-qtest-owner-token'] = _qTestContext.QtestContext.ownerToken;
        }

        // eslint-disable-next-line no-undef
        $.ajax({
          type: sendType,
          url: url,
          data: data,
          contentType: 'application/json;charset=UTF-8',
          dataType: token ? 'json' : null,
          headers: headers
        }).done(function (resultData) {
          resolve({
            data: resultData
          });
        }).fail(function (jqXHR, textStatus, errorThrown) {
          if (jqXHR.status === 200) {
            resolve({});
          } else {
            resolve({
              status: jqXHR.status,
              error: errorThrown
            });
          }
        });
      });
    }
  }, {
    key: 'sendWithResponse',
    value: function sendWithResponse(url, token, sendType, data) {
      var _this2 = this;

      return new Promise(function (resolve, reject) {
        var headers = _this2.getCommonHeaders();
        if (token) {
          headers.Authorization = _qTestContext.QtestContext.qTestVersion >= 7 ? 'bearer ' + token : token;
        }
        if (headers && _qTestContext.QtestContext.ownerToken) {
          headers['x-qtest-owner-token'] = _qTestContext.QtestContext.ownerToken;
        }
        // eslint-disable-next-line no-undef
        $.ajax({
          type: sendType,
          url: url,
          data: data,
          contentType: 'application/json;charset=UTF-8',
          dataType: token ? 'json' : null,
          headers: headers
        }).done(function (resultData, status, xhr) {
          resolve({
            data: resultData,
            response: xhr
          });
        }).fail(function (jqXHR, textStatus, errorThrown) {
          if (jqXHR.status === 200) {
            resolve({});
          } else {
            resolve({
              status: jqXHR.status,
              error: errorThrown
            });
          }
        });
      });
    }
  }, {
    key: 'upload',
    value: function upload(url, token, filename, binaryData, contentType) {
      var _this3 = this;

      return new Promise(function (resolve, reject) {
        if (!binaryData) {
          resolve({
            error: 'HttpRequest: error: No binary data'
          });
          return;
        }
        var oReq = new XMLHttpRequest();
        oReq.open('POST', url, true);
        var headers = _this3.getCommonHeaders();
        if (token) {
          headers.Authorization = _qTestContext.QtestContext.qTestVersion >= 7 ? 'bearer ' + token : token;
        }
        headers['Content-Type'] = contentType;
        headers['x-filename'] = filename;
        // eslint-disable-next-line no-undef
        $.each(headers, function (key, value) {
          if (Object.prototype.hasOwnProperty.call(headers, key) && !(value instanceof Function)) {
            oReq.setRequestHeader(key, value);
          }
        });
        oReq.onload = function (oEvent) {
          var data = oReq.response;
          var responseStatus = oReq.status;
          console.log(new Date().toString() + ' HttpRequest: finished uploading binary data, response status: \'' + responseStatus + '\', response data: \'' + data + '\'...');
          oReq.abort();
          if (responseStatus === 200 || responseStatus === 201) {
            resolve({
              data: JSON.parse(data)
            });
          } else {
            resolve({
              error: responseStatus + 'ERROR'
            });
          }
        };
        oReq.onerror = function (oEvent) {
          resolve({
            error: 'HttpRequest: error :' + oEvent.error
          });
        };
        oReq.send(binaryData);
      });
    }
  }]);

  return HttpRequest;
}();

},{"../../extension/js/background/config.js":9,"../qTestContext.js":1}],3:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MessagingService = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _sendStatusEnum = require('./model/sendStatusEnum.js');

var _DateUtils = require('./utils/DateUtils.js');

var _httpRequest = require('./httpRequest.js');

var _qTestContext = require('../qTestContext.js');

var _config = require('../../extension/js/background/config.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MessagingService = exports.MessagingService = function () {
  function MessagingService(baseURL, token) {
    _classCallCheck(this, MessagingService);

    this.baseURL = baseURL;
    this.token = token;
  }

  _createClass(MessagingService, [{
    key: 'getSessionJson',
    value: function getSessionJson(session, sendCaptureDate) {
      var sysInfoJson = {
        app_version: _config.App.systemInfo.appVersion,
        incl_app_version: true,
        os: _config.App.systemInfo.os,
        incl_os: true,
        resolutions: _config.App.systemInfo.resolutions,
        incl_resolutions: true
      };
      var appInfoJson = {
        name: _config.App.applicationInfo.name,
        file_version: _config.App.applicationInfo.fileVersion,
        incl_file_version: true,
        version: _config.App.applicationInfo.version,
        incl_version: true
      };
      var json = {
        client_name: 'qTestWebeXplorer',
        project_id: session.project,
        title: session.title,
        desc: session.description,
        planned_duration: session.plannedDuration.hour * 3600 + session.plannedDuration.min * 60,
        sys_info: sysInfoJson,
        app_infos: [appInfoJson],
        tester_name: session.tester,
        has_meta_data: true
      };
      if (sendCaptureDate) {
        var capturedDate = _DateUtils.DateUtils.getDateString(new Date());
        json.captured_date = capturedDate;
        json.doc = {
          captured_date: capturedDate
        };
      }
      return json;
    }
  }, {
    key: 'sendCreateSession',
    value: async function sendCreateSession(session) {
      if (session.sendStatus && session.sendStatus !== _sendStatusEnum.SendStatusEnum.notSent) {
        return {
          success: true
        };
      }
      session.sendStatus = _sendStatusEnum.SendStatusEnum.sending;
      var url = this.baseURL + '/sessions';
      var json = this.getSessionJson(session, true);
      json.owner_user = session.tester;
      json.edit_user = session.tester;
      json.tester_name = session.tester;
      json.status = 'running';
      console.log(new Date().toString() + ' about to send create session...');

      var res = await _httpRequest.HttpRequest.send(url, this.token, 'POST', JSON.stringify(json));
      console.log(new Date().toString() + ' finished creating session...');
      if (res.error) {
        session.sendStatus = _sendStatusEnum.SendStatusEnum.error;
      } else {
        _qTestContext.QtestContext.ownerToken = res.data.owner_token;
        session.id = res.data.id;
        session.sendStatus = _sendStatusEnum.SendStatusEnum.sent;
        session.status = 'running';
        this.buildRedirectUrl(session);
      }
      return {
        success: res.error == null, // should be ==
        error: res.error
      };
    }
  }, {
    key: 'buildRedirectUrl',
    value: function buildRedirectUrl(session) {
      var redirectUrl = '';
      var version = _qTestContext.QtestContext.sessionManagerVersion;

      if ((version ? version.major : undefined) >= 3) {
        redirectUrl = _qTestContext.QtestContext.user.url + '/p/' + _qTestContext.QtestContext.session.project + '/portal/session/' + session.id + '/review';
        session.redirectUrl = _qTestContext.QtestContext.user.apiURL + '/' + session.id + '/review';
      } else if (_qTestContext.QtestContext.qTestVersion >= 7) {
        redirectUrl = _qTestContext.QtestContext.user.url + '/p/' + _qTestContext.QtestContext.session.project + '/portal/session/' + session.id + '/review';
        session.redirectUrl = redirectUrl;
      } else {
        redirectUrl = _qTestContext.QtestContext.user.url + '/p/' + _qTestContext.QtestContext.session.project + '/portal/session/playback/' + session.id;
        session.redirectUrl = redirectUrl;
      }
      var encodedRedirectUrl = encodeURIComponent(redirectUrl);
      session.url = _qTestContext.QtestContext.user.url + '/portal/loginform?token=' + _qTestContext.QtestContext.user.token + '&redirect=' + encodedRedirectUrl;
    }
  }, {
    key: 'sendUpdateSession',
    value: async function sendUpdateSession(session, sendCaptureDate) {
      if (!session.sendStatus) {
        return {
          success: false
        };
      }
      var url = this.baseURL + '/sessions/' + session.id;
      var json = this.getSessionJson(session, sendCaptureDate);
      json.time_lines = [];
      var order = 0;
      var actualDuration = 0;
      var ref = _qTestContext.QtestContext.timeTypes;
      for (var i = 0, len = ref.length; i < len; i++) {
        var timeType = ref[i];
        var jsonTimeLine = {
          total_time: 0,
          order: order++,
          time_type: {
            id: timeType.id,
            name: timeType.name,
            color: timeType.color
          }
        };
        json.time_lines.push(jsonTimeLine);
        var timelines = session.timeLines;
        for (var j = 0, len1 = timelines.length; j < len1; j++) {
          var timeLine = timelines[j];
          if (timeLine.timeType.name === timeType.name) {
            jsonTimeLine.total_time += timeLine.totalTime;
          }
        }
        actualDuration += jsonTimeLine.total_time;
      }
      json.actual_duration = actualDuration;

      var res = await _httpRequest.HttpRequest.send(url, this.token, 'PUT', JSON.stringify(json));
      if (res.error) {
        console.error('sendUpdateSession error - status: ' + res.status + ', error: ' + res.error);
      } else {
        this.buildRedirectUrl(session);
      }
      return {
        success: !res.error,
        error: res.error
      };
    }
  }, {
    key: 'sendUpdateSessionStatus',
    value: async function sendUpdateSessionStatus(session, status) {
      var url = this.baseURL + '/sessions/' + session.id + '/status';
      console.log(new Date().toString() + ' about to send update session status \'' + status + '\'...');
      var res = await _httpRequest.HttpRequest.send(url, this.token, 'PUT', '{ "status": "' + status + '" }');
      console.log(new Date().toString() + ' finished updating session status \'' + status + '\'...');
      if (!res.error) {
        session.status = status;
        if (status === 'running') {
          if (!res.data || !res.data.owner_token) {
            console.error(new Date().toString() + ' updating session status error: missing Owner Token...');
            return {
              success: false,
              error: 'missing Owner Token'
            };
          }
          console.log(new Date().toString() + ' obtained Owner Token...');
          _qTestContext.QtestContext.ownerToken = res.data.owner_token;
        }
      }
      return {
        success: !res.error,
        error: res.error
      };
    }
  }, {
    key: 'processUploadScreen',
    value: async function processUploadScreen(sessionId, screen, url) {
      var annotations = [];
      var ref = screen.annotations;
      for (var i = 0, len = ref.length; i < len; i++) {
        var annotation = ref[i];
        var actionJSON = annotation.getJson();
        if (actionJSON.timestamp) {
          actionJSON.timestamp = _DateUtils.DateUtils.getDateString(new Date(actionJSON.timestamp));
        }
        annotations.push(actionJSON);
      }
      var json = {
        order: screen.order,
        title: screen.title,
        browser_url: screen.url,
        capture_mode: 'Form',
        left: 0,
        top: 0,
        width: screen.width,
        height: screen.height,
        app_left: 0,
        app_top: 0,
        app_width: screen.width,
        app_height: screen.height,
        screen_height: screen.height,
        screen_width: screen.width,
        timestamp: _DateUtils.DateUtils.getDateString(new Date(screen.timeStamp)),
        finished_timestamp: _DateUtils.DateUtils.getDateString(new Date(screen.finishedTimestamp)),
        annotations: annotations,
        time_type: screen.timeType ? {
          color: screen.timeType.color,
          name: screen.timeType.name,
          id: screen.timeType.id
        } : null
      };

      var res = await _httpRequest.HttpRequest.send(url, this.token, 'POST', JSON.stringify(json));
      if (res.error) {
        screen.sendStatus = _sendStatusEnum.SendStatusEnum.error;
        console.error(new Date().toString() + ' error sending screen metadata: ' + screen.order + ' to ' + url + ': ' + res.error);
      } else {
        screen.id = res.data.id;
        console.log(new Date().toString() + ' call uploading for screen: ' + res.data.id);
        await this.sendUpload(sessionId, screen);
      }
    }
  }, {
    key: 'processUploadMedia',
    value: async function processUploadMedia(index, sessionId, url, screen, annotationLength) {
      var mediaUploadUrl = this.baseURL + '/upload-objects';
      if (index < annotationLength) {
        var annotation = screen.annotations[index];
        var annotationType = annotation.annotationType;
        if (annotationType === 'Video' || annotationType === 'Audio') {
          var mediaFileName = annotation.description;
          if (annotationType === 'Video') {
            mediaFileName += '.webm';
          } else {
            mediaFileName += '.wav';
          }
          console.log(new Date().toString() + ' about to upload media of type ' + annotationType + ', fileName: ' + mediaFileName);
          var response = await _httpRequest.HttpRequest.upload(mediaUploadUrl, this.token, mediaFileName, annotation.blob, annotation.mimeType);
          if (response.error) {
            console.log(new Date().toString() + ' error uploading media ' + mediaFileName + ': ' + response.error);
          } else {
            annotation.url = response.data.url;
            console.log(new Date().toString() + ' successfully uploading media ' + mediaFileName + ', url: ' + annotation.url);
          }
        }
        var nextIndex = index + 1;
        await this.processUploadMedia(nextIndex, sessionId, url, screen, annotationLength);
      }
    }
  }, {
    key: 'uploadMedia',
    value: async function uploadMedia(sessionId, screen, url) {
      var annotationLength = screen.annotations.length;
      await this.processUploadMedia(0, sessionId, url, screen, annotationLength);
      await this.processUploadScreen(sessionId, screen, url);
    }
  }, {
    key: 'sendCreateScreen',
    value: async function sendCreateScreen(sessionId, screen) {
      if (screen.sendStatus) {
        if (screen.sendStatus === _sendStatusEnum.SendStatusEnum.sent) {
          return;
        } else if (screen.sendStatus === _sendStatusEnum.SendStatusEnum.error) {
          console.error('Error sending screen ' + screen.order());
          return;
        } else if (screen.sendStatus === _sendStatusEnum.SendStatusEnum.sending) {
          return;
        }
      }
      screen.sendStatus = _sendStatusEnum.SendStatusEnum.sending;
      var url = this.baseURL + '/sessions/' + sessionId + '/screens';

      await this.uploadMedia(sessionId, screen, url);
    }
  }, {
    key: 'sendUpload',
    value: async function sendUpload(sessionId, screen) {
      if (screen.sendStatus) {
        if (screen.sendStatus === _sendStatusEnum.SendStatusEnum.sent) {
          return {
            success: true
          };
        } else if (screen.sendStatus !== _sendStatusEnum.SendStatusEnum.sending) {
          return {
            success: false
          };
        }
      }
      var url = this.baseURL + '/sessions/' + sessionId + '/screens/' + screen.id + '/images';
      var fileName = 'Temp';
      var binaryData = screen.screenShotBinary ? new Uint8Array(screen.screenShotBinary) : null;
      console.log(new Date().toString() + ' about to upload screen...');

      var res = await _httpRequest.HttpRequest.upload(url, this.token, fileName, binaryData, 'image/jpeg');
      if (res.error) {
        screen.sendStatus = _sendStatusEnum.SendStatusEnum.error;
        console.error(new Date().toString() + ' error uploading screen ' + screen.id + ': ' + res.error);
      } else {
        screen.sendStatus = _sendStatusEnum.SendStatusEnum.sent;
        console.log(new Date().toString() + ' successfully upload screen ' + screen.id);
      }
      return {
        success: res.error === undefined,
        error: res.error
      };
    }
  }, {
    key: 'sendAllScreens',
    value: async function sendAllScreens(sessionId, screens) {
      if (screens && screens.length > 0) {
        if (screens[0].sendStatus === _sendStatusEnum.SendStatusEnum.notSent) {
          await this.sendCreateScreen(sessionId, screens[0]);
          //
          var shifted = screens.shift();
          if (shifted && typeof shifted.destroyScreenshotBinary === 'function') {
            shifted.destroyScreenshotBinary();
            shifted = null;
          }
          if (screens.length > 0) {
            await this.sendAllScreens(sessionId, screens);
          }
        }
      }
    }
  }, {
    key: 'startSendingAllScreen',
    value: function startSendingAllScreen() {
      try {
        this.sendAllScreens(_qTestContext.QtestContext.session.id, _qTestContext.QtestContext.session.screens);
      } catch (error) {
        console.error('error sending: ' + error);
        var screens = _qTestContext.QtestContext.session.screens;
        if (screens > 0) {
          var shifted = _qTestContext.QtestContext.session.screens.shift();
          if (shifted) {
            shifted.destroyScreenshotBinary();
            shifted = null;
          }
        }
        this.sendAllScreens(_qTestContext.QtestContext.session.id, _qTestContext.QtestContext.session.screens);
      }
    }
  }]);

  return MessagingService;
}();

},{"../../extension/js/background/config.js":9,"../qTestContext.js":1,"./httpRequest.js":2,"./model/sendStatusEnum.js":5,"./utils/DateUtils.js":8}],4:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ApplicationInfo = exports.ApplicationInfo = function ApplicationInfo(name, version, fileVersion) {
  _classCallCheck(this, ApplicationInfo);

  this.name = name;
  this.version = version;
  this.fileVersion = fileVersion;
};

},{}],5:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var SendStatusEnum = exports.SendStatusEnum = {
  error: 'Error',

  notSent: 'NotSent',

  sent: 'Sent',

  sending: 'Sending'
};

},{}],6:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var StatusEnum = exports.StatusEnum = {
  notLoggedIn: 'notLoggedIn',

  loggingIn: 'loggingIn',

  loggedIn: 'loggedIn',

  loadingServerSession: 'loadingServerSession',

  loadedServerSession: 'loadedServerSession',

  startingSession: 'startingSession',

  startingSessionIndicator: 'startingSessionIndicator',

  recording: 'recording',

  editing: 'editing',

  paused: 'paused',

  capturingFullPage: 'capturingFullPage',

  inProgress: 'inProgress',

  completingSession: 'completingSession',

  recordingMedia: 'recordingMedia'
};

},{}],7:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SystemInfo = exports.SystemInfo = function SystemInfo(os, resolutions, appVersion) {
  _classCallCheck(this, SystemInfo);

  this.os = os;
  this.resolutions = resolutions;
  this.appVersion = appVersion;
};

},{}],8:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DateUtils = exports.DateUtils = function () {
  function DateUtils() {
    _classCallCheck(this, DateUtils);
  }

  _createClass(DateUtils, null, [{
    key: 'getDateString',
    value: function getDateString(date) {
      var strDate = JSON.stringify(date).toString().replace('"', '').replace('"', '');
      strDate = strDate.substring(0, strDate.indexOf('Z')) + '+00:00';
      return strDate;
    }
  }]);

  return DateUtils;
}();

},{}],9:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.App = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _systemInfo = require('../../../common/services/model/systemInfo.js');

var _applicationInfo = require('../../../common/services/model/applicationInfo.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var fileVersion = '';
var browserName = '';
var firefoxVersion = '';
var osName = '';
var nAgt = window.navigator.userAgent;
var verOffset = nAgt.indexOf('Firefox');
if (verOffset !== -1) {
  browserName = 'firefox';
  fileVersion = nAgt.substring(verOffset + 8);
  firefoxVersion = parseInt(fileVersion, 10);
}
var mozillaExp = nAgt.match(/Mozilla\/(.*?) /);
if (mozillaExp && mozillaExp.length > 0) {
  var mozillaExp2 = /Mozilla\//;
  var osExp = /\((.*?)\)/;
  osName = navigator.userAgent.match(new RegExp(String(mozillaExp2.source) + mozillaExp[1] + ' ' + osExp.source))[1];
}

var App = exports.App = function () {
  function App() {
    _classCallCheck(this, App);
  }

  _createClass(App, null, [{
    key: 'manifest',
    get: function get() {
      return this._manifest || chrome.runtime.getManifest();
    }
  }, {
    key: 'name',
    get: function get() {
      return this.manifest.name;
    }
  }, {
    key: 'version',
    get: function get() {
      return this.manifest.version;
    }
  }, {
    key: 'apiVersion',
    get: function get() {
      return this.manifest.apiVersion;
    }
  }, {
    key: 'scaleBeforeCompare',
    get: function get() {
      return this._scaleBeforeCompare || true;
    },
    set: function set(value) {
      this._scaleBeforeCompare = value;
    }
  }, {
    key: 'fileVersion',
    get: function get() {
      if (mozillaExp && mozillaExp.length > 0) {
        return mozillaExp[1];
      }
      return -1;
    }
  }, {
    key: 'systemInfo',
    get: function get() {
      var width = window.screen.width * window.devicePixelRatio;
      var height = window.screen.height * window.devicePixelRatio;
      return new _systemInfo.SystemInfo(osName, width + 'x' + height, this.version);
    }
  }, {
    key: 'applicationInfo',
    get: function get() {
      return new _applicationInfo.ApplicationInfo(browserName, firefoxVersion, fileVersion);
    }
  }]);

  return App;
}();

},{"../../../common/services/model/applicationInfo.js":4,"../../../common/services/model/systemInfo.js":7}]},{},[3]);
