(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Action = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _GuidUtils = require('../utils/GuidUtils.js');

var _ObjectUtils = require('../utils/ObjectUtils.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Action = exports.Action = function () {
  function Action(description, type, metaData) {
    _classCallCheck(this, Action);

    this._x = -100;
    this._y = -1;
    this._orderNumber = null;
    this._keyCode = null;
    this._timeStamp = null;
    this._repeat = 1;
    this._description = description;
    this._type = type;
    this._metaData = _ObjectUtils.ObjectUtils.clone(metaData);
    this._description = this.description.trim();
    this._id = _GuidUtils.GuidUtils.generateGuid();
    if (this._description.length > 0) {
      this._description = this.description.slice(0, 1).toUpperCase() + this.description.slice(1);
    }
  }

  _createClass(Action, [{
    key: 'getJson',
    value: function getJson() {
      var des = this.description;
      if (this.repeat > 1) {
        des = des + ' ' + this.repeat + ' times';
      }
      if (this.repeat === -2) {
        des = 'Double ' + this.description;
        if (des.indexOf('Double Select') === 0) {
          des = des.replace('Double Select', 'Double Click');
        }
      }
      return {
        id: this.id,
        annotation_type: 'Action',
        order_number: this.orderNumber,
        desc: des,
        meta_data: this.metaData,
        left: this.x,
        top: this.y,
        hotspotx: this.x,
        hotspoty: this.y,
        timestamp: this.timeStamp
      };
    }
  }, {
    key: 'getDrawableData',
    value: function getDrawableData() {
      return {
        id: this.id,
        annotationType: 'Action',
        orderNumber: this.orderNumber,
        desc: this.description,
        meta_data: this.metaData,
        left: this.x,
        top: this.y,
        hotspotx: this.x,
        hotspoty: this.y,
        timestamp: this.timeStamp,
        repeat: this.repeat
      };
    }
  }, {
    key: 'importData',
    value: function importData(data) {
      this.id = data.id;
      this.orderNumber = data.orderNumber;
      this.description = data.desc;
      this.metaData = data.meta_data;
      this.x = data.hotspotx;
      this.y = data.hotspoty;
      this.timeStamp = data.timestamp;
      this.repeat = data.repeat;
    }
  }, {
    key: 'x',
    get: function get() {
      return this._x;
    },
    set: function set(value) {
      this._x = value;
    }
  }, {
    key: 'y',
    get: function get() {
      return this._y;
    },
    set: function set(value) {
      this._y = value;
    }
  }, {
    key: 'orderNumber',
    get: function get() {
      return this._orderNumber;
    },
    set: function set(value) {
      this._orderNumber = value;
    }
  }, {
    key: 'keyCode',
    get: function get() {
      return this._keyCode;
    },
    set: function set(value) {
      this._keyCode = value;
    }
  }, {
    key: 'timeStamp',
    get: function get() {
      return this._timeStamp;
    },
    set: function set(value) {
      this._timeStamp = value;
    }
  }, {
    key: 'repeat',
    get: function get() {
      return this._repeat;
    },
    set: function set(value) {
      this._repeat = value;
    }
  }, {
    key: 'description',
    get: function get() {
      return this._description;
    },
    set: function set(value) {
      this._description = value;
    }
  }, {
    key: 'type',
    get: function get() {
      return this._type;
    },
    set: function set(value) {
      this._type = value;
    }
  }, {
    key: 'metaData',
    get: function get() {
      return this._metaData;
    },
    set: function set(value) {
      this._metaData = value;
    }
  }, {
    key: 'id',
    get: function get() {
      return this._id;
    },
    set: function set(value) {
      this._id = value;
    }
  }]);

  return Action;
}();

},{"../utils/GuidUtils.js":2,"../utils/ObjectUtils.js":3}],2:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var GuidUtils = exports.GuidUtils = function () {
  function GuidUtils() {
    _classCallCheck(this, GuidUtils);
  }

  _createClass(GuidUtils, null, [{
    key: 'generateGuid',
    value: function generateGuid() {
      var d = new Date().getTime();
      var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
        var r = (d + Math.random() * 16) % 16 | 0;
        d = Math.floor(d / 16);
        return (c === 'x' ? r : r & 0x3 | 0x8).toString(16);
      });
      return uuid;
    }
  }]);

  return GuidUtils;
}();

},{}],3:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ObjectUtils = exports.ObjectUtils = function () {
  function ObjectUtils() {
    _classCallCheck(this, ObjectUtils);
  }

  _createClass(ObjectUtils, null, [{
    key: 'clone',
    value: function clone(obj) {
      if (!obj || (typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) !== 'object') {
        return obj;
      }
      if (obj instanceof Date) {
        var copy = new Date();
        copy.setTime(obj.getTime());
        return copy;
      }
      if (obj instanceof Array || Array.isArray(obj)) {
        var _copy = [];
        for (var i = 0, len = obj.length; i < len; i++) {
          var item = obj[i];
          _copy.push(ObjectUtils.clone(item));
        }
        return _copy;
      }
      if ((typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) === 'object') {
        var _copy2 = {};
        for (var attr in obj) {
          if (Object.prototype.hasOwnProperty.call(obj, attr)) {
            _copy2[attr] = this.clone(obj[attr]);
          }
        }
        return _copy2;
      }
      return obj;
    }
  }]);

  return ObjectUtils;
}();

},{}]},{},[1]);
