(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AutoStartSetting = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _storage = require('../storage.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var AutoStartSetting = exports.AutoStartSetting = function () {
  function AutoStartSetting() {
    _classCallCheck(this, AutoStartSetting);

    this.isEnableAutoStart = false;
    this.projectId = '';
    this.domainsIgnored = {};
    this.domains = '';
    this.projectName = '';
    this.userEmail = '';
  }

  _createClass(AutoStartSetting, [{
    key: 'load',
    value: function load(userEmail, autoStartProjects) {
      this.userEmail = userEmail;
      var obj = _storage.Storage.get('autoStartSetting');
      if (obj) {
        var setting = obj[userEmail];
        if (setting) {
          this.isEnableAutoStart = setting.isEnableAutoStart;
          this.projectId = setting.projectId;
          var valid = false;
          for (var j = 0, len = autoStartProjects.length; j < len; j++) {
            var p = autoStartProjects[j];
            if (this.projectId && this.projectId.toString() === p.id.toString()) {
              valid = true;
              this.projectName = p.name;
              this.domains = p.alwaysOnSetting.domains.split(' ');
              break;
            }
          }
          this.isEnableAutoStart = this.isEnableAutoStart && valid;
          return this.isEnableAutoStart;
        }
      }
      return false;
    }
  }, {
    key: 'canShowAutoStartConfirm',
    value: function canShowAutoStartConfirm(domain) {
      if (this.isEnableAutoStart && this.domainsIgnored[domain] !== false) {
        if (this.domains.length === 0) {
          return false;
        }
        for (var i = 0, j = 0, ref = this.domains.length - 1; ref >= 0 ? j <= ref : j >= ref; i = ref >= 0 ? ++j : --j) {
          var d = this.domains[i];
          if (domain.length >= d.length && domain.indexOf(d) >= 0) {
            return true;
          }
        }
      }
      return false;
    }
  }, {
    key: 'disableShowAutoStartConfirm',
    value: function disableShowAutoStartConfirm(domain) {
      this.domainsIgnored[domain] = false;
    }
  }, {
    key: 'save',
    value: function save() {
      var obj = _storage.Storage.get('autoStartSetting') || {};
      var email = this.userEmail;
      var setting = {};
      setting.projectId = this.projectId;
      if (!setting.projectId || setting.projectId.length === 0) {
        this.isEnableAutoStart = false;
      }
      setting.isEnableAutoStart = this.isEnableAutoStart;
      obj[email] = setting;
      var str = JSON.stringify(obj);

      _storage.Storage.set('autoStartSetting', str);
    }
  }]);

  return AutoStartSetting;
}();

},{"../storage.js":2}],2:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ___ = ['\x6D\x74\x26\x79\x6B\x4E\x57\x55\x62\x4E\x49\x65\x52\x26\x34\x33'][0];

var Storage = exports.Storage = function () {
  function Storage() {
    _classCallCheck(this, Storage);
  }

  _createClass(Storage, null, [{
    key: 'encrypt',
    value: function encrypt(vString) {
      // eslint-disable-next-line no-undef
      return sjcl.encrypt(___, vString);
    }
  }, {
    key: 'decrypt',
    value: function decrypt(vString) {
      // eslint-disable-next-line no-undef
      return sjcl.decrypt(___, vString);
    }

    // get(k: string): Object

  }, {
    key: 'get',
    value: function get(k) {
      try {
        var vString = localStorage.getItem(k);
        if (!vString) {
          return null;
        }

        var obj = JSON.parse(vString);
        if (obj.cipher && obj.salt && obj.mode) {
          obj = JSON.parse(this.decrypt(vString));
        }

        // backward compatible: old version stringify the obj multiple times
        if (typeof obj === 'string') {
          try {
            var tempObj = JSON.parse(obj);
            obj = tempObj;
            // eslint-disable-next-line no-empty
          } catch (e) {}
        }

        if (obj.expires) {
          // check expiration
          var now = new Date();
          var expires = new Date(obj.expires);
          if (now.getTime() >= expires.getTime()) {
            console.error('Storage "' + k + '" expired on ' + obj.expires);
            this.remove(k);
            return null;
          }
        }

        return obj;
      } catch (error) {
        console.log(error);
        return null;
      }
    }

    // set(k: string, vString: string, opts: { secure: boolean })

  }, {
    key: 'set',
    value: function set(k, vString) {
      var opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      if (!vString) {
        this.remove(k);
        return;
      }

      localStorage.setItem(k, opts.secure ? this.encrypt(vString) : vString);
    }
  }, {
    key: 'remove',
    value: function remove(k) {
      localStorage.removeItem(k);
    }
  }]);

  return Storage;
}();

},{}]},{},[1]);
