(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.QtestContext = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _statusEnum = require('./services/model/statusEnum.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var QtestContext = exports.QtestContext = function () {
  function QtestContext() {
    _classCallCheck(this, QtestContext);
  }

  _createClass(QtestContext, null, [{
    key: 'clear',
    value: function clear() {
      this._user = null;
      this._session = null;
      this._projects = [];
      this._selectedProject = null;
      this._timeTypes = [];
      this._noteTypes = [];
      this._pendingAnnotations = [];
      this._currentProcessingScreen = null;
      this._domainOptions = null;
      this._runFromQtest = false;
      this._projectId = null;
      this._sessionId = null;
      this._status = {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    }
  }, {
    key: 'canRecordMedia',
    value: function canRecordMedia() {
      return this._qTestVersion && this._qTestVersion >= 6;
    }
  }, {
    key: 'getProjectAutoStartSupported',
    value: function getProjectAutoStartSupported() {
      var result = [];
      if (this._projects) {
        var ref = this._projects;
        for (var j = 0, len = ref.length; j < len; j++) {
          var p = ref[j];
          if (p.alwaysOnSetting.domains.length > 0 && p.alwaysOnSetting.enabled) {
            result.push(p);
          }
        }
      }
      return result;
    }
  }, {
    key: 'qTestVersion',
    get: function get() {
      return this._qTestVersion || null;
    },
    set: function set(qTestVersion) {
      this._qTestVersion = qTestVersion;
    }
  }, {
    key: 'qTestMinorVersion',
    get: function get() {
      return this._qTestMinorVersion || null;
    },
    set: function set(qTestMinorVersion) {
      this._qTestMinorVersion = qTestMinorVersion;
    }
  }, {
    key: 'session',
    get: function get() {
      return this._session || null;
    },
    set: function set(session) {
      this._session = session;
    }
  }, {
    key: 'user',
    get: function get() {
      return this._user || null;
    },
    set: function set(user) {
      this._user = user;
    }
  }, {
    key: 'projects',
    get: function get() {
      if (!this._projects) {
        this._projects = [];
      }
      return this._projects;
    },
    set: function set(projects) {
      this._projects = projects;
    }
  }, {
    key: 'selectedProject',
    get: function get() {
      return this._selectedProject || null;
    },
    set: function set(selectedProject) {
      this._selectedProject = selectedProject;
    }
  }, {
    key: 'timeTypes',
    get: function get() {
      if (!this._timeTypes) {
        this._timeTypes = [];
      }
      return this._timeTypes;
    },
    set: function set(timeTypes) {
      this._timeTypes = timeTypes;
    }
  }, {
    key: 'noteTypes',
    get: function get() {
      if (!this._noteTypes) {
        this._noteTypes = [];
      }
      return this._noteTypes;
    },
    set: function set(noteTypes) {
      this._noteTypes = noteTypes;
    }
  }, {
    key: 'pendingAnnotations',
    get: function get() {
      if (!this._pendingAnnotations) {
        this._pendingAnnotations = [];
      }
      return this._pendingAnnotations;
    },
    set: function set(pendingAnnotations) {
      this._pendingAnnotations = pendingAnnotations;
    }
  }, {
    key: 'currentProcessingScreen',
    get: function get() {
      return this._currentProcessingScreen || null;
    },
    set: function set(currentProcessingScreen) {
      this._currentProcessingScreen = currentProcessingScreen;
    }
  }, {
    key: 'domainOptions',
    get: function get() {
      return this._domainOptions || null;
    },
    set: function set(domainOptions) {
      this._domainOptions = domainOptions;
    }
  }, {
    key: 'runFromQtest',
    get: function get() {
      return this._runFromQtest || false;
    },
    set: function set(runFromQtest) {
      this._runFromQtest = runFromQtest;
    }
  }, {
    key: 'projectId',
    get: function get() {
      return this._projectId || null;
    },
    set: function set(projectId) {
      this._projectId = projectId;
    }
  }, {
    key: 'sessionId',
    get: function get() {
      return this._sessionId || null;
    },
    set: function set(sessionId) {
      this._sessionId = sessionId;
    }
  }, {
    key: 'status',
    get: function get() {
      return this._status || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._status = value;
    }
  }, {
    key: 'currentqTestSession',
    get: function get() {
      return this._currentqTestSession || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._currentqTestSession = value;
    }
  }, {
    key: 'sessionManagerVersion',
    get: function get() {
      return this._sessionManagerVersion || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._sessionManagerVersion = value;
    }
  }]);

  return QtestContext;
}();

},{"./services/model/statusEnum.js":7}],2:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Action = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _GuidUtils = require('../utils/GuidUtils.js');

var _ObjectUtils = require('../utils/ObjectUtils.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Action = exports.Action = function () {
  function Action(description, type, metaData) {
    _classCallCheck(this, Action);

    this._x = -100;
    this._y = -1;
    this._orderNumber = null;
    this._keyCode = null;
    this._timeStamp = null;
    this._repeat = 1;
    this._description = description;
    this._type = type;
    this._metaData = _ObjectUtils.ObjectUtils.clone(metaData);
    this._description = this.description.trim();
    this._id = _GuidUtils.GuidUtils.generateGuid();
    if (this._description.length > 0) {
      this._description = this.description.slice(0, 1).toUpperCase() + this.description.slice(1);
    }
  }

  _createClass(Action, [{
    key: 'getJson',
    value: function getJson() {
      var des = this.description;
      if (this.repeat > 1) {
        des = des + ' ' + this.repeat + ' times';
      }
      if (this.repeat === -2) {
        des = 'Double ' + this.description;
        if (des.indexOf('Double Select') === 0) {
          des = des.replace('Double Select', 'Double Click');
        }
      }
      return {
        id: this.id,
        annotation_type: 'Action',
        order_number: this.orderNumber,
        desc: des,
        meta_data: this.metaData,
        left: this.x,
        top: this.y,
        hotspotx: this.x,
        hotspoty: this.y,
        timestamp: this.timeStamp
      };
    }
  }, {
    key: 'getDrawableData',
    value: function getDrawableData() {
      return {
        id: this.id,
        annotationType: 'Action',
        orderNumber: this.orderNumber,
        desc: this.description,
        meta_data: this.metaData,
        left: this.x,
        top: this.y,
        hotspotx: this.x,
        hotspoty: this.y,
        timestamp: this.timeStamp,
        repeat: this.repeat
      };
    }
  }, {
    key: 'importData',
    value: function importData(data) {
      this.id = data.id;
      this.orderNumber = data.orderNumber;
      this.description = data.desc;
      this.metaData = data.meta_data;
      this.x = data.hotspotx;
      this.y = data.hotspoty;
      this.timeStamp = data.timestamp;
      this.repeat = data.repeat;
    }
  }, {
    key: 'x',
    get: function get() {
      return this._x;
    },
    set: function set(value) {
      this._x = value;
    }
  }, {
    key: 'y',
    get: function get() {
      return this._y;
    },
    set: function set(value) {
      this._y = value;
    }
  }, {
    key: 'orderNumber',
    get: function get() {
      return this._orderNumber;
    },
    set: function set(value) {
      this._orderNumber = value;
    }
  }, {
    key: 'keyCode',
    get: function get() {
      return this._keyCode;
    },
    set: function set(value) {
      this._keyCode = value;
    }
  }, {
    key: 'timeStamp',
    get: function get() {
      return this._timeStamp;
    },
    set: function set(value) {
      this._timeStamp = value;
    }
  }, {
    key: 'repeat',
    get: function get() {
      return this._repeat;
    },
    set: function set(value) {
      this._repeat = value;
    }
  }, {
    key: 'description',
    get: function get() {
      return this._description;
    },
    set: function set(value) {
      this._description = value;
    }
  }, {
    key: 'type',
    get: function get() {
      return this._type;
    },
    set: function set(value) {
      this._type = value;
    }
  }, {
    key: 'metaData',
    get: function get() {
      return this._metaData;
    },
    set: function set(value) {
      this._metaData = value;
    }
  }, {
    key: 'id',
    get: function get() {
      return this._id;
    },
    set: function set(value) {
      this._id = value;
    }
  }]);

  return Action;
}();

},{"../utils/GuidUtils.js":11,"../utils/ObjectUtils.js":12}],3:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Annotation = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _modelMapper = require('./../modelMapper.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Annotation = exports.Annotation = function () {
  function Annotation(data) {
    _classCallCheck(this, Annotation);

    if (data) {
      // eslint-disable-next-line no-undef
      $.extend(this, data);
    }
  }

  _createClass(Annotation, [{
    key: 'mapModelToData',
    value: function mapModelToData(model, excludes) {
      var _this = this;

      var excludesRef = excludes;
      if (!excludesRef) {
        excludesRef = [];
      }
      var objData = {};
      // eslint-disable-next-line no-undef
      $.each(model, function (key, value) {
        if ((excludesRef.length === 0 || excludesRef.indexOf(key.toString()) < 0) && !(value instanceof Function)) {
          if (value instanceof Array) {
            objData[key] = [];
            for (var j = 0, len = value.length; j < len; j++) {
              var valItem = value[j];
              objData[key].push(_this.mapModelToData(valItem, excludesRef));
            }
          } else if (value instanceof Object) {
            objData[key] = _this.mapModelToData(value, excludesRef);
          } else {
            objData[key] = value;
          }
        }
      });
      return objData;
    }
  }, {
    key: 'getJson',
    value: function getJson() {
      return _modelMapper.ModelMapper.mapModelToData(this, ['$$hashKey', 'isListItem', 'getJson', 'getDrawableData']);
    }
  }, {
    key: 'getDrawableData',
    value: function getDrawableData() {
      return this.mapModelToData(this, []);
    }
  }]);

  return Annotation;
}();

},{"./../modelMapper.js":9}],4:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Media = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _GuidUtils = require('../utils/GuidUtils.js');

var _DateUtils = require('../utils/DateUtils.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Media = exports.Media = function () {
  function Media() {
    _classCallCheck(this, Media);

    this.id = _GuidUtils.GuidUtils.generateGuid();
    this.annotationType = null;
    this.mimeType = null;
    this.description = null;
    this.blob = null;
    this.blobUrl = null;
    this.url = null;
    this.startTimestamp = null;
    this.endTimestamp = null;
    this.timestamp = null;
    this.size = 0;
  }

  _createClass(Media, [{
    key: 'getJson',
    value: function getJson() {
      return {
        id: this.id,
        annotation_type: this.annotationType,
        mime_type: this.mimeType,
        desc: this.description,
        start_timestamp: _DateUtils.DateUtils.getDateString(new Date(this.startTimestamp)),
        end_timestamp: _DateUtils.DateUtils.getDateString(new Date(this.endTimestamp)),
        timestamp: this.timestamp,
        url: this.url,
        size: this.size
      };
    }
  }, {
    key: 'getDrawableData',
    value: function getDrawableData() {
      return {
        id: this.id,
        annotationType: this.annotationType,
        mimeType: this.mimeType,
        desc: this.description,
        blobUrl: this.blobUrl,
        startTimestamp: this.startTimestamp,
        endTimestamp: this.endTimestamp,
        timestamp: this.timestamp,
        size: this.size
      };
    }
  }, {
    key: 'importData',
    value: function importData(data) {
      this.id = data.id;
      this.annotationType = data.annotationType;
      this.mimeType = data.mimeType;
      this.blobUrl = data.blobUrl;
      this.description = data.desc;
      this.startTimestamp = data.startTimestamp;
      this.endTimestamp = data.endTimestamp;
      this.timestamp = data.timestamp;
      this.size = data.size;
    }
  }]);

  return Media;
}();

},{"../utils/DateUtils.js":10,"../utils/GuidUtils.js":11}],5:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Note = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _GuidUtils = require('../utils/GuidUtils.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Note = exports.Note = function () {
  function Note() {
    _classCallCheck(this, Note);

    this.noteType = null;
    this.text = null;
    this.id = _GuidUtils.GuidUtils.generateGuid();
  }

  _createClass(Note, [{
    key: 'getJson',
    value: function getJson() {
      return {
        id: this.id,
        annotation_type: 'Note',
        note_type: {
          id: this.noteType.id,
          name: this.noteType.name,
          color: this.noteType.color
        },
        desc: this.text
      };
    }
  }, {
    key: 'getDrawableData',
    value: function getDrawableData() {
      return {
        annotationType: 'Note',
        id: this.id,
        noteType: {
          id: this.noteType.id,
          name: this.noteType.name,
          color: this.noteType.color
        },
        desc: this.text
      };
    }
  }, {
    key: 'importData',
    value: function importData(data) {
      this.text = data.desc;
      this.id = data.id;
      this.noteType = {
        id: data.noteType.id,
        name: data.noteType.name,
        color: data.noteType.color
      };
    }
  }]);

  return Note;
}();

},{"../utils/GuidUtils.js":11}],6:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Screen = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _timeType = require('./timeType.js');

var _action = require('./action.js');

var _note = require('./note.js');

var _media = require('./media.js');

var _annotation = require('./annotation.js');

var _qTestContext = require('../../qTestContext.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Screen = exports.Screen = function () {
  function Screen(title, url, screenShotBinary) {
    _classCallCheck(this, Screen);

    this.timeStamp = null;
    this.finishedTimestamp = null;
    this.forceCaptured = false;
    this.title = title;
    this.url = url;
    this.screenShotBinary = screenShotBinary;
    this.width = 0;
    this.height = 0;
    this.annotations = [];
    this.id = '';
    this.sendStatus = 'NotSent';
    this.order = 0;
    this.timeType = null;

    var timeTypeName = _qTestContext.QtestContext.session.currentTimeType;
    var timetypes = _qTestContext.QtestContext.timeTypes;
    if (timeTypeName && timetypes.length > 0) {
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = timetypes[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var type = _step.value;

          if (type.name === timeTypeName) {
            this.timeType = new _timeType.TimeType(type.id, type.name, type.color);
            break;
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }
  }

  _createClass(Screen, [{
    key: 'destroyScreenshotBinary',
    value: function destroyScreenshotBinary() {
      this._screenShotBinary = null;
    }
  }, {
    key: 'getDrawableData',
    value: function getDrawableData() {
      var screen = {
        width: this.width,
        height: this.height,
        id: this.id,
        sendStatus: this.sendStatus,
        order: this.order,
        screenShotBinary: this.screenShotBinary,
        title: this.title,
        annotations: []
      };
      this.annotations.sort(function (a, b) {
        if (a.timeStamp && b.timeStamp) {
          return a.timeStamp - b.timeStamp;
        }
        return 0;
      });
      var actionOrder = 1;
      var ref = this.annotations;
      for (var j = 0, len = ref.length; j < len; j++) {
        var annotation = ref[j];
        var data = annotation.getDrawableData();
        if (data.annotationType === 'Action') {
          data.orderNumber = actionOrder;
          actionOrder++;
        }
        screen.annotations.push(data);
      }
      return screen;
    }
  }, {
    key: 'importData',
    value: function importData(data) {
      this.width = data.width;
      this.height = data.height;
      this.id = data.id;
      this.sendStatus = data.sendStatus;
      this.order = data.order;
      if (data.screenShotBinary) {
        this.screenShotBinary = data.screenShotBinary;
      }
      this.title = data.title;
      var updatedAnnotations = [];
      var ref = data.annotations;
      for (var j = 0, len = ref.length; j < len; j++) {
        var annotation = ref[j];
        switch (annotation.annotationType) {
          case 'Action':
            {
              var action = new _action.Action(annotation.desc);
              action.importData(annotation);
              updatedAnnotations.push(action);
              break;
            }
          case 'Note':
            {
              var note = new _note.Note();
              note.importData(annotation);
              updatedAnnotations.push(note);
              break;
            }
          case 'Audio':
          case 'Video':
            {
              var media = new _media.Media();
              media.importData(annotation);
              var annotations = this.annotations;
              var _iteratorNormalCompletion2 = true;
              var _didIteratorError2 = false;
              var _iteratorError2 = undefined;

              try {
                for (var _iterator2 = annotations[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                  var a = _step2.value;

                  if (a.annotationType === annotation.annotationType && a.id === annotation.id) {
                    media.blob = a.blob;
                    break;
                  }
                }
              } catch (err) {
                _didIteratorError2 = true;
                _iteratorError2 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion2 && _iterator2.return) {
                    _iterator2.return();
                  }
                } finally {
                  if (_didIteratorError2) {
                    throw _iteratorError2;
                  }
                }
              }

              updatedAnnotations.push(media);
              break;
            }
          default:
            {
              var ann = new _annotation.Annotation(annotation);
              updatedAnnotations.push(ann);
              break;
            }
        }
      }
      this.annotations = updatedAnnotations;
    }
  }]);

  return Screen;
}();

},{"../../qTestContext.js":1,"./action.js":2,"./annotation.js":3,"./media.js":4,"./note.js":5,"./timeType.js":8}],7:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var StatusEnum = exports.StatusEnum = {
  notLoggedIn: 'notLoggedIn',

  loggingIn: 'loggingIn',

  loggedIn: 'loggedIn',

  loadingServerSession: 'loadingServerSession',

  loadedServerSession: 'loadedServerSession',

  startingSession: 'startingSession',

  startingSessionIndicator: 'startingSessionIndicator',

  recording: 'recording',

  editing: 'editing',

  paused: 'paused',

  capturingFullPage: 'capturingFullPage',

  inProgress: 'inProgress',

  completingSession: 'completingSession',

  recordingMedia: 'recordingMedia'
};

},{}],8:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TimeType = exports.TimeType = function TimeType(id, name, color) {
  _classCallCheck(this, TimeType);

  this.id = id;
  this.name = name;
  this.color = color;
};

},{}],9:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ModelMapper = exports.ModelMapper = function () {
  function ModelMapper() {
    _classCallCheck(this, ModelMapper);
  }

  _createClass(ModelMapper, null, [{
    key: 'toColConverter',
    value: function toColConverter(propName) {
      return propName.replace(/[A-Z]/g, function ($0) {
        return '_' + $0.toLowerCase();
      });
    }
  }, {
    key: 'mapModelToData',
    value: function mapModelToData(model, excludes) {
      var _this = this;

      if (!excludes) {
        excludes = [];
      }
      var objData = {};
      $.each(model, function (key, value) {
        if ((excludes.length === 0 || excludes.indexOf(key.toString()) < 0) && typeof value !== 'function') {
          if (value instanceof Array) {
            objData[_this.toColConverter(key)] = [];
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
              for (var _iterator = value[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                var valItem = _step.value;

                if (valItem instanceof Object || valItem instanceof Array) {
                  objData[_this.toColConverter(key)].push(_this.mapModelToData(valItem));
                } else {
                  objData[_this.toColConverter(key)].push(valItem);
                }
              }
            } catch (err) {
              _didIteratorError = true;
              _iteratorError = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }
              } finally {
                if (_didIteratorError) {
                  throw _iteratorError;
                }
              }
            }
          } else if (value instanceof Object) {
            objData[_this.toColConverter(key)] = _this.mapModelToData(value);
          } else {
            objData[_this.toColConverter(key)] = value;
          }
        }
      });
      return objData;
    }
  }]);

  return ModelMapper;
}();

},{}],10:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DateUtils = exports.DateUtils = function () {
  function DateUtils() {
    _classCallCheck(this, DateUtils);
  }

  _createClass(DateUtils, null, [{
    key: 'getDateString',
    value: function getDateString(date) {
      var strDate = JSON.stringify(date).toString().replace('"', '').replace('"', '');
      strDate = strDate.substring(0, strDate.indexOf('Z')) + '+00:00';
      return strDate;
    }
  }]);

  return DateUtils;
}();

},{}],11:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var GuidUtils = exports.GuidUtils = function () {
  function GuidUtils() {
    _classCallCheck(this, GuidUtils);
  }

  _createClass(GuidUtils, null, [{
    key: 'generateGuid',
    value: function generateGuid() {
      var d = new Date().getTime();
      var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
        var r = (d + Math.random() * 16) % 16 | 0;
        d = Math.floor(d / 16);
        return (c === 'x' ? r : r & 0x3 | 0x8).toString(16);
      });
      return uuid;
    }
  }]);

  return GuidUtils;
}();

},{}],12:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ObjectUtils = exports.ObjectUtils = function () {
  function ObjectUtils() {
    _classCallCheck(this, ObjectUtils);
  }

  _createClass(ObjectUtils, null, [{
    key: 'clone',
    value: function clone(obj) {
      if (!obj || (typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) !== 'object') {
        return obj;
      }
      if (obj instanceof Date) {
        var copy = new Date();
        copy.setTime(obj.getTime());
        return copy;
      }
      if (obj instanceof Array || Array.isArray(obj)) {
        var _copy = [];
        for (var i = 0, len = obj.length; i < len; i++) {
          var item = obj[i];
          _copy.push(ObjectUtils.clone(item));
        }
        return _copy;
      }
      if ((typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) === 'object') {
        var _copy2 = {};
        for (var attr in obj) {
          if (Object.prototype.hasOwnProperty.call(obj, attr)) {
            _copy2[attr] = this.clone(obj[attr]);
          }
        }
        return _copy2;
      }
      return obj;
    }
  }]);

  return ObjectUtils;
}();

},{}]},{},[6]);
