(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.QtestContext = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _statusEnum = require('./services/model/statusEnum.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var QtestContext = exports.QtestContext = function () {
  function QtestContext() {
    _classCallCheck(this, QtestContext);
  }

  _createClass(QtestContext, null, [{
    key: 'clear',
    value: function clear() {
      this._user = null;
      this._session = null;
      this._projects = [];
      this._selectedProject = null;
      this._timeTypes = [];
      this._noteTypes = [];
      this._pendingAnnotations = [];
      this._currentProcessingScreen = null;
      this._domainOptions = null;
      this._runFromQtest = false;
      this._projectId = null;
      this._sessionId = null;
      this._status = {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    }
  }, {
    key: 'canRecordMedia',
    value: function canRecordMedia() {
      return this._qTestVersion && this._qTestVersion >= 6;
    }
  }, {
    key: 'getProjectAutoStartSupported',
    value: function getProjectAutoStartSupported() {
      var result = [];
      if (this._projects) {
        var ref = this._projects;
        for (var j = 0, len = ref.length; j < len; j++) {
          var p = ref[j];
          if (p.alwaysOnSetting.domains.length > 0 && p.alwaysOnSetting.enabled) {
            result.push(p);
          }
        }
      }
      return result;
    }
  }, {
    key: 'qTestVersion',
    get: function get() {
      return this._qTestVersion || null;
    },
    set: function set(qTestVersion) {
      this._qTestVersion = qTestVersion;
    }
  }, {
    key: 'qTestMinorVersion',
    get: function get() {
      return this._qTestMinorVersion || null;
    },
    set: function set(qTestMinorVersion) {
      this._qTestMinorVersion = qTestMinorVersion;
    }
  }, {
    key: 'session',
    get: function get() {
      return this._session || null;
    },
    set: function set(session) {
      this._session = session;
    }
  }, {
    key: 'user',
    get: function get() {
      return this._user || null;
    },
    set: function set(user) {
      this._user = user;
    }
  }, {
    key: 'projects',
    get: function get() {
      if (!this._projects) {
        this._projects = [];
      }
      return this._projects;
    },
    set: function set(projects) {
      this._projects = projects;
    }
  }, {
    key: 'selectedProject',
    get: function get() {
      return this._selectedProject || null;
    },
    set: function set(selectedProject) {
      this._selectedProject = selectedProject;
    }
  }, {
    key: 'timeTypes',
    get: function get() {
      if (!this._timeTypes) {
        this._timeTypes = [];
      }
      return this._timeTypes;
    },
    set: function set(timeTypes) {
      this._timeTypes = timeTypes;
    }
  }, {
    key: 'noteTypes',
    get: function get() {
      if (!this._noteTypes) {
        this._noteTypes = [];
      }
      return this._noteTypes;
    },
    set: function set(noteTypes) {
      this._noteTypes = noteTypes;
    }
  }, {
    key: 'pendingAnnotations',
    get: function get() {
      if (!this._pendingAnnotations) {
        this._pendingAnnotations = [];
      }
      return this._pendingAnnotations;
    },
    set: function set(pendingAnnotations) {
      this._pendingAnnotations = pendingAnnotations;
    }
  }, {
    key: 'currentProcessingScreen',
    get: function get() {
      return this._currentProcessingScreen || null;
    },
    set: function set(currentProcessingScreen) {
      this._currentProcessingScreen = currentProcessingScreen;
    }
  }, {
    key: 'domainOptions',
    get: function get() {
      return this._domainOptions || null;
    },
    set: function set(domainOptions) {
      this._domainOptions = domainOptions;
    }
  }, {
    key: 'runFromQtest',
    get: function get() {
      return this._runFromQtest || false;
    },
    set: function set(runFromQtest) {
      this._runFromQtest = runFromQtest;
    }
  }, {
    key: 'projectId',
    get: function get() {
      return this._projectId || null;
    },
    set: function set(projectId) {
      this._projectId = projectId;
    }
  }, {
    key: 'sessionId',
    get: function get() {
      return this._sessionId || null;
    },
    set: function set(sessionId) {
      this._sessionId = sessionId;
    }
  }, {
    key: 'status',
    get: function get() {
      return this._status || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._status = value;
    }
  }, {
    key: 'currentqTestSession',
    get: function get() {
      return this._currentqTestSession || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._currentqTestSession = value;
    }
  }, {
    key: 'sessionManagerVersion',
    get: function get() {
      return this._sessionManagerVersion || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._sessionManagerVersion = value;
    }
  }]);

  return QtestContext;
}();

},{"./services/model/statusEnum.js":9}],2:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HttpRequest = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _qTestContext = require('../qTestContext.js');

var _config = require('../../extension/js/background/config.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var HttpRequest = exports.HttpRequest = function () {
  function HttpRequest() {
    _classCallCheck(this, HttpRequest);
  }

  _createClass(HttpRequest, null, [{
    key: 'getCommonHeaders',
    value: function getCommonHeaders() {
      var headers = {
        'x-client-name': _config.App.name,
        'x-client-version': _config.App.version,
        'x-explorer-api-version': _config.App.apiVersion
      };
      return headers;
    }
  }, {
    key: 'send',
    value: function send(url, token, sendType, data) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        var headers = _this.getCommonHeaders();
        if (token) {
          headers.Authorization = _qTestContext.QtestContext.qTestVersion >= 7 ? 'bearer ' + token : token;
        }
        if (headers && _qTestContext.QtestContext.ownerToken) {
          headers['x-qtest-owner-token'] = _qTestContext.QtestContext.ownerToken;
        }

        // eslint-disable-next-line no-undef
        $.ajax({
          type: sendType,
          url: url,
          data: data,
          contentType: 'application/json;charset=UTF-8',
          dataType: token ? 'json' : null,
          headers: headers
        }).done(function (resultData) {
          resolve({
            data: resultData
          });
        }).fail(function (jqXHR, textStatus, errorThrown) {
          if (jqXHR.status === 200) {
            resolve({});
          } else {
            resolve({
              status: jqXHR.status,
              error: errorThrown
            });
          }
        });
      });
    }
  }, {
    key: 'sendWithResponse',
    value: function sendWithResponse(url, token, sendType, data) {
      var _this2 = this;

      return new Promise(function (resolve, reject) {
        var headers = _this2.getCommonHeaders();
        if (token) {
          headers.Authorization = _qTestContext.QtestContext.qTestVersion >= 7 ? 'bearer ' + token : token;
        }
        if (headers && _qTestContext.QtestContext.ownerToken) {
          headers['x-qtest-owner-token'] = _qTestContext.QtestContext.ownerToken;
        }
        // eslint-disable-next-line no-undef
        $.ajax({
          type: sendType,
          url: url,
          data: data,
          contentType: 'application/json;charset=UTF-8',
          dataType: token ? 'json' : null,
          headers: headers
        }).done(function (resultData, status, xhr) {
          resolve({
            data: resultData,
            response: xhr
          });
        }).fail(function (jqXHR, textStatus, errorThrown) {
          if (jqXHR.status === 200) {
            resolve({});
          } else {
            resolve({
              status: jqXHR.status,
              error: errorThrown
            });
          }
        });
      });
    }
  }, {
    key: 'upload',
    value: function upload(url, token, filename, binaryData, contentType) {
      var _this3 = this;

      return new Promise(function (resolve, reject) {
        if (!binaryData) {
          resolve({
            error: 'HttpRequest: error: No binary data'
          });
          return;
        }
        var oReq = new XMLHttpRequest();
        oReq.open('POST', url, true);
        var headers = _this3.getCommonHeaders();
        if (token) {
          headers.Authorization = _qTestContext.QtestContext.qTestVersion >= 7 ? 'bearer ' + token : token;
        }
        headers['Content-Type'] = contentType;
        headers['x-filename'] = filename;
        // eslint-disable-next-line no-undef
        $.each(headers, function (key, value) {
          if (Object.prototype.hasOwnProperty.call(headers, key) && !(value instanceof Function)) {
            oReq.setRequestHeader(key, value);
          }
        });
        oReq.onload = function (oEvent) {
          var data = oReq.response;
          var responseStatus = oReq.status;
          console.log(new Date().toString() + ' HttpRequest: finished uploading binary data, response status: \'' + responseStatus + '\', response data: \'' + data + '\'...');
          oReq.abort();
          if (responseStatus === 200 || responseStatus === 201) {
            resolve({
              data: JSON.parse(data)
            });
          } else {
            resolve({
              error: responseStatus + 'ERROR'
            });
          }
        };
        oReq.onerror = function (oEvent) {
          resolve({
            error: 'HttpRequest: error :' + oEvent.error
          });
        };
        oReq.send(binaryData);
      });
    }
  }]);

  return HttpRequest;
}();

},{"../../extension/js/background/config.js":16,"../qTestContext.js":1}],3:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MessagingService = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _sendStatusEnum = require('./model/sendStatusEnum.js');

var _DateUtils = require('./utils/DateUtils.js');

var _httpRequest = require('./httpRequest.js');

var _qTestContext = require('../qTestContext.js');

var _config = require('../../extension/js/background/config.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MessagingService = exports.MessagingService = function () {
  function MessagingService(baseURL, token) {
    _classCallCheck(this, MessagingService);

    this.baseURL = baseURL;
    this.token = token;
  }

  _createClass(MessagingService, [{
    key: 'getSessionJson',
    value: function getSessionJson(session, sendCaptureDate) {
      var sysInfoJson = {
        app_version: _config.App.systemInfo.appVersion,
        incl_app_version: true,
        os: _config.App.systemInfo.os,
        incl_os: true,
        resolutions: _config.App.systemInfo.resolutions,
        incl_resolutions: true
      };
      var appInfoJson = {
        name: _config.App.applicationInfo.name,
        file_version: _config.App.applicationInfo.fileVersion,
        incl_file_version: true,
        version: _config.App.applicationInfo.version,
        incl_version: true
      };
      var json = {
        client_name: 'qTestWebeXplorer',
        project_id: session.project,
        title: session.title,
        desc: session.description,
        planned_duration: session.plannedDuration.hour * 3600 + session.plannedDuration.min * 60,
        sys_info: sysInfoJson,
        app_infos: [appInfoJson],
        tester_name: session.tester,
        has_meta_data: true
      };
      if (sendCaptureDate) {
        var capturedDate = _DateUtils.DateUtils.getDateString(new Date());
        json.captured_date = capturedDate;
        json.doc = {
          captured_date: capturedDate
        };
      }
      return json;
    }
  }, {
    key: 'sendCreateSession',
    value: async function sendCreateSession(session) {
      if (session.sendStatus && session.sendStatus !== _sendStatusEnum.SendStatusEnum.notSent) {
        return {
          success: true
        };
      }
      session.sendStatus = _sendStatusEnum.SendStatusEnum.sending;
      var url = this.baseURL + '/sessions';
      var json = this.getSessionJson(session, true);
      json.owner_user = session.tester;
      json.edit_user = session.tester;
      json.tester_name = session.tester;
      json.status = 'running';
      console.log(new Date().toString() + ' about to send create session...');

      var res = await _httpRequest.HttpRequest.send(url, this.token, 'POST', JSON.stringify(json));
      console.log(new Date().toString() + ' finished creating session...');
      if (res.error) {
        session.sendStatus = _sendStatusEnum.SendStatusEnum.error;
      } else {
        _qTestContext.QtestContext.ownerToken = res.data.owner_token;
        session.id = res.data.id;
        session.sendStatus = _sendStatusEnum.SendStatusEnum.sent;
        session.status = 'running';
        this.buildRedirectUrl(session);
      }
      return {
        success: res.error == null, // should be ==
        error: res.error
      };
    }
  }, {
    key: 'buildRedirectUrl',
    value: function buildRedirectUrl(session) {
      var redirectUrl = '';
      var version = _qTestContext.QtestContext.sessionManagerVersion;

      if ((version ? version.major : undefined) >= 3) {
        redirectUrl = _qTestContext.QtestContext.user.url + '/p/' + _qTestContext.QtestContext.session.project + '/portal/session/' + session.id + '/review';
        session.redirectUrl = _qTestContext.QtestContext.user.apiURL + '/' + session.id + '/review';
      } else if (_qTestContext.QtestContext.qTestVersion >= 7) {
        redirectUrl = _qTestContext.QtestContext.user.url + '/p/' + _qTestContext.QtestContext.session.project + '/portal/session/' + session.id + '/review';
        session.redirectUrl = redirectUrl;
      } else {
        redirectUrl = _qTestContext.QtestContext.user.url + '/p/' + _qTestContext.QtestContext.session.project + '/portal/session/playback/' + session.id;
        session.redirectUrl = redirectUrl;
      }
      var encodedRedirectUrl = encodeURIComponent(redirectUrl);
      session.url = _qTestContext.QtestContext.user.url + '/portal/loginform?token=' + _qTestContext.QtestContext.user.token + '&redirect=' + encodedRedirectUrl;
    }
  }, {
    key: 'sendUpdateSession',
    value: async function sendUpdateSession(session, sendCaptureDate) {
      if (!session.sendStatus) {
        return {
          success: false
        };
      }
      var url = this.baseURL + '/sessions/' + session.id;
      var json = this.getSessionJson(session, sendCaptureDate);
      json.time_lines = [];
      var order = 0;
      var actualDuration = 0;
      var ref = _qTestContext.QtestContext.timeTypes;
      for (var i = 0, len = ref.length; i < len; i++) {
        var timeType = ref[i];
        var jsonTimeLine = {
          total_time: 0,
          order: order++,
          time_type: {
            id: timeType.id,
            name: timeType.name,
            color: timeType.color
          }
        };
        json.time_lines.push(jsonTimeLine);
        var timelines = session.timeLines;
        for (var j = 0, len1 = timelines.length; j < len1; j++) {
          var timeLine = timelines[j];
          if (timeLine.timeType.name === timeType.name) {
            jsonTimeLine.total_time += timeLine.totalTime;
          }
        }
        actualDuration += jsonTimeLine.total_time;
      }
      json.actual_duration = actualDuration;

      var res = await _httpRequest.HttpRequest.send(url, this.token, 'PUT', JSON.stringify(json));
      if (res.error) {
        console.error('sendUpdateSession error - status: ' + res.status + ', error: ' + res.error);
      } else {
        this.buildRedirectUrl(session);
      }
      return {
        success: !res.error,
        error: res.error
      };
    }
  }, {
    key: 'sendUpdateSessionStatus',
    value: async function sendUpdateSessionStatus(session, status) {
      var url = this.baseURL + '/sessions/' + session.id + '/status';
      console.log(new Date().toString() + ' about to send update session status \'' + status + '\'...');
      var res = await _httpRequest.HttpRequest.send(url, this.token, 'PUT', '{ "status": "' + status + '" }');
      console.log(new Date().toString() + ' finished updating session status \'' + status + '\'...');
      if (!res.error) {
        session.status = status;
        if (status === 'running') {
          if (!res.data || !res.data.owner_token) {
            console.error(new Date().toString() + ' updating session status error: missing Owner Token...');
            return {
              success: false,
              error: 'missing Owner Token'
            };
          }
          console.log(new Date().toString() + ' obtained Owner Token...');
          _qTestContext.QtestContext.ownerToken = res.data.owner_token;
        }
      }
      return {
        success: !res.error,
        error: res.error
      };
    }
  }, {
    key: 'processUploadScreen',
    value: async function processUploadScreen(sessionId, screen, url) {
      var annotations = [];
      var ref = screen.annotations;
      for (var i = 0, len = ref.length; i < len; i++) {
        var annotation = ref[i];
        var actionJSON = annotation.getJson();
        if (actionJSON.timestamp) {
          actionJSON.timestamp = _DateUtils.DateUtils.getDateString(new Date(actionJSON.timestamp));
        }
        annotations.push(actionJSON);
      }
      var json = {
        order: screen.order,
        title: screen.title,
        browser_url: screen.url,
        capture_mode: 'Form',
        left: 0,
        top: 0,
        width: screen.width,
        height: screen.height,
        app_left: 0,
        app_top: 0,
        app_width: screen.width,
        app_height: screen.height,
        screen_height: screen.height,
        screen_width: screen.width,
        timestamp: _DateUtils.DateUtils.getDateString(new Date(screen.timeStamp)),
        finished_timestamp: _DateUtils.DateUtils.getDateString(new Date(screen.finishedTimestamp)),
        annotations: annotations,
        time_type: screen.timeType ? {
          color: screen.timeType.color,
          name: screen.timeType.name,
          id: screen.timeType.id
        } : null
      };

      var res = await _httpRequest.HttpRequest.send(url, this.token, 'POST', JSON.stringify(json));
      if (res.error) {
        screen.sendStatus = _sendStatusEnum.SendStatusEnum.error;
        console.error(new Date().toString() + ' error sending screen metadata: ' + screen.order + ' to ' + url + ': ' + res.error);
      } else {
        screen.id = res.data.id;
        console.log(new Date().toString() + ' call uploading for screen: ' + res.data.id);
        await this.sendUpload(sessionId, screen);
      }
    }
  }, {
    key: 'processUploadMedia',
    value: async function processUploadMedia(index, sessionId, url, screen, annotationLength) {
      var mediaUploadUrl = this.baseURL + '/upload-objects';
      if (index < annotationLength) {
        var annotation = screen.annotations[index];
        var annotationType = annotation.annotationType;
        if (annotationType === 'Video' || annotationType === 'Audio') {
          var mediaFileName = annotation.description;
          if (annotationType === 'Video') {
            mediaFileName += '.webm';
          } else {
            mediaFileName += '.wav';
          }
          console.log(new Date().toString() + ' about to upload media of type ' + annotationType + ', fileName: ' + mediaFileName);
          var response = await _httpRequest.HttpRequest.upload(mediaUploadUrl, this.token, mediaFileName, annotation.blob, annotation.mimeType);
          if (response.error) {
            console.log(new Date().toString() + ' error uploading media ' + mediaFileName + ': ' + response.error);
          } else {
            annotation.url = response.data.url;
            console.log(new Date().toString() + ' successfully uploading media ' + mediaFileName + ', url: ' + annotation.url);
          }
        }
        var nextIndex = index + 1;
        await this.processUploadMedia(nextIndex, sessionId, url, screen, annotationLength);
      }
    }
  }, {
    key: 'uploadMedia',
    value: async function uploadMedia(sessionId, screen, url) {
      var annotationLength = screen.annotations.length;
      await this.processUploadMedia(0, sessionId, url, screen, annotationLength);
      await this.processUploadScreen(sessionId, screen, url);
    }
  }, {
    key: 'sendCreateScreen',
    value: async function sendCreateScreen(sessionId, screen) {
      if (screen.sendStatus) {
        if (screen.sendStatus === _sendStatusEnum.SendStatusEnum.sent) {
          return;
        } else if (screen.sendStatus === _sendStatusEnum.SendStatusEnum.error) {
          console.error('Error sending screen ' + screen.order());
          return;
        } else if (screen.sendStatus === _sendStatusEnum.SendStatusEnum.sending) {
          return;
        }
      }
      screen.sendStatus = _sendStatusEnum.SendStatusEnum.sending;
      var url = this.baseURL + '/sessions/' + sessionId + '/screens';

      await this.uploadMedia(sessionId, screen, url);
    }
  }, {
    key: 'sendUpload',
    value: async function sendUpload(sessionId, screen) {
      if (screen.sendStatus) {
        if (screen.sendStatus === _sendStatusEnum.SendStatusEnum.sent) {
          return {
            success: true
          };
        } else if (screen.sendStatus !== _sendStatusEnum.SendStatusEnum.sending) {
          return {
            success: false
          };
        }
      }
      var url = this.baseURL + '/sessions/' + sessionId + '/screens/' + screen.id + '/images';
      var fileName = 'Temp';
      var binaryData = screen.screenShotBinary ? new Uint8Array(screen.screenShotBinary) : null;
      console.log(new Date().toString() + ' about to upload screen...');

      var res = await _httpRequest.HttpRequest.upload(url, this.token, fileName, binaryData, 'image/jpeg');
      if (res.error) {
        screen.sendStatus = _sendStatusEnum.SendStatusEnum.error;
        console.error(new Date().toString() + ' error uploading screen ' + screen.id + ': ' + res.error);
      } else {
        screen.sendStatus = _sendStatusEnum.SendStatusEnum.sent;
        console.log(new Date().toString() + ' successfully upload screen ' + screen.id);
      }
      return {
        success: res.error === undefined,
        error: res.error
      };
    }
  }, {
    key: 'sendAllScreens',
    value: async function sendAllScreens(sessionId, screens) {
      if (screens && screens.length > 0) {
        if (screens[0].sendStatus === _sendStatusEnum.SendStatusEnum.notSent) {
          await this.sendCreateScreen(sessionId, screens[0]);
          //
          var shifted = screens.shift();
          if (shifted && typeof shifted.destroyScreenshotBinary === 'function') {
            shifted.destroyScreenshotBinary();
            shifted = null;
          }
          if (screens.length > 0) {
            await this.sendAllScreens(sessionId, screens);
          }
        }
      }
    }
  }, {
    key: 'startSendingAllScreen',
    value: function startSendingAllScreen() {
      try {
        this.sendAllScreens(_qTestContext.QtestContext.session.id, _qTestContext.QtestContext.session.screens);
      } catch (error) {
        console.error('error sending: ' + error);
        var screens = _qTestContext.QtestContext.session.screens;
        if (screens > 0) {
          var shifted = _qTestContext.QtestContext.session.screens.shift();
          if (shifted) {
            shifted.destroyScreenshotBinary();
            shifted = null;
          }
        }
        this.sendAllScreens(_qTestContext.QtestContext.session.id, _qTestContext.QtestContext.session.screens);
      }
    }
  }]);

  return MessagingService;
}();

},{"../../extension/js/background/config.js":16,"../qTestContext.js":1,"./httpRequest.js":2,"./model/sendStatusEnum.js":7,"./utils/DateUtils.js":15}],4:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ApplicationInfo = exports.ApplicationInfo = function ApplicationInfo(name, version, fileVersion) {
  _classCallCheck(this, ApplicationInfo);

  this.name = name;
  this.version = version;
  this.fileVersion = fileVersion;
};

},{}],5:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var MessageEnum = exports.MessageEnum = {
  getStatus: 'getStatus',

  login: 'login',

  logout: 'logout',

  getSessions: 'getSessions',

  startSession: 'startSession',

  viewSession: 'viewSession',

  completeSession: 'completeSession',

  addNote: 'addNote',

  switchTimetype: 'switchTimetype',

  keyEvent: 'keyEvent',

  clickEvent: 'clickEvent',

  takeSnapshot: 'takeSnapshot',

  modalDialog: 'modalDialog',

  devicePixelRatio: 'devicePixelRatio',

  toggleRecordingStatus: 'toggleRecordingStatus',

  captureVisiblePart: 'captureVisiblePart',

  captureFullPage: 'captureFullPage',

  captureScrollingPage: 'captureScrollingPage',

  finishedScrolling: 'finishedScrolling',

  finishedCaptureFullPage: 'finishedCaptureFullPage',

  discardScrollingCapture: 'discardScrollingCapture',

  openUrl: 'openUrl',

  editCurrentScreen: 'editCurrentScreen',

  editorReady: 'editorReady',

  saveCurrentScreen: 'saveCurrentScreen',

  cancelEditCurrentScreen: 'cancelEditCurrentScreen',

  confirmMediaPermission: 'confirmMediaPermission',

  deniedMediaPermission: 'deniedMediaPermission',

  cancelledMediaPermission: 'cancelledMediaPermission',

  recordMedia: 'recordMedia',

  stopRecordMedia: 'stopRecordMedia',

  cancelRecordMedia: 'cancelRecordMedia',

  showSettings: 'showSettings',

  getSettings: 'getSettings',

  saveSettings: 'saveSettings',

  cancelSaveSettings: 'cancelSaveSettings',

  closeSettings: 'closeSettings',

  openCommandsConfiguration: 'openCommandsConfiguration',

  startSessionFromqTest: 'startSessionFromqTest',

  currentqTestSession: 'currentqTestSession',

  getCurrentqTestSession: 'getCurrentqTestSession',

  getOpeningDomains: 'getOpeningDomains',

  getAutoStartData: 'getAutoStartData',

  autoStartDisableConfirm: 'autoStartDisableConfirm',

  startAutoStartSession: 'startAutoStartSession',

  removeAutoStartDialog: 'remove-web-explorer-confirm-start-always-on-session-dialog',

  removeStartSessionDialog: 'remove-web-explorer-start-session-dialog'
};

},{}],6:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var NoteType = exports.NoteType = function NoteType(id, name, color) {
  _classCallCheck(this, NoteType);

  this.id = id;
  this.name = name;
  this.color = color;
};

},{}],7:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var SendStatusEnum = exports.SendStatusEnum = {
  error: 'Error',

  notSent: 'NotSent',

  sent: 'Sent',

  sending: 'Sending'
};

},{}],8:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Session = exports.Session = function () {
  function Session(id, project, title, description1, plannedDuration, tester) {
    _classCallCheck(this, Session);

    this.id = id;
    this.project = project;
    this.title = title;
    this.description = description1;
    this.plannedDuration = plannedDuration;
    this.tester = tester;
    this.currentTimeType = 0;
    this.timeLines = [];
    this.screens = [];
    this.screenCount = 0;
    this.sendStatus = 'NotSent';
    this.status = 'planned';

    this.url = '';
    this.redirectUrl = '';
  }

  _createClass(Session, [{
    key: 'pushScreen',
    value: function pushScreen(newScreen, finishedTimestamp) {
      console.log('-->PUSHING');
      newScreen.finishedTimestamp = finishedTimestamp;
      if (newScreen.order > 0) {
        console.error('DUPPLICATE SCREEN at ' + newScreen.order);
      } else {
        this.screenCount++;
        newScreen.order = this.screenCount;
        this.screens.push(newScreen);
      }
      console.log('-->PUSHED  + ' + newScreen.order);
    }
  }, {
    key: 'getViewData',
    value: function getViewData() {
      var session = {
        id: this.id,
        project: this.project,
        title: this.title,
        url: this.url,
        redirectUrl: this.redirectUrl,
        description: this.description,
        plannedDuration: this.plannedDuration,
        tester: this.tester,
        currentTimeType: this.currentTimeType,
        timeLines: this.timeLines,
        status: this.status
      };
      return session;
    }
  }]);

  return Session;
}();

},{}],9:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var StatusEnum = exports.StatusEnum = {
  notLoggedIn: 'notLoggedIn',

  loggingIn: 'loggingIn',

  loggedIn: 'loggedIn',

  loadingServerSession: 'loadingServerSession',

  loadedServerSession: 'loadedServerSession',

  startingSession: 'startingSession',

  startingSessionIndicator: 'startingSessionIndicator',

  recording: 'recording',

  editing: 'editing',

  paused: 'paused',

  capturingFullPage: 'capturingFullPage',

  inProgress: 'inProgress',

  completingSession: 'completingSession',

  recordingMedia: 'recordingMedia'
};

},{}],10:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SystemInfo = exports.SystemInfo = function SystemInfo(os, resolutions, appVersion) {
  _classCallCheck(this, SystemInfo);

  this.os = os;
  this.resolutions = resolutions;
  this.appVersion = appVersion;
};

},{}],11:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TimeLine = exports.TimeLine = function TimeLine() {
  _classCallCheck(this, TimeLine);

  this.startedTimestamp = null;
  this.finishedTimestamp = null;
  this.timeType = null;
  this.totalTime = null;
};

},{}],12:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TimeType = exports.TimeType = function TimeType(id, name, color) {
  _classCallCheck(this, TimeType);

  this.id = id;
  this.name = name;
  this.color = color;
};

},{}],13:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StartSessionMessageHandler = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _httpRequest = require('./httpRequest.js');

var _qTestContext = require('../qTestContext.js');

var _statusEnum = require('./model/statusEnum.js');

var _session = require('./model/session.js');

var _messagingService = require('./messagingService.js');

var _timeType = require('./model/timeType.js');

var _timeLine = require('./model/timeLine.js');

var _noteType = require('./model/noteType.js');

var _tabManager = require('./../../extension/js/background/tabManager.js');

var _storage = require('./storage.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var StartSessionMessageHandler = exports.StartSessionMessageHandler = function () {
  function StartSessionMessageHandler() {
    _classCallCheck(this, StartSessionMessageHandler);

    this.messagingService = new _messagingService.MessagingService(_qTestContext.QtestContext.user.apiURL, _qTestContext.QtestContext.user.token);
  }

  _createClass(StartSessionMessageHandler, [{
    key: 'handle',
    value: async function handle(message) {
      var getSettingsURL = _qTestContext.QtestContext.user.apiURL + '/project-settings/' + message.project;
      console.log(new Date().toString() + ' about to get time types, note types');
      var res = await _httpRequest.HttpRequest.send(getSettingsURL, _qTestContext.QtestContext.user.token, 'GET', '');
      var data = res.data;
      var error = res.error;

      console.log(new Date().toString() + ' finished getting time types, note types');
      if (error || data.total <= 0) {
        return {
          success: false,
          error: error
        };
      }
      var timeTypes = [];
      var timetypes = data.items[0].time_types;
      for (var i = 0, len = timetypes.length; i < len; i++) {
        var timeType = timetypes[i];
        if (timeType.active) {
          timeTypes.push(new _timeType.TimeType(timeType.id, timeType.name, timeType.color));
        }
      }
      var noteTypes = [];
      var notetypes = data.items[0].note_types;
      for (var j = 0, _len = notetypes.length; j < _len; j++) {
        var noteType = notetypes[j];
        if (noteType.active) {
          noteTypes.push(new _noteType.NoteType(noteType.id, noteType.name, noteType.color));
        }
      }
      var response = await this.startSession(message, timeTypes, noteTypes);
      return response;
    }
  }, {
    key: 'handleFail',
    value: async function handleFail(result) {
      _qTestContext.QtestContext.session = null;
      var lastSelectedProjectId = _storage.Storage.get('lastSelectedProjectId');
      var domainArray = await _tabManager.TabManager.getOpeningDomains();
      _qTestContext.QtestContext.status = {
        name: _statusEnum.StatusEnum.loggedIn,
        info: {
          domainOptions: {
            all: true,
            domains: domainArray,
            include: false,
            exclude: false
          },
          lastSelectedProjectId: lastSelectedProjectId ? parseInt(lastSelectedProjectId, 10) : undefined
        }
      };
      return {
        success: false,
        error: result.error
      };
    }
  }, {
    key: 'updateLastSession',
    value: async function updateLastSession(result, session, message, timeTypes, noteTypes) {
      if (result.success) {
        _qTestContext.QtestContext.session = session;
        _qTestContext.QtestContext.status = {
          name: _statusEnum.StatusEnum.recording
        };
        _qTestContext.QtestContext.domainOptions = message.domainOptions;
        _qTestContext.QtestContext.timeTypes = timeTypes;
        _qTestContext.QtestContext.noteTypes = noteTypes;
        if (_qTestContext.QtestContext.timeTypes && _qTestContext.QtestContext.timeTypes.length > 0) {
          var firstTimeType = _qTestContext.QtestContext.timeTypes[0];
          var startTimeType = new _timeType.TimeType(firstTimeType.id, firstTimeType.name, firstTimeType.color);
          var startTimeLine = new _timeLine.TimeLine();
          startTimeLine.timeType = startTimeType;
          startTimeLine.startedTimestamp = Math.round(new Date() / 1000);
          _qTestContext.QtestContext.session.timeLines.push(startTimeLine);
          _qTestContext.QtestContext.session.currentTimeType = startTimeType.name;
        }
        _storage.Storage.set('lastSelectedProjectId', JSON.stringify(message.project));
        var lastSession = {
          url: session.url,
          redirectUrl: session.redirectUrl
        };
        _storage.Storage.set('lastSession', JSON.stringify(lastSession), {
          secure: true
        });
        return {
          success: true
        };
      }
      var res = await this.handleFail(result);
      return res;
    }
  }, {
    key: 'startSession',
    value: async function startSession(message, timeTypes, noteTypes) {
      var session = null;
      var projects = _qTestContext.QtestContext.projects;
      for (var i = 0, len = projects.length; i < len; i++) {
        var project = projects[i];
        if (project.id.toString() === message.project) {
          _qTestContext.QtestContext.selectedProject = project;
        }
      }
      if (message.isRunExisting) {
        var sessions = _qTestContext.QtestContext.selectedProject.sessions;
        for (var j = 0, len1 = sessions.length; j < len1; j++) {
          var existingSession = sessions[j];
          if (existingSession.id === message.id) {
            session = existingSession;
            break;
          }
        }
        session.tester = message.tester;
        session.plannedDuration = message.plannedDuration;
        session.description = message.description;
      } else {
        session = new _session.Session('', message.project, message.title, message.description, message.plannedDuration, message.tester);
      }
      _qTestContext.QtestContext.status = {
        name: _statusEnum.StatusEnum.startingSession,
        info: {
          runExisting: message.isRunExisting,
          domainOptions: message.domainOptions
        }
      };
      _qTestContext.QtestContext.session = session;

      if (message.isRunExisting) {
        var res = await this.messagingService.sendUpdateSessionStatus(session, 'running');
        if (res.success) {
          var res1 = await this.messagingService.sendUpdateSession(session, true);
          var handled = await this.updateLastSession(res1, session, message, timeTypes, noteTypes);
          return handled;
        }
        return this.handleFail(res);
      }
      var resp = await this.messagingService.sendCreateSession(session);
      var resp1 = await this.updateLastSession(resp, session, message, timeTypes, noteTypes);
      return resp1;
    }
  }]);

  return StartSessionMessageHandler;
}();

},{"../qTestContext.js":1,"./../../extension/js/background/tabManager.js":18,"./httpRequest.js":2,"./messagingService.js":3,"./model/noteType.js":6,"./model/session.js":8,"./model/statusEnum.js":9,"./model/timeLine.js":11,"./model/timeType.js":12,"./storage.js":14}],14:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ___ = ['\x6D\x74\x26\x79\x6B\x4E\x57\x55\x62\x4E\x49\x65\x52\x26\x34\x33'][0];

var Storage = exports.Storage = function () {
  function Storage() {
    _classCallCheck(this, Storage);
  }

  _createClass(Storage, null, [{
    key: 'encrypt',
    value: function encrypt(vString) {
      // eslint-disable-next-line no-undef
      return sjcl.encrypt(___, vString);
    }
  }, {
    key: 'decrypt',
    value: function decrypt(vString) {
      // eslint-disable-next-line no-undef
      return sjcl.decrypt(___, vString);
    }

    // get(k: string): Object

  }, {
    key: 'get',
    value: function get(k) {
      try {
        var vString = localStorage.getItem(k);
        if (!vString) {
          return null;
        }

        var obj = JSON.parse(vString);
        if (obj.cipher && obj.salt && obj.mode) {
          obj = JSON.parse(this.decrypt(vString));
        }

        // backward compatible: old version stringify the obj multiple times
        if (typeof obj === 'string') {
          try {
            var tempObj = JSON.parse(obj);
            obj = tempObj;
            // eslint-disable-next-line no-empty
          } catch (e) {}
        }

        if (obj.expires) {
          // check expiration
          var now = new Date();
          var expires = new Date(obj.expires);
          if (now.getTime() >= expires.getTime()) {
            console.error('Storage "' + k + '" expired on ' + obj.expires);
            this.remove(k);
            return null;
          }
        }

        return obj;
      } catch (error) {
        console.log(error);
        return null;
      }
    }

    // set(k: string, vString: string, opts: { secure: boolean })

  }, {
    key: 'set',
    value: function set(k, vString) {
      var opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      if (!vString) {
        this.remove(k);
        return;
      }

      localStorage.setItem(k, opts.secure ? this.encrypt(vString) : vString);
    }
  }, {
    key: 'remove',
    value: function remove(k) {
      localStorage.removeItem(k);
    }
  }]);

  return Storage;
}();

},{}],15:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DateUtils = exports.DateUtils = function () {
  function DateUtils() {
    _classCallCheck(this, DateUtils);
  }

  _createClass(DateUtils, null, [{
    key: 'getDateString',
    value: function getDateString(date) {
      var strDate = JSON.stringify(date).toString().replace('"', '').replace('"', '');
      strDate = strDate.substring(0, strDate.indexOf('Z')) + '+00:00';
      return strDate;
    }
  }]);

  return DateUtils;
}();

},{}],16:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.App = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _systemInfo = require('../../../common/services/model/systemInfo.js');

var _applicationInfo = require('../../../common/services/model/applicationInfo.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var fileVersion = '';
var browserName = '';
var firefoxVersion = '';
var osName = '';
var nAgt = window.navigator.userAgent;
var verOffset = nAgt.indexOf('Firefox');
if (verOffset !== -1) {
  browserName = 'firefox';
  fileVersion = nAgt.substring(verOffset + 8);
  firefoxVersion = parseInt(fileVersion, 10);
}
var mozillaExp = nAgt.match(/Mozilla\/(.*?) /);
if (mozillaExp && mozillaExp.length > 0) {
  var mozillaExp2 = /Mozilla\//;
  var osExp = /\((.*?)\)/;
  osName = navigator.userAgent.match(new RegExp(String(mozillaExp2.source) + mozillaExp[1] + ' ' + osExp.source))[1];
}

var App = exports.App = function () {
  function App() {
    _classCallCheck(this, App);
  }

  _createClass(App, null, [{
    key: 'manifest',
    get: function get() {
      return this._manifest || chrome.runtime.getManifest();
    }
  }, {
    key: 'name',
    get: function get() {
      return this.manifest.name;
    }
  }, {
    key: 'version',
    get: function get() {
      return this.manifest.version;
    }
  }, {
    key: 'apiVersion',
    get: function get() {
      return this.manifest.apiVersion;
    }
  }, {
    key: 'scaleBeforeCompare',
    get: function get() {
      return this._scaleBeforeCompare || true;
    },
    set: function set(value) {
      this._scaleBeforeCompare = value;
    }
  }, {
    key: 'fileVersion',
    get: function get() {
      if (mozillaExp && mozillaExp.length > 0) {
        return mozillaExp[1];
      }
      return -1;
    }
  }, {
    key: 'systemInfo',
    get: function get() {
      var width = window.screen.width * window.devicePixelRatio;
      var height = window.screen.height * window.devicePixelRatio;
      return new _systemInfo.SystemInfo(osName, width + 'x' + height, this.version);
    }
  }, {
    key: 'applicationInfo',
    get: function get() {
      return new _applicationInfo.ApplicationInfo(browserName, firefoxVersion, fileVersion);
    }
  }]);

  return App;
}();

},{"../../../common/services/model/applicationInfo.js":4,"../../../common/services/model/systemInfo.js":10}],17:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EditorHandler = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _qTestContext = require('../../../common/qTestContext.js');

var _messageEnum = require('../../../common/services/model/messageEnum.js');

var _statusEnum = require('../../../common/services/model/statusEnum.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var EditorHandler = exports.EditorHandler = function () {
  function EditorHandler() {
    _classCallCheck(this, EditorHandler);

    this.URL = '../../../common/editor/editor.html';
    this.editorTab = null;
    this.lastActiveTab = null;
  }

  _createClass(EditorHandler, [{
    key: 'activeTab',
    value: function activeTab(tab, reload) {
      this.editorTab = {
        id: tab.id,
        url: tab.url,
        windowId: tab.windowId
      };
      chrome.windows.update(tab.windowId, {
        focused: true
      });
      chrome.tabs.update(tab.id, {
        active: true
      });
      if (reload) {
        chrome.tabs.reload(tab.id);
      }
      return {
        success: true
      };
    }
  }, {
    key: 'handle',
    value: function handle(message) {
      var _this = this;

      return new Promise(async function (resolve) {
        var tab = {};
        if (message.name === _messageEnum.MessageEnum.editCurrentScreen) {
          if (!_qTestContext.QtestContext.currentProcessingScreen) {
            console.log(new Date().toString() + ' handle editCurrentScreen message, but current processing screen is not available');
            resolve({ success: false });
          }
          tab = await _this.findEditorTab();
          if (tab) {
            _this.activeTab(tab, true);
          } else {
            _this.lastActiveTab = null;
            chrome.tabs.query({
              windowId: chrome.windows.WINDOW_ID_CURRENT,
              active: true
            }, function (tabs) {
              if (tabs && tabs.length > 0) {
                tab = tabs[0];
                _this.lastActiveTab = {
                  id: tab.id,
                  url: tab.url,
                  windowId: tab.windowId
                };
                chrome.tabs.create({
                  index: tab.index + 1,
                  url: _this.URL
                }, function (newTab) {
                  resolve(_this.activeTab(newTab, false));
                });
              } else {
                _this.lastActiveTab = null;
                chrome.tabs.create({
                  url: _this.URL
                }, function (newTab) {
                  resolve(_this.activeTab(newTab, false));
                });
              }
            });
          }
        } else if (message.name === _messageEnum.MessageEnum.editorReady) {
          if (_qTestContext.QtestContext.currentProcessingScreen && _this.editorTab) {
            var screen = _qTestContext.QtestContext.currentProcessingScreen.getDrawableData();
            var obj = {
              screen: screen,
              noteTypes: _qTestContext.QtestContext.noteTypes,
              qTestVersion: {
                major: _qTestContext.QtestContext.qTestVersion,
                minor: _qTestContext.QtestContext.qTestMinorVersion
              }
            };
            var dataString = JSON.stringify(obj);
            chrome.tabs.sendMessage(_this.editorTab.id, {
              name: 'currentScreen',
              data: dataString
            }, function (response) {
              _qTestContext.QtestContext.status = {
                name: _statusEnum.StatusEnum.editing
              };
              resolve({ success: true });
            });
          }
        } else if (message.name === _messageEnum.MessageEnum.saveCurrentScreen) {
          _qTestContext.QtestContext.currentProcessingScreen.importData(message.data);
          _qTestContext.QtestContext.status = {
            name: _statusEnum.StatusEnum.recording
          };
          chrome.tabs.sendMessage(_this.editorTab.id, {
            name: 'savedCurrentScreen',
            data: null
          }, function (response) {});
          await _this.closeEditorTab(_this.editorTab.id);
          await _this.activateLastActiveTab(_this.lastActiveTab.id);
          _this.lastActiveTab = null;
          resolve({ success: true });
        } else if (message.name === _messageEnum.MessageEnum.cancelEditCurrentScreen) {
          _qTestContext.QtestContext.status = {
            name: _statusEnum.StatusEnum.recording
          };
          await _this.closeEditorTab(_this.editorTab.id);
          if (_this.lastActiveTab && _this.lastActiveTab.id) {
            await _this.activateLastActiveTab(_this.lastActiveTab.id);
          }
          _this.lastActiveTab = null;
          resolve({ success: true });
        }
      });
    }
  }, {
    key: 'findEditorTab',
    value: async function findEditorTab() {
      return new Promise(function (resolve) {
        chrome.windows.getAll({
          populate: true
        }, function (wnds) {
          var tab = null;
          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = wnds[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var wd = _step.value;

              if (tab) {
                break;
              }
              var _iteratorNormalCompletion2 = true;
              var _didIteratorError2 = false;
              var _iteratorError2 = undefined;

              try {
                for (var _iterator2 = wd.tabs[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                  var tb = _step2.value;

                  if (tb.url.indexOf(EditorHandler.URL_PREFIX) >= 0) {
                    tab = tb;
                    break;
                  }
                }
              } catch (err) {
                _didIteratorError2 = true;
                _iteratorError2 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion2 && _iterator2.return) {
                    _iterator2.return();
                  }
                } finally {
                  if (_didIteratorError2) {
                    throw _iteratorError2;
                  }
                }
              }
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }

          resolve(tab);
        });
      });
    }
  }, {
    key: 'closeEditorTab',
    value: async function closeEditorTab(tabId) {
      return new Promise(function (resolve) {
        chrome.tabs.query({}, function (tabs) {
          if (tabs) {
            var found = false;
            var _iteratorNormalCompletion3 = true;
            var _didIteratorError3 = false;
            var _iteratorError3 = undefined;

            try {
              for (var _iterator3 = tabs[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                var tab = _step3.value;

                if (tab.id === tabId) {
                  found = true;
                  break;
                }
              }
            } catch (err) {
              _didIteratorError3 = true;
              _iteratorError3 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion3 && _iterator3.return) {
                  _iterator3.return();
                }
              } finally {
                if (_didIteratorError3) {
                  throw _iteratorError3;
                }
              }
            }

            if (found) {
              chrome.tabs.remove(tabId, function () {});
            }
          }
          resolve(true);
        });
      });
    }
  }, {
    key: 'activateLastActiveTab',
    value: async function activateLastActiveTab(tabId) {
      return new Promise(function (resolve) {
        chrome.windows.getAll({
          populate: true
        }, function (wnds) {
          var tab = null;
          var _iteratorNormalCompletion4 = true;
          var _didIteratorError4 = false;
          var _iteratorError4 = undefined;

          try {
            for (var _iterator4 = wnds[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
              var wd = _step4.value;

              if (tab) {
                break;
              }
              var _iteratorNormalCompletion5 = true;
              var _didIteratorError5 = false;
              var _iteratorError5 = undefined;

              try {
                for (var _iterator5 = wd.tabs[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
                  var tb = _step5.value;

                  if (tb.id === tabId) {
                    tab = tb;
                    break;
                  }
                }
              } catch (err) {
                _didIteratorError5 = true;
                _iteratorError5 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion5 && _iterator5.return) {
                    _iterator5.return();
                  }
                } finally {
                  if (_didIteratorError5) {
                    throw _iteratorError5;
                  }
                }
              }
            }
          } catch (err) {
            _didIteratorError4 = true;
            _iteratorError4 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion4 && _iterator4.return) {
                _iterator4.return();
              }
            } finally {
              if (_didIteratorError4) {
                throw _iteratorError4;
              }
            }
          }

          if (tab) {
            chrome.windows.update(tab.windowId, {
              focused: true
            });
            chrome.tabs.update(tab.id, {
              active: true
            });
          }
          resolve(true);
        });
      });
    }
  }], [{
    key: 'URL_PREFIX',
    get: function get() {
      return 'moz-extension://' + chrome.i18n.getMessage('@@extension_id');
    }
  }]);

  return EditorHandler;
}();

},{"../../../common/qTestContext.js":1,"../../../common/services/model/messageEnum.js":5,"../../../common/services/model/statusEnum.js":9}],18:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TabManager = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _qTestContext = require('../../../common/qTestContext.js');

var _statusEnum = require('../../../common/services/model/statusEnum.js');

var _messageEnum = require('../../../common/services/model/messageEnum.js');

var _editorHandler = require('../background/editorHandler.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TabManager = exports.TabManager = function () {
  function TabManager() {
    _classCallCheck(this, TabManager);
  }

  _createClass(TabManager, null, [{
    key: 'isCapturableTab',
    value: function isCapturableTab(tabUrl) {
      // eslint-disable-next-line no-undef
      if (!tabUrl || tabUrl.length === 0 || tabUrl.match(/(chrome):\/\//gi) || tabUrl.match(/(opera):\/\//gi) || tabUrl.match(/(chrome-extension):\/\//gi) || tabUrl.match(/(chrome-devtools):\/\//gi) || tabUrl.indexOf('about:') >= 0 || tabUrl.indexOf(_editorHandler.EditorHandler.URL_PREFIX) === 0) {
        return false;
      }
      if (_qTestContext.QtestContext.session) {
        if (tabUrl.indexOf(_qTestContext.QtestContext.session.redirectUrl) === 0 || tabUrl.indexOf(_qTestContext.QtestContext.session.url) === 0) {
          return false;
        }
        if (_qTestContext.QtestContext.domainOptions.all) {
          return true;
        }
        if (_qTestContext.QtestContext.domainOptions.include) {
          if (_qTestContext.QtestContext.domainOptions.domains.length === 0) {
            return false;
          }
          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = _qTestContext.QtestContext.domainOptions.domains[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var domain = _step.value;

              if (tabUrl.length >= domain.length && tabUrl.indexOf(domain) >= 0) {
                return true;
              }
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }

          return false;
        } else if (_qTestContext.QtestContext.domainOptions.exclude) {
          if (_qTestContext.QtestContext.domainOptions.domains.length === 0) {
            return true;
          }
          var _iteratorNormalCompletion2 = true;
          var _didIteratorError2 = false;
          var _iteratorError2 = undefined;

          try {
            for (var _iterator2 = _qTestContext.QtestContext.domainOptions.domains[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
              var _domain = _step2.value;

              if (tabUrl.length >= _domain.length && tabUrl.indexOf(_domain) >= 0) {
                return false;
              }
            }
          } catch (err) {
            _didIteratorError2 = true;
            _iteratorError2 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion2 && _iterator2.return) {
                _iterator2.return();
              }
            } finally {
              if (_didIteratorError2) {
                throw _iteratorError2;
              }
            }
          }

          return true;
        }
      }
      return true;
    }
  }, {
    key: 'isExisting',
    value: function isExisting(domains, domainString) {
      if (domains.length === 0) {
        return false;
      }
      var _iteratorNormalCompletion3 = true;
      var _didIteratorError3 = false;
      var _iteratorError3 = undefined;

      try {
        for (var _iterator3 = domains[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
          var domain = _step3.value;

          if (domain.toLowerCase() === domainString.toLowerCase()) {
            return true;
          }
        }
      } catch (err) {
        _didIteratorError3 = true;
        _iteratorError3 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion3 && _iterator3.return) {
            _iterator3.return();
          }
        } finally {
          if (_didIteratorError3) {
            throw _iteratorError3;
          }
        }
      }

      return false;
    }
  }, {
    key: 'getOpeningDomains',
    value: function getOpeningDomains() {
      var _this = this;

      return new Promise(function (resolve) {
        var domains = [];
        return chrome.windows.getAll({
          populate: true
        }, function (wnds) {
          var _iteratorNormalCompletion4 = true;
          var _didIteratorError4 = false;
          var _iteratorError4 = undefined;

          try {
            for (var _iterator4 = wnds[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
              var wd = _step4.value;
              var _iteratorNormalCompletion5 = true;
              var _didIteratorError5 = false;
              var _iteratorError5 = undefined;

              try {
                for (var _iterator5 = wd.tabs[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
                  var tb = _step5.value;

                  if (tb.url && _this.isCapturableTab(tb.url)) {
                    var domain = new URL(tb.url).hostname.trim();
                    if (domain !== '' && !_this.isExisting(domains, domain)) {
                      domains.push(domain.toLowerCase());
                    }
                  }
                }
              } catch (err) {
                _didIteratorError5 = true;
                _iteratorError5 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion5 && _iterator5.return) {
                    _iterator5.return();
                  }
                } finally {
                  if (_didIteratorError5) {
                    throw _iteratorError5;
                  }
                }
              }
            }
          } catch (err) {
            _didIteratorError4 = true;
            _iteratorError4 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion4 && _iterator4.return) {
                _iterator4.return();
              }
            } finally {
              if (_didIteratorError4) {
                throw _iteratorError4;
              }
            }
          }

          resolve(domains);
        });
      });
    }
  }, {
    key: 'registerTabEvents',
    value: function registerTabEvents(register) {
      var _this2 = this;

      this.onCreated = function (tab) {
        if (_this2.isCapturableTab(tab.url)) {
          if (_qTestContext.QtestContext.status.name === _statusEnum.StatusEnum.recording) {
            _this2.updateTabCaptureState(tab.id, 1);
          } else if (_qTestContext.QtestContext.status.name === _statusEnum.StatusEnum.paused) {
            _this2.updateTabCaptureState(tab.id, 2);
          }
        }
      };
      this.onAttached = function (tabId, attachInfo) {};
      this.onDetached = function (tabId, detachInfo) {};
      this.onActivated = function (activeInfo) {
        console.log(new Date().toString() + ' tab activated - tabId: ' + activeInfo.tabId + ', windowId: ' + activeInfo.windowId);
        return chrome.tabs.get(activeInfo.tabId, function (tab) {
          if (tab) {
            _this2.detectCapturableTab(tab);
            if (_this2.isActiveTabCapturable) {
              _this2.sendMessageToQueryDevicePixelRatio(activeInfo.tabId);
            }
          }
        });
      };
      this.onZoomChange = function (zoomChangeInfo) {
        console.log(new Date().toString() + ' zoom changed - tabId: \n      ' + zoomChangeInfo.tabId + ', oldZoomFactor: ' + zoomChangeInfo.oldZoomFactor + ', \n      newZoomFactor: ' + zoomChangeInfo.newZoomFactor);
        if (zoomChangeInfo.oldZoomFactor !== zoomChangeInfo.newZoomFactor) {
          _this2.activeTabDevicePixelRatio = zoomChangeInfo.newZoomFactor;
        }
      };
      this.onFocusChanged = function (windowId) {
        if (windowId !== chrome.windows.WINDOW_ID_NONE) {
          chrome.tabs.query({
            windowId: windowId,
            active: true
          }, function (tabs) {
            if ((tabs ? tabs.length : undefined) > 0) {
              _this2.detectCapturableTab(tabs[0]);
              if (_this2.isActiveTabCapturable) {
                _this2.sendMessageToQueryDevicePixelRatio(tabs[0].id);
              }
            }
          });
        }
      };
      if (register) {
        console.log(new Date().toString() + ' register tab events...');
        chrome.tabs.onCreated.addListener(this.onCreated);
        chrome.tabs.onAttached.addListener(this.onAttached);
        chrome.tabs.onDetached.addListener(this.onDetached);
        chrome.tabs.onActivated.addListener(this.onActivated);
        chrome.tabs.onZoomChange.addListener(this.onZoomChange);
        chrome.windows.onFocusChanged.addListener(this.onFocusChanged);
        chrome.tabs.query({
          windowId: chrome.windows.WINDOW_ID_CURRENT,
          active: true
        }, function (tabs) {
          if ((tabs ? tabs.length : undefined) > 0) {
            _this2.detectCapturableTab(tabs[0]);
            if (_this2.isActiveTabCapturable) {
              _this2.sendMessageToQueryDevicePixelRatio(tabs[0].id);
            }
          } else {
            console.log(new Date().toString() + ' unregister tab events...');
            chrome.tabs.onCreated.removeListener(_this2.onCreated);
            chrome.tabs.onAttached.removeListener(_this2.onAttached);
            chrome.tabs.onDetached.removeListener(_this2.onDetached);
            chrome.tabs.onActivated.removeListener(_this2.onActivated);
            chrome.tabs.onZoomChange.removeListener(_this2.onZoomChange);
            chrome.windows.onFocusChanged.removeListener(_this2.onFocusChanged);
            _this2.isActiveTabCapturable = false;
            _this2.canCaptureFullPageOfActiveTab = false;
          }
        });
      }
    }
  }, {
    key: 'detectCapturableTab',
    value: function detectCapturableTab(tab) {
      if (tab ? tab.url : undefined) {
        this.isActiveTabCapturable = this.isCapturableTab(tab.url);
        this.canCaptureFullPageOfActiveTab = this.isActiveTabCapturable;
        console.log(new Date().toString() + ' tab \'' + tab.url + '\' is capturable: ' + this.isActiveTabCapturable);
      }
    }
  }, {
    key: 'updateTabCaptureState',
    value: function updateTabCaptureState(tabId, state) {
      var msg = {
        name: 'initCapture',
        state: state,
        defaultDevicePixelRatio: this.defaultDevicePixelRatio
      };
      try {
        return chrome.tabs.sendMessage(tabId, msg, function (response) {});
      } catch (error) {
        return console.log(error);
      }
    }
  }, {
    key: 'sendMessageToQueryDevicePixelRatio',
    value: async function sendMessageToQueryDevicePixelRatio(tabId) {
      var _this3 = this;

      try {
        await chrome.tabs.sendMessage(tabId, {
          name: _messageEnum.MessageEnum.devicePixelRatio
        }, function (response) {
          if (response ? response.devicePixelRatio : undefined) {
            console.log(new Date().toString() + ' current tab\'s devicePixelRatio: ' + response.devicePixelRatio);
            _this3.activeTabDevicePixelRatio = response.devicePixelRatio;
          }
        });
      } catch (error) {
        console.log(error);
      }
    }
  }, {
    key: 'sendUpdateTabCaptureState',
    value: async function sendUpdateTabCaptureState(state) {
      var _this4 = this;

      await chrome.windows.getAll({
        populate: true
      }, async function (wnds) {
        var _iteratorNormalCompletion6 = true;
        var _didIteratorError6 = false;
        var _iteratorError6 = undefined;

        try {
          for (var _iterator6 = wnds[Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
            var wd = _step6.value;
            var _iteratorNormalCompletion7 = true;
            var _didIteratorError7 = false;
            var _iteratorError7 = undefined;

            try {
              for (var _iterator7 = wd.tabs[Symbol.iterator](), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
                var tb = _step7.value;

                if (tb.url.indexOf(_editorHandler.EditorHandler.URL_PREFIX < 0)) {
                  try {
                    _this4.updateTabCaptureState(tb.id, state);
                  } catch (error) {
                    console.log(new Date().toString() + ' updateTabCaptureState for tab ' + tb.id + ' | ' + tb.url + ' failed: ' + error);
                  }
                }
              }
            } catch (err) {
              _didIteratorError7 = true;
              _iteratorError7 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion7 && _iterator7.return) {
                  _iterator7.return();
                }
              } finally {
                if (_didIteratorError7) {
                  throw _iteratorError7;
                }
              }
            }
          }
        } catch (err) {
          _didIteratorError6 = true;
          _iteratorError6 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion6 && _iterator6.return) {
              _iterator6.return();
            }
          } finally {
            if (_didIteratorError6) {
              throw _iteratorError6;
            }
          }
        }
      });
    }
  }, {
    key: 'showAlert',
    value: function showAlert(tabId, errorMessage) {
      var msg = {
        name: 'showError',
        error: errorMessage
      };
      try {
        chrome.tabs.sendMessage(tabId, msg);
      } catch (error) {
        console.log(error);
      }
    }
  }, {
    key: 'openSessionReview',
    value: function openSessionReview(url, redirectUrl, createIfNotExists) {
      chrome.windows.getAll({
        populate: true
      }, function (wnds) {
        var tab = null;
        var _iteratorNormalCompletion8 = true;
        var _didIteratorError8 = false;
        var _iteratorError8 = undefined;

        try {
          for (var _iterator8 = wnds[Symbol.iterator](), _step8; !(_iteratorNormalCompletion8 = (_step8 = _iterator8.next()).done); _iteratorNormalCompletion8 = true) {
            var wd = _step8.value;

            if (tab) {
              break;
            }
            var _iteratorNormalCompletion9 = true;
            var _didIteratorError9 = false;
            var _iteratorError9 = undefined;

            try {
              for (var _iterator9 = wd.tabs[Symbol.iterator](), _step9; !(_iteratorNormalCompletion9 = (_step9 = _iterator9.next()).done); _iteratorNormalCompletion9 = true) {
                var tb = _step9.value;

                if (tb.url.indexOf(redirectUrl) === 0) {
                  tab = tb;
                  break;
                }
              }
            } catch (err) {
              _didIteratorError9 = true;
              _iteratorError9 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion9 && _iterator9.return) {
                  _iterator9.return();
                }
              } finally {
                if (_didIteratorError9) {
                  throw _iteratorError9;
                }
              }
            }
          }
        } catch (err) {
          _didIteratorError8 = true;
          _iteratorError8 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion8 && _iterator8.return) {
              _iterator8.return();
            }
          } finally {
            if (_didIteratorError8) {
              throw _iteratorError8;
            }
          }
        }

        if (tab) {
          chrome.windows.update(tab.windowId, {
            focused: true
          });
          chrome.tabs.update(tab.id, {
            url: url,
            active: true
          });
        } else if (createIfNotExists) {
          chrome.tabs.query({
            windowId: chrome.windows.WINDOW_ID_CURRENT,
            active: true
          }, function (tabs) {
            if (tabs && tabs.length > 0) {
              tab = tabs[0];
              chrome.tabs.create({
                index: tab.index + 1,
                url: url
              }, function () {});
            } else {
              chrome.tabs.create({
                url: url
              }, function () {});
            }
          });
        }
      });
    }
  }, {
    key: 'activeTabDevicePixelRatio',
    get: function get() {
      return this._activeTabDevicePixelRatio || 1;
    },
    set: function set(value) {
      this._activeTabDevicePixelRatio = value;
    }
  }, {
    key: 'defaultDevicePixelRatio',
    get: function get() {
      return this._defaultDevicePixelRatio || null;
    },
    set: function set(value) {
      this._defaultDevicePixelRatio = value;
    }
  }, {
    key: 'isActiveTabCapturable',
    get: function get() {
      if (this._isActiveTabCapturable === undefined) {
        return true;
      }
      return this._isActiveTabCapturable;
    },
    set: function set(value) {
      this._isActiveTabCapturable = value;
    }
  }, {
    key: 'canCaptureFullPageOfActiveTab',
    get: function get() {
      if (this._canCaptureFullPageOfActiveTabs === undefined) {
        return true;
      }
      return this._canCaptureFullPageOfActiveTabs;
    },
    set: function set(value) {
      this._canCaptureFullPageOfActiveTab = value;
    }
  }]);

  return TabManager;
}();

},{"../../../common/qTestContext.js":1,"../../../common/services/model/messageEnum.js":5,"../../../common/services/model/statusEnum.js":9,"../background/editorHandler.js":17}]},{},[13]);
