(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.QtestContext = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _statusEnum = require('./services/model/statusEnum.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var QtestContext = exports.QtestContext = function () {
  function QtestContext() {
    _classCallCheck(this, QtestContext);
  }

  _createClass(QtestContext, null, [{
    key: 'clear',
    value: function clear() {
      this._user = null;
      this._session = null;
      this._projects = [];
      this._selectedProject = null;
      this._timeTypes = [];
      this._noteTypes = [];
      this._pendingAnnotations = [];
      this._currentProcessingScreen = null;
      this._domainOptions = null;
      this._runFromQtest = false;
      this._projectId = null;
      this._sessionId = null;
      this._status = {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    }
  }, {
    key: 'canRecordMedia',
    value: function canRecordMedia() {
      return this._qTestVersion && this._qTestVersion >= 6;
    }
  }, {
    key: 'getProjectAutoStartSupported',
    value: function getProjectAutoStartSupported() {
      var result = [];
      if (this._projects) {
        var ref = this._projects;
        for (var j = 0, len = ref.length; j < len; j++) {
          var p = ref[j];
          if (p.alwaysOnSetting.domains.length > 0 && p.alwaysOnSetting.enabled) {
            result.push(p);
          }
        }
      }
      return result;
    }
  }, {
    key: 'qTestVersion',
    get: function get() {
      return this._qTestVersion || null;
    },
    set: function set(qTestVersion) {
      this._qTestVersion = qTestVersion;
    }
  }, {
    key: 'qTestMinorVersion',
    get: function get() {
      return this._qTestMinorVersion || null;
    },
    set: function set(qTestMinorVersion) {
      this._qTestMinorVersion = qTestMinorVersion;
    }
  }, {
    key: 'session',
    get: function get() {
      return this._session || null;
    },
    set: function set(session) {
      this._session = session;
    }
  }, {
    key: 'user',
    get: function get() {
      return this._user || null;
    },
    set: function set(user) {
      this._user = user;
    }
  }, {
    key: 'projects',
    get: function get() {
      if (!this._projects) {
        this._projects = [];
      }
      return this._projects;
    },
    set: function set(projects) {
      this._projects = projects;
    }
  }, {
    key: 'selectedProject',
    get: function get() {
      return this._selectedProject || null;
    },
    set: function set(selectedProject) {
      this._selectedProject = selectedProject;
    }
  }, {
    key: 'timeTypes',
    get: function get() {
      if (!this._timeTypes) {
        this._timeTypes = [];
      }
      return this._timeTypes;
    },
    set: function set(timeTypes) {
      this._timeTypes = timeTypes;
    }
  }, {
    key: 'noteTypes',
    get: function get() {
      if (!this._noteTypes) {
        this._noteTypes = [];
      }
      return this._noteTypes;
    },
    set: function set(noteTypes) {
      this._noteTypes = noteTypes;
    }
  }, {
    key: 'pendingAnnotations',
    get: function get() {
      if (!this._pendingAnnotations) {
        this._pendingAnnotations = [];
      }
      return this._pendingAnnotations;
    },
    set: function set(pendingAnnotations) {
      this._pendingAnnotations = pendingAnnotations;
    }
  }, {
    key: 'currentProcessingScreen',
    get: function get() {
      return this._currentProcessingScreen || null;
    },
    set: function set(currentProcessingScreen) {
      this._currentProcessingScreen = currentProcessingScreen;
    }
  }, {
    key: 'domainOptions',
    get: function get() {
      return this._domainOptions || null;
    },
    set: function set(domainOptions) {
      this._domainOptions = domainOptions;
    }
  }, {
    key: 'runFromQtest',
    get: function get() {
      return this._runFromQtest || false;
    },
    set: function set(runFromQtest) {
      this._runFromQtest = runFromQtest;
    }
  }, {
    key: 'projectId',
    get: function get() {
      return this._projectId || null;
    },
    set: function set(projectId) {
      this._projectId = projectId;
    }
  }, {
    key: 'sessionId',
    get: function get() {
      return this._sessionId || null;
    },
    set: function set(sessionId) {
      this._sessionId = sessionId;
    }
  }, {
    key: 'status',
    get: function get() {
      return this._status || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._status = value;
    }
  }, {
    key: 'currentqTestSession',
    get: function get() {
      return this._currentqTestSession || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._currentqTestSession = value;
    }
  }, {
    key: 'sessionManagerVersion',
    get: function get() {
      return this._sessionManagerVersion || {
        name: _statusEnum.StatusEnum.notLoggedIn,
        text: 'Not logged in'
      };
    },
    set: function set(value) {
      this._sessionManagerVersion = value;
    }
  }]);

  return QtestContext;
}();

},{"./services/model/statusEnum.js":12}],2:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HttpRequest = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _qTestContext = require('../qTestContext.js');

var _config = require('../../extension/js/background/config.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var HttpRequest = exports.HttpRequest = function () {
  function HttpRequest() {
    _classCallCheck(this, HttpRequest);
  }

  _createClass(HttpRequest, null, [{
    key: 'getCommonHeaders',
    value: function getCommonHeaders() {
      var headers = {
        'x-client-name': _config.App.name,
        'x-client-version': _config.App.version,
        'x-explorer-api-version': _config.App.apiVersion
      };
      return headers;
    }
  }, {
    key: 'send',
    value: function send(url, token, sendType, data) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        var headers = _this.getCommonHeaders();
        if (token) {
          headers.Authorization = _qTestContext.QtestContext.qTestVersion >= 7 ? 'bearer ' + token : token;
        }
        if (headers && _qTestContext.QtestContext.ownerToken) {
          headers['x-qtest-owner-token'] = _qTestContext.QtestContext.ownerToken;
        }

        // eslint-disable-next-line no-undef
        $.ajax({
          type: sendType,
          url: url,
          data: data,
          contentType: 'application/json;charset=UTF-8',
          dataType: token ? 'json' : null,
          headers: headers
        }).done(function (resultData) {
          resolve({
            data: resultData
          });
        }).fail(function (jqXHR, textStatus, errorThrown) {
          if (jqXHR.status === 200) {
            resolve({});
          } else {
            resolve({
              status: jqXHR.status,
              error: errorThrown
            });
          }
        });
      });
    }
  }, {
    key: 'sendWithResponse',
    value: function sendWithResponse(url, token, sendType, data) {
      var _this2 = this;

      return new Promise(function (resolve, reject) {
        var headers = _this2.getCommonHeaders();
        if (token) {
          headers.Authorization = _qTestContext.QtestContext.qTestVersion >= 7 ? 'bearer ' + token : token;
        }
        if (headers && _qTestContext.QtestContext.ownerToken) {
          headers['x-qtest-owner-token'] = _qTestContext.QtestContext.ownerToken;
        }
        // eslint-disable-next-line no-undef
        $.ajax({
          type: sendType,
          url: url,
          data: data,
          contentType: 'application/json;charset=UTF-8',
          dataType: token ? 'json' : null,
          headers: headers
        }).done(function (resultData, status, xhr) {
          resolve({
            data: resultData,
            response: xhr
          });
        }).fail(function (jqXHR, textStatus, errorThrown) {
          if (jqXHR.status === 200) {
            resolve({});
          } else {
            resolve({
              status: jqXHR.status,
              error: errorThrown
            });
          }
        });
      });
    }
  }, {
    key: 'upload',
    value: function upload(url, token, filename, binaryData, contentType) {
      var _this3 = this;

      return new Promise(function (resolve, reject) {
        if (!binaryData) {
          resolve({
            error: 'HttpRequest: error: No binary data'
          });
          return;
        }
        var oReq = new XMLHttpRequest();
        oReq.open('POST', url, true);
        var headers = _this3.getCommonHeaders();
        if (token) {
          headers.Authorization = _qTestContext.QtestContext.qTestVersion >= 7 ? 'bearer ' + token : token;
        }
        headers['Content-Type'] = contentType;
        headers['x-filename'] = filename;
        // eslint-disable-next-line no-undef
        $.each(headers, function (key, value) {
          if (Object.prototype.hasOwnProperty.call(headers, key) && !(value instanceof Function)) {
            oReq.setRequestHeader(key, value);
          }
        });
        oReq.onload = function (oEvent) {
          var data = oReq.response;
          var responseStatus = oReq.status;
          console.log(new Date().toString() + ' HttpRequest: finished uploading binary data, response status: \'' + responseStatus + '\', response data: \'' + data + '\'...');
          oReq.abort();
          if (responseStatus === 200 || responseStatus === 201) {
            resolve({
              data: JSON.parse(data)
            });
          } else {
            resolve({
              error: responseStatus + 'ERROR'
            });
          }
        };
        oReq.onerror = function (oEvent) {
          resolve({
            error: 'HttpRequest: error :' + oEvent.error
          });
        };
        oReq.send(binaryData);
      });
    }
  }]);

  return HttpRequest;
}();

},{"../../extension/js/background/config.js":19,"../qTestContext.js":1}],3:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MessagingService = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _sendStatusEnum = require('./model/sendStatusEnum.js');

var _DateUtils = require('./utils/DateUtils.js');

var _httpRequest = require('./httpRequest.js');

var _qTestContext = require('../qTestContext.js');

var _config = require('../../extension/js/background/config.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MessagingService = exports.MessagingService = function () {
  function MessagingService(baseURL, token) {
    _classCallCheck(this, MessagingService);

    this.baseURL = baseURL;
    this.token = token;
  }

  _createClass(MessagingService, [{
    key: 'getSessionJson',
    value: function getSessionJson(session, sendCaptureDate) {
      var sysInfoJson = {
        app_version: _config.App.systemInfo.appVersion,
        incl_app_version: true,
        os: _config.App.systemInfo.os,
        incl_os: true,
        resolutions: _config.App.systemInfo.resolutions,
        incl_resolutions: true
      };
      var appInfoJson = {
        name: _config.App.applicationInfo.name,
        file_version: _config.App.applicationInfo.fileVersion,
        incl_file_version: true,
        version: _config.App.applicationInfo.version,
        incl_version: true
      };
      var json = {
        client_name: 'qTestWebeXplorer',
        project_id: session.project,
        title: session.title,
        desc: session.description,
        planned_duration: session.plannedDuration.hour * 3600 + session.plannedDuration.min * 60,
        sys_info: sysInfoJson,
        app_infos: [appInfoJson],
        tester_name: session.tester,
        has_meta_data: true
      };
      if (sendCaptureDate) {
        var capturedDate = _DateUtils.DateUtils.getDateString(new Date());
        json.captured_date = capturedDate;
        json.doc = {
          captured_date: capturedDate
        };
      }
      return json;
    }
  }, {
    key: 'sendCreateSession',
    value: async function sendCreateSession(session) {
      if (session.sendStatus && session.sendStatus !== _sendStatusEnum.SendStatusEnum.notSent) {
        return {
          success: true
        };
      }
      session.sendStatus = _sendStatusEnum.SendStatusEnum.sending;
      var url = this.baseURL + '/sessions';
      var json = this.getSessionJson(session, true);
      json.owner_user = session.tester;
      json.edit_user = session.tester;
      json.tester_name = session.tester;
      json.status = 'running';
      console.log(new Date().toString() + ' about to send create session...');

      var res = await _httpRequest.HttpRequest.send(url, this.token, 'POST', JSON.stringify(json));
      console.log(new Date().toString() + ' finished creating session...');
      if (res.error) {
        session.sendStatus = _sendStatusEnum.SendStatusEnum.error;
      } else {
        _qTestContext.QtestContext.ownerToken = res.data.owner_token;
        session.id = res.data.id;
        session.sendStatus = _sendStatusEnum.SendStatusEnum.sent;
        session.status = 'running';
        this.buildRedirectUrl(session);
      }
      return {
        success: res.error == null, // should be ==
        error: res.error
      };
    }
  }, {
    key: 'buildRedirectUrl',
    value: function buildRedirectUrl(session) {
      var redirectUrl = '';
      var version = _qTestContext.QtestContext.sessionManagerVersion;

      if ((version ? version.major : undefined) >= 3) {
        redirectUrl = _qTestContext.QtestContext.user.url + '/p/' + _qTestContext.QtestContext.session.project + '/portal/session/' + session.id + '/review';
        session.redirectUrl = _qTestContext.QtestContext.user.apiURL + '/' + session.id + '/review';
      } else if (_qTestContext.QtestContext.qTestVersion >= 7) {
        redirectUrl = _qTestContext.QtestContext.user.url + '/p/' + _qTestContext.QtestContext.session.project + '/portal/session/' + session.id + '/review';
        session.redirectUrl = redirectUrl;
      } else {
        redirectUrl = _qTestContext.QtestContext.user.url + '/p/' + _qTestContext.QtestContext.session.project + '/portal/session/playback/' + session.id;
        session.redirectUrl = redirectUrl;
      }
      var encodedRedirectUrl = encodeURIComponent(redirectUrl);
      session.url = _qTestContext.QtestContext.user.url + '/portal/loginform?token=' + _qTestContext.QtestContext.user.token + '&redirect=' + encodedRedirectUrl;
    }
  }, {
    key: 'sendUpdateSession',
    value: async function sendUpdateSession(session, sendCaptureDate) {
      if (!session.sendStatus) {
        return {
          success: false
        };
      }
      var url = this.baseURL + '/sessions/' + session.id;
      var json = this.getSessionJson(session, sendCaptureDate);
      json.time_lines = [];
      var order = 0;
      var actualDuration = 0;
      var ref = _qTestContext.QtestContext.timeTypes;
      for (var i = 0, len = ref.length; i < len; i++) {
        var timeType = ref[i];
        var jsonTimeLine = {
          total_time: 0,
          order: order++,
          time_type: {
            id: timeType.id,
            name: timeType.name,
            color: timeType.color
          }
        };
        json.time_lines.push(jsonTimeLine);
        var timelines = session.timeLines;
        for (var j = 0, len1 = timelines.length; j < len1; j++) {
          var timeLine = timelines[j];
          if (timeLine.timeType.name === timeType.name) {
            jsonTimeLine.total_time += timeLine.totalTime;
          }
        }
        actualDuration += jsonTimeLine.total_time;
      }
      json.actual_duration = actualDuration;

      var res = await _httpRequest.HttpRequest.send(url, this.token, 'PUT', JSON.stringify(json));
      if (res.error) {
        console.error('sendUpdateSession error - status: ' + res.status + ', error: ' + res.error);
      } else {
        this.buildRedirectUrl(session);
      }
      return {
        success: !res.error,
        error: res.error
      };
    }
  }, {
    key: 'sendUpdateSessionStatus',
    value: async function sendUpdateSessionStatus(session, status) {
      var url = this.baseURL + '/sessions/' + session.id + '/status';
      console.log(new Date().toString() + ' about to send update session status \'' + status + '\'...');
      var res = await _httpRequest.HttpRequest.send(url, this.token, 'PUT', '{ "status": "' + status + '" }');
      console.log(new Date().toString() + ' finished updating session status \'' + status + '\'...');
      if (!res.error) {
        session.status = status;
        if (status === 'running') {
          if (!res.data || !res.data.owner_token) {
            console.error(new Date().toString() + ' updating session status error: missing Owner Token...');
            return {
              success: false,
              error: 'missing Owner Token'
            };
          }
          console.log(new Date().toString() + ' obtained Owner Token...');
          _qTestContext.QtestContext.ownerToken = res.data.owner_token;
        }
      }
      return {
        success: !res.error,
        error: res.error
      };
    }
  }, {
    key: 'processUploadScreen',
    value: async function processUploadScreen(sessionId, screen, url) {
      var annotations = [];
      var ref = screen.annotations;
      for (var i = 0, len = ref.length; i < len; i++) {
        var annotation = ref[i];
        var actionJSON = annotation.getJson();
        if (actionJSON.timestamp) {
          actionJSON.timestamp = _DateUtils.DateUtils.getDateString(new Date(actionJSON.timestamp));
        }
        annotations.push(actionJSON);
      }
      var json = {
        order: screen.order,
        title: screen.title,
        browser_url: screen.url,
        capture_mode: 'Form',
        left: 0,
        top: 0,
        width: screen.width,
        height: screen.height,
        app_left: 0,
        app_top: 0,
        app_width: screen.width,
        app_height: screen.height,
        screen_height: screen.height,
        screen_width: screen.width,
        timestamp: _DateUtils.DateUtils.getDateString(new Date(screen.timeStamp)),
        finished_timestamp: _DateUtils.DateUtils.getDateString(new Date(screen.finishedTimestamp)),
        annotations: annotations,
        time_type: screen.timeType ? {
          color: screen.timeType.color,
          name: screen.timeType.name,
          id: screen.timeType.id
        } : null
      };

      var res = await _httpRequest.HttpRequest.send(url, this.token, 'POST', JSON.stringify(json));
      if (res.error) {
        screen.sendStatus = _sendStatusEnum.SendStatusEnum.error;
        console.error(new Date().toString() + ' error sending screen metadata: ' + screen.order + ' to ' + url + ': ' + res.error);
      } else {
        screen.id = res.data.id;
        console.log(new Date().toString() + ' call uploading for screen: ' + res.data.id);
        await this.sendUpload(sessionId, screen);
      }
    }
  }, {
    key: 'processUploadMedia',
    value: async function processUploadMedia(index, sessionId, url, screen, annotationLength) {
      var mediaUploadUrl = this.baseURL + '/upload-objects';
      if (index < annotationLength) {
        var annotation = screen.annotations[index];
        var annotationType = annotation.annotationType;
        if (annotationType === 'Video' || annotationType === 'Audio') {
          var mediaFileName = annotation.description;
          if (annotationType === 'Video') {
            mediaFileName += '.webm';
          } else {
            mediaFileName += '.wav';
          }
          console.log(new Date().toString() + ' about to upload media of type ' + annotationType + ', fileName: ' + mediaFileName);
          var response = await _httpRequest.HttpRequest.upload(mediaUploadUrl, this.token, mediaFileName, annotation.blob, annotation.mimeType);
          if (response.error) {
            console.log(new Date().toString() + ' error uploading media ' + mediaFileName + ': ' + response.error);
          } else {
            annotation.url = response.data.url;
            console.log(new Date().toString() + ' successfully uploading media ' + mediaFileName + ', url: ' + annotation.url);
          }
        }
        var nextIndex = index + 1;
        await this.processUploadMedia(nextIndex, sessionId, url, screen, annotationLength);
      }
    }
  }, {
    key: 'uploadMedia',
    value: async function uploadMedia(sessionId, screen, url) {
      var annotationLength = screen.annotations.length;
      await this.processUploadMedia(0, sessionId, url, screen, annotationLength);
      await this.processUploadScreen(sessionId, screen, url);
    }
  }, {
    key: 'sendCreateScreen',
    value: async function sendCreateScreen(sessionId, screen) {
      if (screen.sendStatus) {
        if (screen.sendStatus === _sendStatusEnum.SendStatusEnum.sent) {
          return;
        } else if (screen.sendStatus === _sendStatusEnum.SendStatusEnum.error) {
          console.error('Error sending screen ' + screen.order());
          return;
        } else if (screen.sendStatus === _sendStatusEnum.SendStatusEnum.sending) {
          return;
        }
      }
      screen.sendStatus = _sendStatusEnum.SendStatusEnum.sending;
      var url = this.baseURL + '/sessions/' + sessionId + '/screens';

      await this.uploadMedia(sessionId, screen, url);
    }
  }, {
    key: 'sendUpload',
    value: async function sendUpload(sessionId, screen) {
      if (screen.sendStatus) {
        if (screen.sendStatus === _sendStatusEnum.SendStatusEnum.sent) {
          return {
            success: true
          };
        } else if (screen.sendStatus !== _sendStatusEnum.SendStatusEnum.sending) {
          return {
            success: false
          };
        }
      }
      var url = this.baseURL + '/sessions/' + sessionId + '/screens/' + screen.id + '/images';
      var fileName = 'Temp';
      var binaryData = screen.screenShotBinary ? new Uint8Array(screen.screenShotBinary) : null;
      console.log(new Date().toString() + ' about to upload screen...');

      var res = await _httpRequest.HttpRequest.upload(url, this.token, fileName, binaryData, 'image/jpeg');
      if (res.error) {
        screen.sendStatus = _sendStatusEnum.SendStatusEnum.error;
        console.error(new Date().toString() + ' error uploading screen ' + screen.id + ': ' + res.error);
      } else {
        screen.sendStatus = _sendStatusEnum.SendStatusEnum.sent;
        console.log(new Date().toString() + ' successfully upload screen ' + screen.id);
      }
      return {
        success: res.error === undefined,
        error: res.error
      };
    }
  }, {
    key: 'sendAllScreens',
    value: async function sendAllScreens(sessionId, screens) {
      if (screens && screens.length > 0) {
        if (screens[0].sendStatus === _sendStatusEnum.SendStatusEnum.notSent) {
          await this.sendCreateScreen(sessionId, screens[0]);
          //
          var shifted = screens.shift();
          if (shifted && typeof shifted.destroyScreenshotBinary === 'function') {
            shifted.destroyScreenshotBinary();
            shifted = null;
          }
          if (screens.length > 0) {
            await this.sendAllScreens(sessionId, screens);
          }
        }
      }
    }
  }, {
    key: 'startSendingAllScreen',
    value: function startSendingAllScreen() {
      try {
        this.sendAllScreens(_qTestContext.QtestContext.session.id, _qTestContext.QtestContext.session.screens);
      } catch (error) {
        console.error('error sending: ' + error);
        var screens = _qTestContext.QtestContext.session.screens;
        if (screens > 0) {
          var shifted = _qTestContext.QtestContext.session.screens.shift();
          if (shifted) {
            shifted.destroyScreenshotBinary();
            shifted = null;
          }
        }
        this.sendAllScreens(_qTestContext.QtestContext.session.id, _qTestContext.QtestContext.session.screens);
      }
    }
  }]);

  return MessagingService;
}();

},{"../../extension/js/background/config.js":19,"../qTestContext.js":1,"./httpRequest.js":2,"./model/sendStatusEnum.js":11,"./utils/DateUtils.js":16}],4:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Action = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _GuidUtils = require('../utils/GuidUtils.js');

var _ObjectUtils = require('../utils/ObjectUtils.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Action = exports.Action = function () {
  function Action(description, type, metaData) {
    _classCallCheck(this, Action);

    this._x = -100;
    this._y = -1;
    this._orderNumber = null;
    this._keyCode = null;
    this._timeStamp = null;
    this._repeat = 1;
    this._description = description;
    this._type = type;
    this._metaData = _ObjectUtils.ObjectUtils.clone(metaData);
    this._description = this.description.trim();
    this._id = _GuidUtils.GuidUtils.generateGuid();
    if (this._description.length > 0) {
      this._description = this.description.slice(0, 1).toUpperCase() + this.description.slice(1);
    }
  }

  _createClass(Action, [{
    key: 'getJson',
    value: function getJson() {
      var des = this.description;
      if (this.repeat > 1) {
        des = des + ' ' + this.repeat + ' times';
      }
      if (this.repeat === -2) {
        des = 'Double ' + this.description;
        if (des.indexOf('Double Select') === 0) {
          des = des.replace('Double Select', 'Double Click');
        }
      }
      return {
        id: this.id,
        annotation_type: 'Action',
        order_number: this.orderNumber,
        desc: des,
        meta_data: this.metaData,
        left: this.x,
        top: this.y,
        hotspotx: this.x,
        hotspoty: this.y,
        timestamp: this.timeStamp
      };
    }
  }, {
    key: 'getDrawableData',
    value: function getDrawableData() {
      return {
        id: this.id,
        annotationType: 'Action',
        orderNumber: this.orderNumber,
        desc: this.description,
        meta_data: this.metaData,
        left: this.x,
        top: this.y,
        hotspotx: this.x,
        hotspoty: this.y,
        timestamp: this.timeStamp,
        repeat: this.repeat
      };
    }
  }, {
    key: 'importData',
    value: function importData(data) {
      this.id = data.id;
      this.orderNumber = data.orderNumber;
      this.description = data.desc;
      this.metaData = data.meta_data;
      this.x = data.hotspotx;
      this.y = data.hotspoty;
      this.timeStamp = data.timestamp;
      this.repeat = data.repeat;
    }
  }, {
    key: 'x',
    get: function get() {
      return this._x;
    },
    set: function set(value) {
      this._x = value;
    }
  }, {
    key: 'y',
    get: function get() {
      return this._y;
    },
    set: function set(value) {
      this._y = value;
    }
  }, {
    key: 'orderNumber',
    get: function get() {
      return this._orderNumber;
    },
    set: function set(value) {
      this._orderNumber = value;
    }
  }, {
    key: 'keyCode',
    get: function get() {
      return this._keyCode;
    },
    set: function set(value) {
      this._keyCode = value;
    }
  }, {
    key: 'timeStamp',
    get: function get() {
      return this._timeStamp;
    },
    set: function set(value) {
      this._timeStamp = value;
    }
  }, {
    key: 'repeat',
    get: function get() {
      return this._repeat;
    },
    set: function set(value) {
      this._repeat = value;
    }
  }, {
    key: 'description',
    get: function get() {
      return this._description;
    },
    set: function set(value) {
      this._description = value;
    }
  }, {
    key: 'type',
    get: function get() {
      return this._type;
    },
    set: function set(value) {
      this._type = value;
    }
  }, {
    key: 'metaData',
    get: function get() {
      return this._metaData;
    },
    set: function set(value) {
      this._metaData = value;
    }
  }, {
    key: 'id',
    get: function get() {
      return this._id;
    },
    set: function set(value) {
      this._id = value;
    }
  }]);

  return Action;
}();

},{"../utils/GuidUtils.js":17,"../utils/ObjectUtils.js":18}],5:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Annotation = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _modelMapper = require('./../modelMapper.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Annotation = exports.Annotation = function () {
  function Annotation(data) {
    _classCallCheck(this, Annotation);

    if (data) {
      // eslint-disable-next-line no-undef
      $.extend(this, data);
    }
  }

  _createClass(Annotation, [{
    key: 'mapModelToData',
    value: function mapModelToData(model, excludes) {
      var _this = this;

      var excludesRef = excludes;
      if (!excludesRef) {
        excludesRef = [];
      }
      var objData = {};
      // eslint-disable-next-line no-undef
      $.each(model, function (key, value) {
        if ((excludesRef.length === 0 || excludesRef.indexOf(key.toString()) < 0) && !(value instanceof Function)) {
          if (value instanceof Array) {
            objData[key] = [];
            for (var j = 0, len = value.length; j < len; j++) {
              var valItem = value[j];
              objData[key].push(_this.mapModelToData(valItem, excludesRef));
            }
          } else if (value instanceof Object) {
            objData[key] = _this.mapModelToData(value, excludesRef);
          } else {
            objData[key] = value;
          }
        }
      });
      return objData;
    }
  }, {
    key: 'getJson',
    value: function getJson() {
      return _modelMapper.ModelMapper.mapModelToData(this, ['$$hashKey', 'isListItem', 'getJson', 'getDrawableData']);
    }
  }, {
    key: 'getDrawableData',
    value: function getDrawableData() {
      return this.mapModelToData(this, []);
    }
  }]);

  return Annotation;
}();

},{"./../modelMapper.js":15}],6:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ApplicationInfo = exports.ApplicationInfo = function ApplicationInfo(name, version, fileVersion) {
  _classCallCheck(this, ApplicationInfo);

  this.name = name;
  this.version = version;
  this.fileVersion = fileVersion;
};

},{}],7:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Media = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _GuidUtils = require('../utils/GuidUtils.js');

var _DateUtils = require('../utils/DateUtils.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Media = exports.Media = function () {
  function Media() {
    _classCallCheck(this, Media);

    this.id = _GuidUtils.GuidUtils.generateGuid();
    this.annotationType = null;
    this.mimeType = null;
    this.description = null;
    this.blob = null;
    this.blobUrl = null;
    this.url = null;
    this.startTimestamp = null;
    this.endTimestamp = null;
    this.timestamp = null;
    this.size = 0;
  }

  _createClass(Media, [{
    key: 'getJson',
    value: function getJson() {
      return {
        id: this.id,
        annotation_type: this.annotationType,
        mime_type: this.mimeType,
        desc: this.description,
        start_timestamp: _DateUtils.DateUtils.getDateString(new Date(this.startTimestamp)),
        end_timestamp: _DateUtils.DateUtils.getDateString(new Date(this.endTimestamp)),
        timestamp: this.timestamp,
        url: this.url,
        size: this.size
      };
    }
  }, {
    key: 'getDrawableData',
    value: function getDrawableData() {
      return {
        id: this.id,
        annotationType: this.annotationType,
        mimeType: this.mimeType,
        desc: this.description,
        blobUrl: this.blobUrl,
        startTimestamp: this.startTimestamp,
        endTimestamp: this.endTimestamp,
        timestamp: this.timestamp,
        size: this.size
      };
    }
  }, {
    key: 'importData',
    value: function importData(data) {
      this.id = data.id;
      this.annotationType = data.annotationType;
      this.mimeType = data.mimeType;
      this.blobUrl = data.blobUrl;
      this.description = data.desc;
      this.startTimestamp = data.startTimestamp;
      this.endTimestamp = data.endTimestamp;
      this.timestamp = data.timestamp;
      this.size = data.size;
    }
  }]);

  return Media;
}();

},{"../utils/DateUtils.js":16,"../utils/GuidUtils.js":17}],8:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var MessageEnum = exports.MessageEnum = {
  getStatus: 'getStatus',

  login: 'login',

  logout: 'logout',

  getSessions: 'getSessions',

  startSession: 'startSession',

  viewSession: 'viewSession',

  completeSession: 'completeSession',

  addNote: 'addNote',

  switchTimetype: 'switchTimetype',

  keyEvent: 'keyEvent',

  clickEvent: 'clickEvent',

  takeSnapshot: 'takeSnapshot',

  modalDialog: 'modalDialog',

  devicePixelRatio: 'devicePixelRatio',

  toggleRecordingStatus: 'toggleRecordingStatus',

  captureVisiblePart: 'captureVisiblePart',

  captureFullPage: 'captureFullPage',

  captureScrollingPage: 'captureScrollingPage',

  finishedScrolling: 'finishedScrolling',

  finishedCaptureFullPage: 'finishedCaptureFullPage',

  discardScrollingCapture: 'discardScrollingCapture',

  openUrl: 'openUrl',

  editCurrentScreen: 'editCurrentScreen',

  editorReady: 'editorReady',

  saveCurrentScreen: 'saveCurrentScreen',

  cancelEditCurrentScreen: 'cancelEditCurrentScreen',

  confirmMediaPermission: 'confirmMediaPermission',

  deniedMediaPermission: 'deniedMediaPermission',

  cancelledMediaPermission: 'cancelledMediaPermission',

  recordMedia: 'recordMedia',

  stopRecordMedia: 'stopRecordMedia',

  cancelRecordMedia: 'cancelRecordMedia',

  showSettings: 'showSettings',

  getSettings: 'getSettings',

  saveSettings: 'saveSettings',

  cancelSaveSettings: 'cancelSaveSettings',

  closeSettings: 'closeSettings',

  openCommandsConfiguration: 'openCommandsConfiguration',

  startSessionFromqTest: 'startSessionFromqTest',

  currentqTestSession: 'currentqTestSession',

  getCurrentqTestSession: 'getCurrentqTestSession',

  getOpeningDomains: 'getOpeningDomains',

  getAutoStartData: 'getAutoStartData',

  autoStartDisableConfirm: 'autoStartDisableConfirm',

  startAutoStartSession: 'startAutoStartSession',

  removeAutoStartDialog: 'remove-web-explorer-confirm-start-always-on-session-dialog',

  removeStartSessionDialog: 'remove-web-explorer-start-session-dialog'
};

},{}],9:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Note = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _GuidUtils = require('../utils/GuidUtils.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Note = exports.Note = function () {
  function Note() {
    _classCallCheck(this, Note);

    this.noteType = null;
    this.text = null;
    this.id = _GuidUtils.GuidUtils.generateGuid();
  }

  _createClass(Note, [{
    key: 'getJson',
    value: function getJson() {
      return {
        id: this.id,
        annotation_type: 'Note',
        note_type: {
          id: this.noteType.id,
          name: this.noteType.name,
          color: this.noteType.color
        },
        desc: this.text
      };
    }
  }, {
    key: 'getDrawableData',
    value: function getDrawableData() {
      return {
        annotationType: 'Note',
        id: this.id,
        noteType: {
          id: this.noteType.id,
          name: this.noteType.name,
          color: this.noteType.color
        },
        desc: this.text
      };
    }
  }, {
    key: 'importData',
    value: function importData(data) {
      this.text = data.desc;
      this.id = data.id;
      this.noteType = {
        id: data.noteType.id,
        name: data.noteType.name,
        color: data.noteType.color
      };
    }
  }]);

  return Note;
}();

},{"../utils/GuidUtils.js":17}],10:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Screen = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _timeType = require('./timeType.js');

var _action = require('./action.js');

var _note = require('./note.js');

var _media = require('./media.js');

var _annotation = require('./annotation.js');

var _qTestContext = require('../../qTestContext.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Screen = exports.Screen = function () {
  function Screen(title, url, screenShotBinary) {
    _classCallCheck(this, Screen);

    this.timeStamp = null;
    this.finishedTimestamp = null;
    this.forceCaptured = false;
    this.title = title;
    this.url = url;
    this.screenShotBinary = screenShotBinary;
    this.width = 0;
    this.height = 0;
    this.annotations = [];
    this.id = '';
    this.sendStatus = 'NotSent';
    this.order = 0;
    this.timeType = null;

    var timeTypeName = _qTestContext.QtestContext.session.currentTimeType;
    var timetypes = _qTestContext.QtestContext.timeTypes;
    if (timeTypeName && timetypes.length > 0) {
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = timetypes[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var type = _step.value;

          if (type.name === timeTypeName) {
            this.timeType = new _timeType.TimeType(type.id, type.name, type.color);
            break;
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }
  }

  _createClass(Screen, [{
    key: 'destroyScreenshotBinary',
    value: function destroyScreenshotBinary() {
      this._screenShotBinary = null;
    }
  }, {
    key: 'getDrawableData',
    value: function getDrawableData() {
      var screen = {
        width: this.width,
        height: this.height,
        id: this.id,
        sendStatus: this.sendStatus,
        order: this.order,
        screenShotBinary: this.screenShotBinary,
        title: this.title,
        annotations: []
      };
      this.annotations.sort(function (a, b) {
        if (a.timeStamp && b.timeStamp) {
          return a.timeStamp - b.timeStamp;
        }
        return 0;
      });
      var actionOrder = 1;
      var ref = this.annotations;
      for (var j = 0, len = ref.length; j < len; j++) {
        var annotation = ref[j];
        var data = annotation.getDrawableData();
        if (data.annotationType === 'Action') {
          data.orderNumber = actionOrder;
          actionOrder++;
        }
        screen.annotations.push(data);
      }
      return screen;
    }
  }, {
    key: 'importData',
    value: function importData(data) {
      this.width = data.width;
      this.height = data.height;
      this.id = data.id;
      this.sendStatus = data.sendStatus;
      this.order = data.order;
      if (data.screenShotBinary) {
        this.screenShotBinary = data.screenShotBinary;
      }
      this.title = data.title;
      var updatedAnnotations = [];
      var ref = data.annotations;
      for (var j = 0, len = ref.length; j < len; j++) {
        var annotation = ref[j];
        switch (annotation.annotationType) {
          case 'Action':
            {
              var action = new _action.Action(annotation.desc);
              action.importData(annotation);
              updatedAnnotations.push(action);
              break;
            }
          case 'Note':
            {
              var note = new _note.Note();
              note.importData(annotation);
              updatedAnnotations.push(note);
              break;
            }
          case 'Audio':
          case 'Video':
            {
              var media = new _media.Media();
              media.importData(annotation);
              var annotations = this.annotations;
              var _iteratorNormalCompletion2 = true;
              var _didIteratorError2 = false;
              var _iteratorError2 = undefined;

              try {
                for (var _iterator2 = annotations[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                  var a = _step2.value;

                  if (a.annotationType === annotation.annotationType && a.id === annotation.id) {
                    media.blob = a.blob;
                    break;
                  }
                }
              } catch (err) {
                _didIteratorError2 = true;
                _iteratorError2 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion2 && _iterator2.return) {
                    _iterator2.return();
                  }
                } finally {
                  if (_didIteratorError2) {
                    throw _iteratorError2;
                  }
                }
              }

              updatedAnnotations.push(media);
              break;
            }
          default:
            {
              var ann = new _annotation.Annotation(annotation);
              updatedAnnotations.push(ann);
              break;
            }
        }
      }
      this.annotations = updatedAnnotations;
    }
  }]);

  return Screen;
}();

},{"../../qTestContext.js":1,"./action.js":4,"./annotation.js":5,"./media.js":7,"./note.js":9,"./timeType.js":14}],11:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var SendStatusEnum = exports.SendStatusEnum = {
  error: 'Error',

  notSent: 'NotSent',

  sent: 'Sent',

  sending: 'Sending'
};

},{}],12:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var StatusEnum = exports.StatusEnum = {
  notLoggedIn: 'notLoggedIn',

  loggingIn: 'loggingIn',

  loggedIn: 'loggedIn',

  loadingServerSession: 'loadingServerSession',

  loadedServerSession: 'loadedServerSession',

  startingSession: 'startingSession',

  startingSessionIndicator: 'startingSessionIndicator',

  recording: 'recording',

  editing: 'editing',

  paused: 'paused',

  capturingFullPage: 'capturingFullPage',

  inProgress: 'inProgress',

  completingSession: 'completingSession',

  recordingMedia: 'recordingMedia'
};

},{}],13:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SystemInfo = exports.SystemInfo = function SystemInfo(os, resolutions, appVersion) {
  _classCallCheck(this, SystemInfo);

  this.os = os;
  this.resolutions = resolutions;
  this.appVersion = appVersion;
};

},{}],14:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TimeType = exports.TimeType = function TimeType(id, name, color) {
  _classCallCheck(this, TimeType);

  this.id = id;
  this.name = name;
  this.color = color;
};

},{}],15:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ModelMapper = exports.ModelMapper = function () {
  function ModelMapper() {
    _classCallCheck(this, ModelMapper);
  }

  _createClass(ModelMapper, null, [{
    key: 'toColConverter',
    value: function toColConverter(propName) {
      return propName.replace(/[A-Z]/g, function ($0) {
        return '_' + $0.toLowerCase();
      });
    }
  }, {
    key: 'mapModelToData',
    value: function mapModelToData(model, excludes) {
      var _this = this;

      if (!excludes) {
        excludes = [];
      }
      var objData = {};
      $.each(model, function (key, value) {
        if ((excludes.length === 0 || excludes.indexOf(key.toString()) < 0) && typeof value !== 'function') {
          if (value instanceof Array) {
            objData[_this.toColConverter(key)] = [];
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
              for (var _iterator = value[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                var valItem = _step.value;

                if (valItem instanceof Object || valItem instanceof Array) {
                  objData[_this.toColConverter(key)].push(_this.mapModelToData(valItem));
                } else {
                  objData[_this.toColConverter(key)].push(valItem);
                }
              }
            } catch (err) {
              _didIteratorError = true;
              _iteratorError = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }
              } finally {
                if (_didIteratorError) {
                  throw _iteratorError;
                }
              }
            }
          } else if (value instanceof Object) {
            objData[_this.toColConverter(key)] = _this.mapModelToData(value);
          } else {
            objData[_this.toColConverter(key)] = value;
          }
        }
      });
      return objData;
    }
  }]);

  return ModelMapper;
}();

},{}],16:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DateUtils = exports.DateUtils = function () {
  function DateUtils() {
    _classCallCheck(this, DateUtils);
  }

  _createClass(DateUtils, null, [{
    key: 'getDateString',
    value: function getDateString(date) {
      var strDate = JSON.stringify(date).toString().replace('"', '').replace('"', '');
      strDate = strDate.substring(0, strDate.indexOf('Z')) + '+00:00';
      return strDate;
    }
  }]);

  return DateUtils;
}();

},{}],17:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var GuidUtils = exports.GuidUtils = function () {
  function GuidUtils() {
    _classCallCheck(this, GuidUtils);
  }

  _createClass(GuidUtils, null, [{
    key: 'generateGuid',
    value: function generateGuid() {
      var d = new Date().getTime();
      var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
        var r = (d + Math.random() * 16) % 16 | 0;
        d = Math.floor(d / 16);
        return (c === 'x' ? r : r & 0x3 | 0x8).toString(16);
      });
      return uuid;
    }
  }]);

  return GuidUtils;
}();

},{}],18:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ObjectUtils = exports.ObjectUtils = function () {
  function ObjectUtils() {
    _classCallCheck(this, ObjectUtils);
  }

  _createClass(ObjectUtils, null, [{
    key: 'clone',
    value: function clone(obj) {
      if (!obj || (typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) !== 'object') {
        return obj;
      }
      if (obj instanceof Date) {
        var copy = new Date();
        copy.setTime(obj.getTime());
        return copy;
      }
      if (obj instanceof Array || Array.isArray(obj)) {
        var _copy = [];
        for (var i = 0, len = obj.length; i < len; i++) {
          var item = obj[i];
          _copy.push(ObjectUtils.clone(item));
        }
        return _copy;
      }
      if ((typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) === 'object') {
        var _copy2 = {};
        for (var attr in obj) {
          if (Object.prototype.hasOwnProperty.call(obj, attr)) {
            _copy2[attr] = this.clone(obj[attr]);
          }
        }
        return _copy2;
      }
      return obj;
    }
  }]);

  return ObjectUtils;
}();

},{}],19:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.App = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _systemInfo = require('../../../common/services/model/systemInfo.js');

var _applicationInfo = require('../../../common/services/model/applicationInfo.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var fileVersion = '';
var browserName = '';
var firefoxVersion = '';
var osName = '';
var nAgt = window.navigator.userAgent;
var verOffset = nAgt.indexOf('Firefox');
if (verOffset !== -1) {
  browserName = 'firefox';
  fileVersion = nAgt.substring(verOffset + 8);
  firefoxVersion = parseInt(fileVersion, 10);
}
var mozillaExp = nAgt.match(/Mozilla\/(.*?) /);
if (mozillaExp && mozillaExp.length > 0) {
  var mozillaExp2 = /Mozilla\//;
  var osExp = /\((.*?)\)/;
  osName = navigator.userAgent.match(new RegExp(String(mozillaExp2.source) + mozillaExp[1] + ' ' + osExp.source))[1];
}

var App = exports.App = function () {
  function App() {
    _classCallCheck(this, App);
  }

  _createClass(App, null, [{
    key: 'manifest',
    get: function get() {
      return this._manifest || chrome.runtime.getManifest();
    }
  }, {
    key: 'name',
    get: function get() {
      return this.manifest.name;
    }
  }, {
    key: 'version',
    get: function get() {
      return this.manifest.version;
    }
  }, {
    key: 'apiVersion',
    get: function get() {
      return this.manifest.apiVersion;
    }
  }, {
    key: 'scaleBeforeCompare',
    get: function get() {
      return this._scaleBeforeCompare || true;
    },
    set: function set(value) {
      this._scaleBeforeCompare = value;
    }
  }, {
    key: 'fileVersion',
    get: function get() {
      if (mozillaExp && mozillaExp.length > 0) {
        return mozillaExp[1];
      }
      return -1;
    }
  }, {
    key: 'systemInfo',
    get: function get() {
      var width = window.screen.width * window.devicePixelRatio;
      var height = window.screen.height * window.devicePixelRatio;
      return new _systemInfo.SystemInfo(osName, width + 'x' + height, this.version);
    }
  }, {
    key: 'applicationInfo',
    get: function get() {
      return new _applicationInfo.ApplicationInfo(browserName, firefoxVersion, fileVersion);
    }
  }]);

  return App;
}();

},{"../../../common/services/model/applicationInfo.js":6,"../../../common/services/model/systemInfo.js":13}],20:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EditorHandler = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _qTestContext = require('../../../common/qTestContext.js');

var _messageEnum = require('../../../common/services/model/messageEnum.js');

var _statusEnum = require('../../../common/services/model/statusEnum.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var EditorHandler = exports.EditorHandler = function () {
  function EditorHandler() {
    _classCallCheck(this, EditorHandler);

    this.URL = '../../../common/editor/editor.html';
    this.editorTab = null;
    this.lastActiveTab = null;
  }

  _createClass(EditorHandler, [{
    key: 'activeTab',
    value: function activeTab(tab, reload) {
      this.editorTab = {
        id: tab.id,
        url: tab.url,
        windowId: tab.windowId
      };
      chrome.windows.update(tab.windowId, {
        focused: true
      });
      chrome.tabs.update(tab.id, {
        active: true
      });
      if (reload) {
        chrome.tabs.reload(tab.id);
      }
      return {
        success: true
      };
    }
  }, {
    key: 'handle',
    value: function handle(message) {
      var _this = this;

      return new Promise(async function (resolve) {
        var tab = {};
        if (message.name === _messageEnum.MessageEnum.editCurrentScreen) {
          if (!_qTestContext.QtestContext.currentProcessingScreen) {
            console.log(new Date().toString() + ' handle editCurrentScreen message, but current processing screen is not available');
            resolve({ success: false });
          }
          tab = await _this.findEditorTab();
          if (tab) {
            _this.activeTab(tab, true);
          } else {
            _this.lastActiveTab = null;
            chrome.tabs.query({
              windowId: chrome.windows.WINDOW_ID_CURRENT,
              active: true
            }, function (tabs) {
              if (tabs && tabs.length > 0) {
                tab = tabs[0];
                _this.lastActiveTab = {
                  id: tab.id,
                  url: tab.url,
                  windowId: tab.windowId
                };
                chrome.tabs.create({
                  index: tab.index + 1,
                  url: _this.URL
                }, function (newTab) {
                  resolve(_this.activeTab(newTab, false));
                });
              } else {
                _this.lastActiveTab = null;
                chrome.tabs.create({
                  url: _this.URL
                }, function (newTab) {
                  resolve(_this.activeTab(newTab, false));
                });
              }
            });
          }
        } else if (message.name === _messageEnum.MessageEnum.editorReady) {
          if (_qTestContext.QtestContext.currentProcessingScreen && _this.editorTab) {
            var screen = _qTestContext.QtestContext.currentProcessingScreen.getDrawableData();
            var obj = {
              screen: screen,
              noteTypes: _qTestContext.QtestContext.noteTypes,
              qTestVersion: {
                major: _qTestContext.QtestContext.qTestVersion,
                minor: _qTestContext.QtestContext.qTestMinorVersion
              }
            };
            var dataString = JSON.stringify(obj);
            chrome.tabs.sendMessage(_this.editorTab.id, {
              name: 'currentScreen',
              data: dataString
            }, function (response) {
              _qTestContext.QtestContext.status = {
                name: _statusEnum.StatusEnum.editing
              };
              resolve({ success: true });
            });
          }
        } else if (message.name === _messageEnum.MessageEnum.saveCurrentScreen) {
          _qTestContext.QtestContext.currentProcessingScreen.importData(message.data);
          _qTestContext.QtestContext.status = {
            name: _statusEnum.StatusEnum.recording
          };
          chrome.tabs.sendMessage(_this.editorTab.id, {
            name: 'savedCurrentScreen',
            data: null
          }, function (response) {});
          await _this.closeEditorTab(_this.editorTab.id);
          await _this.activateLastActiveTab(_this.lastActiveTab.id);
          _this.lastActiveTab = null;
          resolve({ success: true });
        } else if (message.name === _messageEnum.MessageEnum.cancelEditCurrentScreen) {
          _qTestContext.QtestContext.status = {
            name: _statusEnum.StatusEnum.recording
          };
          await _this.closeEditorTab(_this.editorTab.id);
          if (_this.lastActiveTab && _this.lastActiveTab.id) {
            await _this.activateLastActiveTab(_this.lastActiveTab.id);
          }
          _this.lastActiveTab = null;
          resolve({ success: true });
        }
      });
    }
  }, {
    key: 'findEditorTab',
    value: async function findEditorTab() {
      return new Promise(function (resolve) {
        chrome.windows.getAll({
          populate: true
        }, function (wnds) {
          var tab = null;
          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = wnds[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var wd = _step.value;

              if (tab) {
                break;
              }
              var _iteratorNormalCompletion2 = true;
              var _didIteratorError2 = false;
              var _iteratorError2 = undefined;

              try {
                for (var _iterator2 = wd.tabs[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                  var tb = _step2.value;

                  if (tb.url.indexOf(EditorHandler.URL_PREFIX) >= 0) {
                    tab = tb;
                    break;
                  }
                }
              } catch (err) {
                _didIteratorError2 = true;
                _iteratorError2 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion2 && _iterator2.return) {
                    _iterator2.return();
                  }
                } finally {
                  if (_didIteratorError2) {
                    throw _iteratorError2;
                  }
                }
              }
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }

          resolve(tab);
        });
      });
    }
  }, {
    key: 'closeEditorTab',
    value: async function closeEditorTab(tabId) {
      return new Promise(function (resolve) {
        chrome.tabs.query({}, function (tabs) {
          if (tabs) {
            var found = false;
            var _iteratorNormalCompletion3 = true;
            var _didIteratorError3 = false;
            var _iteratorError3 = undefined;

            try {
              for (var _iterator3 = tabs[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                var tab = _step3.value;

                if (tab.id === tabId) {
                  found = true;
                  break;
                }
              }
            } catch (err) {
              _didIteratorError3 = true;
              _iteratorError3 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion3 && _iterator3.return) {
                  _iterator3.return();
                }
              } finally {
                if (_didIteratorError3) {
                  throw _iteratorError3;
                }
              }
            }

            if (found) {
              chrome.tabs.remove(tabId, function () {});
            }
          }
          resolve(true);
        });
      });
    }
  }, {
    key: 'activateLastActiveTab',
    value: async function activateLastActiveTab(tabId) {
      return new Promise(function (resolve) {
        chrome.windows.getAll({
          populate: true
        }, function (wnds) {
          var tab = null;
          var _iteratorNormalCompletion4 = true;
          var _didIteratorError4 = false;
          var _iteratorError4 = undefined;

          try {
            for (var _iterator4 = wnds[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
              var wd = _step4.value;

              if (tab) {
                break;
              }
              var _iteratorNormalCompletion5 = true;
              var _didIteratorError5 = false;
              var _iteratorError5 = undefined;

              try {
                for (var _iterator5 = wd.tabs[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
                  var tb = _step5.value;

                  if (tb.id === tabId) {
                    tab = tb;
                    break;
                  }
                }
              } catch (err) {
                _didIteratorError5 = true;
                _iteratorError5 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion5 && _iterator5.return) {
                    _iterator5.return();
                  }
                } finally {
                  if (_didIteratorError5) {
                    throw _iteratorError5;
                  }
                }
              }
            }
          } catch (err) {
            _didIteratorError4 = true;
            _iteratorError4 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion4 && _iterator4.return) {
                _iterator4.return();
              }
            } finally {
              if (_didIteratorError4) {
                throw _iteratorError4;
              }
            }
          }

          if (tab) {
            chrome.windows.update(tab.windowId, {
              focused: true
            });
            chrome.tabs.update(tab.id, {
              active: true
            });
          }
          resolve(true);
        });
      });
    }
  }], [{
    key: 'URL_PREFIX',
    get: function get() {
      return 'moz-extension://' + chrome.i18n.getMessage('@@extension_id');
    }
  }]);

  return EditorHandler;
}();

},{"../../../common/qTestContext.js":1,"../../../common/services/model/messageEnum.js":8,"../../../common/services/model/statusEnum.js":12}],21:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FullPageCapture = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _messageEnum = require('../../../common/services/model/messageEnum.js');

var _statusEnum = require('../../../common/services/model/statusEnum.js');

var _qTestContext = require('../../../common/qTestContext.js');

var _messagingService = require('../../../common/services/messagingService.js');

var _tabManager = require('../../js/background/tabManager.js');

var _screen = require('../../../common/services/model/screen.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var queryParams = {
  windowId: chrome.windows.WINDOW_ID_CURRENT,
  active: true
};

var FullPageCapture = exports.FullPageCapture = function () {
  function FullPageCapture(devicePixelRatio) {
    var _this = this;

    _classCallCheck(this, FullPageCapture);

    this.devicePixelRatio = devicePixelRatio;
    this.isCapturingFullPage = false;
    this.entirePageScreenshot = {
      canvas: null,
      title: '',
      url: '',
      reset: function reset() {
        delete _this.canvas;
        _this.title = '';
        _this.url = '';
      }
    };
  }

  _createClass(FullPageCapture, [{
    key: 'handle',
    value: async function handle(message) {
      return new Promise(async function (resolve) {
        if (message.name === _messageEnum.MessageEnum.captureFullPage) {
          chrome.tabs.query(queryParams, function (tabs) {
            if (tabs && tabs.length > 0 && _tabManager.TabManager.isCapturableTab(tabs[0].url) === true) {
              var tab = tabs[0];
              chrome.tabs.sendMessage(tab.id, {
                name: 'getFullPage'
              }, function () {});
              _qTestContext.QtestContext.status = {
                name: _statusEnum.StatusEnum.capturingFullPage,
                info: {
                  tabId: tab.id,
                  tabUrl: tab.url
                }
              };
              resolve({
                success: true
              });
            } else {
              // eslint-disable-next-line no-alert
              console.log('eXplorer does not have permission to capture this page');
              resolve({
                success: false
              });
            }
          });
        } else if (message.name === _messageEnum.MessageEnum.finishedCaptureFullPage) {
          try {
            var byteCharacters = atob(message.img.substring('data:image/jpeg;base64,'.length));
            var byteNumbers = new Array(byteCharacters.length);
            for (var i = 0; i < byteCharacters.length; i++) {
              byteNumbers[i] = byteCharacters.charCodeAt(i);
            }
            var timeStamp = new Date().getTime();
            if (_qTestContext.QtestContext.currentProcessingScreen) {
              var newScreen = _qTestContext.QtestContext.currentProcessingScreen;
              _qTestContext.QtestContext.session.pushScreen(newScreen, timeStamp);
              var messagingService = new _messagingService.MessagingService(_qTestContext.QtestContext.user.apiURL, _qTestContext.QtestContext.user.token);
              messagingService.startSendingAllScreen();
              _qTestContext.QtestContext.currentProcessingScreen = null;
            }
            var screen = new _screen.Screen(message.title, message.url, byteNumbers);
            screen.forceCaptured = true;
            screen.width = message.width;
            screen.height = message.height;
            screen.timeStamp = timeStamp;
            var pendingAnnots = _qTestContext.QtestContext.pendingAnnotations;
            if (pendingAnnots && pendingAnnots.length > 0) {
              var _iteratorNormalCompletion = true;
              var _didIteratorError = false;
              var _iteratorError = undefined;

              try {
                for (var _iterator = pendingAnnots[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                  var annotation = _step.value;

                  screen.annotations.push(annotation);
                }
              } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion && _iterator.return) {
                    _iterator.return();
                  }
                } finally {
                  if (_didIteratorError) {
                    throw _iteratorError;
                  }
                }
              }

              _qTestContext.QtestContext.pendingAnnotations = [];
            }
            _qTestContext.QtestContext.currentProcessingScreen = screen;
            _qTestContext.QtestContext.status = {
              name: _statusEnum.StatusEnum.recording
            };
            resolve({
              success: true
            });
            return;
          } catch (error) {
            console.log('qTest Web eXplorer cannot capture current page.', error);
            _qTestContext.QtestContext.status = {
              name: _statusEnum.StatusEnum.recording
            };
            resolve({
              success: false
            });
          }
        }
      });
    }
  }]);

  return FullPageCapture;
}();

},{"../../../common/qTestContext.js":1,"../../../common/services/messagingService.js":3,"../../../common/services/model/messageEnum.js":8,"../../../common/services/model/screen.js":10,"../../../common/services/model/statusEnum.js":12,"../../js/background/tabManager.js":22}],22:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TabManager = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _qTestContext = require('../../../common/qTestContext.js');

var _statusEnum = require('../../../common/services/model/statusEnum.js');

var _messageEnum = require('../../../common/services/model/messageEnum.js');

var _editorHandler = require('../background/editorHandler.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TabManager = exports.TabManager = function () {
  function TabManager() {
    _classCallCheck(this, TabManager);
  }

  _createClass(TabManager, null, [{
    key: 'isCapturableTab',
    value: function isCapturableTab(tabUrl) {
      // eslint-disable-next-line no-undef
      if (!tabUrl || tabUrl.length === 0 || tabUrl.match(/(chrome):\/\//gi) || tabUrl.match(/(opera):\/\//gi) || tabUrl.match(/(chrome-extension):\/\//gi) || tabUrl.match(/(chrome-devtools):\/\//gi) || tabUrl.indexOf('about:') >= 0 || tabUrl.indexOf(_editorHandler.EditorHandler.URL_PREFIX) === 0) {
        return false;
      }
      if (_qTestContext.QtestContext.session) {
        if (tabUrl.indexOf(_qTestContext.QtestContext.session.redirectUrl) === 0 || tabUrl.indexOf(_qTestContext.QtestContext.session.url) === 0) {
          return false;
        }
        if (_qTestContext.QtestContext.domainOptions.all) {
          return true;
        }
        if (_qTestContext.QtestContext.domainOptions.include) {
          if (_qTestContext.QtestContext.domainOptions.domains.length === 0) {
            return false;
          }
          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = _qTestContext.QtestContext.domainOptions.domains[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var domain = _step.value;

              if (tabUrl.length >= domain.length && tabUrl.indexOf(domain) >= 0) {
                return true;
              }
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }

          return false;
        } else if (_qTestContext.QtestContext.domainOptions.exclude) {
          if (_qTestContext.QtestContext.domainOptions.domains.length === 0) {
            return true;
          }
          var _iteratorNormalCompletion2 = true;
          var _didIteratorError2 = false;
          var _iteratorError2 = undefined;

          try {
            for (var _iterator2 = _qTestContext.QtestContext.domainOptions.domains[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
              var _domain = _step2.value;

              if (tabUrl.length >= _domain.length && tabUrl.indexOf(_domain) >= 0) {
                return false;
              }
            }
          } catch (err) {
            _didIteratorError2 = true;
            _iteratorError2 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion2 && _iterator2.return) {
                _iterator2.return();
              }
            } finally {
              if (_didIteratorError2) {
                throw _iteratorError2;
              }
            }
          }

          return true;
        }
      }
      return true;
    }
  }, {
    key: 'isExisting',
    value: function isExisting(domains, domainString) {
      if (domains.length === 0) {
        return false;
      }
      var _iteratorNormalCompletion3 = true;
      var _didIteratorError3 = false;
      var _iteratorError3 = undefined;

      try {
        for (var _iterator3 = domains[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
          var domain = _step3.value;

          if (domain.toLowerCase() === domainString.toLowerCase()) {
            return true;
          }
        }
      } catch (err) {
        _didIteratorError3 = true;
        _iteratorError3 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion3 && _iterator3.return) {
            _iterator3.return();
          }
        } finally {
          if (_didIteratorError3) {
            throw _iteratorError3;
          }
        }
      }

      return false;
    }
  }, {
    key: 'getOpeningDomains',
    value: function getOpeningDomains() {
      var _this = this;

      return new Promise(function (resolve) {
        var domains = [];
        return chrome.windows.getAll({
          populate: true
        }, function (wnds) {
          var _iteratorNormalCompletion4 = true;
          var _didIteratorError4 = false;
          var _iteratorError4 = undefined;

          try {
            for (var _iterator4 = wnds[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
              var wd = _step4.value;
              var _iteratorNormalCompletion5 = true;
              var _didIteratorError5 = false;
              var _iteratorError5 = undefined;

              try {
                for (var _iterator5 = wd.tabs[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
                  var tb = _step5.value;

                  if (tb.url && _this.isCapturableTab(tb.url)) {
                    var domain = new URL(tb.url).hostname.trim();
                    if (domain !== '' && !_this.isExisting(domains, domain)) {
                      domains.push(domain.toLowerCase());
                    }
                  }
                }
              } catch (err) {
                _didIteratorError5 = true;
                _iteratorError5 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion5 && _iterator5.return) {
                    _iterator5.return();
                  }
                } finally {
                  if (_didIteratorError5) {
                    throw _iteratorError5;
                  }
                }
              }
            }
          } catch (err) {
            _didIteratorError4 = true;
            _iteratorError4 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion4 && _iterator4.return) {
                _iterator4.return();
              }
            } finally {
              if (_didIteratorError4) {
                throw _iteratorError4;
              }
            }
          }

          resolve(domains);
        });
      });
    }
  }, {
    key: 'registerTabEvents',
    value: function registerTabEvents(register) {
      var _this2 = this;

      this.onCreated = function (tab) {
        if (_this2.isCapturableTab(tab.url)) {
          if (_qTestContext.QtestContext.status.name === _statusEnum.StatusEnum.recording) {
            _this2.updateTabCaptureState(tab.id, 1);
          } else if (_qTestContext.QtestContext.status.name === _statusEnum.StatusEnum.paused) {
            _this2.updateTabCaptureState(tab.id, 2);
          }
        }
      };
      this.onAttached = function (tabId, attachInfo) {};
      this.onDetached = function (tabId, detachInfo) {};
      this.onActivated = function (activeInfo) {
        console.log(new Date().toString() + ' tab activated - tabId: ' + activeInfo.tabId + ', windowId: ' + activeInfo.windowId);
        return chrome.tabs.get(activeInfo.tabId, function (tab) {
          if (tab) {
            _this2.detectCapturableTab(tab);
            if (_this2.isActiveTabCapturable) {
              _this2.sendMessageToQueryDevicePixelRatio(activeInfo.tabId);
            }
          }
        });
      };
      this.onZoomChange = function (zoomChangeInfo) {
        console.log(new Date().toString() + ' zoom changed - tabId: \n      ' + zoomChangeInfo.tabId + ', oldZoomFactor: ' + zoomChangeInfo.oldZoomFactor + ', \n      newZoomFactor: ' + zoomChangeInfo.newZoomFactor);
        if (zoomChangeInfo.oldZoomFactor !== zoomChangeInfo.newZoomFactor) {
          _this2.activeTabDevicePixelRatio = zoomChangeInfo.newZoomFactor;
        }
      };
      this.onFocusChanged = function (windowId) {
        if (windowId !== chrome.windows.WINDOW_ID_NONE) {
          chrome.tabs.query({
            windowId: windowId,
            active: true
          }, function (tabs) {
            if ((tabs ? tabs.length : undefined) > 0) {
              _this2.detectCapturableTab(tabs[0]);
              if (_this2.isActiveTabCapturable) {
                _this2.sendMessageToQueryDevicePixelRatio(tabs[0].id);
              }
            }
          });
        }
      };
      if (register) {
        console.log(new Date().toString() + ' register tab events...');
        chrome.tabs.onCreated.addListener(this.onCreated);
        chrome.tabs.onAttached.addListener(this.onAttached);
        chrome.tabs.onDetached.addListener(this.onDetached);
        chrome.tabs.onActivated.addListener(this.onActivated);
        chrome.tabs.onZoomChange.addListener(this.onZoomChange);
        chrome.windows.onFocusChanged.addListener(this.onFocusChanged);
        chrome.tabs.query({
          windowId: chrome.windows.WINDOW_ID_CURRENT,
          active: true
        }, function (tabs) {
          if ((tabs ? tabs.length : undefined) > 0) {
            _this2.detectCapturableTab(tabs[0]);
            if (_this2.isActiveTabCapturable) {
              _this2.sendMessageToQueryDevicePixelRatio(tabs[0].id);
            }
          } else {
            console.log(new Date().toString() + ' unregister tab events...');
            chrome.tabs.onCreated.removeListener(_this2.onCreated);
            chrome.tabs.onAttached.removeListener(_this2.onAttached);
            chrome.tabs.onDetached.removeListener(_this2.onDetached);
            chrome.tabs.onActivated.removeListener(_this2.onActivated);
            chrome.tabs.onZoomChange.removeListener(_this2.onZoomChange);
            chrome.windows.onFocusChanged.removeListener(_this2.onFocusChanged);
            _this2.isActiveTabCapturable = false;
            _this2.canCaptureFullPageOfActiveTab = false;
          }
        });
      }
    }
  }, {
    key: 'detectCapturableTab',
    value: function detectCapturableTab(tab) {
      if (tab ? tab.url : undefined) {
        this.isActiveTabCapturable = this.isCapturableTab(tab.url);
        this.canCaptureFullPageOfActiveTab = this.isActiveTabCapturable;
        console.log(new Date().toString() + ' tab \'' + tab.url + '\' is capturable: ' + this.isActiveTabCapturable);
      }
    }
  }, {
    key: 'updateTabCaptureState',
    value: function updateTabCaptureState(tabId, state) {
      var msg = {
        name: 'initCapture',
        state: state,
        defaultDevicePixelRatio: this.defaultDevicePixelRatio
      };
      try {
        return chrome.tabs.sendMessage(tabId, msg, function (response) {});
      } catch (error) {
        return console.log(error);
      }
    }
  }, {
    key: 'sendMessageToQueryDevicePixelRatio',
    value: async function sendMessageToQueryDevicePixelRatio(tabId) {
      var _this3 = this;

      try {
        await chrome.tabs.sendMessage(tabId, {
          name: _messageEnum.MessageEnum.devicePixelRatio
        }, function (response) {
          if (response ? response.devicePixelRatio : undefined) {
            console.log(new Date().toString() + ' current tab\'s devicePixelRatio: ' + response.devicePixelRatio);
            _this3.activeTabDevicePixelRatio = response.devicePixelRatio;
          }
        });
      } catch (error) {
        console.log(error);
      }
    }
  }, {
    key: 'sendUpdateTabCaptureState',
    value: async function sendUpdateTabCaptureState(state) {
      var _this4 = this;

      await chrome.windows.getAll({
        populate: true
      }, async function (wnds) {
        var _iteratorNormalCompletion6 = true;
        var _didIteratorError6 = false;
        var _iteratorError6 = undefined;

        try {
          for (var _iterator6 = wnds[Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
            var wd = _step6.value;
            var _iteratorNormalCompletion7 = true;
            var _didIteratorError7 = false;
            var _iteratorError7 = undefined;

            try {
              for (var _iterator7 = wd.tabs[Symbol.iterator](), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
                var tb = _step7.value;

                if (tb.url.indexOf(_editorHandler.EditorHandler.URL_PREFIX < 0)) {
                  try {
                    _this4.updateTabCaptureState(tb.id, state);
                  } catch (error) {
                    console.log(new Date().toString() + ' updateTabCaptureState for tab ' + tb.id + ' | ' + tb.url + ' failed: ' + error);
                  }
                }
              }
            } catch (err) {
              _didIteratorError7 = true;
              _iteratorError7 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion7 && _iterator7.return) {
                  _iterator7.return();
                }
              } finally {
                if (_didIteratorError7) {
                  throw _iteratorError7;
                }
              }
            }
          }
        } catch (err) {
          _didIteratorError6 = true;
          _iteratorError6 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion6 && _iterator6.return) {
              _iterator6.return();
            }
          } finally {
            if (_didIteratorError6) {
              throw _iteratorError6;
            }
          }
        }
      });
    }
  }, {
    key: 'showAlert',
    value: function showAlert(tabId, errorMessage) {
      var msg = {
        name: 'showError',
        error: errorMessage
      };
      try {
        chrome.tabs.sendMessage(tabId, msg);
      } catch (error) {
        console.log(error);
      }
    }
  }, {
    key: 'openSessionReview',
    value: function openSessionReview(url, redirectUrl, createIfNotExists) {
      chrome.windows.getAll({
        populate: true
      }, function (wnds) {
        var tab = null;
        var _iteratorNormalCompletion8 = true;
        var _didIteratorError8 = false;
        var _iteratorError8 = undefined;

        try {
          for (var _iterator8 = wnds[Symbol.iterator](), _step8; !(_iteratorNormalCompletion8 = (_step8 = _iterator8.next()).done); _iteratorNormalCompletion8 = true) {
            var wd = _step8.value;

            if (tab) {
              break;
            }
            var _iteratorNormalCompletion9 = true;
            var _didIteratorError9 = false;
            var _iteratorError9 = undefined;

            try {
              for (var _iterator9 = wd.tabs[Symbol.iterator](), _step9; !(_iteratorNormalCompletion9 = (_step9 = _iterator9.next()).done); _iteratorNormalCompletion9 = true) {
                var tb = _step9.value;

                if (tb.url.indexOf(redirectUrl) === 0) {
                  tab = tb;
                  break;
                }
              }
            } catch (err) {
              _didIteratorError9 = true;
              _iteratorError9 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion9 && _iterator9.return) {
                  _iterator9.return();
                }
              } finally {
                if (_didIteratorError9) {
                  throw _iteratorError9;
                }
              }
            }
          }
        } catch (err) {
          _didIteratorError8 = true;
          _iteratorError8 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion8 && _iterator8.return) {
              _iterator8.return();
            }
          } finally {
            if (_didIteratorError8) {
              throw _iteratorError8;
            }
          }
        }

        if (tab) {
          chrome.windows.update(tab.windowId, {
            focused: true
          });
          chrome.tabs.update(tab.id, {
            url: url,
            active: true
          });
        } else if (createIfNotExists) {
          chrome.tabs.query({
            windowId: chrome.windows.WINDOW_ID_CURRENT,
            active: true
          }, function (tabs) {
            if (tabs && tabs.length > 0) {
              tab = tabs[0];
              chrome.tabs.create({
                index: tab.index + 1,
                url: url
              }, function () {});
            } else {
              chrome.tabs.create({
                url: url
              }, function () {});
            }
          });
        }
      });
    }
  }, {
    key: 'activeTabDevicePixelRatio',
    get: function get() {
      return this._activeTabDevicePixelRatio || 1;
    },
    set: function set(value) {
      this._activeTabDevicePixelRatio = value;
    }
  }, {
    key: 'defaultDevicePixelRatio',
    get: function get() {
      return this._defaultDevicePixelRatio || null;
    },
    set: function set(value) {
      this._defaultDevicePixelRatio = value;
    }
  }, {
    key: 'isActiveTabCapturable',
    get: function get() {
      if (this._isActiveTabCapturable === undefined) {
        return true;
      }
      return this._isActiveTabCapturable;
    },
    set: function set(value) {
      this._isActiveTabCapturable = value;
    }
  }, {
    key: 'canCaptureFullPageOfActiveTab',
    get: function get() {
      if (this._canCaptureFullPageOfActiveTabs === undefined) {
        return true;
      }
      return this._canCaptureFullPageOfActiveTabs;
    },
    set: function set(value) {
      this._canCaptureFullPageOfActiveTab = value;
    }
  }]);

  return TabManager;
}();

},{"../../../common/qTestContext.js":1,"../../../common/services/model/messageEnum.js":8,"../../../common/services/model/statusEnum.js":12,"../background/editorHandler.js":20}]},{},[21]);
