(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var MessageEnum = exports.MessageEnum = {
  getStatus: 'getStatus',

  login: 'login',

  logout: 'logout',

  getSessions: 'getSessions',

  startSession: 'startSession',

  viewSession: 'viewSession',

  completeSession: 'completeSession',

  addNote: 'addNote',

  switchTimetype: 'switchTimetype',

  keyEvent: 'keyEvent',

  clickEvent: 'clickEvent',

  takeSnapshot: 'takeSnapshot',

  modalDialog: 'modalDialog',

  devicePixelRatio: 'devicePixelRatio',

  toggleRecordingStatus: 'toggleRecordingStatus',

  captureVisiblePart: 'captureVisiblePart',

  captureFullPage: 'captureFullPage',

  captureScrollingPage: 'captureScrollingPage',

  finishedScrolling: 'finishedScrolling',

  finishedCaptureFullPage: 'finishedCaptureFullPage',

  discardScrollingCapture: 'discardScrollingCapture',

  openUrl: 'openUrl',

  editCurrentScreen: 'editCurrentScreen',

  editorReady: 'editorReady',

  saveCurrentScreen: 'saveCurrentScreen',

  cancelEditCurrentScreen: 'cancelEditCurrentScreen',

  confirmMediaPermission: 'confirmMediaPermission',

  deniedMediaPermission: 'deniedMediaPermission',

  cancelledMediaPermission: 'cancelledMediaPermission',

  recordMedia: 'recordMedia',

  stopRecordMedia: 'stopRecordMedia',

  cancelRecordMedia: 'cancelRecordMedia',

  showSettings: 'showSettings',

  getSettings: 'getSettings',

  saveSettings: 'saveSettings',

  cancelSaveSettings: 'cancelSaveSettings',

  closeSettings: 'closeSettings',

  openCommandsConfiguration: 'openCommandsConfiguration',

  startSessionFromqTest: 'startSessionFromqTest',

  currentqTestSession: 'currentqTestSession',

  getCurrentqTestSession: 'getCurrentqTestSession',

  getOpeningDomains: 'getOpeningDomains',

  getAutoStartData: 'getAutoStartData',

  autoStartDisableConfirm: 'autoStartDisableConfirm',

  startAutoStartSession: 'startAutoStartSession',

  removeAutoStartDialog: 'remove-web-explorer-confirm-start-always-on-session-dialog',

  removeStartSessionDialog: 'remove-web-explorer-start-session-dialog'
};

},{}],2:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AutoStartConfirmViewModel = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _messageEnum = require('../../../common/services/model/messageEnum');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var AutoStartConfirmViewModel = exports.AutoStartConfirmViewModel = function () {
  _createClass(AutoStartConfirmViewModel, null, [{
    key: 'ensureZeroPrefix',
    value: function ensureZeroPrefix(number) {
      if (number < 10) {
        return '0' + number;
      }
      return String(number);
    }
  }]);

  function AutoStartConfirmViewModel() {
    _classCallCheck(this, AutoStartConfirmViewModel);

    // eslint-disable-next-line no-undef
    this.$form = $('#startSessionForm');
    this.$fieldSet = this.$form.find('#startSessionFormFields');
    // eslint-disable-next-line no-undef
    this.progressStartSession = $('#progressStartSession');
    // eslint-disable-next-line no-undef
    this.chkNotNotifyAgain = $('#notNotifyAgain')[0];
    // eslint-disable-next-line no-undef
    this.errorMessage = $('.errorMessage');
    this.openerDomain = location.search.split('url=')[1];
    this.hasNewSize = false;
    this.tester_nameMsg = 0;
    this.tester_emailMsg = 0;
  }

  _createClass(AutoStartConfirmViewModel, [{
    key: 'onBtnYesClicked',
    value: function onBtnYesClicked() {
      var _this = this;

      var newHeight = this.height + 21;
      if (!this.hasNewSize) {
        parent.window.postMessage({
          name: 'resize-web-explorer-confirm-start-always-on-session-dialog',
          height: newHeight
        }, '*');
        this.height = newHeight;
        this.hasNewSize = true;
      }
      this.errorMessage.hide();
      this.progressStartSession.show();
      var today = new Date();
      var title = this.openerDomain + '_' + today.getFullYear() + AutoStartConfirmViewModel.ensureZeroPrefix(today.getMonth() + 1) + AutoStartConfirmViewModel.ensureZeroPrefix(today.getDate()) + '_' + AutoStartConfirmViewModel.ensureZeroPrefix(today.getHours()) + AutoStartConfirmViewModel.ensureZeroPrefix(today.getMinutes()) + AutoStartConfirmViewModel.ensureZeroPrefix(today.getSeconds());
      var canvas = document.createElementNS('http://www.w3.org/1999/xhtml', 'html:canvas');
      var ctx = canvas.getContext('2d');
      var backingStoreRatio = ctx.webkitBackingStorePixelRatio || ctx.mozBackingStorePixelRatio || ctx.msBackingStorePixelRatio || ctx.oBackingStorePixelRatio || ctx.backingStorePixelRatio || 1;
      var devicePixelRatio = window.devicePixelRatio || 1;
      var ratio = devicePixelRatio / backingStoreRatio;
      var message = {
        currentDomain: this.openerDomain,
        name: 'startAutoStartSession',
        notNotifyAgain: this.chkNotNotifyAgain.checked,
        title: title,
        description: '',
        id: null,
        isRunExisting: false,
        plannedDuration: {
          hour: '1',
          min: '30'
        },
        defaultDevicePixelRatio: ratio
      };
      chrome.runtime.sendMessage(browser.runtime.id, message, function (response) {
        if (response.success) {
          _this.progressStartSession.hide();
          parent.window.postMessage({
            name: _messageEnum.MessageEnum.removeAutoStartDialog
          }, '*');
        }
        _this.progressStartSession.hide();
        _this.errorMessage.show();
        var msgError = _this.handleError(response.error);
        _this.errorMessage.text(msgError);
      });
    }
  }, {
    key: 'handleError',
    value: function handleError(error) {
      var msgError = '';
      if (!error.status) {
        msgError = error;
      } else if (error.status === 404) {
        msgError = 'Error creating session: Server not found or session was deleted.';
      } else if (error.status === 403) {
        msgError = 'Error creating session: You don\'t have permission for creating session.';
      } else if (error.status === 409 || error.status === 412) {
        msgError = 'Error creating session: session is out of date.';
      } else if (error.status === 500) {
        msgError = 'Error creating session. Please contact Tricentis.';
      } else if (error.status === 0) {
        msgError = 'Web eXplorer is processing other operations. Please try again later.';
      } else {
        msgError = 'Error creating session: ' + error.status + '. Please contact Tricentis.';
      }
      return msgError;
    }
  }, {
    key: 'show',
    value: function show() {
      var _this2 = this;

      var doc = document;
      var body = doc.body;
      var html = doc.documentElement;
      this.progressStartSession.hide();
      this.height = Math.max(body.scrollHeight, body.offsetHeight, html.clientHeight, html.scrollHeight, html.offsetHeight);
      parent.window.postMessage({
        name: 'resize-web-explorer-confirm-start-always-on-session-dialog',
        height: this.height
      }, '*');
      // eslint-disable-next-line no-undef
      $('#btnNo').on('click', function () {
        if (_this2.chkNotNotifyAgain.checked) {
          chrome.runtime.sendMessage({
            name: 'autoStartDisableConfirm',
            currentDomain: _this2.openerDomain
          });
        }
        parent.window.postMessage({
          name: _messageEnum.MessageEnum.removeAutoStartDialog
        }, '*');
      });
      // eslint-disable-next-line no-undef
      $('#btnYes').on('click', function () {
        _this2.$fieldSet.attr('disabled', 'disabled');
        _this2.onBtnYesClicked();
        _this2.$fieldSet.removeAttr('disabled');
      });
    }
  }]);

  return AutoStartConfirmViewModel;
}();

// eslint-disable-next-line no-undef


$(function () {
  var viewModel = new AutoStartConfirmViewModel();
  viewModel.show();
});

},{"../../../common/services/model/messageEnum":1}]},{},[2]);
