(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var MessageEnum = exports.MessageEnum = {
  getStatus: 'getStatus',

  login: 'login',

  logout: 'logout',

  getSessions: 'getSessions',

  startSession: 'startSession',

  viewSession: 'viewSession',

  completeSession: 'completeSession',

  addNote: 'addNote',

  switchTimetype: 'switchTimetype',

  keyEvent: 'keyEvent',

  clickEvent: 'clickEvent',

  takeSnapshot: 'takeSnapshot',

  modalDialog: 'modalDialog',

  devicePixelRatio: 'devicePixelRatio',

  toggleRecordingStatus: 'toggleRecordingStatus',

  captureVisiblePart: 'captureVisiblePart',

  captureFullPage: 'captureFullPage',

  captureScrollingPage: 'captureScrollingPage',

  finishedScrolling: 'finishedScrolling',

  finishedCaptureFullPage: 'finishedCaptureFullPage',

  discardScrollingCapture: 'discardScrollingCapture',

  openUrl: 'openUrl',

  editCurrentScreen: 'editCurrentScreen',

  editorReady: 'editorReady',

  saveCurrentScreen: 'saveCurrentScreen',

  cancelEditCurrentScreen: 'cancelEditCurrentScreen',

  confirmMediaPermission: 'confirmMediaPermission',

  deniedMediaPermission: 'deniedMediaPermission',

  cancelledMediaPermission: 'cancelledMediaPermission',

  recordMedia: 'recordMedia',

  stopRecordMedia: 'stopRecordMedia',

  cancelRecordMedia: 'cancelRecordMedia',

  showSettings: 'showSettings',

  getSettings: 'getSettings',

  saveSettings: 'saveSettings',

  cancelSaveSettings: 'cancelSaveSettings',

  closeSettings: 'closeSettings',

  openCommandsConfiguration: 'openCommandsConfiguration',

  startSessionFromqTest: 'startSessionFromqTest',

  currentqTestSession: 'currentqTestSession',

  getCurrentqTestSession: 'getCurrentqTestSession',

  getOpeningDomains: 'getOpeningDomains',

  getAutoStartData: 'getAutoStartData',

  autoStartDisableConfirm: 'autoStartDisableConfirm',

  startAutoStartSession: 'startAutoStartSession',

  removeAutoStartDialog: 'remove-web-explorer-confirm-start-always-on-session-dialog',

  removeStartSessionDialog: 'remove-web-explorer-start-session-dialog'
};

},{}],2:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StartSessionFromqTestViewModel = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _messageEnum = require('../../../common/services/model/messageEnum');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var StartSessionFromqTestViewModel = exports.StartSessionFromqTestViewModel = function () {
  function StartSessionFromqTestViewModel(inProgress) {
    _classCallCheck(this, StartSessionFromqTestViewModel);

    this.inProgress = inProgress;
    this.allProjectSessions = [];
    this.allProjects = [];
    this.domainOptions = null;
    this.originalHeight = null;
    // eslint-disable-next-line no-undef
    this.$form = $('#startSessionForm');
    // eslint-disable-next-line no-undef
    this.$tester = $('#tester');
    // eslint-disable-next-line no-undef
    this.$fieldSet = this.$form.find('#startSessionFormFields');
    // eslint-disable-next-line no-undef
    this.$projectName = $('#project-name');
    // eslint-disable-next-line no-undef
    this.$sessionTitle = $('#session-title');
    // eslint-disable-next-line no-undef
    this.$sessionDescription = this.$form.find('#session-desc');
    // eslint-disable-next-line no-undef
    this.$plannedDurationHour = this.$form.find('#plannedDuration-hour');
    // eslint-disable-next-line no-undef
    this.$plannedDurationMin = this.$form.find('#plannedDuration-min');
    // eslint-disable-next-line no-undef
    this.$progressStartSession = this.$form.find('#progressStartSession');
    // eslint-disable-next-line no-undef
    this.$startSessionBtn = this.$form.find('#startSessionBtn');
    // eslint-disable-next-line no-undef
    this.$cancelStartSessionBtn = this.$form.find('#cancelStartSessionBtn');
    // eslint-disable-next-line no-undef
    this.$errorMessage = this.$form.find('.errorMessage');
    // eslint-disable-next-line no-undef
    this.$domainFilterGroup = this.$form.find('input[name=domainFilter]');
    // eslint-disable-next-line no-undef
    this.$domainEditContainer = this.$form.find('#domainEditContainer');
    // eslint-disable-next-line no-undef
    this.$domainFilterEdit = this.$form.find('#domainFilterEdit');
    this.dataContext = {
      projectId: null,
      projectName: null,
      sessionId: null,
      sessionTitle: null,
      email: null,
      qTestUrl: null,
      apiUrl: null,
      plannedDuration: null,
      domains: null
    };
  }

  _createClass(StartSessionFromqTestViewModel, [{
    key: 'show',
    value: function show(data) {
      if (data) {
        var session = data.session;
        var domains = data.domains;
        this.dataContext.projectId = session.projectId;
        this.dataContext.projectName = session.projectName;
        this.dataContext.sessionId = session.sessionId;
        this.dataContext.sessionTitle = session.sessionTitle;
        this.dataContext.sessionDesc = session.sessionDesc;
        this.dataContext.email = session.email;
        this.dataContext.qTestUrl = session.qtestUrl;
        this.dataContext.apiUrl = session.apiUrl;
        this.dataContext.token = session.token;
        this.dataContext.plannedDuration = session.plannedDuration;
        if (this.dataContext.email.length <= 36) {
          this.$tester.text(this.dataContext.email);
        } else {
          this.$tester.text(this.dataContext.email.substring(0, 32) + '...');
        }
        this.$projectName.val(String(this.dataContext.projectName));
        this.$sessionTitle.val(this.dataContext.sessionTitle);
        this.$sessionDescription.val(this.dataContext.sessionDesc);
        // eslint-disable-next-line func-names
        var ensureZeroPrefix = function ensureZeroPrefix(number) {
          if (number < 10) {
            return '0' + number;
          }
          return String(number);
        };
        this.$plannedDurationHour.val(ensureZeroPrefix(this.dataContext.plannedDuration.hour));
        this.$plannedDurationMin.val(ensureZeroPrefix(this.dataContext.plannedDuration.min));
        this.dataContext.domainOptions = {
          all: true,
          include: false,
          exclude: false,
          domains: domains
        };
        var value = 'noFilter';
        this.$domainEditContainer.hide();
        var radio = this.$form.find('input:radio[name=domainFilter][value=' + value + ']');
        radio.attr('checked', true);
        this.$domainFilterEdit.val(domains.join(' '));
        this.$fieldSet.removeAttr('disabled');
        this.$progressStartSession.hide();
        this.originalHeight = this.getMaxHeight();
        this.bindEvents();
      }
      console.log(new Date().toString() + ' Error: data is null');
    }
  }, {
    key: 'bindEvents',
    value: function bindEvents() {
      var _this = this;

      var parsleyForm = this.$form.parsley();
      parsleyForm.subscribe('parsley:form:validate', function (formInstance) {
        formInstance.submitEvent.preventDefault();
        var validatePlannedDuration = function validatePlannedDuration() {
          var $parsleyPlannedDuration = _this.$form.find('#parsley-plannedDuration');
          var valid = /^[0-9]+$/.test(_this.$plannedDurationHour.val());
          if (valid === false) {
            _this.$plannedDurationHour.parent().addClass('has-error');
            $parsleyPlannedDuration.find('.parsley-required').text('Hour(s) must be a valid number');
            $parsleyPlannedDuration.show();
          } else {
            _this.$plannedDurationHour.parent().removeClass('has-error');
            $parsleyPlannedDuration.hide();
            valid = /^[0-9]+$/.test(_this.$plannedDurationMin.val());
            if (valid === false) {
              _this.$plannedDurationMin.parent().addClass('has-error');
              $parsleyPlannedDuration.find('.parsley-required').text('Minute(s) must be a valid number');
              $parsleyPlannedDuration.show();
            } else {
              _this.$plannedDurationMin.parent().removeClass('has-error');
              $parsleyPlannedDuration.hide();
            }
          }
          if (valid) {
            var hour = parseInt(_this.$plannedDurationHour.val(), 10);
            var min = parseInt(_this.$plannedDurationMin.val(), 10);
            if (hour === 0 && min === 0) {
              _this.$plannedDurationHour.val('01');
              _this.$plannedDurationMin.val('30');
            }
          }
          return valid;
        };
        if (formInstance.isValid('', false) && validatePlannedDuration()) {
          _this.$errorMessage.hide();
          _this.$fieldSet.attr('disabled', 'disabled');
          _this.$progressStartSession.show();
          _this.resize();
          var domainOptions = {
            all: true,
            include: false,
            exclude: false,
            domains: []
          };
          var domainFilter = _this.$form.find('input[name=domainFilter]:checked');
          var domainFilterVal = domainFilter.val();
          if (domainFilterVal !== 'noFilter') {
            var domains = [];
            var existing = function existing(domainString) {
              if (domains.length === 0) {
                return false;
              }
              var _iteratorNormalCompletion = true;
              var _didIteratorError = false;
              var _iteratorError = undefined;

              try {
                for (var _iterator = domains[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                  var domain = _step.value;

                  if (domain.toLowerCase() === domainString.toLowerCase()) {
                    return true;
                  }
                }
              } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion && _iterator.return) {
                    _iterator.return();
                  }
                } finally {
                  if (_didIteratorError) {
                    throw _iteratorError;
                  }
                }
              }

              return false;
            };
            var selectedDomains = _this.$domainFilterEdit.val().split(' ');
            if (selectedDomains.length > 0) {
              var _iteratorNormalCompletion2 = true;
              var _didIteratorError2 = false;
              var _iteratorError2 = undefined;

              try {
                for (var _iterator2 = selectedDomains[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                  var selectedDomain = _step2.value;

                  var domainString = selectedDomain.trim();
                  if (domainString !== '' && existing(domainString) === false) {
                    domains.push(domainString);
                  }
                }
              } catch (err) {
                _didIteratorError2 = true;
                _iteratorError2 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion2 && _iterator2.return) {
                    _iterator2.return();
                  }
                } finally {
                  if (_didIteratorError2) {
                    throw _iteratorError2;
                  }
                }
              }
            }
            domainOptions = {
              all: false,
              include: domainFilterVal === 'include',
              exclude: domainFilterVal === 'exclude',
              domains: domains
            };
          }
          var canvas = document.createElementNS('http://www.w3.org/1999/xhtml', 'html:canvas');
          var ctx = canvas.getContext('2d');
          var backingStoreRatio = ctx.webkitBackingStorePixelRatio || ctx.mozBackingStorePixelRatio || ctx.msBackingStorePixelRatio || ctx.oBackingStorePixelRatio || ctx.backingStorePixelRatio || 1;
          var devicePixelRatio = window.devicePixelRatio || 1;
          var ratio = devicePixelRatio / backingStoreRatio;
          chrome.runtime.sendMessage({
            name: _messageEnum.MessageEnum.startSessionFromqTest,
            project: _this.dataContext.projectId,
            session: _this.dataContext.sessionId,
            title: _this.dataContext.sessionTitle,
            description: _this.$sessionDescription.val(),
            url: _this.dataContext.qTestUrl,
            token: _this.dataContext.token,
            apiURL: _this.dataContext.apiUrl,
            plannedDuration: {
              hour: _this.$plannedDurationHour.val(),
              min: _this.$plannedDurationMin.val()
            },
            tester: _this.dataContext.email,
            domainOptions: domainOptions,
            defaultDevicePixelRatio: ratio
          }, function (response) {
            _this.$progressStartSession.hide();
            if (response.success) {
              _this.close();
              return;
            }
            var errorMsg = 'Error starting session.';
            if (response.error.status) {
              if (response.error.status === 404) {
                errorMsg = 'Error starting session: Server not found or session was deleted.';
              } else if (response.error.status === 409 || response.error.status === 412) {
                errorMsg = 'Error starting session: session is out of date.';
              } else if (response.error.status === 500) {
                errorMsg = 'Error starting session. Please contact Tricentis.';
              } else {
                errorMsg = 'Error starting session: ' + response.error.status + '. Please contact Tricentis.';
              }
            } else if (response.error) {
              errorMsg = response.error;
            }
            _this.showError(errorMsg, 1500);
            _this.$fieldSet.removeAttr('disabled');
          });
        }
      });
      this.$plannedDurationHour.on('keydown', this.onNumericTextboxKeydown);
      this.$plannedDurationMin.on('keydown', this.onNumericTextboxKeydown);
      this.$sessionTitle.on('keyup', function () {
        if (_this.$sessionTitle.val() !== '') {
          _this.$startSessionBtn.removeAttr('disabled');
        } else {
          _this.$startSessionBtn.attr('disabled', 'disabled');
        }
        _this.dataContext.sessionTitle = _this.$sessionTitle.val();
      });
      this.$domainFilterGroup.on('change', function () {
        var checked = _this.$form.find('input[name=domainFilter]:checked');
        var checkVal = checked.val();
        if (checkVal === 'noFilter') {
          _this.$domainEditContainer.hide();
        } else {
          _this.$domainEditContainer.show();
        }
        _this.resize();
      });
      this.$cancelStartSessionBtn.on('click', function () {
        _this.close();
      });
    }
  }, {
    key: 'close',
    value: function close() {
      parent.window.postMessage({
        name: _messageEnum.MessageEnum.removeStartSessionDialog
      }, '*');
    }
  }, {
    key: 'resize',
    value: function resize() {
      var checked = this.$form.find('input[name=domainFilter]:checked');
      var checkVal = checked.val();
      var height = this.originalHeight;
      if (checkVal !== 'noFilter') {
        height = this.getMaxHeight();
      }
      if (this.$progressStartSession.is(':visible')) {
        height += 30;
      }
      parent.window.postMessage({
        name: 'resize-web-explorer-start-session-dialog',
        height: height
      }, '*');
    }
  }, {
    key: 'showError',
    value: function showError(errorMessage, hideAfterMilliseconds) {
      var _this2 = this;

      this.$errorMessage.text(errorMessage);
      this.$errorMessage.show();
      this.resize();
      if (hideAfterMilliseconds && hideAfterMilliseconds > 0) {
        window.setTimeout(function () {
          _this2.$errorMessage.hide();
          _this2.resize();
        }, hideAfterMilliseconds);
      }
    }
  }, {
    key: 'onNumericTextboxKeydown',
    value: function onNumericTextboxKeydown(evt) {
      if (evt.shiftKey) {
        if (evt.keyCode !== 9) {
          evt.preventDefault();
          return;
        }
      }
      if (evt.which === 13 || evt.keyCode === 46 || evt.keyCode === 8 || evt.keyCode === 9) {
        return;
      }
      if ((evt.keyCode === 48 || evt.keyCode === 96) && this.val().length === 0) {
        evt.preventDefault();
      } else if (evt.keyCode < 95) {
        if (evt.keyCode < 48 || evt.keyCode > 57) {
          evt.preventDefault();
        }
      } else if (evt.keyCode < 96 || evt.keyCode > 105) {
        evt.preventDefault();
      }
    }
  }, {
    key: 'getMaxHeight',
    value: function getMaxHeight() {
      var doc = document;
      var body = doc.body;
      var html = doc.documentElement;
      return Math.max(body.scrollHeight, body.offsetHeight, html.clientHeight, html.scrollHeight, html.offsetHeight);
    }
  }]);

  return StartSessionFromqTestViewModel;
}();

// eslint-disable-next-line no-undef


$(function () {
  chrome.runtime.sendMessage({
    name: 'getCurrentqTestSession'
  }, function (response) {
    if (response.success) {
      var viewModel = new StartSessionFromqTestViewModel();
      viewModel.show(response.data);
    }
  });
});

},{"../../../common/services/model/messageEnum":1}]},{},[2]);
